{"!","Returns the logical inverse of the argument if prefixed or factorial if infixed.","","!(b==0); 5!","or,and,xor,factorial"},
{"!=","Boolean infixed operator that tests the difference.",""," 1+1!=2; 2!=3","==,<=,>="},
{"#","Transforms (in a program) a string into the name of a variable.",""," #(\"a\")","input"},
{"$","Infixed version of seq.",""," 0.3$4; t$4; 0$0; a:=(1,2,3);eval(a$4); (2^k)$(k=0..3); [(2^k)$(k=0..3)]; (0.3..2)$0.2; (k^2)$(k=(1..10)$2); (k^2)$(k=1..10,2); (k+1)$(k=(0..1)$(1/2)); (k+1)$(k=(0..1)$0.5); [k^2,k^3]$(k=1..10)","seq,makelist,range"},
{"%","Infixed operator which returns n mod p a number of ℤ/pℤ.","Intg(n),Intg(p)"," 15 mod 6; (2 mod 10)^50; (72 mod 7) mod 0; (2%10)^50; (72%7)%0","smod,irem,fracmod"},
{"%/","Euclidean remainder of 2 integer : it is the infixed version of irem.","Intg(a),Intg(b)"," 125 %/ 15; 125 %/ 41; -7 %/ 3; 25+12*i %/ 5+7*i","iquo,smod,rem,mod"},
{"%/","Euclidean remainder of 2 integer : it is the infixed version of irem.","Intg(a),Intg(b)","iquo(125,15);iquo(125,41);iquo(-7,3);iquo(25+12*i,5+7*i)","irem,smod,quo"},
{"%{%}","set[] or %{%} is used to define a set.","Seq"," set[1,2,3]; %{1,2,3%}; L:=[1,2,2,3];S:=set[op(L)]; set[1,2]*set[2,3]","in,op"},
{"&&","infixed boolean operator (and).","Expr, Expr"," 1==2 and 2>1; 1!=2 and 2>0","or,not,xor"},
{"&*","Matrix multiplication (infixed operator, &* Maple compatibility).",""," [[1,2],[1,4]] &* [[1,2],[3,4]]","*"},
{"&^","Calculates the n power of the matrix (infixed operator, &^ Maple compatibility).",""," [[1,2],[3,4]] &^ 3; [[1,2],[3,4]] &^ n","^"},
{"'","Returns the derivative with respect to the 2nd argument (postfixed version of diff).",""," (x^3-x)'; (x^3-x,x$3)'; (x*y+z*y,y)'; (x*y+z*y,y,z)'; (x*y+z*y,[y,z])'; f(x):=sin(2x);g:=f';h:=f''","diff,function_diff,integrate"},
{"()","() returns the value of a function or substitutes values in an expression",""," f(x,y,z):=x+2y+3z;f(1,2,z); f:=(x,y,z)->x+2y+3z;f(1,2,z); g:=x+2y+3z;g(x=1,y=2)","subst,->,:="},
{"*","Scalar product infixed (or product of 2 expressions or 2 matrix).",""," [1,2]*[3,4]","dot,cross,.*,hadamard"},
{"*=","Infixed operator : a*=b equivalent to a:=a*b.",""," a:=2;a*=3","sto,:="},
{"+","String concatenation or addition element by element of 2 expressions or 2 lists or 2 matrix or of 2 points (infixed operator).",""," \"bon\"+\"jour\"; 1+2; [1,2]+[3,4,5]; point(2+i)+point(1+2i); point(1+2*i)+2+i","concat,.+"},
{"+&","String concatenation or addition element by element of 2 expressions or 2 lists or 2 matrix (infixed operator, TI compatibility).",""," \"bon\"+&\"jour\"; 1+&2; [1,2]+&[3,4,5]","concat"},
{"+=","Infixed operator : a+=b equivalent to a:=a+b.",""," a:=2;a+=3; a:=\"abc\";a+=\"d\"","sto,:="},
{"+infinity","Plus infinity","","","infinity,-infinity"},
{"-","substraction element by element of 2 expressions or 2 lists or 2 matrix or of 2 points (infixed operator).","Lst||Expr||Pnt, ||Lst||Expr||Pnt"," 1-2; [1,2]-[3,4,5]; point(2+i)-point(1+2i); point(2+i)-(1+2i)",".-"},
{"-<","Infixed operator (equivalent to the prefixed instruction color) which define the attributes of a geometrical figure.",""," square(0,1) -< filled+red; square(0,2) -< green; square(0,2) -< green+dash_line; square(0,2) -< filled","color"},
{"-=","Infixed operator : a-=b equivalent to a:=a-b.",""," a:=2;a-=3",":="},
{"->","Infixed operator which define an user function: x->f(x).",""," x -> sin(x); f:= (x,y)->sin(x+y)+sin(x-y); k:=(x,y)->{if (x!=y) 0; else 1;}; g:=(x,y)->return(sin(x+y),sin(x-y))","for,if,local,{}"},
{"-infinity","Minus infinity","","","infinity,+infinity,inf"},
{".*","Performs an element by element multiplication of 2 lists or 2 matrix with the same size dimension (infixed operator, TI compatibility).",""," [[1,2],[3,4]] .* [[3,4],[5,6]]; [1,2] .* [5,6]","hadamard,./,.^"},
{".+","Performs an element by element addition of 2 lists or 2 matrix or add $a$ at each element of the list or matrix (infixed operator, TI compatibility).",""," [1,2,3].+4; [[1,2],[3,4]].+5; [[1,2],[3,4]].+[5,6]; [[1,2],[3,4]].+[[3,4],[5,6]]; [1,2] .+ [5,6]",".-"},
{".-","Performs an element by element subtraction of 2 lists or 2 matrix or substract $a$ at each element of the list or matrix (infixed operator, TI compatibility).",""," [1,2,3].-4; [[1,2],[3,4]].-5; [[1,2],[3,4]] .- [[3,4],[5,6]]; [1,2] .- [5,6]",".+"},
{"./","Performs an element by element division of 2 lists or 2 matrix (infixed operator, TI compatibility).",""," [[1,2],[3,4]] ./ [[3,4],[5,6]]; [1,2] ./ [5,6]",".*"},
{".^","Calculates the power of each element of the matrix (infixed operator, TI compatibility).",""," [[1,2],[3,4]] .^ 3",".*"},
{"/%","Euclidean quotient of 2 integers : it is the infixed version of iquo.","Intg(a),Intg(b)","irem(125,15);irem(125,41);irem(-7,3);irem(25+12*i,5+7*i)","mod"},
{"/=","Infixed operator : a/=b equivalent to a:=a/b.",""," a:=2;a/=3",":="},
{":=","Infixed operator that stores the second argument in the variable given as first argument.",""," a:=2; b:=\"salut\"","sto,=<,=>"},
{"<","Boolean infixed operator that tests the inequality.",""," 1+1<2; 2<3","!=,==,>=,<=,>"},
{"<=","Boolean infixed operator that tests the inequality.",""," 1+1<=2; 2<=3","!=,==,>=,>,<"},
{"=","Infixed symbol that connects the 2 members of an equation.",""," x+4=2; x^2-3x+2=0; equal(x+4,2)","equal,equal2diff,equal2list,left,right"},
{"=<","Infixed operator that stores by reference the second argument in a variable (containing a list) given as first argument.",""," a:=[1,2,3]; a[1]=<5","sto,:="},
{"==","Boolean infixed operator that tests the equality.",""," 1+1==2; 2==3","!=,<=,>="},
{"=>","Infixed operator that store the first argument in the variable given as second argument or is the infixed version of convert.",""," 2=>a; \"salut\"=>b; x^2+sin(x)=>diff; x^2-1=>*","sto,:=,convert"},
{">","Boolean infixed operator that tests the inequality.",""," 1+1>2; 4>3","!=,==,>=,<=,<"},
{">=","Boolean infixed operator that tests the inequality.",""," 1+1>=2; 2>=3","!=,==,<=,>,<"},
{"?","? is the infixed version of when : (Cond) ? Expr1:Expr2. If condition Cond=1 (even symbolic) returns Expr1 else returns Expr2.","Cond,Expr1,Expr2"," (x>0)?x+1:x-1; (n),1:0; (a>1)?a+1:0","when,if,then,else,ifte"},
{"?","Returns the help about the command (if ? is infixed see when) .","","findhelp(ifactor)","ifte,when"},
{"@","Is the infixed operator for composition of functions.",""," sq@sin; sin@sin; (sq@sin)(x)","@@"},
{"@@","f @@ n is the function fof..of (n times) (infixed operator).",""," sin@@3; (sin@@3)(x)","@"},
{"ACOSH","Hyperbolic arccosine.","Expr","acosh(1)","cosh,acos"},
{"ACOT","Arccotangent.","Expr","acot(0)","atan,arccos"},
{"ACSC","Arccosecant: acsc(x)=asin(1/x).","Expr","acsc(1);acsc(2)","asin,csc"},
{"ASEC","Arcsecant: asec(x)=acos(1/x).","Expr","asec(1);asec(2)","acos,sec"},
{"ASIN","Arcsine.","Expr","asin(0)","sin"},
{"ASINH","Hyperbolic arcsine.","Expr","asinh(0)","sinh,asin"},
{"ATAN","Arctangent.","Expr","atan(0)","tan,atanh"},
{"ATANH","Hyperbolic arctangent.","Expr","atanh(0)","atan,tanh"},
{"Airy_Ai","Returns the value of Ai the Airy function solution of w''-xw=0. Ai(x)=Ai(0)f(z)+Ai'(0)g(z)(f et g are taylor's series sol of w''-xw=0).","","Airy_Ai(0);Airy_Ai(1.5)","Airy_Bi"},
{"Airy_Bi","Returns the value of Ai the Airy function solution of w''-xw=0. Bi(x)=sqrt(3)(Bi(0)f(z)-Bi'(0)g(z))(f et g are taylor's series sol of w''-xw=0).","","Airy_Bi(1.5);Airy_Bi(0)","Airy_Ai"},
{"Archive","Protects the variables given as argument in an archive file.","","Archive(a,b)","Unarchiv,archive,unarchive"},
{"BesselJ","BesselJ(p,x) returns the Bessel function of first kind Jp(x).","","BesselJ(2,sqrt(2));BesselJ(-2,sqrt(2))","besselJ,BesselY,besselY"},
{"BesselY","BesselY(p,x) returns the Bessel function of second kind Yp(x).","","BesselJ(2,sqrt(2));BesselJ(-2,sqrt(2))","besselY,BesselJ,besselJ"},
{"Beta","Beta(a,b)=int(t^(a-1)*(1-t)^(b-1),t=0..1), Beta(a,b,p)=int(t^(a-1)*(1-t)^(b-1),t=0..p), Beta(a,b,p,1)=Beta(a,b,p)/Beta(a,b).(Beta(x,y) returns Gamma(x)*Gamma(y)/Gamma(x+y)).","","Beta(x,y);Beta(3,2);Beta(3,2,0.5);Beta(3,2,0.5,1)","Gamma,igamma"},
{"BlockDiagonal","Returns either the diagonal matrix with diagonal l or the diagonal of A.","","BlockDiagonal([[1,2],[3,4]]);BlockDiagonal([1,2,3])","identity,diag "},
{"COND","Condition number of a matrix, use COND(.,1) for l1, COND(.,2) for l2 norm and COND(.,inf) for linf (1 by default).","","COND([[1,2],[1,4]]);COND([[1,2],[1,4]],1);COND([[1,2],[1,4]],2);COND([[1,2],[1,4]],inf)","SVL"},
{"COS","Cosine or Option of the convert or convertir command (id trigcos).","Expr or Opt","cos(0); convert(cos(x)^4+sin(x)^2,cos)","acos,convert,trigsin"},
{"COSH","Hyperbolic cosine.","Expr","cosh(0)","acosh"},
{"COT","Cotangent.","Expr","cot(pi/2)","acot,tan"},
{"CSC","Cosecant: csc(x)=1/sin(x).","Expr","csc(pi/2)","sin,acsc"},
{"CST","Name of the variable creating the menu cust of the bandeau.",""," CST:=[evalc,[\"euro\",6.55957],[\"f\",x->2*x],[\"g\",g]]",""},
{"Celsius2Fahrenheit","Convert Celsius into Fahrenheit","","Celsius2Fahrenheit(10);Celsius2Fahrenheit(-40)","Fahrenheit2Celsius,_degreeF"},
{"Ci","Cosine integral int(cos(t)/t,t=-inf..x)","","Ci(1.0)","Ei,Si,Li"},
{"Circle","Draws the circle with center (xc,yc) and radius r (by default option=1 and option=0 is to remove this circle).","","Circle(0,1,1);Circle(0,1,1,0);Circle(0,1,1,1)","circle"},
{"ClrDraw","Clear the graphs and the geometric objects on the graphic screen DispG.","NULL","ClrGraph()","ClrIO,erase,erase3d,DispG"},
{"ClrGraph","Clear the graphs and the geometric objects on the graphic screen DispG.","","ClrGraph()","ClrIO,erase,erase3d,DispG"},
{"ClrIO","Clear the output screen.","","ClrIO()","ClrGraph,ClrDraw"},
{"Col","Returns the index of the column of the lightened cell in the matrixwriter.","","Col()","Row"},
{"CopyVar","Copy the storage without evaluation of var1 into var2.","","CopyVar(A,B)",""},
{"CyclePic","Realizes an automatic sequence of n pictures (stored with StoPic for example with name des1,des2,des3..desn). The display is done n times with a pause p seconds between each picture.","","CyclePic(\"des\",3,0.5,4)","StoPic"},
{"DIGITS","Pseudo-variable to modify the number of significant digits (Digits:=n).",":=Intg(n)"," Digits:=16; Digits:=24","cas_setup"},
{"DOM_COMPLEX","DOM_COMPLEX or complex is the type of a complex or of a complex variable, as returned by the type command. It is also an option of the assume command.",""," assume(a,complex); assume(a,DOM_COMPLEX); a:=1+i;type(a)","type,assume,DOM_INT,DOM_FLOAT"},
{"DOM_FLOAT","DOM_FLOAT or float is an integer representing the type of a floating point variable, returned by the type command. It is also an option of the assume command.",""," type(2.3); DOM_FLOAT+0; assume(a,DOM_FLOAT); assume(a,real); type(1.2)","type,assume,DOM_INT,DOM_SYMBOLIC"},
{"DOM_FUNC","DOM_FUNC or func is the type of a function, as returned by the type command. It is also an option of the assume command.",""," assume(a,DOM_FUNC); a(x):=1+x;type(a); type(sin); type(factor)","type,assume,DOM_INT,DOM_FLOAT"},
{"DOM_IDENT","DOM_IDENT or identifier is the type of an identifier, as returned by the type command. It is also an option of the assume command.",""," purge(a);type(a)","type,assume,DOM_INT,DOM_FLOAT"},
{"DOM_INT","DOM_INT or integer or DOM_int is an integer which is the type of an integer variable, it is the value of the type command. DOM_INT is used for integers < 2^31. It is also an option of the assume command.",""," type(2^31); DOM_INT+0; assume(a,DOM_INT); assume(a,integer); a:=2;type(a)","type,assume,DOM_FLOAT,DOM_SYMBOLIC"},
{"DOM_LIST","DOM_LIST or vector is the type of a list or of a sequence, as returned by the type command. It is also an option of the assume command.",""," assume(a,DOM_LIST); a:=[1,2,3];type(a); a:=1,2,3;type(a)","type,assume,DOM_INT,DOM_FLOAT"},
{"DOM_RAT","DOM_RAT or rational is the type of a rational, as returned by the type command. It is also an option of the assume command.",""," assume(a,rational); assume(a,DOM_RAT); a:=1/2;type(a)","type,assume,DOM_INT,DOM_FLOAT"},
{"DOM_STRING","DOM_STRING or string is the type of a string, as returned by the type command. It is also an option of the assume command.",""," a:=\"123\";type(a); assume(a,DOM_STRING)","type,assume,DOM_INT,DOM_FLOAT"},
{"DOM_SYMBOLIC","DOM_SYMBOLIC or symbol is the type of a symbolic variable, as returned by the type command. It is also an option of the assume command.",""," assume(a,symbol); assume(a,DOM_SYMBOLIC); a:=sqrt(2);type(a); type(2x+1)","type,assume,DOM_INT,DOM_FLOAT"},
{"DOM_int","DOM_INT or integer or DOM_int is an integer which is the type of an integer variable, it is the value of the type command. DOM_INT is used for integers < 2^31. It is also an option of the assume command.","Opt"," type(2^31); DOM_INT+0; assume(a,DOM_INT); assume(a,integer); a:=2;type(a)","type,assume,DOM_FLOAT,DOM_SYMBOLIC"},
{"DelFold","Remove the appointed folder (there is an error if this folder is not empty).","","DelFold(essai)","SetFold,NewFold,GetFold"},
{"DelVar","purge(varname) unassign the variable varname.","Var","purge(t);purge(C)","sto,restart,assume,about"},
{"Det","Determinant of a square matrix M, without evaluation.","","Det([[1,2],[3,4]]);Det([[1,2,3],[1,3,6],[2,5,7]])","det"},
{"Dialog","In a program, do inputs :Dialog{Title(\"title\");Text(\"Pupil\"+ string(c));Request(\"Name=\",a);Request(\"Age=\",b);DropDown(\"Level\",[\"un\",\"deux\"],n);} (you can replace {} with EndDlog at the end).",""," Dialog Title(\"section TS\");Text(\"Pupil\"+ string(c));Request(\"Name=\",a);Request(\"Age=\",b);DropDown(\"Level\",[\"un\",\"deux\"],n);EndDlog","DropDown,Request,Text,Title"},
{"Digits","Pseudo-variable to modify the number of significant digits (Digits:=n).",""," Digits:=16; Digits:=24","cas_setup"},
{"Dirac","Function derivative of Heaviside.","","Dirac(1);Dirac(-1); int(Dirac(x)*(x-1)^2,x,-1,2)","Heaviside"},
{"Disp","Prints a result in a program.","Expr|| Str","print(\"salut\");print(a)","printf"},
{"DispG","Shows DispG windows (DispG without ()).",""," DispG;","DispHome,ClrGraph"},
{"DispHome","Closes DispG windows.",""," DispHome;","DispG"},
{"DrawFunc","Plot a 1 variable or 2 variables expression with superposition.","Expr,[Var(x) or VectVar] ,[Intg(color)]","plotfunc(-2*x+1,x=1..2,color=red);plotfunc([-2*x+1,x^2-2],x=-2..2,color=[red,yellow],xstep=0.2);plotfunc(x^2-y^2,[x,y],xstep=0.5,ystep=0.3);plotfunc(x^2+y^2,[x=-1..1,y=-2..2],nstep=900);plotfunc((x+i*y)^2,[x=-1..1,y=-2..2],nstep=900,affichage=rempli)","plot,plot3d,plotparam,animate,animate3d,plotdensity"},
{"DrawInv","Draws the graph of the symmetric of the expression with respect to y=x.","","DrawInv(exp(x))","plotfunc"},
{"DrawParm","plotparam(a(x)+i*b(x),x=x0..x1) draws the curve X=a(x),Y=b(x) x=x0..x1 or plotparam([a(u,v),b(u,v),c(u,v)],[u=u0..u1,v=v0..v1]) draws the surface X=a(u,v),Y=b(u,v),Z=c(u,v) u=u0..u1 and v=v0..v1.","Cplx||Lst,Var||Lst(Var)","plotparam(sin(t)+i*cos(t),t);plotparam(exp(i*t),t=0..pi/2,affichage=1);plotparam(exp(i*t),t=0..pi/2,affichage=1+rempli);plotparam([sin(x),cos(x)],x=0..1);plotparam([sin(x),cos(x)],x=0..1,affichage=rouge);plotparam(sin(x)+i*cos(x),x=0..1,tstep=0.01);plotparam([v*cos(u),v*sin(u),v],[u,v]);plotparam([v*cos(u),v*sin(u),v],[u=0..pi,v=0..3],ustep=0.1,vstep=0.2)","plotfunc,plotpolar,arc"},
{"DrawPol","plotpolar(f(x),x,a,b) draws the polar curve r=fx) for x in [a,b].","Expr,Var,VarMin,VarMax","plotpolar(sin(2*x),x,0,pi);plotpolar(sin(2*x),x,0,pi,tstep=0.1)","plotparam,plotfunc,plotpolar"},
{"DrawSlp","Draws the line with slope m,going through the point (a,b): y-b=m(x-a).","","DrawSlp(2,1,-1)","line"},
{"DropDown","In a program, instruction of a dialog box.","","","Dialog,choosebox"},
{"DrwCtour","Draws whether 11 equirepartited contour-lines z=z_min,,...z=z_max of the surface z=Xpr, whether the contour-lines defined by the 3-rd argument.","Expr(Xpr),[LstVar],[LstVal]","plotcontour(x^2+y^2);plotcontour(x^2+y^2,[x,y]);plotcontour(x^2+2*y^2-2,[x,y],[1.0,2.0,3.0]);plotcontour(x^2-y^2,[x=-4..4,y=-4..4],seq(k,k,-11,11,3),xstep=0.1,ystep=0.1)","plotdensity,plotimplicit"},
{"ERROR","Generates the display of an error in a program","Str","error(\"Argument should be integer\");error(\"je provoque une erreur\")","try,catch"},
{"EXP","Exponential or Option of the convert or convertir command (id trig2exp).","Expr or Opt","exp(0); convert(cos(x),exp)","ln,convert,trig2exp"},
{"Ei","Exponential integral int(exp(t)/t,t=-inf..x)","","Ei(1.0)","Si,Ci,Li"},
{"EndDlog","In a program, do inputs :Dialog{Title(\"title\");Text(\"Pupil\"+ string(c));Request(\"Name=\",a);Request(\"Age=\",b);DropDown(\"Level\",[\"un\",\"deux\"],n);} (you can replace {} with EndDlog at the end).","Title;Text;Request;Request;DropDown;EndDlog"," Dialog Title(\"section TS\");Text(\"Pupil\"+ string(c));Request(\"Name=\",a);Request(\"Age=\",b);DropDown(\"Level\",[\"un\",\"deux\"],n);EndDlog","DropDown,Request,Text,Title"},
{"FALSE","boolean equal to false or 0.",""," a:=false","true"},
{"Factor","Factorizes a polynomial without evaluation.","","Factor(x^4-1);Factor(x^4+12*x^3+54*x^2+108*x+81)","factor,ifactor,normal"},
{"Fahrenheit2Celsius","Convert Fahrenheit into Celsius","","Fahrenheit2Celsius(50);Fahrenheit2Celsius(-40)","Celsius2Fahrenheit,_degreeF"},
{"False","boolean equal to false or 0.",""," a:=false","true"},
{"Fill","Fill the list or the matrix stored in A with Xpr.","","Fill(1.1,A)","makelist,makemat"},
{"GF","Create a Galois Field of characteristic p with p^n elements. The minimal polynomial is primitive except if given or if 0 is passed as last argument.","","GF(2,8);GF(5,9,a);GF(2,128,0);GF(2,w^8+w^7+w^5+w+1);GF(2,8,['a','G']); G:=GF(2,a^8+a^6+a^3+a^2+1,['a','G'],undef)",""},
{"Gamma","Calculus of Gamma at a point a (Gamma(n+1)=n! for n integer) if a>0, Gamma(a)=int(e^{-t}*t^{a-1},t=0..inf)) and Gamma(a)=Gamma(a+1)/a and Gamma(a,b)=ugamma(a,b).","","Gamma(5);Gamma(1/2);gamma(-5.1);Gamma(-5.1,2.1)","Psi,Beta,ugamma,igamma"},
{"Gcd","Returns the greatest common divisor of 2 polynomials or of 2 integers without evaluation","","Gcd(45,75);Gcd(x^2-2*x+1,x^3-1);Gcd(x^2-2*x+1,x^2+x-2)","gcd"},
{"GetFold","Returns the name of the current folder.","","GetFold()","SetFold,DelFold,NewFold"},
{"Graph","Plot a 1 variable or 2 variables expression with superposition.","Expr,[Var(x) or VectVar] ,[Intg(color)]","plotfunc(-2*x+1,x=1..2,color=red);plotfunc([-2*x+1,x^2-2],x=-2..2,color=[red,yellow],xstep=0.2);plotfunc(x^2-y^2,[x,y],xstep=0.5,ystep=0.3);plotfunc(x^2+y^2,[x=-1..1,y=-2..2],nstep=900);plotfunc((x+i*y)^2,[x=-1..1,y=-2..2],nstep=900,affichage=rempli)","plot,plot3d,plotparam,animate,animate3d,plotdensity"},
{"Heaviside","Function equal to 0 if x<0 and 1 if x>=0.","","Heaviside(1);Heaviside(-1);Heaviside(0)","Dirac,laplace"},
{"IFTE","If condition returns Expr1 else returns Expr2.","Cond,Expr1,Expr2"," x:=3;ifte(x>0,x+1,x-1); a:=2;ifte(a>1,a+1,0)","if,then,else,when"},
{"Input","Instruction in a program so that you can input an expression and store it in var.","[Str],Var(Var)","input(\"age\",a)","InputStr,output"},
{"InputStr","Instruction in a program so that you can input a string and store it in var.","","InputStr(\"nom?\",N)","input"},
{"Int","Returns the primitive or the calculus of the integrate (bounds a and b) without evaluation.","","Int(sin(x));Int(sin(t),t);Int(sin(x),x,0,pi)","int"},
{"Inverse","Returns the reciprocal or the matrix inverse without evaluation.","","Inverse(9/5);Inverse([[1,2],[3,4]])","inv"},
{"JordanBlock","Returns a matrix n*n with a on the diagonal ,1 above and 0 everywhere else.","","JordanBlock(7,3)","jordan"},
{"LN","Natural logarithm or Option of the convert or convertir command (id trig2exp).","Expr or Opt","ln(1);ln(e); convert(cos(x),ln)","exp,convert,trig2exp,log10"},
{"LQ","For a numerical matrix A, returns L a lower matrix, Q an orthogonal matrix and P a permutation matrix such that P*A=L*Q.","","LQ([[1,2],[3,4]]);LQ([[6,12,18],[5,14,31],[3,8,18]]);LQ([[4,0,0],[8,-4,3]])","lu,QR"},
{"LSQ","Returns the vector (resp matrix) X which is the minimum of the euclidean (resp Frobenius) norm of A*X-B corresponding to the linear system A*X=B when B is a vector (resp matrix).","","LSQ([[1,2],[3,4]],[5,11]);LSQ([[1,2],[3,4]],[[5,-1],[11,-1]])","lu,QR"},
{"LU","For a numerical matrix A, store in L a lower matrix, in U a upper matrix and in P a permutation matrix such that P*A=L*U.","","LU([[1,2],[3,4]],L,U,P);LU([[6,12,18],[5,14,31],[3,8,18]],L,U,P)","lu,QR"},
{"LambertW","Returns a solution in t of t*exp(t)=x","Real(x),[Intg(n)]","LambertW(1.0);LambertW(ln(4));LambertW(-0.1,-1)",""},
{"Li","Logarithm integral Li(x)=Ei(ln(x)) primitive de 1/ln(x) ","","Li(2.0)","Si,Ci,Ei"},
{"Line","Draws the segment [a+i*b,c+i*d].","","Line(-1,-2,1,2)","segment"},
{"LineHorz","Draws the horizontal line y=a.","","LineHorz(-1)","Line,LineVert"},
{"LineTan","Draws the tangent to y=f(x) at x=a. Do not put parenthesis or put the parenthesis around.",""," LineTan sin(x),pi/4; LineTan sin(t),t=pi/4); LineTan sin(t),t,pi/4; LineTan x^2-x,1; (LineTan sin(t),t,pi/4)","tangent,droite_tangente"},
{"LineVert","Draws the vertical line x=a.","","LineVert(2)","Line,LineHorz"},
{"NORMALD","Returns the density of probability of the Normal law (mu is the mean and sigma the standard deviation).","Real(mu),Real(sigma),Real(x0)","normald(1);normald(1,2,3.5); randvector(3,normald,1,0.5); ranm(4,3,normald,1,0.5)","normal_cdf,normal_icdf,randvector,ranm"},
{"NewFold","Make a new folder and then we are in this folder.","","NewFold(essai)","SetFold,DelFold,GetFold"},
{"NewPic","Creates a picture named pic1, made with the points defined by the rows of A.","","NewPic ([[1,1],[1,2],[2,2]],des1)",""},
{"Nullspace","Inert form of nullspace for modular computation (irem/mod)","","Nullspace([[1,2],[3,6]]);Nullspace([[1,2,3],[1,3,6],[2,5,9]])","image,rref,nullspace"},
{"Output","Instruction in a program so that you can output an expression stored in var.","[Str],Var(Var)","output(\"age\",a)","input"},
{"Ox_2d_unit_vector","Ox_2d_unit_vector() draws the unit vector of the x-axis of the graphic-screen 2-d.","","Ox_2d_unit_vector(); legende(1,\"u\",vert,quadrant4),Ox_2d_unit_vector()","frame_2d,Oy_2d_unit_vector,Ox_3d_unit_vector,Oy_3d_unit_vector,Oz_3d_unit_vector,gl_x_axis_unit,gl_x_axis_name"},
{"Ox_3d_unit_vector","Ox_3d_unit_vector() draws the unit vector of the x-axis of the graphic-screen 3-d.","","Ox_3d_unit_vector(); legende(point(1,0,0),\"i\",vert),Ox_3d_unit_vector()","frame_3d,Oy_3d_unit_vector,Oz_3d_unit_vector,Ox_2d_unit_vector,Oy_2d_unit_vector"},
{"Oy_2d_unit_vector","Oy_2d_unit_vector() draws the unit vector of the y-axis of the graphic-screen 2-d.","","Oy_2d_unit_vector(); legende(i,\"v\",vert,quadrant2),Oy_2d_unit_vector()","frame_2d,Ox_2d_unit_vector,Ox_3d_unit_vector,Oy_3d_unit_vector,Oz_3d_unit_vector,gl_y_axis_unit,gl_y_axis_name"},
{"Oy_3d_unit_vector","Oy_3d_unit_vector() draws the unit vector of the y-axis of the graphic-screen 3-d.","","Oy_3d_unit_vector(); legende(point(0,1,0),\"j\",vert),Oy_3d_unit_vector()","frame_3d,Ox_3d_unit_vector,Oz_3d_unit_vector,Ox_2d_unit_vector,Oy_2d_unit_vector"},
{"Oz_3d_unit_vector","Oz_3d_unit_vector() draws the unit vector of the z-axis of the graphic-screen 3-d,","","Oz_3d_unit_vector(); legende(point(0,0,1),\"k\",vert),Oz_3d_unit_vector()","frame_3d,Ox_3d_unit_vector,Oy_3d_unit_vector,Ox_2d_unit_vector,Oy_2d_unit_vector"},
{"Pause","Pause; in a program stopping its execution (the execution goes on if you press ENTER) [Pause n; stopping its execution during n seconds].",""," Pause 3;;sleep(2)","WAIT"},
{"Phi","Euler's function (euler(n)=card({p<n,gcd(n,p)=1})).","Intg(n)","euler(11);euler(6)","gcd"},
{"Pi","pi",""," pi/4; Pi/4; evalf(pi); evalf(Pi)","e,i"},
{"PopUp","In a program, do an input with a display of a choose list.","Str(titel),LstVal,Var","choosebox(\"titre\",[\"un\",\"deux\",\"trois\"],a);choosebox(\"valeur de a\",[-1,0,1],a)","Dialog"},
{"Psi","Psi(a,n)=n-th derivative of the function DiGamma (=ln@Gamma) at point a (Psi(a,0)=Psi(a)).","","Psi(3,1)","Gamma"},
{"QR","For a numerical matrix A, store in Q a orthogonal matrix and in U a lower matrix such that A=Q*R [exchanging by 0 the elements such that abs(el)<eps].","","QR([[1,2],[3,4]],Q,R)","qr,LU"},
{"Quo","Returns the euclidean quotient of 2 polynomials without evaluation.","","Quo([1,2,3,4],[-1,2]);Quo(x^3+2x^2+3x+4,-x+2);Quo(t^3+2t^2+3t+4,-t+2,t)","quo,quorem"},
{"REDIM","Shrink or enlarge with 0 a matrix (or vector) according to the new n1 and n2 dimensions.","","redim([[1,2,3],[3,-9,6],[4,5,6]],1,2);redim([[1,2,3],[3,-9,6],[4,5,6]],4,4)","replace"},
{"REPLACE","Replace part of matrix A from indices n1,n2 with the values of matrix B.","","replace([[1,2,3],[3,-9,6],[4,5,6]],[1,0],[[7,8],[9,0]])","redim"},
{"RandSeed","Initializes random numbers.","","RandSeed(321)","srand"},
{"RclPic","Adds to the graphic in the DispG screen, the picture stored with StoPic.","","RclPic(des1)","RplcPic,StoPic"},
{"Rem","Returns the euclidean remainder of 2 polynomials without evaluation.","","Rem([1,2,3,4],[-1,2]);Rem(x^3+2*x^2+3*x+4,-x+2);Rem(t^3+2*t^2+3*t+4,-t+2,t)","rem,quorem"},
{"Request","In a program, instruction of a dialog box.","","","Dialog,input"},
{"Resultant","Inert form of resultant for modular computation (irem/mod)","","Resultant(x^3+x+1,x^2-x-2,x)","resultant"},
{"Row","Returns the index of the row of the lightened cell in the matrixwriter.","","Row()","Col"},
{"RplcPic","Erase and replaces the graphic in the DispG screen, with the picture stored with StoPic.","","RplcPic(des1)","StoPic,RclPic"},
{"Rref","Returns the row reduction to echelon form of AX=b (M=A|b) without evaluation.","","Rref([[3,1,-2],[3,2,2]]);Rref([[2,1,1,-1],[1,1,2,-1],[1,2,1,-4]])","rref"},
{"SCALE","Multiplies the row n1 of the matrix A by Xpr.","Mtrx(A),Expr(Xpr),Intg(n1)","scale([[1,2],[3,4],[5,6]],12,0)","rowAdd,scaleadd,mRowAdd"},
{"SCALEADD","Multiplies the row n1 of the matrix A by Xpr, then adds it to the row n2.","Mtrx(A),Expr(Xpr),Intg(n1),Intg(n2)","scaleadd([[1,2],[3,4],[5,6]],12,0,2)","rowAdd,scale,mRow"},
{"SCHUR","Matrix reduction to Hessenberg form. Returns [P,B] such that B=inv(P)*A*P:SCHUR(A)=hessenberg(A,-1).","","SCHUR([[1,2,3],[4,5,6],[7,8,1]]);SCHUR([[1,2,3,4],[4,5,6,7],[7,8,9,0],[0,1,2,3]])","hessenberg"},
{"SIN","Sine or Option of the convert or convertir command (id trigsin).","Expr or Opt","sin(0); convert(cos(x)^4+sin(x)^2,sin)","asin,convert,trigsin"},
{"SVD","Singular Value Decomposition for a numerical real matrix A, returns U an orthogonal matrix, S the vector of singular values of A and Q an orthogonal matrix and S the vector of singular values such that A=U*diag(S)*trn(Q)","","SVD([[1,4],[4,1]]);SVD([[6,12,18],[5,14,31],[3,8,18]])","lu,svd"},
{"SVL","For a numerical real matrix A returns the singular value vector i.e. sqrt(eigenvals(A*trn(A))).","","SVL([[1,4],[4,1]]);SVL([[6,12,18],[5,14,31],[3,8,18]])","lu,svd"},
{"SWAPCOL","Returns the matrix get from A by swapping the n1-th column and the n2-th column.","Mtrx(A),Intg(n1),Intg(n2)","colSwap([[1,2],[3,4],[5,6]],0,1)","rowSwap"},
{"SWAPROW","Returns the matrix get from A by swapping the n1-th row and the n2-th row.","Mtrx(A),Intg(n1),Intg(n2)","rowSwap([[1,2],[3,4],[5,6]],1,2)","rowAdd,colSwap"},
{"SetFold","Returns the name of the current folder and chooses the appointed name as new folder (main for the root folder).","","SetFold(essai);SetFold(main)","NewFold,DelFold,GetFold"},
{"Si","Sine integral int(sin(t)/t,t=0..x)","","Si(1.0)","Ei,Ci,Li"},
{"SortA","Sorts the lists with increasing order (like TI).","","SortA [3,4,2];SortA 3,4,2;SortA [3,4,2],[6,4,5];SortA [[3,4,2],[6,4,5]]","SortD,sorta,sort"},
{"SortD","Sorts the lists with decreasing order (like TI).","","SortD [3,4,2];SortD 3,4,2;SortD [[3,4,2],[6,4,5]];SortD [3,4,2],[6,4,5]","SortA,sortd,sort"},
{"StoPic","To store graphics in variables with same root-name (radical1,radical2..) and then we can animate the graphics with CyclePic.","","StoPic(des1);StoPic(des2);StoPic(des3)","CyclePic"},
{"Store","Store the first argument in the variable given as second argument.","(Real or Str),Var","sto(2,a);sto(\"salut\",b)",":=,=>"},
{"TAN","Tangent or Option of the convert or convertir command (id halftan)","Expr","tan(0);tan(pi/4); convert(tan(x),tan)","atan or Opt,convert,halftan"},
{"TRUE","boolean equal to true or 1.",""," a:=true","false"},
{"TeX","Returns the evaluated expression written in latex.","Expr","latex(1/2);latex((x^4-1)/(x^2+3))","mathml"},
{"Text","In a program, instruction of a dialog box.","","","Dialog"},
{"Title","In a program, instruction of a dialog box.","","","Dialog"},
{"True","boolean equal to true or 1.",""," a:=true","false"},
{"UTPC","Returns the probability that a Chisquare random variable is greater than x0 (n is the number of degrees of freedom).","","UTPC(2,6.1);UTPC(4,6.1)","chisquare_cdf,chisquare_icdf"},
{"UTPF","Returns the probability that a Fisher-Snedecor random variable is greater than x0 (n and d are the numbers of degrees of freedom).","","UTPF(4,10,3.5);UTPF(4,4,2.1)","fisher_cdf,fisher_icdf"},
{"UTPN","Returns the probability that a Normal random variable is greater than x0 (mu is the mean and v the variance).","","UTPN(1.96);UTPN(1,4,2.96)+normal_cdf(1,2,2.96)","normal_cdf,normal_icdf"},
{"UTPT","Returns the probability that a Student random variable is greater than x0 (n is the number of degrees of freedom).","","UTPT(3,2.35);UTPT(3,-2.35)","student_cdf,student_icdf"},
{"Unarchiv","Unprotects the variables given as argument.","","Unarchiv(a,b)","Archive,archive,unarchive"},
{"VARS","List of the variables and folders of the current directory.","","VARS()","lvar"},
{"VAS","Returns a list of intervals containing the real roots of P. Vincent-Akritas-Strzebonski's method (VAS) is used.","","VAS(x^3-7*x+7)","VAS_positive,sturmab,realroot"},
{"VAS_positive","Returns a list of intervals containing the positive roots of P. Vincent-Akritas-Strzebonski's method (VAS) is used.","","VAS_positive(x^3-7*x+7)","poslbdLMQ,posubLMQ,VAS,realroot"},
{"WAIT","WAIT(n); in a program stopping its execution during n seconds.","","WAIT(3)","Pause"},
{"Zeta","Returns if a>1 sum(1/n^a,n,1,+infinity).","","Zeta(2)","sum"},
{"[..]","i[] is used to define a real interval(i[a,b]=[a..b]).","Seq(a,b)","i[1,3]; i[1,3]+i[2,4]*i","op"},
{"^","Calculates the n power of a number (infixed operator).",""," 2^12; [[1,2],[3,4]] ^ 3","&^,matpow,.^,sqrt,surd,pow,powmod"},
{"_(cm/s)","centimetre per second.",""," 5_(cm/s); mksa(_(cm/s))",""},
{"_(ft/s)","foot per second.",""," 5_(ft/s); mksa(_(ft/s))",""},
{"_(m/s)","metre per second.",""," 5_(m/s); mksa(_(m/s))",""},
{"_(m/s^2)","metre per square second.",""," 5_(m/s^2); mksa(_(m/s^2))",""},
{"_(rad/s)","Radian per second.",""," 5_(rad/s); mksa(_(rad/s))",""},
{"_(rad/s^2)","Radian per square second.",""," 5_(rad/s^2); mksa(_(rad/s^2))",""},
{"_(tr/min)","Revolutions per minute.",""," 5_(tr/min); mksa(_(tr/min))",""},
{"_(tr/s)","Revolutions per second.",""," 5_(tr/s); mksa(_(tr/s))",""},
{"_A","Ampere",""," 5_A; mksa(_A)",""},
{"_Angstrom","Angstrom",""," 5_Angstrom; mksa(_Angstrom)",""},
{"_Bq","Becquerel",""," 5_Bq; mksa(_Bq)",""},
{"_Btu","Btu British thermal unit",""," 5_Btu; mksa(_Btu)",""},
{"_Ci","Curie",""," 5_Ci; mksa(_Ci)",""},
{"_F","Farad",""," 5_F; mksa(_F)",""},
{"_F_","Faraday constant",""," mksa(_F_)",""},
{"_Fdy","Faraday",""," 5_Fdy; mksa(_fdy)",""},
{"_G_","Gravitational constant",""," mksa(_G_)",""},
{"_Gal","Gal=0.01_(m/s^2).",""," 5_Gal; mksa(_Gal)",""},
{"_Gy","Gray",""," 5_Gy; mksa(_Gy)",""},
{"_H","Henry",""," 5_H; mksa(_H)",""},
{"_Hz","Hertz",""," 5_Hz; mksa(_Hz)",""},
{"_I0_","","","",""},
{"_J","Joule",""," 5_J; mksa(_J)",""},
{"_K","Kelvins",""," 5_K; mksa(_K)",""},
{"_Kcal","Kilocalorie.",""," 5_Kcal; mksa(_Kcal)",""},
{"_MHz","Megahertz.",""," 5_MHz; mksa(_MHz)",""},
{"_MW","Megawatt.",""," 5_MW; mksa(_MW)",""},
{"_MeV","Megaelectronvolt.",""," 5_MeV; mksa(_MeV)",""},
{"_N","Newton",""," 5_N; mksa(_N)",""},
{"_NA_","Avogadro's number.",""," mksa(_NA_)",""},
{"_Ohm","Ohm",""," 5_Ohm; mksa(_Ohm)",""},
{"_P","Poise (measures viscosity)",""," 5_P; mksa(_P)",""},
{"_PSun_","Power at the surface of the Sun",""," mksa(_PSun_)",""},
{"_Pa","Pascal",""," 5_Pa; mksa(_Pa)",""},
{"_R","Roentgen 1_R=",""," 5_R; mksa(_R)",""},
{"_REarth_","Radius of the Earth",""," mksa(_REarth_)",""},
{"_RSun_","Radius of the Sun",""," mksa(_RSun_)",""},
{"_R_","Universal gas constant.",""," mksa(_R_)",""},
{"_Rankine","Degree Rankine.",""," 5_Rankine; mksa(_Rankine)",""},
{"_Rinfinity_","Rydberg constant",""," mksa(_Rinfinity_)",""},
{"_S","Siemens",""," 5_S; mksa(_S)",""},
{"_St","Stokes",""," 5_St; mksa(_St)",""},
{"_StdP_","Standard pressure.",""," mksa(_StdP_)",""},
{"_StdT_","Standard temperature.",""," mksa(_StdT_)",""},
{"_Sv","Sievert",""," 5_Sv; mksa(_Sv)",""},
{"_T","Tesla",""," 5_T; mksa(_T)",""},
{"_V","Volt",""," 5_V; mksa(_V)",""},
{"_Vm_","Molar volume.",""," mksa(_Vm_)",""},
{"_W","Watt",""," 5_W; mksa(_W)",""},
{"_Wb","Weber",""," 5_Wb; mksa(_Wb)",""},
{"_Wh","Watt-hour.",""," 5_Wh; mksa(_Wh)",""},
{"_a","Are (100 m^2)",""," 5_a; mksa(_a)",""},
{"_a0_","Bohr radius",""," mksa(_a0_)",""},
{"_acre","Acre",""," 5_acre; mksa(_acre)",""},
{"_alpha_","Fine structure constant",""," mksa(_alpha_)",""},
{"_angl_","","","",""},
{"_arcmin","Minute of arc",""," 5_arcmin; mksa(_arcmin)",""},
{"_arcs","Second of arc",""," 5_arcs; mksa(_arcs)",""},
{"_atm","Atmosphere",""," 5_atm; mksa(_atm)",""},
{"_au","Astronomical unit",""," 5_au; mksa(_au)",""},
{"_b","Barn",""," 5_b; mksa(_b)",""},
{"_bar","Bar",""," 5_bar; mksa(_bar)",""},
{"_bbl","Barrel",""," 5_bbl; mksa(_bbl)",""},
{"_bblep","Barrel of oil equivalent.",""," 5_bblep; mksa(_bblep)",""},
{"_bu","Bushel (1_bu=8_galUK)",""," 5_bu; mksa(_bu)",""},
{"_buUS","",""," 5_buUS; mksa(_buUS); _C; 5_C; mksa(_C)",""},
{"_c3_","Wien displacement constant",""," mksa(_c3_)",""},
{"_c_","Speed of light in vacuum.",""," mksa(_c_)",""},
{"_cal","Calorie",""," 5_cal; mksa(_cal)",""},
{"_cd","Candela",""," 5_cd; mksa(_cd)",""},
{"_chain","Chain (1 chain = 66 feet or 22 yards)",""," 5_chain; mksa(_chain)",""},
{"_cm","Centimetre.",""," 5_cm; mksa(_cm)",""},
{"_cm^2","Square centimetre.",""," 5_cm^2; mksa(_cm^2)",""},
{"_cm^3","Cubic centimetre.",""," 5_cm^3; mksa(_cm^3)",""},
{"_ct","Carat",""," 5_ct; mksa(_ct)",""},
{"_cu","US cup",""," 5_cu; mksa(_cu)",""},
{"_d","Day",""," 5_d; mksa(_d)",""},
{"_dB","Decibel",""," 5_dB; mksa(_dB)",""},
{"_deg","Degree (angle).",""," 5_deg; mksa(_deg)",""},
{"_degreeF","Degree Fahrenheit.",""," 5_degreeF; mksa(_degreeF)",""},
{"_dyn","Dyne",""," 5_dyn; mksa(_dyn)",""},
{"_eV","Electron volt",""," 5_eV; mksa(_eV)",""},
{"_epsilon0_","Permittivity of vacuum",""," mksa(_epsilon0_)",""},
{"_epsilon0q_","epsilon0/q (permittivity/charge of the electron)",""," mksa(_epsilon0q_)",""},
{"_epsilonox_","Dielectric constant of Silicon dioxide",""," mksa(_epsilonox_)",""},
{"_epsilonsi_","Dielectric constant",""," mksa(_epsilonsi_)",""},
{"_erg","Erg",""," 5_erg; mksa(_erg)",""},
{"_f0_","Photon frequency (e/h)",""," mksa(_f0_)",""},
{"_fath","Fathom",""," 5_fath; mksa(_fath)",""},
{"_fbm","Board foot",""," 5_fbm; mksa(_fbm)",""},
{"_fc","Footcandle (1 footcandle ≈ 10.764 lux)",""," 5_fc; mksa(_fc)",""},
{"_fermi","Fermi",""," 5_fermi; mksa(_fermi)",""},
{"_flam","Footlambert",""," 5_flam; mksa(_flam)",""},
{"_fm","Fathom",""," 5_fm; mksa(_fm)",""},
{"_ft","International foot",""," 5_ft; mksa(_ft)",""},
{"_ft*lb","foot per pound.",""," 5_ft*lb; mksa(_ft*lb)",""},
{"_ftUS","Survey foot",""," 5_ftUS; mksa(_ftUS)",""},
{"_ft^2","Square foot.",""," 5_ft^2; mksa(_ft^2)",""},
{"_ft^3","Cubic foot.",""," 5_ft^3; mksa(_ft^3)",""},
{"_g","Gram",""," 5_g; mksa(_g)",""},
{"_g_","Acceleration of gravity",""," mksa(_g_)",""},
{"_ga","Standard freefall",""," 5_ga; mksa(_ga)",""},
{"_galC","Canadian gallon",""," 5_galC; mksa(_galC)",""},
{"_galUK","UK gallon",""," 5_galUK; mksa(_galUK)",""},
{"_galUS","US gallon",""," 5_galUS; mksa(_galUS)",""},
{"_gf","Gram-force",""," 5_gf; mksa(_gf)",""},
{"_gmol","Gram-mole",""," 5_gmol; mksa(_gmol)",""},
{"_gon","Grade",""," 5_gon; mksa(_gon)",""},
{"_grad","Grade",""," 5_grad; mksa(_grad)",""},
{"_grain","Grain (1 grain ≈ 0,0648 grams)",""," 5_grain; mksa(_grain)",""},
{"_h","Hour",""," 5_h; mksa(_h)",""},
{"_h_","Planck's constant",""," mksa(_h_)",""},
{"_ha","Hectare",""," 5_ha; mksa(_ha)",""},
{"_hbar_","Dirac's constant",""," mksa(_hbar_)",""},
{"_hp","Horsepower",""," 5_hp; mksa(_hp)",""},
{"_in","Inch",""," 5_in; mksa(_in)",""},
{"_inH20","Inches of water, 60 degrees Fahrenheit",""," 5_inH20; mksa(_inH20)",""},
{"_inHg","Inches of mercury, 0 degree Celsius",""," 5_inHg; mksa(_inHg)",""},
{"_in^2","Square inch.",""," 5_in^2; mksa(_in^2)",""},
{"_in^3","Cubic inch.",""," 5_in^3; mksa(_in^3)",""},
{"_j","Day",""," 5_j; mksa(_j)",""},
{"_kWh","Kilowatt-hour.",""," 5_kWh; mksa(_kWh)",""},
{"_k_","Boltzmann constant.",""," mksa(_k_)",""},
{"_kg","Kilogram",""," 5_kg; mksa(_kg)",""},
{"_kip","Kilopound-force",""," 5_kip; mksa(_kip)",""},
{"_km","Kilometre.",""," 5_km; mksa(_km)",""},
{"_km^2","Square kilometre.",""," 5_km^2; mksa(_km^2)",""},
{"_knot","nautical miles per hour",""," 5_knot; mksa(_knot)",""},
{"_kph","Kilometers per hour",""," 5_kph; mksa(_kph)",""},
{"_kq_","k/q (Boltzmann/charge of the electron)",""," mksa(_kq_)",""},
{"_l","Liter",""," 5_l; mksa(_l)",""},
{"_lam","Lambert",""," 5_lam; mksa(_lam)",""},
{"_lambda0_","Photon wavelength (ch/e)",""," mksa(_lambda0_)",""},
{"_lambdac_","Compton wavelength",""," mksa(_lambdac_)",""},
{"_lb","pound (1 pound = 16 oz)",""," 5_lb; mksa(_lb)",""},
{"_lbf","Pound-force",""," 5_lbf; mksa(_lbf)",""},
{"_lbmol","Pound-mole",""," 5_lbmol; mksa(_lbmol)",""},
{"_lbt","Troy pound",""," 5_lbt; mksa(_lbt)",""},
{"_lep","Liter of oil equivalent.",""," 5_lep; mksa(_lep)",""},
{"_liqpt","US liquid pint (1_galUS=8_liqpt)",""," 5_liqpt; mksa(_liqpt)",""},
{"_lm","Lumen",""," 5_lm; mksa(_lm)",""},
{"_lx","Lux",""," 5_lx; mksa(_lx)",""},
{"_lyr","Light year",""," 5_lyr; mksa(_lyr)",""},
{"_m","Metre (unit)",""," 5_m",""},
{"_mEarth_","Mass of the Earth",""," mksa(_mEarth_)",""},
{"_m^2","Square metre.",""," 5_m^2; mksa(_m^2)",""},
{"_m^3","Cubic metre.",""," 5_m^3; mksa(_m^3)",""},
{"_me_","Electron rest mass",""," mksa(_me_)",""},
{"_mho","Mho",""," 5_mho; mksa(_mho)",""},
{"_miUS","US statute mile",""," 5_miUS; mksa(_miUS)",""},
{"_miUS^2","Square US statue mile.",""," 5_miUS^2; mksa(_miUS^2)",""},
{"_mi^2","Square international mile.",""," 5_mi^2; mksa(_mi^2)",""},
{"_mil","Mil",""," 5_mil; mksa(_mil)",""},
{"_mile","International mile",""," 5_mile; mksa(_mile)",""},
{"_mille","Nautical mile",""," 5_mille; mksa(_mille)",""},
{"_ml","millilitre.",""," 5_ml; mksa(_ml)",""},
{"_mm","Millimetre.",""," 5_mm; mksa(_mm)",""},
{"_mmHg","Millimeter of mercury (torr), 0 degree Celsius",""," 5_mmHg; mksa(_mmHg)",""},
{"_mn","Minute.",""," 5_mn; mksa(_mn)","convert,mksa"},
{"_mol","Mole",""," 5_mol; mksa(_mol)",""},
{"_mp_","Proton rest mass",""," mksa(_mp_)",""},
{"_mph","Miles per hour",""," 5_mph; mksa(_mph)",""},
{"_mpme_","Quotient mp/me (mass of the proton/mass of the electron)",""," mksa(_mpme_)",""},
{"_mu0_","Permeability of vacuum",""," mksa(_mu0_)",""},
{"_muB_","Bohr magneton",""," mksa(_muB_)",""},
{"_muN_","Nuclear magneton",""," mksa(_muN_)",""},
{"_oz","Ounce",""," 5_oz; mksa(_oz)",""},
{"_ozUK","UK fluid ounce",""," 5_ozUK; mksa(_ozUK)",""},
{"_ozfl","US fluid ounce",""," 5_ozfl; mksa(_ozfl)",""},
{"_ozt","Troy ounce",""," 5_ozt; mksa(_ozt)",""},
{"_pc","Parsec",""," 5_pc; mksa(_pc)",""},
{"_pdl","Poundal (force)",""," 5_pdl; mksa(_pdl)",""},
{"_ph","Phot",""," 5_ph; mksa(_ph)",""},
{"_phi_","Magnetic flux quantum",""," mksa(_phi_)",""},
{"_pk","US peck",""," 5_pk; mksa(_pk)",""},
{"_psi","Pounds per square inch",""," 5_psi; mksa(_psi)",""},
{"_ptUK","UK pint (1_galUK=8_ptUK)",""," 5_ptUK; mksa(_ptUK)",""},
{"_q_","","","",""},
{"_qe_","Electron charge",""," mksa(_qe_)",""},
{"_qepsilon0_","q*epsilon0 (charge of the electron*permittivity)",""," mksa(_qepsilon0_)",""},
{"_qme_","Quotient q/me (charge/mass of the electron)",""," mksa(_qme_)",""},
{"_qt","Quart",""," 5_qt; mksa(_qt)",""},
{"_rad","Radian",""," 5_rad; mksa(_rad)",""},
{"_rad_","1 radian",""," mksa(_rad_)",""},
{"_rd","Rad 1_rd=0.01_Gy",""," 5_rd; mksa(_rd)",""},
{"_rem","Rem",""," 5_rem; mksa(_rem)",""},
{"_rod","Rod 1_rod=5.029215842_m",""," 5_rod; mksa(_rod)",""},
{"_rpm","Revolutions per minute",""," 5_rpm; mksa(_rpm)",""},
{"_s","Second",""," 5_s; mksa(_s)",""},
{"_s","second.",""," 5_mn; mksa(_mn)","convert,mksa"},
{"_sb","Stilb",""," 5_sb; mksa(_sb)",""},
{"_sd_","Duration of a sidereal day",""," mksa(_sd_)",""},
{"_sigma_","Stefan-Boltzmann constant.",""," mksa(_sigma_)",""},
{"_slug","Slug",""," 5_slug; mksa(_slug)",""},
{"_sr","Steradian",""," 5_sr; mksa(_sr)",""},
{"_st","Stere",""," 5_st; mksa(_st)",""},
{"_syr_","Duration of a sidereal year",""," mksa(_syr_)",""},
{"_t","Metric ton",""," 5_t; mksa(_t)",""},
{"_tbsp","Tablespoon",""," 5_tbps; mksa(_tbsp)",""},
{"_tec","Tonne of coal equivalent.",""," 5_tec; mksa(_tec)",""},
{"_tep","Tonne of oil equivalent.",""," 5_tep; mksa(_tep)",""},
{"_tex","tex=10^-6 _(kg/m).",""," 5_tex; mksa(_tex)",""},
{"_therm","EEC therm",""," 5_therm; mksa(_therm)",""},
{"_ton","Short ton (1 short ton = 2000 pounds)",""," 5_ton; mksa(_ton)",""},
{"_tonUK","Long (UK)",""," 5_tonUK; mksa(_tonUK)",""},
{"_torr","Torr (mmHg)",""," 5_torr; mksa(_torr)",""},
{"_tr","tour=2*pi _rad.",""," 5_tr; mksa(_tr)",""},
{"_tsp","Teaspoon",""," 5_tsp; mksa(_tsp)",""},
{"_twopi_","","","",""},
{"_u","Atomic mass unit",""," 5_u; mksa(_u)",""},
{"_yd","International yard",""," 5_yd; mksa(_yd)",""},
{"_yd^2","Square yard.",""," 5_yd^2; mksa(_yd^2)",""},
{"_yd^3","Cubic yard.",""," 5_yd^3; mksa(_yd^3)",""},
{"_yr","Year",""," 5_yr; mksa(_yr)",""},
{"_µ","Micron",""," 5_µ; mksa(_µ)",""},
{"_Âµ","","","",""},
{"a2q","a2q(A,X)=the quadratic form q associated to A, X=vector of variables.","","a2q([[1,2],[4,4]],[x,y]);a2q([[1,3],[3,4]],[x,y])","q2a"},
{"abcuv","Returns [u,v] such as au+bv=c for 3 polynomials a,b,c.","","abcuv(x^2+2*x+1,x^2-1,x+1);abcuv(X^2+2*X+1,X^2-1,X+1,X);abcuv(x^2+2*x+1,x^2-1,x^3+1);abcuv(X^2+2*X+1,X^2-1,X^3+1,X);abcuv([1,2,1],[1,0,-1],[1,0,0,1])","egcd,iabcuv"},
{"about","Returns the hypothesis made with assume on the variable a.","","about(a);about(n)","assume,purge"},
{"abs","Returns the absolute value or the norm of its argument.","","abs(-4);abs(1+2*i);abs((1+2*i)^2);abs([-2,1+i,-4])","arg"},
{"abscissa","Returns the abscissa of a point or a vector.","","abscissa(point(1+2*i));abscissa(point(i)-point(1+2*i));abscissa(-1-i);abscissa(point(1,2,3))","ordinate,affix,cote,coordinates"},
{"accumulate_head_tail","Returns the list where the first p and the last q elements of l are replaced by their sum.","","accumulate_head_tail([0,1,2,3,4,5,6,7,8,9],3,2)",""},
{"acos","Arccosine","","acos(0)","cos,acosh"},
{"acos2asin","Replaces arccos(x) by pi/2-arcsin(x) in the argument.","","acos2asin(acos(x)+asin(x));acos2asin(2*acos(x))","acos2atan"},
{"acos2atan","Replaces arccos(x) by pi/2-arctan(x/sqrt(1-x^2)) in the argument.","","acos2atan(2*acos(x));acos2atan(acos(sqrt(1-x^2))+acos(x))","acos2asin"},
{"acosh","Hyperbolic arccosine.","","acosh(1)","cosh,acos"},
{"acot","Arccotangent.","","acot(0)","atan,arccos"},
{"acsc","Arccosecant: acsc(x)=asin(1/x).","","acsc(1);acsc(2)","asin,csc"},
{"acyclic","Option for the random_network command.","Opt","","random_network"},
{"add","Python (linalg): add 2 matrices. Xcas: Discrete sum (with 2 or 4 arguments return then sum from a to b if a<=b or of the opposite of the sum from b+1 to a-1 if a>b+1 or 0 if a=b+1) or the discrete primitive or sum of the elements of a list or a sequence.","Expr,Var,VarMin(a),VarMax(b),[VarStep(p)]","add([1,2],[3,4]);add([[1,2],[3,4]],[[5,6],[7,8]])","+"},
{"add_arc","Returns a modified copy of digraph G with added arc e (or trail T or list of arcs E).","Graph(G),Edge(e)||Trail(T)||Lst(E)","add_arc(digraph(trail(1,2,3,4,5,1)),[[1,3],[2,4]])","add_edge,delete_arc,digraph,edges,has_arc,trail"},
{"add_edge","Returns a modified copy of undirected graph G with added edge e (or trail T or list of edges E).","Graph(G),Edge(e)||Trail(T)||Lst(E)","add_edge(graph(trail(1,2,3,4)),[4,1])","add_arc,delete_edge,edges,graph,has_edge,trail"},
{"add_vertex","Returns a modified copy of G with added vertex v [or vertices from list V].","Graph(G),Vrtx(v)||Lst(V)","add_vertex(cycle_graph(5),[\"a\",\"b\"])","add_arc,add_edge,delete_vertex"},
{"additionally","Make an additionally assumption on a variable.",""," assume(n,integer);additionally(n>5); assume(n,integer);assume(n>=2,additionally)","purge,about,assume"},
{"adjacency_matrix","Returns the adjacency matrix of G (rows and columns are indexed by the vertices).","Graph(G)","adjacency_matrix(graph(trail(1,2,3,4,2,5,1,3)))","neighbors"},
{"adjoint_matrix","Returns the characteristic polynomial of A and the comatrix of A-xI.","","adjoint_matrix([[1,i],[2,3]])","pcar"},
{"affix","Complex number equal to the affix of a point or of a vector.","","affix(point(i));affix(point(i)-point(1+2*i));affix([1,2])","point,vector"},
{"algsubs","Substitutes in the expression Xpr, the algebraic expression Xpr1 by the algebraic expression Xpr2.","","algsubs(x^2=u,1+x^2+x^4);algsubs(a*b/c=d, 2*a*b^2/c);algsubs(2a=p^2-q^2,algsubs(2c=p^2+q^2,c^2-a^2))","subst,subs"},
{"algvar","List of the variables by ascending algebraic extension order.","","algvar(sqrt(x)+y)","lvar,lname"},
{"all_trig_solutions","Pseudo-variable to return the general solution (all_trig_solutions:=1) or principal solution (all_trig_solutions:=0).",":=Intg(0 or 1)"," all_trig_solutions:=1; all_trig_solutions:=0","cas_setup"},
{"allpairs_distance","Returns a square matrix D of order equal to the number of vertices in G such that D(i,j) is the distance between i-th and j-th vertex of the (weighted) graph G.","Graph(G)","allpairs_distance(graph(%{[1,2],[1,3],[1,4],[1,5],[2,3],[3,4],[4,5],[5,2]%}))","dijkstra,graph_diameter,vertex_distance"},
{"alog10","Function x->10^x.","","alog10(3)","log10"},
{"alors","Conditional instruction : (si...alors...sinon...fsi).",""," si alors sinon fsi; n:=1; si n>0 alors triangle_plein(20*n); sinon disque(20*n);fsi;; n:=-1; si n>0 alors triangle_plein(20*n); sinon disque(20*n);fsi;; si x>0 alors x:=x+1; print(\"x est strictement plus grand que 1\");fsi;; si x>0 alors x:=x+1; print(\"x est strictement plus grand que 1\"); sinon x:=x-1;print(\"x est plus petit ou égal à -1\");fsi;","if"},
{"altitude","altitude(A,B,C) draws the altitude through A of the triangle ABC","","altitude(-1,1-i,i)","perpendicular,orthogonal,orthocenter,common_perpendicular"},
{"and","infixed boolean operator (and).",""," 1==2 and 2>1; 1!=2 and 2>0","or,not,xor"},
{"angle","angle(A,B,C) is the value of the measure of the angle (AB,AC).","","angle(point(0),point(i),point(1));angle(0,1,i);angle(0,1,i,\"\");angle(0,1,i,\"a\");angle(i,1,1+i,\"b\")","triangle,bissector,legend,labels,angleat,angleatraw"},
{"angle_radian","Pseudo-variable to work with radian (angle_radian:=1) or degree (angle_radian:=0).",""," angle_radian:=1; angle_radian:=0","cas_setup"},
{"angleat","angleat(A,B,C,z0) displays at point(z0) with a legend, the value of the measure of the angle (AB,AC).",""," A:=point(0);B:=point(1);C:=point(i);angleat(A,B,C,-2-i)","angle,angleatraw,legend"},
{"angleatraw","angleatraw(A,B,C,z0) displays at point(z0), the value of the measure of the angle (AB,AC).",""," A:=point(0);B:=point(1);C:=point(i);angleatraw(A,B,C,-2-i)","angle,angleat"},
{"animate","Animates a plot of Xpr, depending of x, parameter t by calling plot.","","animate(sin(x*t),x=-pi..pi,t=-3..3,frames=30)","plot,animate3d,animation"},
{"animate3d","Animate a plot of Xpr, depending of [x,y], parameter t by calling plotfunc.","","animate3d(x^2+t*y^2,[x=-2..2,y=-2..2],t=-3..3,frames=10)","plotfunc,animate,animation"},
{"animation","Draws in a loop each object of a geometric object sequence.","","animation(seq(plotfunc([cos(a*t),sin(a*t)],t=0..2*pi/a),a,1,12,0.3));animation(seq(plotparam([sin(t),sin(a*t)],t,0,2*pi,tstep=0.01),a,1,10,0.2));animation(seq(line([0,0,0],[1,1,a]),a,-5,5,0.5));animation(seq(plotfunc(x^2-y^a,[x,y]),a=1..3));animation(seq(plotfunc((x+i*y)^a,[x,y],display=filled),a=1..10)); plotfunc(x^2);animation([point(1),segment(1,1+i),point(1+i)],droite(y=2*x-1))","animate,animate3d"},
{"ans","Returns the n+1-th answer of the command history if n>=0 or, the (-n)th previous answer if n<0 (by defaults n=-1 for the previous answer).","","ans();ans(2);ans(-2)","quest"},
{"antiprism_graph","Returns the antiprism graph of order n.","Intg(n)","antiprism_graph(5)","prism_graph"},
{"append","Append an element to a set or at the end of a list or of a string (L:=append(L,a) o L.append(a)).","","L:=[1,2,4] ;L.append(6);append([1,2,4],6);append(%{1,2,4%},6); L:=[1,2,4];L:=append(L,6);  S:=set[1,2,4];S:=append(S,6); S:=set[1,2,4];S.append(6)","concat,prepend"},
{"apply","Apply the function f at the elements of the list l (option matrix for a matrix). linalg module command in Python","","apply(lambda x:x**2,[1,2,3]);apply(lambda x:return x+1,[[1,2,3],[1,2,3]],matrix)","map,unapply,matrix"},
{"approx","Numerical evaluation of the first argument (we can give the number of digits as second argument)","Expr,[Int]","evalf(2/3);evalf(2/3,2);evalf(2*sin(1));evalf(2*sin(1),40);evalf(sqrt(2)+pi);evalf(sqrt(2)+pi,30)","evalb,eval"},
{"approx_mode","Pseudo-variable to work in approximative mode (approx_mode:=1) or in exact mode (approx_mode:=0).",""," approx_mode:=1; approx_mode:=0","cas_setup"},
{"arange","arange(a,b,p) returns the list [a,a+p,...,a+n*p] where a+n*p<b and a+n*p+b>=b","Real(a),Real(b),[Real(p)]","arange(1,2,0.1)","range,makelist,seq"},
{"arc","Draws a circle arc given by 2 vertices and the angle at center [Xcas will put the center in C and the radius in r].","","arc(0,1,pi/4);arc(i,1,pi/4,C,r);arc(i,1,pi/4,segment);arc(i,1,pi/4,segment,affichage=1+rempli)","circle,segment,plotparam"},
{"arcLen","Returns the length of the arc of the curve defined by y=Xpr(or by x=Xpr1,y=Xpr2) when the parameter values are between a and b.","","arcLen(t^2,t,1,2);arcLen([t,t^2],t,1,2);arcLen([cos(t),sin(t)],t,1,2)","int"},
{"arccos","Arccosine","Expr","acos(0)","cos,acosh"},
{"arccosh","Hyperbolic arccosine.","Expr","acosh(1)","cosh,acos"},
{"archive","Archive the value of a variable or of a list of variables given as argument in the specified file (legible with unarchive).","","archive(\"toto\",[a,b]);archive(\"aa.txt\",aa)","unarchive,Archive,Unarchiv"},
{"arclen","Returns the length of the arc of the curve defined by y=Xpr(or by x=Xpr1,y=Xpr2) when the parameter values are between a and b.","Expr(Xpr) or Lst([Xpr1,Xpr2]),Var,Real(a),Real(b)","arcLen(t^2,t,1,2);arcLen([t,t^2],t,1,2);arcLen([cos(t),sin(t)],t,1,2)","int"},
{"arcsin","Arcsine.","Expr","asin(0)","sin"},
{"arcsinh","Hyperbolic arcsine.","Expr","asinh(0)","sinh,asin"},
{"arctan","Arctangent.","Expr","atan(0)","tan,atanh"},
{"arctanh","Hyperbolic arctangent.","Expr","atanh(0)","atan,tanh"},
{"area","Algebraic area of a circle, a circle arc or of a (star) polygon (e.g. triangle, square, ...)or of the area below a curve, optionally with a quadrature method (trapezoid,left_rectangle,right_rectangle,middle_point,simpson,rombergt,rombergm).","","area(triangle(0,1,i));area(square(0,2));area(circle(0,2));area(0,1,i);area(x^2,x=0..1,5,trapezoid);area(x^2,x=0..1,5,simpson);area(x^2,x=0..1,5,rombergm)","trapezoid,perimeter,areaatraw,areaat,areaplot"},
{"areaat","Displays at point(z0), with a legend, algebraic area of a circle or of a (star) polygon (e.g. triangle, square, ...)",""," t:=triangle(0,1,i);areaat(t,(1+i)/2); c:=square(0,2);areaat(c,1+i); c2:=circle(0,2);areaat(c2,1+i); p:=polygon(0,1,i);areaat(p,1+i); A:=point(0);B:=point(1+i);c:=carre(A,B);areaat(c,i)","area,areaatraw,polygon,perimeteratraw,areaplot"},
{"areaatraw","Displays at point(z0), algebraic area of a circle or of a (star-)polygon (e.g. triangle, square, ...)","","areaatraw(triangle(0,1,i),(1+i)/2);areaatraw(square(0,2),1+i);areaatraw(circle(0,2),1+i);areaatraw(polygon(0,1,i),1+i); A:=point(0);B:=point(1+i);c:=carre(A,B);areaatraw(c,i)","area,areaat,polygon,perimeteratraw,areaplot"},
{"areaplot","Displays the area below a curve, optionally with a quadrature method (trapezoid,left_rectangle,right_rectangle,middle_point).","Expr,x=a..b,[n],[Method]","plotarea(sin(x),x=0..pi);plotarea(x^2,x=0..1,5,trapezoid);plotarea(x^2,x=0..1,5,middle_point)","integrate,plot,area,areaat,areaatraw"},
{"arg","Returns the argument of a complex number.","","arg(1+i);arg(1+2*i);arg((1+2*i)^2)","abs"},
{"args","Inside a program args(NULL) is the list of the function and its arguments.",""," f(a,b):={local y; y:=args(NULL); print(y); return a+b;};f(12,5)",""},
{"array","Python: vector/matrices class (numpy). Xcas: convert option to define a sparse matrix","","m=array([[1,2],[3,4]]); A[0..2,0..2]:=1 ;A[0..1,1..2]:=2 ;convert(A,array);","convert,table"},
{"arrivals","Returns the list of vertices in digraph G which are connected by v with arcs such that heads are in v. If v is omitted, a list of arrivals is computed for every vertex in G.","Graph(G),[Vrtx(v)]","arrivals(digraph(%{[1,2],[1,3],[2,3]%}),1)","in_degree"},
{"arrow","Display from point x,y a vector dx,dy","","arrow(1,2,2,3);arrow(0,0,2,3)","coordinates,segment"},
{"articulation_points","Returns the list of articulation points (cut vertices) of G.","Graph(G)","articulation_points(path_graph(5));articulation_points(cycle_graph(5))","biconnected_components,is_biconnected,is_connected,is_triconnected"},
{"as_function_of","Returns an element defined as a function of an element previously defined.","","as_function_of(b,a)","locus"},
{"asc","Returns the list of the ASCII codes of a string.","","asc(\"bonjour\");asc(\"A\")","char,ord"},
{"asec","Arcsecant: asec(x)=acos(1/x).","","asec(1);asec(2)","acos,sec"},
{"asin","Arcsine.","","asin(0)","sin"},
{"asin2acos","Replaces arcsin(x) by pi/2-arccos(x) in the argument.","","asin2acos(acos(x)+asin(x));asin2acos(2*asin(x))","asin2atan"},
{"asin2atan","Replaces arcsin(x) by arctan(x/sqrt(1-x^2)) in the argument.","","asin2atan(2*asin(x));asin2atan(asin(sqrt(1-x^2))+asin(x))","asin2acos"},
{"asinh","Hyperbolic arcsine.","","asinh(0)","sinh,asin"},
{"assert","Instruction in a program, returns an error if b==false.","Boolean(b)","assert(a>0);","break"},
{"assign","Store the second argument (of the equality) in the variable given as first argument (of the equality) (Maple compatibility).","","assign(a,2);assign(a=2);assign([a1=1,a2=2,a3=3])","sto,:="},
{"assign_edge_weights","Assigns random edge weights to the edges of G and returns a modified copy of G. If integers n and m such that n>=m are specified, weights are integers randomly chosen in [m,n]. If an interval a..b is specified, weights are uniformly distributed in the interval [a,b).","Graph(G),Seq(m,n)||Intrv(a..b)","assign_edge_weights(digraph(trail(1,2,3,4,1)),1,9);assign_edge_weights(digraph(trail(1,2,3,4,1)),0..1)","set_edge_weight,get_edge_weight,weight_matrix,random_digraph,random_tournament"},
{"assume","Make an assumption on a variable.","","assume(a>0);assume(a=0.3);assume(a:=[pi/4,0,pi/2]);assume(a:=[pi/4,0,pi/2,0.1]);assume(n,integer);;assume(n,integer);additionally(n>6);assume(a>-10 and a<10);assume((a>=2 and a<4) or a>6);assume(a>=2);additionally(a<6);assume(a)","purge,about,additionally"},
{"at","at(l,j) (or at(m,[j,k])) is the element of the list l (or matrix m) for index=j (or for index j,k).","","at([10,11,12],1);at([[1,2],[3,4]],[1,0])","of"},
{"atan","Arctangent.","","atan(0)","tan,atanh"},
{"atan2acos","Replaces arctan(x) by pi/2-arccos(x/sqrt(1+x^2)) in the argument.","","","atan2acos(atan(x))"},
{"atan2asin","Replaces arctan(x) by arcsin(x/sqrt(1+x^2))in the argument.","","","atan2asin(atan(x))"},
{"atanh","Hyperbolic arctangent.","","atanh(0)","atan,tanh"},
{"atrig2ln","Rewrites the expression containing inverse trigonometric functions with logarithmic functions.","","atrig2ln(atan(x));atrig2ln(asin(x));atrig2ln(acos(x))","trig2exp,exp2trig"},
{"augment","Concatenates two lists or two strings or two sequences or 2 matrix; L:=concat(L,L1) or L.concat(L1).","Lst,Lst||Seq,Seq||Str,Str||Mtrx,Mtrx","concat([1,2],[3,4,5]);concat(\"bon\",\"jour\");concat([[1,2],[3,4]],[[4,5,6],[6,7,8]]); L:=[1,2];L.concat([3,4,5]); S:=\"abcd\";S.concat(\"efghi\")","append,cat,semi_augment,border,+"},
{"auto_correlation","Returns the cross-correlation of the given signal with itself.","Lst","auto_correlation([1,-1,0,2,1])","cross_correlation,correlation"},
{"autosimplify","The argument is a command that Xcas will use to rewrite answers (initial value is regroup and for no simplification it is nop or 0).","","autosimplify(nop);autosimplify(0);autosimplify(regroup);autosimplify(1);autosimplify(factor);autosimplify(simplify)","simplify,factor,regroup"},
{"avance","The turtle takes n steps forward (by default n=10).","","forward(30);avance(30)","recule,saute"},
{"avgRC","Returns (Xpr(var+h)-Xpr(Var))/h (by default h=0.001).","","avgRC(f(x),x,h);avgRC(x^2,x,0.1);avgRC(x^2,x)","nDeriv"},
{"axes","Global option (Maple compatibility) of a graphic command to put or not the axes.",""," axes=0;segment(0,point(1,1)); axes=1;segment(0,point(1,1),epaisseur=5)","line_width,gl_showaxes,switch_axes"},
{"back","Returns the last element of a vector or a sequence or a string.","","back(1,2,3);back([1,2,3]);back(\"bonjour\")","inter,head,mid,left,right"},
{"backquote","``","","","quote"},
{"backward","The turtle takes n steps back (by default n=10).","NULL or Real(n)","backward(30);recule(30)","avance,saute"},
{"baisse_crayon","Puts the pencil down so that the turtle move with traces.","","baisse_crayon()","leve_crayon,crayon"},
{"bandwidth","Option for the kernel_density command.","Opt","","kernel_density,bins"},
{"barplot","Draws barplot of a one variable statistical series.","","barplot([3/2,2/3,5/4,4/5,7/6,6/7,9/8,8/9,11/10]);barplot([[\"France\",6],[\"Allemagne\",12],[\"Suisse\",5]]);barplot([[2,\"xyz\",\"abc\"],[\"A\",2,5],[\"B\",5,6],[\"C\",7,7]])","camembert,histogram,frequencies"},
{"bartlett_hann_window","Applies the Bartlett-Hann windowing function to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Interval(n1..n2)]"," scatterplot(bartlett_hann_window(randvector(1000,0..1)))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"barycenter","barycenter([point1,coeff1],...) draws the barycenter of point1 with weight coeff1...","","barycenter([point(-1),1],[point(1+i),2],[point(1-i),1]);barycenter([[point(-1),1],[point(1+i),2],[point(1-i),1]]);barycenter([point(-1),point(1+i),point(1-i)],[1,2,1])","isobarycenter,midpoint"},
{"base","Option for convert : convert(p,base,b)= [a0,a1,..an] or convert([a0,a1,..an],base,b)=p with p=a0+a1*b+....an*b^(n-1).",""," convert(123,base,8); convert([3,7,1],base,8); horner(revlist([3,7,1]),8)","convert,horner,revlist"},
{"basis","Extract a basis from a spanning set of vectors.","","basis([[1,2,3],[4,5,6],[7,8,9],[10,11,12]])","ker,ibasis"},
{"batons","Draws for k=0..nrows, the segments (xk,0)-(xk,yk) where xk=element row k column 0 and yk=element row k column j (j=1..ncols).","","batons([1,3],[2,5],[3,2]);batons([[1,3],[2,5],[3,2]]);batons([1,2,3],[3,5,2])","polygonplot,scatterplot,listplot"},
{"begin","Bloc begin.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end","end,bloc,{}"},
{"bellman_ford","Returns the length of the shortest path resp. paths from s to vertex t resp. vertices in T in weighted graph G.","Graph(G),Vrtx(s),Vrtx(t)||Lst(T)","bellman_ford(graph(%{[[1,2],-1],[[2,3],-3],[[3,4],-7],[[4,5],-3],[[5,6],-3],[[1,6],-3]%}),1,4)","dijkstra,shortest_path"},
{"bernoulli","bernoulli(n) is the n-th number of Bernoulli and bernoulli(n,x) is the n-th polynomial of Bernoulli and the second argument is the variable.","","bernoulli(6);bernoulli(6,x)",""},
{"besselJ","besselJ(x,p) returns the Bessel function of first kind Jp(x).","","besselJ(sqrt(2),2);besselJ(sqrt(2),-2)","BesselJ,BesselY,besselY"},
{"besselY","besselY(x,p) returns the Bessel function of second kind Yp(x).","","besselY(sqrt(2),2);besselY(sqrt(2),-2)","BesselY,BesselJ,besselJ"},
{"betad","Returns the density of probability of the Beta law (=Gamma(a+b)*x^(a-1)*(1-x)^(b-1)/(Gamma(a)*Gamma(b))).","","betad(2.2,1.5,0.8)","betad_cdf,betad_icdf"},
{"betad_cdf","Returns the probability that a Beta random variable (with a and b as parameters) is lower than x0 or between x0 and y0.","","betad_cdf(2,1,0.2);betad_cdf(2,1,0.1,0.3)","betad,betad_icdf"},
{"betad_icdf","Returns h such that the probability that a Beta random variable is lower than h is p (0<=p<=1).","","betad_icdf(2,1,0.95);betad_icdf(2,1,0.5)","betad_cdf,betad"},
{"betavariate","Returns a random real according to the Beta distribution of parameter a>0 and b>0","Real(a),Real(b)","randbetad(1,2);randbetad(1.5,4)","rand,randpoly,randnorm,randvector"},
{"bezier","Bezier curve defined by control points.","","bezier(1,1+i,2+i,3-i,plot);bezier(point([0,0,0]),point([1,1,0]),point([0,1,1]),plot); parameq(bezier(1,1+i,2+i,3-i)); parameq(bezier(point([0,0,0]),point([1,1,0]),point([0,1,1])))","parameq"},
{"bezout_entiers","Extended greatest common divisor of 2 integers.","Intg,Intg","iegcd(45,75);iegcd(21,28);iegcd(30,49)","gcd,iabcuv,egcd"},
{"biconnected_components","Returns the biconnected components of G as a list of lists of vertices.","Graph(G)","biconnected_components(graph(trail(1,2,3,4,2),trail(4,5,6,7,5)))","articulation_points,is_biconnected,is_connected,trail"},
{"binomial","Returns comb(n,k)*p^k*(1-p)^(n-k) or comb(n,k) if no 3rd argument.","","binomial(4,2);binomial(4,0,0.5);binomial(4,2,0.5); assume(p>=0 and p<=1);binomial(4,2,p); assume(p>=0 and p<=1);binomial(4,p,2); randvector(6,binomial,4,0.2); ranm(4,6,binomial,4,0.7)","binomial_cdf,binomial_icdf,multinomial,randvector,ranm"},
{"binomial_cdf","Returns Proba(X<=x) or Proba(x<=X<=y) when X follows the B(n,p) law.","","binomial_cdf(4,0.5,2);binomial_cdf(4,0.1,2);binomial_cdf(4,0.5,2,3)","binomial,binomial_icdf"},
{"binomial_icdf","Returns h such as Proba(X<=h)=t when X follows the B(n,p) law.","","binomial_icdf(4,0.5,0.68);binomial_icdf(4,0.1,0.95)","binomial,binomial_cdf"},
{"bins","Option for the kernel_density command.","Opt","","kernel_density,bandwidth"},
{"bipartite","Option for the draw_graph command","Opt","","draw_graph"},
{"bipartite_matching","Returns the list of edges in a maximum matching of the undirected unweighted bipartite graph G.","Graph(G)","bipartite_matching(graph(\"desargues\"))","is_bipartite,maximum_matching"},
{"bisection_solver","Argument for fsolve giving the method for solving an numerical equation.",""," fsolve(cos(x)=x,x,0..1,bisection_solver); fsolve(cos(x)=x,x,0..1,brent_solver); fsolve(cos(x)=x,x,0..1,falsepos_solver); fsolve(cos(x)=x,x,0,newton_solver); fsolve(cos(x)=x,x,0,secant_solver); fsolve(cos(x)=x,x,0,steffenson_solver)","fsolve"},
{"bisector","Draws the bisector of the angle (AB,AC) given by 3 points A,B,C.","","bisector(0,1,i)","angle,exbisector"},
{"bit_depth","Returns the bit depth of an audio clip.","Lst(clip)","bit_depth(readwav(\"/some/file\"))","channels,channel_data,duration,samplerate"},
{"bitand","Logical bit and.","","bitand(0x12,0x38)","bitxor,bitor"},
{"bitor","Inclusive logical bit or.","","bitor(0x12,0x38)","bitxor,bitand"},
{"bitxor","Exclusive logical bit or.","","bitxor(0x12,0x38)","bitor,bitand"},
{"black","Option of the display command to display with color.","Opt"," F:=display(point(2+1.5*i),red); F:=display(point(2+1.5*i),point_point+green)","display"},
{"blackman_harris_window","Applies the Blackman-Harris windowing function to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Interval(n1..n2)]"," scatterplot(blackman_harris_window(randvector(1000,0..1)))","bartlett_hann_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"blackman_window","Applies the Blackman windowing function with parameter a (by default a=0.16) to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Real(a)],[Interval(n1..n2)]"," scatterplot(blackman_window(randvector(1000,0..1)))","blackman_harris_window,bartlett_harris_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"bloc","Reserved word.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end; if (2>1) {print(\"ifactor(154)=\",ifactor(154));ifactor(154);}","begin,end,{}"},
{"blockmatrix","Returns the matrix get from the list divided into n lists of dimension m.","","blockmatrix(2,3,[idn(2),idn(2),idn(2),idn(2),idn(2),idn(2)]);blockmatrix(2,2,[idn(2),newMat(2,3),newMat(3,2),idn(3)])","list2mat"},
{"blue","Option of the display command to display with color.","Opt"," F:=display(point(2+1.5*i),red); F:=display(point(2+1.5*i),point_point+green)","display"},
{"bohman_window","Applies the Bohman windowing function to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Interval(n1..n2)]"," scatterplot(bohman_window(randvector(1000,0..1)))","blackman_harris_window,blackman_window,bartlett_hann_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"border","Returns the matrix obtained by bording A with b as latest column, if nrows(A)=size(b), border(A,b)=tran(append(tran(A),b)).","","border([[1,2,3,4],[4,5,6,8],[7,8,9,10]],[1,3,5]);border([[1,2,3],[4,5,6],[7,8,9]],[1,0,1])","tran,append,augment"},
{"boxwhisker","Box and Whisker plot for a statistical series.","","boxwhisker([-1,1,2,2.2,3,4,-2,5]);boxwhisker([1,2,3,5,10,4],x=1..2);boxwhisker([1,2,3,5,10,4],[1,2,3,1,2,3]);boxwhisker([[6,0,1,3,4,2,5],[0,1,3,4,2,5,6],[1,3,4,2,5,6,0],[3,4,2,5,6,0,1],[4,2,5,6,0,1,3],[2,5,6,0,1,3,4]])","quartiles"},
{"break","Interrupts a loop: while (cond) {inst1; if (cond) {inst2;break;}}.","","  f(a,b):={local r;while (1==1){if (b==0){break;} r:=irem(a,b);a:=b;b:=r;}a;}","continue"},
{"breakpoint","Adds a breakpoint.","","breakpoint(1)","rmbreakpoint"},
{"brent_solver","Argument for fsolve giving the method for solving an numerical equation.","Opt"," fsolve(cos(x)=x,x,0..1,bisection_solver); fsolve(cos(x)=x,x,0..1,brent_solver); fsolve(cos(x)=x,x,0..1,falsepos_solver); fsolve(cos(x)=x,x,0,newton_solver); fsolve(cos(x)=x,x,0,secant_solver); fsolve(cos(x)=x,x,0,steffenson_solver)","fsolve"},
{"bvpsolve","Returns an approximation of the function y (and optionally of y') on the interval a..b.","Expr(f(x,y,y')),Lst(x=a..b,y),Lst(y(a),y(b),[y'(1)]),[options]","bvpsolve((32+2x^3-y*diff(y(x),x))/8,[x=1..3,y],[17,43/3],20);bvpsolve((x^2*diff(y(x),x)^2-9y^2+4x^6)/x^5,[x=1..2,y],[0,ln(256),1],10,output=spline)","odesolve"},
{"by","Step in an iteration (step size of incrementation).",""," s:=0;for j from 1 to 10 step 2 do s:=s+j end_for; s:=0;for j from 1 step 2 to 10 do s:=s+j end_for; s:=0;for j from 1 to 10 by 2 do s:=s+j end_for; s:=0;for j from 1 by 2 to 10 do s:=s+j end_for; s:=0;pour j de 1 jusque 10 pas 2 do s:=s+j fpour; s:=0;pour j de 1 pas 2 jusque 10 do s:=s+j fpour","for,pour"},
{"c1oc2","Returns the permutation product of the two cycles.","","c1oc2([3,4,5],[0,3])","c1op2,p1oc2"},
{"c1op2","Returns the permutation product of the cycle and the permutation.","","c1op2([3,4,5],[0,3,2,1,5,4])","c1oc2,p1oc2"},
{"cFactor","Factorization of the expression in ℂ (on the Gauss integers if there are more than 2 variables).","","cFactor(x^2*y+y);cFactor(x^2*y^2+y^2+4*x^2+4);cFactor(x^2*y^2+y^2+2*x^2+2)","factor"},
{"cSolve","Returns the list of complex solutions of an equation or a matrix where the rows are ℂ-solutions of a system of polynomial equations.","LstEq,LstVar","csolve(x^4-1,x);csolve(x^4-y^4 and x+y=2,[x,y]);csolve(x^4-y^4 and x+y=0 and x^2=2*x,[x,y]);csolve(u*v-u=v and v^2=u,[u,v])","cZeros,solve,fslove"},
{"cZeros","Returns the list of complex elements solution of Xpr=0 or the matrix where the lines are the solutions of the system : Xpr1=0,Xpr2=0...","","cZeros(x^2-1);cZeros([x^2-1,x^2-y^2],[x,y])","solve"},
{"cache_tortue","Hides the turtle.","","cache_tortue()","montre_tortue"},
{"camembert","Draws pie chart of a one variable statistical serie.","","camembert([[\"France\",6],[\"Allemagne\",12],[\"Suisse\",5]]);camembert([3/2,2/3,5/4,4/5,7/6,6/7,9/8,8/9,11/10]);camembert([[2,\"xyz\",\"abc\"],[\"A\",2,5],[\"B\",5,6],[\"C\",7,7]])","bar_plot"},
{"canonical_form","Canonical_form of a 2 degree polynomial.","","canonical_form(2*x^2-12*x+1);canonical_form(2*a^2-12*a+1,a)",""},
{"canonical_labeling","Returns the permutation representing the canonical labeling of G.","Graph(G)","canonical_labeling(graph(\"petersen\"))","isomorphic_copy,relabel_vertices"},
{"cap","Returns the turtle cap in degrees or turns the turtle with the cap given by the argument.",""," cap;cap();cap 90","position,initialise"},
{"cap_flat_line","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"cap_round_line","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"cap_square_line","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"cartesian_product","Returns the Cartesian product of graphs G1, G2, ... with vertices labelled as \"u:v:...\" where u, v, ... are vertices from G1, G2, ..., respectively.","Seq(G1,G2,..)","cartesian_product(graph(trail(1,2,3,4,5,2)),star_graph(3))","tensor_product"},
{"cas_setup","Is the command for initialized the cas, arguments: Approx,Cplx_var,Cplx,Angle,Format,Epsilon,Digit","","cas_setup(0,0,0,1,0,1e-10,12)","complexe_mode,angle_radian"},
{"case","Test (multiple choice): switch(variable){case 1: {bloc1;} default: {bloc2;}};",""," a:=1;switch(a){case 0:{b:=1;break;} case 1:{b:=3;break;} default:{b:=0;}};b;","if,switch,default"},
{"caseval","Evaluates a string using the CAS.","","caseval(\"factor(x^4-1)\")","concat"},
{"cat","Evaluates the arguments, then concatenates them into a string.","","cat(\"aaa\",c,12*3)","concat"},
{"catch","Error protection: try {instructions} catch(variable) {error_instructions}(in a program).",""," essai(x):={local y,err;try {y:=[[1,2]]*x;}catch(err){y:=\"erreur fatale :\"+err;} return y;};essai([1,2,3])","try"},
{"cauchy","Returns the density of probability at x of the Cauchy law of parameters x0 and a (by default  x0=0 and a=1).","","cauchy(0.0,2.0,1.0)","cauchy_cdf,cauchy_icdf"},
{"cauchy_cdf","Returns the probability that a Cauchy random variable is lower than x.","","cauchy_cdf(0.0,2.0,2.1);cauchy_cdf(2,3,-1.9,1.4)","cauchyd,cauchy_icdf"},
{"cauchy_icdf","Returns h such that the probability that a Cauchy random variable is lower than h is p (0<=p<=1).","","cauchy_icdf(0.0,2.0,0.95)","cauchy_cdf,cauchy"},
{"cauchyd","Returns the density of probability at x of the Cauchy law of parameters x0 and a (by default  x0=0 and a=1).","Real(x0),Real(a),Real(x)","cauchy(0.0,2.0,1.0)","cauchy_cdf,cauchy_icdf"},
{"cauchyd_cdf","Returns the probability that a Cauchy random variable is lower than x.","Real(x0),Real(a),Real(x),[Real(y)]","cauchy_cdf(0.0,2.0,2.1);cauchy_cdf(2,3,-1.9,1.4)","cauchyd,cauchy_icdf"},
{"cauchyd_icdf","Returns h such that the probability that a Cauchy random variable is lower than h is p (0<=p<=1).","Real(x0),Real(a),Real(p)","cauchy_icdf(0.0,2.0,0.95)","cauchy_cdf,cauchy"},
{"cd","Change directory.","","cd(\"toto\")","pwd"},
{"cdf","Cumulated distribution function.","","cdf(binomial,10,0.5,4);cdf(normald,0.0,1.0,2.0);cdf([1,3,4,3,5,6],4);cdf([1,3,4,3,5,6],plot)","icdf,binomial_cdf,normald_cdf,plotcdf"},
{"ceil","Returns the smallest integer >= to the argument.","","ceil(-4.2);ceil(4.3+2.4*i)","floor,round"},
{"ceiling","Returns the smallest integer >= to the argument.","Real or Cplx","ceil(-4.2);ceil(4.3+2.4*i)","floor,round"},
{"center","Shows the center of a circle.","","center(circle(1+i,2));center(circumcircle(0,1,1+i))","circle,radius"},
{"center2interval","Returns the list of intervals beginning with a0 and with l as centers.","","center2interval([2,5,9],1);center2interval([2,5,8])","interval2center"},
{"centered_cube","Draws the direct cube with center A, vertex B and such that the plane ABC contains a symmetry axis of the cube.","","centered_cube([0,0,0],[3,0,0],[0,0,1]);centered_cube(evalf([0,0,0],[3,2,4],[1,1,0]))","parallelepiped,cube,icosahedron,dodecahedron,octahedron,centered_tetrahedron"},
{"centered_tetrahedron","Draws the regular direct pyramid with center A, vertex B and a vertex in the plan (A,B,C).","","centered_tetrahedron([0,0,0],[3,0,0],[0,1,0]);centered_tetrahedron(evalf([0,0,0],[3,2,4],[1,1,0]))","cube,tetrahedron,icosahedron,dodecahedron,octahedron"},
{"cfactor","Factorization of the expression in ℂ (on the Gauss integers if there are more than 2 variables).","Expr","cFactor(x^2*y+y);cFactor(x^2*y^2+y^2+4*x^2+4);cFactor(x^2*y^2+y^2+2*x^2+2)","factor"},
{"cfsolve","Numerical solution of an equation or a system of equation on ℂ.","","cfsolve(cos(x)=2);cfsolve([x^2+y+2,x+y^2+2],[x,y])","fsolve,nSolve,csolve,solve"},
{"changebase","Returns the matrix B=inv(P)*A*P.","","changebase([[1,2],[1,3]],[[1,1],[0,1]]);changebase([[1,2],[1,3]],[[1,0],[1,1]])",""},
{"channel_data","Extracts the data from an audio clip (optionally specifying the channel and range).","Lst(clip),[Intg(chn) or matrix],[range=a..b]","channel_data(readwav(\"/some/file\"));channel_data(readwav(\"/some/file\"),matrix);channel_data(readwav(\"/some/file\"),2);channel_data(readwav(\"/some/file\"),matrix,range=1.0..2.5)","bit_depth,channels,duration,samplerate"},
{"channels","Returns the number of channels in audio clip.","Lst(clip)","channels(readwav(\"/some/file\"))","bit_depth,channel_data,duration,samplerate"},
{"char","Returns the string corresponding to the character code of the argument.","","char(65);char([65,66,67])","asc,ord"},
{"charpoly","List of the coefficients of the characteristic polynomial of a matrix or characteristic polynomial of a matrix with the second argument as variable.","Mtrx,[Var]","pcar([[1,2],[3,4]]);pcar([[1,2],[3,4]],x);pcar([[1,2,3],[1,3,6],[2,5,7]]);pcar([[1,2,3],[1,3,6],[2,5,7]],z)","jordan,egv,egvl,companion,rat_jordan,pmin,adjoint_matrix "},
{"chinrem","Chinese remainder for polynomials written as lists or no.","","chinrem([x+2,x^2+1],[x+1,x^2+x+1]);chinrem([[1,2],[1,0,1]],[[1,1],[1,1,1]])","ichinrem"},
{"chisquare","Returns the density of probability of the Chi^2 law at x0 (n is the number of degrees of freedom).","","chisquare(2,3.2);chisquare(4,10.5); randvector(3,chisquare,2); ranm(4,3,chisquare,2)","chisquare_cdf,chisquare_icdf,randvector,ranm"},
{"chisquare_cdf","Returns the probability that a Chi^2 random variable is lower than x0 (n is the number of degrees of freedom).","","chisquare_cdf(2,6.1);chisquare_cdf(4,6.1)","UTPC,chisquare_icdf,chisquared"},
{"chisquare_icdf","Returns h such as the probability that a Chi^2 random variable is lower than h is p (n is the number of degrees of freedom and 0<=p<=1).","","chisquare_icdf(2,0.95);chisquare_icdf(4,0.05)","chisquare_cdf,chisquared"},
{"chisquared","Returns the density of probability of the Chi^2 law at x0 (n is the number of degrees of freedom).","Intg(n),Real(x0)","chisquare(2,3.2);chisquare(4,10.5); randvector(3,chisquare,2); ranm(4,3,chisquare,2)","chisquare_cdf,chisquare_icdf,randvector,ranm"},
{"chisquared_cdf","Returns the probability that a Chi^2 random variable is lower than x0 (n is the number of degrees of freedom).","Intg(n),Real(x0)","chisquare_cdf(2,6.1);chisquare_cdf(4,6.1)","UTPC,chisquare_icdf,chisquared"},
{"chisquared_icdf","Returns h such as the probability that a Chi^2 random variable is lower than h is p (n is the number of degrees of freedom and 0<=p<=1).","Intg(n),Real(p)","chisquare_icdf(2,0.95);chisquare_icdf(4,0.05)","chisquare_cdf,chisquared"},
{"chisquaret","Chi^2 test : adequation between 2 (or n) samples or between 1 sample and a distribution law (multinomial or given by a law).","","chisquaret([57,54]);chisquaret([1,1,1,1,1,0,0,1,0,0,1,1,1,0,1,1,0,1,1,0,0,0,0],[.4,.6]);chisquaret([57,30],[.6,.4]);chisquaret([17,15,12,15],[15,13,13,14]);chisquaret(ranv(1000,binomial,10,.5),binomial);chisquaret(ranv(1000,binomial,10,.5),binomial,11,.5);chisquaret(ranv(1000,normald,0,.2),normald);chisquaret([11,16,17,22,14,10],[1/6,1/6,1/6,1/6,1/6,1/6]);chisquaret([11,16,17,22,14,10],[(1/6)$6])","normalt,studentt,kolmogorovt"},
{"choice","choice(L)=rand(L)=one extracted element of L.","Lst(L)","choice([1,2,3,4,5,6]);choice([\"r\",\"r\",\"r\",\"b\",\"n\"]); L:=[1,2,3,4,5,6];L:=choice(L); L:=[1,2,3,4,5,6];L.choice()","rand ,sample"},
{"cholesky","For a numerical symmetric matrix A, returns L matrix such that A=L*tran(L).","","cholesky([[3,1],[1,4]])","lu,qr,gauss"},
{"choosebox","In a program, do an input with a display of a choose list.","","choosebox(\"titre\",[\"un\",\"deux\",\"trois\"],a);choosebox(\"valeur de a\",[-1,0,1],a)","Dialog"},
{"chr","Returns the string corresponding to the character code of the argument.","Intg or Lst(Intg)","char(65);char([65,66,67])","asc,ord"},
{"chrem","Chinese remainders for integers or for polynomials.","","symbolique.;chrem([2,3],[7,5]);chrem([2,4,6],[3,5,7]);chrem([2,4,6,7],[3,5,7,11]);chrem([2*x+1,4*x+2,6*x-1,x+1],[3,5,7,11])","gcd,fracmod,chinrem,ichinrem"},
{"chromatic_index","Returns the number of colors in the minimal edge coloring of G. If an unassigned identifier cols is given, the coloring is stored to it.","Graph(G),[Lst(cols)]","chromatic_index(graph(\"petersen\"));chromatic_index(graph(\"dodecahedron\"),colors)","minimal_edge_coloring,chromatic_number"},
{"chromatic_number","Returns the chromatic number of G.","Graph(G)","chromatic_number(graph(\"petersen\"))",""},
{"chromatic_polynomial","Returns the chromatic polynomial [or its value at point t] of undirected unweighted graph G.","Graph(G),[Var(t)]","chromatic_polynomial(graph(\"petersen\"));chromatic_polynomial(graph(\"petersen\"),3)","flow_polynomial,reliability_polynomial,tutte_polynomial"},
{"circle","With one argument r, asks the turtle to draw a circle of radius r. Otherwise, define a 2-d circle with a diameter MN (arg1=M ou zM,arg2=N) or  with center and radius (arg1=M ou zM,arg2=zN) et (center=M et radius=abs(zN)) [or the arc AB, A angle a, B angle b, (MN=angle 0) or M(M+zN)=angle 0] or by its equation and for 3-d with a diameter and a third point.","","circle(30);circle(0,point(2*i));circle(i,i);circle(i,1);circle(0,i,pi/4,pi/2);circle(0,i,pi/4,pi/2,A,B);circle(x^2+y^2-x-y);cercle(point([-1,0,0]),point([1,0,0]),point([0,2,0]));cercle([-1,0,0],point([1,0,0]),[0,2,0])","circumcircle,incircle,excircle,center,radius,sphere,Circle"},
{"circumcircle","circumcircle(A,B,C)=circumcircle of the triangle ABC.","","circumcircle(0,1,1+i)","circle,incircle,excircle"},
{"classes","Returns the matrix [[class,number],...] get with class_min and class_size: see init of geo or argument 2 and 3 or with the list of centers.","","classes([1,1.2,1.4,1.6,1.8,2,2.5]);classes([1,1.2,1.4,1.6,1.8,2,2.5],1.2,0.5);classes([1,1.2,1.4,1.6,1.8,2,2.5],1,[1.2,1.6,2,2.4]);classes([1,1.2,1.4,1.6,1.8,2,2.5],1,[1.2,1.6,2.2]);classes([0,0.5,1,1.5,2,2.5,3,3.5,4],[0..2,2..4,4..6])","histogram,cumulated_frequencies,bar_plot,frequencies"},
{"clear","Clear the list of pixels","NULL","clear()","set_pixel,show_pixels"},
{"clf","Clears matplotl graph in Python","NULL","clf()","show"},
{"click","Interactive input of a complex number with a click on a geometric screen.","","click(); A:=point(click()); a:=click()",""},
{"clique_cover","Returns a clique vertex cover of G [containing at most k cliques].","Graph(G),[Intg(k)]","clique_cover(graph(\"petersen\"));clique_cover(cycle_graph(5));clique_cover(graph_complement(complete_graph(3,4)))","clique_cover_number,maximal_cliques"},
{"clique_cover_number","Returns the clique cover number of G.","Graph(G)","clique_cover_number(graph(\"petersen\"));clique_cover_number(cycle_graph(5));clique_cover_number(graph_complement(complete_graph(3,4)))","clique_cover,maximal_cliques"},
{"clique_number","Returns the clique number of G, which is equal to the size of a maximum clique in G.","Graph(G)","clique_number(graph_complement(complete_graph(3,4)))","maximum_clique"},
{"clique_stats","Returns the list of numbers of maximal cliques of size s in G for each s. If parameter k is given, the number of k-cliques is returned. If an interval m..n is given, only cliques with size between m and n (inclusive) are counted (m also may be +infinity).","Graph(G),[Intg(k)||Intrv(m..n)]","clique_stats(random_graph(50,0.5));clique_stats(random_graph(50,0.5),5);clique_stats(random_graph(50,0.5),3..5)","maximum_clique,clique_cover"},
{"close","Closes the file f.","File(f)","fclose(f)","fprint,fopen"},
{"clustering_coefficient","Returns the average clustering coefficient of undirected graph G, or the local clustering coefficient of the vertex v in G.","Graph(G),[Vrtx(v)]","clustering_coefficient(graph(%{[1,2],[2,3],[2,4],[3,4],[4,1]%}));clustering_coefficient(graph(%{[1,2],[2,3],[2,4],[3,4],[4,1]%}),2)","network_transitivity,number_of_triangles"},
{"coeff","Returns the list of coefficients of a polynomial with respect to the 2nd argument or the coefficient of degree the 3rd argument.","","coeff(x*3+2);coeff(5*y^2-3,y);coeff(5*y^2-3,y,2)","pcoeff,fcoeff"},
{"coeffs","Returns the list of coefficients of a polynomial with respect to the 2nd argument or the coefficient of degree the 3rd argument.","Expr(P),[Var]","coeff(x*3+2);coeff(5*y^2-3,y);coeff(5*y^2-3,y,2)","pcoeff,fcoeff"},
{"col","Returns the column n or the sequence of the columns n1..n2 of the matrix A, or optional argument of count,count_eq,count_inf,count_sup.","","col([[1,2,3],[4,5,6],[7,8,9]],1);col([[1,2,3],[4,5,6],[7,8,9]],0..1); count_eq(3,[[3,2,3],[4,3,2],[3,2,1]],col)","row,count,count_eq,count_inf,count_sup"},
{"colDim","Number of columns of a matrix.","Mtrx","coldim([[1,2,3],[4,5,6]]);coldim([[1,2],[3,4],[5,6]])","rowdim"},
{"colNorm","Returns the max of the l1_norm fo the columns of a matrix: colNorm(a_{j,k})=max_k(sum_j(|a_{j,k}|)).","","colNorm([[1,2],[3,-4]]);colNorm([[1,2,3,-4],[-5,3,2,1]])","norm"},
{"colSwap","Returns the matrix get from A by swapping the n1-th column and the n2-th column.","","colSwap([[1,2],[3,4],[5,6]],0,1)","rowSwap"},
{"coldim","Number of columns of a matrix.","","coldim([[1,2,3],[4,5,6]]);coldim([[1,2],[3,4],[5,6]])","rowdim"},
{"collect","Integer factorization of a polynomial (or of a list of poly).","","collect(x^2-4);collect(x^2-2);collect([x^2-2,x^2-4])","factor,factors"},
{"colnorm","Returns the max of the l1_norm fo the columns of a matrix: colNorm(a_{j,k})=max_k(sum_j(|a_{j,k}|)).","Vect or Mtrx","colNorm([[1,2],[3,-4]]);colNorm([[1,2,3,-4],[-5,3,2,1]])","norm"},
{"color","Draws an geometrical object with colors black=0 red=1 green=2 yellow=3 blue=4, filled put the color in the interior of a closed curve,line_width_n (0<n<8) is for the width of the line and dash_line is for dotted line.","[GeoObj or legende],Intg","display(A,1);display(F:=point(2+1.5*i),2);display(point(2+1.5*i),2);display(legende(1+i,\"abc\"),4);display(square(0,1),filled+red);display(carre(0,1),rempli+rouge);display(circle(0,1),filled);display(line(y=x),green+dash_line+line_width_2);display(red);square(0,1);;display(red+filled);square(0,1);","-<,legende"},
{"colspace","Returns a matrix where the columns are a basis of the vector space generated by the columns of the matrix A [d is the dimension of this space].","","colspace([[1,2,3],[1,2,3],[1,2,4],[1,2,5]]);colspace([[1,2,3],[1,3,6],[2,5,9]],d)","rowspace"},
{"colswap","Returns the matrix get from A by swapping the n1-th column and the n2-th column.","Mtrx(A),Intg(n1),Intg(n2)","colSwap([[1,2],[3,4],[5,6]],0,1)","rowSwap"},
{"comDenom","Returns the expression after reduction at the same denominator : the numerator and the denominator are developed [according to the powers of the variable var].","","comDenom(1/x+1/y^2+1);comDenom(1/x+1/y^2+1,y);comDenom(1/x+1/y^2+1,x)","normal"},
{"comb","comb(n,r)=number of combinations of r objects taken among n : n!/(r!(n-r)!) (If n<0 comb(n,r)=n(n-1)..(n-r+1)/r!).","","comb(4,2)","factorial,perm"},
{"combine","Combines terms in Xpr according to a [class of] function f (2nd argument).","","combine(exp(x)*exp(y),exp);combine(sin(x)*cos(x),trig);combine(ln(x)+ln(y),ln)","lncollect,lin,tlin,tcollect"},
{"comment","Comment in a program.","","comment(\"my_comment\")",""},
{"common_perpendicular","Draws the common perpendicular of the lines D1 and D2.","","common_perpendicular(line([0,0,0],[0,5,5]),line([5,0,0],[0,0,5]))","altitude,perpendicular"},
{"companion","Companion matrix of a polynomial (an=1).","","companion(x^2+5x-7,x);companion(-pcar([[1,0,1],[0,2,-1],[1,-1,1]],x),x)","pcar,rat_jordan"},
{"compare","Returns 1 if type(arg1)<type(arg2) or if type(arg1)=type(arg2) and arg1<arg2, else returns 0.","","compare(1,2);compare(1.0,2);compare(\"ab\",\"cd\")","type"},
{"complete_binary_tree","Returns the complete binary tree with depth n.","Intg(n)","complete_binary_tree(3)","complete_kary_tree,is_tree,random_tree"},
{"complete_graph","Returns a complete graph with vertices from list V or enumerated with first n integers or, when two or more positive integers n1,n2,...,nk are given, a complete k-partite graph with partition sizes n1,n2,...,nk.","Intg(n)||Lst(V)||Seq(n1,n2,...,nk)","complete_graph(4);complete_graph([\"one\",\"two\",\"three\"]);complete_graph(2,3,4)","edges"},
{"complete_kary_tree","Returns the complete k-ary tree with depth n.","Intg(n)","complete_kary_tree(3,3)","complete_binary_tree,is_tree,random_tree"},
{"complex","DOM_COMPLEX or complex is the type of a complex or of a complex variable, as returned by the type command. It is also an option of the assume command.","Opt"," assume(a,complex); assume(a,DOM_COMPLEX); a:=1+i;type(a)","type,assume,DOM_INT,DOM_FLOAT"},
{"complex_mode","Pseudo-variable to work in complex mode (complex_mode:=1) or in real mode (complex_mode:=0).",""," complex_mode:=1; complex_mode:=0","cas_setup"},
{"complex_variables","Pseudo-variable to work with complex variables (complex_variables:=1) or with real variables (complex_variables:=0).",""," complex_variables:=1; complex_variables:=0","cas_setup"},
{"complexroot","Returns the list of complex intervals of size<=l containing roots of P (for example i[1.1,1.2]+i[2,2.4]*i pour [1.1,1.2]x[2,2.4] with optionally a=1+2*i,b=2+3*i) with multiplicities.","","complexroot(x^4+1,1e-50,0.7+i*0.7,0.8+i*0.8);complexroot(x^5-2*x^4+x^3+i,0.1);complexroot(x^3+8,1e-5,0,2+2*i);complexroot(x^5-2*x^4+x^3+i,0.1,1+0.5*i,1.1+0.7*i)","proot,froot,realroot,rationalroot,crationalroot"},
{"concat","Concatenates two lists or two strings or two sequences or 2 matrix; L:=concat(L,L1) or L.concat(L1).","","concat([1,2],[3,4,5]);concat(\"bon\",\"jour\");concat([[1,2],[3,4]],[[4,5,6],[6,7,8]]); L:=[1,2];L.concat([3,4,5]); S:=\"abcd\";S.concat(\"efghi\")","append,cat,semi_augment,border,+"},
{"cond","Condition number of a matrix, use COND(.,1) for l1, COND(.,2) for l2 norm and COND(.,inf) for linf (1 by default).","Mtrx,[2]||[inf]","COND([[1,2],[1,4]]);COND([[1,2],[1,4]],1);COND([[1,2],[1,4]],2);COND([[1,2],[1,4]],inf)","SVL"},
{"condensation","Returns the graph obtained by contracting strongly connected components of the digraph G to single vertices.","Graph(G)","condensation(digraph(%{[1,2],[1,3],[3,1],[1,4],[2,3],[4,3],[4,5],[5,3],[5,6],[7,6],[8,6],[8,7]%}))","strongly_connected_components"},
{"cone","Draws a cone with vertex A, direction v, and with half_angle t [and with altitude h and -h].","","cone([0,0,0],[0,0,1],pi/6);cone([0,0,0],[0,1,1],pi/6,4)","half_cone,cylinder"},
{"confrac","Option of the convert or convertir command (ex id L:=dfc(sqrt(2),1e-10)).",""," convert(sqrt(2),confrac,'L'),L","convert"},
{"conic","Defines a conic by its equation with x,y as default variables and draws it.","","conic(x^2+y^2-x*y-3);conic(x^2+2*y^2-x*y-3,x,y);conic(u^2-2*v^2-2*u*v-1,[u,v]);conic(y^2-x*y+3,[x,y])","circle,ellipse,hyperbola,parabola,reduced_conic"},
{"conj","Returns the conjugate of a complex number.","","conj(1+i);conj(1+2*i);conj((1+2*i)^2);conj([[1+i,2,3],[1,3,6],[2,5,9-i]])","re,im,tran"},
{"conjugate_equation","Returns the expression which is zero for a point x1 conjugate to x (a is the left or the right bound for x) with respect to the function y0 depending on two parameters in P with values in V.","Expr(y0),Lst(P),Lst(V),Var(x),Real(a)","conjugate_equation(A*sin(t)+B*cos(t),[A,B],[1,0],t,0)","jacobi_equation,euler_lagrange"},
{"conjugate_gradient","Conjuagte gradient algorithm to solve A*x=y approximately (precision eps) where A is a symmetric positive definite matrix, x0 an optional initial guess.","","conjugate_gradient([[2,1],[1,5]],[1,0]);conjugate_gradient([[4,1+i],[1-i,5]],[1,0]);conjugate_gradient([[2,1],[1,5]],[1,0],[0.55,-0.11],1e-2);conjugate_gradient([[2,1],[1,5]],[1,0],[0.55,-0.11],1e-10)","linsolve"},
{"connected","Option for the random_regular_graph command.","Opt","","directed,weighted,random_regular_graph"},
{"connected_components","Returns a list of lists of vertices, each sublist representing a connected component of G.","Graph(G)","connected_components(graph_complement(cycle_graph(4)))","articulation_points,is_biconnected,is_strongly_connected,strongly_connected_components,underlying_graph"},
{"cont","Continues execution of a stopped program.","","cont()","continue"},
{"contains","Tests if a set contains an expression (returns the index+1 or 1 for intervals or 0).","","contains(%{0,1,2,3%},2);contains([0,1,2,3],4);contains([1..2],1.5)","inString,member,est_element"},
{"content","Returns the gcd of the coefficients of the polynomial P given as argument.","","content(2*x^2+10*x+6);content([2,10,6]);content(2*t^2+10*t+6,t)","primpart,lgcd"},
{"continue","In a program, don't do the end of the iteration but do the next iteration: while (cond) {i1; if(cond) continue; i2;}.",""," a:=10;while (a>0) {a:=a-3; if (a>0) {continue;} print(a);}","break,cont"},
{"contourplot","Draws whether 11 equirepartited contour-lines z=z_min,,...z=z_max of the surface z=Xpr, whether the contour-lines defined by the 3-rd argument.","Expr(Xpr),[LstVar],[LstVal]","plotcontour(x^2+y^2);plotcontour(x^2+y^2,[x,y]);plotcontour(x^2+2*y^2-2,[x,y],[1.0,2.0,3.0]);plotcontour(x^2-y^2,[x=-4..4,y=-4..4],seq(k,k,-11,11,3),xstep=0.1,ystep=0.1)","plotdensity,plotimplicit"},
{"contract_edge","Returns a modified copy of undirected graph G with edge e contracted (to contract more edges apply the foldl command).","Graph(G),Edge(e)","contract_edge(complete_graph(4),[1,3])","delete_edge,delete_vertex,foldl"},
{"convert","Returns the value of cmd(Xpr) cmd is the name of a command specified by the 2nd argument (for ex option sin=command trigsin).","","convert(cos(x)^2,sin);convert(exp(i*x),sincos);convert(1/(x^4-1),parfrac);convert(series(sin(x),x=0,6),polynom);convert([[1,[2,0]],[2,[1,1]],[1,[0,2]]],polynom);convert(%%%{1,[2,0]%%%}+%%%{2,[1,1]%%%}+%%%{1,[0,2]%%%},list);convert(cos(x)^2+1,sin);convert(3e10 _m,_au);convert(pi _rad,_deg);convert(9976/6961,confrac,'l');l;convert(sqrt(2),confrac,'dev');dev;convert(123,base,8);convert([3,7,1],base,8);convert([1,2,3],set[]);convert(pi,interval,20); A[2,1]:=1;convert(A,array); B[0..1,1..2]:=1;B[2,2]:=2;convert(B,array)","mksa,list,polynom,table"},
{"convertir","Returns the value of cmd(Xpr) cmd is the name of a command specified by the 2nd argument (for ex option sin=command trigsin).","Expr(Xpr),Cmd(cmd)","convert(cos(x)^2,sin);convert(exp(i*x),sincos);convert(1/(x^4-1),parfrac);convert(series(sin(x),x=0,6),polynom);convert([[1,[2,0]],[2,[1,1]],[1,[0,2]]],polynom);convert(%%%{1,[2,0]%%%}+%%%{2,[1,1]%%%}+%%%{1,[0,2]%%%},list);convert(cos(x)^2+1,sin);convert(3e10 _m,_au);convert(pi _rad,_deg);convert(9976/6961,confrac,'l');l;convert(sqrt(2),confrac,'dev');dev;convert(123,base,8);convert([3,7,1],base,8);convert([1,2,3],set[]);convert(pi,interval,20); A[2,1]:=1;convert(A,array); B[0..1,1..2]:=1;B[2,2]:=2;convert(B,array)","mksa,list,polynom,table"},
{"convex","Returns a list of conditions under which f(x,y,..) is convex.","Expr(f),Lst(x,y,..)","convex(-2x+y+x^2-2x*y+y^2,[x,y]);convex(3*exp(x)+5x^4-ln(x),x);convex(x+y-exp(x)-exp(x+y),[x,y]);convex(x^2+y^2+3z^2-x*y+2x*z+y*z,[x,y,z]);convex(x1^3+2x1^2+2*x1*x2+x2^2/2-8x1-2x2-8,[x1,x2]);convex(x1^2+2x2^2+a*x3^2-2x1*x2+2x1*x3-6x2*x3,[x1,x2,x3]);convex(exp(x1)+exp(x2)+x1*x2,[x1,x2]);convex(sqrt((1+cos(x)^2)/sin(x)),x);convex(sqrt((1+(u')^2)/(2*g*u)),u(t))","hessian"},
{"convexhull","Convex hull of a list of 2-d points.","","convexhull(0,1,1+i,1+2i,-1-i,1-3i,-2+i);convexhull([0,1,1+i,1+2i,-1-i,1-3i,-2+i]); polygon(convexhull(0,1,1+i,1+2i,-1-i,1-3i,-2+i))","polygon"},
{"convolution","Returns the convolution of two signals u and v.","Lst(u),Lst(v)","convolution([1,2,3],[1,-1,1,-1])","fft,cross_correlation"},
{"coordinates","Returns the list (resp matrix) of the abscissa and of the ordinate of a point or a vector (resp of points or vectors).","","coordinates(point(1+2*i));coordinates(1+2*i);coordinates(point(i),point(1+2*i));coordinates(vecteur(point(i),point(1+2*i)));coordinates(point(1+2*i)-point(i));coordinates(-1-i);coordinates(point(1,2,3));coordinates(vecteur([1,2,3],[4,5,6]))","abscissa,ordinate,cote,vecteur"},
{"copy","A:=copy(B) clones the list or matrix B in A.",""," A:=copy(B)","=<"},
{"correlation","Returns the correlation of the elements of its argument.","","correlation([[1,2],[1,1],[4,7]])","covariance,covariance_correlation"},
{"cos","Cosine or Option of the convert or convertir command (id trigcos).","","cos(0); convert(cos(x)^4+sin(x)^2,cos)","acos,convert,trigsin"},
{"cos2sintan","Replaces cos(x) by sin(x)/tan(x) in the argument.","","cos2sintan(cos(x))","tan2sincos,sin2costan,tan2sincos2,tan2cossin2"},
{"cosh","Hyperbolic cosine.","","cosh(0)","acosh"},
{"cosine_window","Applies the cosine windowing function with parameter a>0 (by default a=1 for sine window) to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Real(a)],[Interval(n1..n2)]"," scatterplot(cosine_window(randvector(1000,0..1),1.5))","blackman_harris_window,blackman_window,bohman_window,bartlett_hann_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"cot","Cotangent.","","cot(pi/2)","acot,tan"},
{"cote","Third coordinate (z) of a 3-d point.","","cote(point[1,2,3]);cote(point(1,2,3))","abscissa,ordinate,coordinates"},
{"count","Returns f(l[0])+f(l[1])+...+f(l[size(l)-1]) or count number of occurrences if the argument is a vector of integers.","","count(id,[-2/5,-1,0,1,2,3/5]);count(1,[-2,-1,0,1,2,3]);count([1,3,1,1,2,10,3]);count((x)->x>2,[3/2,5/2,8/3]);count((x)->x==1,[-2,1,0,1,2,3]);count((x)->x>2,[[3,5/2],[4,1]]);count((x)->x>2,[[3,5/2],[4,1]],row);count((x)->x>2,[[3,5/2],[4,1]],col);count((x)->x>2 && x<4,[[3,9/2],[4,1]]);count((x)->x<2 || x>4,[[3,9/2],[4,1]])","count_eq,count_inf,count_sup"},
{"count_eq","Returns the number of elements of L equal to a.","","count_eq(1,[-2,1,0,1,2,-3]);count_eq(4,[[3,4],[4,1]]);count_eq(4,[[3,4],[4,1]],row);count_eq(4,[[3,4],[4,1]],col)","count,count_inf,count_sup"},
{"count_inf","Returns the number of elements of L strictly lower than a.","","count_inf(1,[-2,-1,0,1,2,3]);count_inf(4,[[3,5],[4,1]]);count_inf(4,[[3,5],[4,1]],row);count_inf(4,[[3,5],[4,1]],col)","count,count_eq,count_sup"},
{"count_sup","Returns the number of elements of L strictly greater than a.","","count_sup(1,[-2,-1,0,1,2,3]);count_sup(3,[[3,5],[4,1]]);count_sup(3,[[3,5],[4,1]],row);count_sup(3,[[3,5],[4,1]],col)","count,count_inf,count_eq"},
{"courbe_parametrique","plotparam(a(x)+i*b(x),x=x0..x1) draws the curve X=a(x),Y=b(x) x=x0..x1 or plotparam([a(u,v),b(u,v),c(u,v)],[u=u0..u1,v=v0..v1]) draws the surface X=a(u,v),Y=b(u,v),Z=c(u,v) u=u0..u1 and v=v0..v1.","Cplx||Lst,Var||Lst(Var)","plotparam(sin(t)+i*cos(t),t);plotparam(exp(i*t),t=0..pi/2,affichage=1);plotparam(exp(i*t),t=0..pi/2,affichage=1+rempli);plotparam([sin(x),cos(x)],x=0..1);plotparam([sin(x),cos(x)],x=0..1,affichage=rouge);plotparam(sin(x)+i*cos(x),x=0..1,tstep=0.01);plotparam([v*cos(u),v*sin(u),v],[u,v]);plotparam([v*cos(u),v*sin(u),v],[u=0..pi,v=0..3],ustep=0.1,vstep=0.2)","plotfunc,plotpolar,arc"},
{"courbe_polaire","plotpolar(f(x),x,a,b) draws the polar curve r=fx) for x in [a,b].","Expr,Var,VarMin,VarMax","plotpolar(sin(2*x),x,0,pi);plotpolar(sin(2*x),x,0,pi,tstep=0.1)","plotparam,plotfunc,plotpolar"},
{"covariance","Returns the covariance of the elements of its argument","","covariance([[1,2],[1,1],[4,7]])","correlation,covariance_correlation"},
{"covariance_correlation","Returns the list of the covariance and the correlation of the elements of its argument.","","covariance_correlation([[1,2],[1,1],[4,7]])","covariance,correlation"},
{"cpartfrac","Performs partial fraction decomposition in ℂ of a fraction.","","cpartfrac((x)/(4-x^2));cpartfrac((x^2-2*x+3)/(x^2-3*x+2));cpartfrac(a/(z*(z-b)),z)","factor,normal"},
{"crationalroot","Returns the list of complex rational roots of P without indicating the multiplicity.","","crationalroot(2*x^3+(-5-7*i)*x^2+(-4+14*i)*x+8-4*i)","proot,froot,complexroot,rationalroot,realroot"},
{"crayon","Changes the color of the pencil (without parameter,returns the current color).",""," crayon vert;crayon(rouge);crayon(5);crayon(gomme)","leve_crayon,baisse_crayon"},
{"createwav","Returns an audio clip from data, optionally setting channel count, bit depth, sample rate, duration and normalization level.","Lst(data),[opts]","createwav(duration=3.5);createwav(sin(2*pi*440*soundsec(2)),samplerate=48000);createwav(sin(2*pi*440*soundsec(2)),bit_depth=8);createwav(10*sin(2*pi*440*soundsec(2)),normalize=-3); t:=soundsec(3):;L,R:=sin(2*pi*440*t),sin(2*pi*445*t):;createwav([L,R])","readwav,writewav,playsnd"},
{"cross","Wedge product.","","cross([1,2],[3,4]);cross([1,2,3],[4,5,6])","dot"},
{"crossP","Wedge product.","Vect(v1),Vect(v2)","cross([1,2],[3,4]);cross([1,2,3],[4,5,6])","dot"},
{"cross_correlation","Returns the cross_correlation of two signals u and v.","cross_correlation(Lst(u),Lst(v))","cross_correlation([1,2],[3,4,5])","auto_correlation,correlation"},
{"cross_point","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"cross_ratio","Returns the complex number equal to ((c-a)/(c-b))/((d-a)/(d-b)).","","cross_ratio(i,2+i,3/2+i,3+i);cross_ratio(0,1+i,1,i);cross_ratio(0,1,2,3)","harmonic_conjugate,is_conjugate"},
{"crossproduct","Wedge product.","Vect(v1),Vect(v2)","cross([1,2],[3,4]);cross([1,2,3],[4,5,6])","dot"},
{"csc","Cosecant: csc(x)=1/sin(x).","","csc(pi/2)","sin,acsc"},
{"csolve","Returns the list of complex solutions of an equation or a matrix where the rows are ℂ-solutions of a system of polynomial equations.","","csolve(x^4-1,x);csolve(x^4-y^4 and x+y=2,[x,y]);csolve(x^4-y^4 and x+y=0 and x^2=2*x,[x,y]);csolve(u*v-u=v and v^2=u,[u,v])","cZeros,solve,fslove"},
{"csv2gen","Reads a file (or string) in CSV format","Strng(filename),Strng(sep),Strng(nl),Strng(decsep),Strng(eof),[string]","csv2gen(\"mat.txt\",\",\",char(10),\".\")","read"},
{"cube","Draws the direct cube with vertices A,B with a face in the plan (A,B,C).","","cube([0,0,0],[1,0,0],[0,1,0]); c:=cube([0,0,0],[1,0,0],[0,1,0]);A,B,C,D,E,F,G,H:=sommets(c); ; A,B,K:=point(1,0,0),point(1,1,0),point(0,2,0);c:=cube(A,B,C);A,B,C,D,E,F,G,H:=sommets(c); ; c:=cube([0,0,0],[1,0,0],[0,1,0]);c1,c2,c4,c3,c5,c6,c7,c8:=sommets(c); ; c:=cube([0,0,0],[0,2,0],[0,0,1]);c1,c2,c4,c3,c5,c6,c7,c8:=sommets(c); ","parallelepiped,cylinder,icosahedron,dodecahedron,octahedron,tetrahedron,centered_cube"},
{"cumSum","Returns the list (or the sequence or the string) lr where the elements are the cumulative sum of the list l: lr[k]=sum(l[j],j=0..k) (or lr=sum(l[j],j=0..k)$(k=0..size(l)-1)).","","cumSum([0,1,2,3,4]);cumSum(1.2,3,4.5,6);cumSum(\"a\",\"b\",\"c\",\"d\")","sum"},
{"cumsum","Returns the list (or the sequence or the string) lr where the elements are the cumulative sum of the list l: lr[k]=sum(l[j],j=0..k) (or lr=sum(l[j],j=0..k)$(k=0..size(l)-1)).","Lst(l)||Seq||Str","cumSum([0,1,2,3,4]);cumSum(1.2,3,4.5,6);cumSum(\"a\",\"b\",\"c\",\"d\")","sum"},
{"cumulated_frequencies","Draws the diagram of the cumulated frequencies (rows=[value,frequencies])","","cumulated_frequencies([1,2,1,1,2,1,2,4,3,3]);cumulated_frequencies([(rand(6)+1)$(k=1..100)]);cumulated_frequencies([[1,0.3],[2,0.5],[3,0.2]]);cumulated_frequencies([[1..2,0.3],[2..3,0.5],[3..4,0.2]]);cumulated_frequencies([[1..2,0.3,0.5],[2..3,0.5,0.2],[3..4,0.2,0.3]])","histogram,classes,bar_plot"},
{"curl","curl([A,B,C],[x,y,z])=[dC/dy-dB/dz,dA/dz-dC/dx,dB/dx-dA/dy].","","curl([2*x*y,x*z,y*z],[x,y,z])","derive,divergence"},
{"current_sheet","Content of the matrix editor or spreadsheet.","","current_sheet(1,2);current_sheet(A1..A5,B,G)",""},
{"curvature","Curvature of curve C at point M.","","curvature(plot(x^2),point(1,1));curvature([5*cos(t),5*sin(t)],t);curvature([t,t^2],t);curvature([t,t^2],t,1);curvature([3*exp(t/2)*cos(t),3*exp(t/2)*sin(t)],t);curvature([3*exp(t/2)*cos(t),3*exp(t/2)*sin(t)],t,7); trigcos(curvature([2*cos(t),2*sin(t),3*t],t))","osculating_circle,evolute"},
{"curve","Reserved word.","","",""},
{"cyan","Option of the display command to display with color.","Opt"," F:=display(point(2+1.5*i),red); F:=display(point(2+1.5*i),point_point+green)","display"},
{"cycle2perm","Converts the cycle c to a permutation.","","cycle2perm([1,3,5])","cycles2permu,permu2cycles"},
{"cycle_graph","Returns a cyclic graph with n vertices (or with vertices from list V).","Intg(n)||Lst(V)","cycle_graph(4);cycle_graph([\"one\",\"two\",\"three\",\"four\",\"five\"])","graph,path_graph"},
{"cycleinv","Returns the inverse cycle of the cycle c.","","cycleinv([1,3,5])","perminv"},
{"cycles2permu","Converts a product of cycles into a permutation.","","cycles2permu([[1,3,5],[3,4]])","permu2cycles,cycle2perm"},
{"cyclotomic","N-th cyclotomic polynomial.","","cyclotomic(20)","none"},
{"cylinder","Draws a cylinder with axis (A,v), with radius r [and with altitude h].","","cylinder([0,0,0],[0,1,0],2);cylinder([0,0,0],[0,1,0],2,-3)","half_cone,cone"},
{"dash_line","Option of the display command for a line.",""," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"dashdot_line","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"dashdotdot_line","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"dayofweek","dayofweek(d,m,y) returns the day of the given date (day,month,year) : 0 for sunday, 1 for monday ...6 for saturday.","Int,Int,Int","dayofweek(21,4,2014);dayofweek(15,10,1582)",""},
{"dayofweek","dayofweek(d,m,y) returns the day of the given date (day,month,year) : 0 for sunday, 1 for monday ...6 for saturday.","","dayofweek(21,4,2014);dayofweek(15,10,1582)",""},
{"de","Used in a loop for (for...from ...to... [step...] do...od;).",""," pour de jusque [pas] faire fpour;; S:=0;pour n de 1jusque 4 faire S:=S+n;fpour;; S:=0;for n from 1 to 4 do S:=S+n;end;; S:=0;pour n de 4 jusque 1 pas -1 faire S:=S+n;fpour ;","for,pour,jusque,to"},
{"deSolve","Solves a differential equation or a differential linear system with constant coefficients.","Eq,[TimeVar],FncVar","desolve(y'+x*y=0);desolve(y'+x*y=0,y);desolve(y'+x*y=0,[0,1]);desolve([y'+x*y=0,y(0)=1],y);desolve([y'=[[1,2],[2,1]]*y+[x,x+1],y(0)=[1,2]]) ;desolve(y''+y=0,y);desolve([y''+y=sin(x),y(0)=1,y'(0)=2],y);desolve([y''+y=sin(x),y(0)=1,y'(0)=2],x,y);desolve([y''+y=sin(x),y(0)=1,y'(0)=2],[x,y]);desolve(diff(y(t),t)+t*y(t)=0,t,y);desolve(diff(y(t),t)+t*y(t)=0,[t,y]);desolve((y''+y=sin(x)) and (y(0)=1) and (y'(0)=2),y);desolve([z''+2*z'+z,z(0)=1,z'(0)=0],u,z);desolve([z''+2*z'+z,z(0)=1,z'(0)=0],z(u));desolve([z'=[[1,2],[2,1]]*z+[t,t+1],z(0)=[1,2]],t,z);desolve([z'=[[1,2],[2,1]]*z+[t,t+1],z(0)=[1,2]],z(t))","integrate,diff,odesolve,plotode,plotfiefd"},
{"debug","Launch a debugging session.","","debug(pgcd(25,15))",""},
{"debut_enregistrement","Marks the beginning of the recording of the commands making up the drawing whose name is the argument.","","debut_enregistrement(maison);debut_enregistrement(arbre)","fin_enregistrement"},
{"default","Default case in a switch instruction.",""," default: print(\"Default case!\"); a:=1;switch(a){case 0:{b:=1;break;} case 1:{b:=3;break;} default:{b:=0;}};","switch,case,if"},
{"degree","Degree of the polynomial P with respect to the second argument.","","degree(x^3+x);degree([1,0,1,0]);degree(x^3+x*y,y)","valuation,size,total_degree"},
{"degree_sequence","Returns the list of degrees of vertices of G (arc directions are ignored).","Graph(G)","degree_sequence(graph(trail(1,2,3,4,2)))","is_graphic_sequence,is_regular,sequence_graph,vertex_degree"},
{"del","purge(varname) unassign the variable varname.","Var","purge(t);purge(C)","sto,restart,assume,about"},
{"delcols","Returns the matrix where the columns n1..n2 (or n1) of the matrix A are deleted.","","delcols([[1,2,3],[4,5,6],[7,8,9]],1..1);delcols([[1,2,3],[4,5,6],[7,8,9]],0..1);delcols([[1,2,3],[4,5,6],[7,8,9]],1)","delrows"},
{"delete_arc","Returns a modified copy of digraph G with arc e (or trail T or list of arcs E). removed.","Graph(G),Edge(e)||Trail(T)||Lst(E)","delete_arc(digraph(trail(1,2,3,4,5,1)),[5,1])","add_arc,delete_edge,digraph,edges,has_arc,trail"},
{"delete_edge","Returns a modified copy of undirected graph G with edge e (or trail T or list of edges E) removed.","Graph(G),Edge(e)||Trail(T)||Lst(E)","delete_edge(cycle_graph(4),[1,2])","add_edge,delete_arc,edges,graph,has_edge,trail"},
{"delete_vertex","Returns a modified copy of G with vertex v (or vertices from V) removed.","Graph(G),Vrtx(v)||Lst(V)","delete_vertex(cycle_graph(5),[1,4])","add_vertex,induced_subgraph"},
{"delrows","Returns the matrix where the rows n1..n2 (or n1) of the matrix A are deleted.","","delrows([[1,2,3],[4,5,6],[7,8,9]],1..1);delrows([[1,2,3],[4,5,6],[7,8,9]],0..1);delrows([[1,2,3],[4,5,6],[7,8,9]],1)","delcols"},
{"deltalist","Returns the list of the difference of two terms in succession.","","deltalist([1,4,8,9]);deltalist([1,8,4,9])",""},
{"denom","Returns the denominator of the simplified fraction.","","denom(25/15);denom((x^3-1)/(x^2-1));denom(1+(x^3-1)/x^2)","getDenom,getNum,numer,f2nd"},
{"densityplot","Shows in the plan with colors the graph of a expression of 2 variables.","Expr,[x=xrange,y=yrange],[z],[xstep],[ystep]","plotdensity(x^2-y^2,[x=-2..2,y=-2..2],xstep=0.1,ystep=0.1);plotdensity(x^2-y^2,[x=-2..2,y=-2..2],z=-2..2,xstep=0.1,ystep=0.1)","plotfunc,plotcontour"},
{"departures","Returns the list of vertices of digraph G which are connected by v with arcs such that tails are in v. If v is omitted, list of departures is computed for every vertex in G.","Graph(G),[Vrtx(v)]","departures(digraph(%{[1,2],[1,3],[2,3]%}),1)","out_degree"},
{"derive","Returns the derivative with respect to the 2nd argument.","Expr or Fnc,[SeqVar or LstVar]","diff(x^3-x);diff(x^3-x,x,3);diff(x^3-x,quote(x)$3);(diff@@3)('x^3-x');diff(x*y+z*y,y);diff(x*y+z*y,y,z);diff(x*y+z*y,[y,z]); f(x):=sin(2x);g:=diff(f);h:=diff(diff(f))","',function_diff,integrate,taux_accroissement,implicitdiff"},
{"deriver","Returns the derivative with respect to the 2nd argument.","Expr or Fnc,[SeqVar or LstVar]","diff(x^3-x);diff(x^3-x,x,3);diff(x^3-x,quote(x)$3);(diff@@3)('x^3-x');diff(x*y+z*y,y);diff(x*y+z*y,y,z);diff(x*y+z*y,[y,z]); f(x):=sin(2x);g:=diff(f);h:=diff(diff(f))","',function_diff,integrate,taux_accroissement,implicitdiff"},
{"desolve","Solves a differential equation or a differential linear system with constant coefficients.","","desolve(y'+x*y=0);desolve(y'+x*y=0,y);desolve(y'+x*y=0,[0,1]);desolve([y'+x*y=0,y(0)=1],y);desolve([y'=[[1,2],[2,1]]*y+[x,x+1],y(0)=[1,2]]) ;desolve(y''+y=0,y);desolve([y''+y=sin(x),y(0)=1,y'(0)=2],y);desolve([y''+y=sin(x),y(0)=1,y'(0)=2],x,y);desolve([y''+y=sin(x),y(0)=1,y'(0)=2],[x,y]);desolve(diff(y(t),t)+t*y(t)=0,t,y);desolve(diff(y(t),t)+t*y(t)=0,[t,y]);desolve((y''+y=sin(x)) and (y(0)=1) and (y'(0)=2),y);desolve([z''+2*z'+z,z(0)=1,z'(0)=0],u,z);desolve([z''+2*z'+z,z(0)=1,z'(0)=0],z(u));desolve([z'=[[1,2],[2,1]]*z+[t,t+1],z(0)=[1,2]],t,z);desolve([z'=[[1,2],[2,1]]*z+[t,t+1],z(0)=[1,2]],z(t))","integrate,diff,odesolve,plotode,plotfiefd"},
{"dessine_tortue","Draws the full (or not full if n=1) triangle representing the turtle.","","dessine_tortue();dessine_tortue(0);dessine_tortue(1)","crayon"},
{"det","Determinant of a square matrix M.","","det([[1,2],[3,4]]);det([[1,2,3],[1,3,6],[2,5,7]])","rref,det_minor,Det"},
{"det_minor","Returns the determinant calculated with the calculus of minors.","","det_minor([[1,2],[3,4]])","det"},
{"developper","Full distribution of * and / over + and -","Expr","expand((x+y)*(z+1));expand((a+b+c)/d);expand((y+x)*(z+y)*(x+z));expand((x+3)^4);expand((2*x-2*1)*(x^2-3*x+2)+(x^2-2*x+3)*(2*x-3*1))","texpand,normal,simplify,ratnormal"},
{"developper_transcendant","Expand transcendental expressions.","Expr","texpand(sin(2*x)+exp(x+y));texpand(cos(x+y));texpand(cos(3*x))","tcollect,tlin,lin,trigexpand"},
{"dfc","Returns the continue fraction development of x0 of order n or with precision eps.","","dfc(sqrt(2),5);dfc(pi,4);dfc(evalf(pi),1e-09); convert(sqrt(2),confrac,'dev');dev; convert(9976/6961,confrac,'l');l","dfc2f,convert"},
{"dfc2f","Converts a continue fraction into a real.","","dfc2f([1,1,1]);dfc2f([1,2,[2]])","dfc,convert"},
{"diag","With 1 argument returns either the diagonal matrix with diagonal l or the diagonal of A, with 2 arguments returns the large left part of A or the large right part of A or cuts A into 3 parts : strict left,diagonal,strict right  and with 3 arguments returns the tridiagonale matrix with diagonals l,d,u.","","diag([[1,2],[3,4]]);diag([1,2,3]);diag([[1,2],[3,4]],left);diag([[1,2],[3,4]],right);diag([[1,2],[3,4]],lu);diag([1,2],[3,4,5],[6,7])","identity,lu,BlockDiagonal,upper,lower"},
{"diff","Returns the derivative with respect to the 2nd argument.","","diff(x^3-x);diff(x^3-x,x,3);diff(x^3-x,quote(x)$3);(diff@@3)('x^3-x');diff(x*y+z*y,y);diff(x*y+z*y,y,z);diff(x*y+z*y,[y,z]); f(x):=sin(2x);g:=diff(f);h:=diff(diff(f))","',function_diff,integrate,taux_accroissement,implicitdiff"},
{"digraph","Create a directed (un)weighted graph from vertices V, edges E and/or adjacency or weight matrix A. All parameters are optional.","[Lst(V)],[Set(E)],[Mtrx(A)],[options]","digraph(%{[1,2],[2,3],[3,4],[4,1]%});digraph([a,b,c,d],%{[[a,b],1.0],[[a,c],2.3],[[b,d],3.1],[[c,d],4]%})","graph,trail"},
{"dijkstra","Returns the cheapest weighted path from vertex v to w (or to vertices from W) in undirected graph G. Output is in form [[v1,v2,...,vk],d] (or list of these) where v1,v2,...,vk are vertices along each path and d is the weight of the path.","Graph(G),Vrtx(v),[Vrtx(w)||Lst(W)]","dijkstra(graph(%{[[1,2],1],[[2,3],3],[[3,4],7],[[4,5],3],[[5,6],3],[[1,6],3]%}),1,4)","allpairs_distance,shortest_path"},
{"dim","Returns the list which gives the dimension of the matrix specified as argument.","","dim([[1,2,3],[4,5,6]])","rowdim,coldim,sizes,size"},
{"directed","Option for graph and digraph commands.","Opt","","weighted,graph,digraph"},
{"discard_edge_attribute","Discards the attributes with tags tag1, tag2, ... assigned to edge e in G and returns the modified copy of G.","Graph(G),Edge(e),Seq(tag1=value1,tag2=value2,..)","discard_edge_attribute(cycle_graph(3),[1,2],\"cost\")","get_edge_attribute,set_edge_attribute,list_edge_attributes"},
{"discard_graph_attribute","Discards the graph attributes with tags tag1, tag2, ... and returns the modified copy of G.","Graph(G),Seq(tag1=value1,tag2=value2,..)","discard_graph_attribute(cycle_graph(3),\"name\")","get_graph_attribute,set_graph_attribute,list_graph_attributes"},
{"discard_vertex_attribute","Discards the attributes with tags tag1, tag2, ... assigned to vertex v in G and returns the modified copy of G.","Graph(G),Vrtx(v),Seq(tag1=value1,tag2=value2,..)","discard_vertex_attribute(cycle_graph(3),1,\"supply\")","get_vertex_attribute,set_vertex_attribute,list_vertex_attributes"},
{"disjoint_union","Returns the disjoint union of the graphs G1, G2, ... Vertices in the resulting graph are labelled with \"k:v\", where k is index of the corresponding k-th graph Gk and v is vertex in Gk.","Seq(G1,G2,...)","is_connected(disjoint_union(cycle_graph(5),path_graph(4)))","graph_join,graph_union"},
{"display","Draws an geometrical object with colors black=0 red=1 green=2 yellow=3 blue=4, filled put the color in the interior of a closed curve,line_width_n (0<n<8) is for the width of the line and dash_line is for dotted line.","","display(A,1);display(F:=point(2+1.5*i),2);display(point(2+1.5*i),2);display(legende(1+i,\"abc\"),4);display(square(0,1),filled+red);display(carre(0,1),rempli+rouge);display(circle(0,1),filled);display(line(y=x),green+dash_line+line_width_2);display(red);square(0,1);;display(red+filled);square(0,1);","-<,legende"},
{"disque","Draws a disk with radius r (resp a sector of angle (0,a) or (a,b)), tangent at the turtle position.",""," disque 30;disque(40);disque(40,90);disque(40,10,100)","rond"},
{"disque_centre","Draws a disk with radius r (resp a sector of angle (0,a) or (a,b)) with center the turtle position.",""," disque_centre 30;disque_centre(40);disque_centre(40,90);disque_centre(40,10,100)","rond"},
{"distance","Calculates the distance between 2 points or a point and a curve.","","distance(point(0),point(1+i));distance(1+i,segment(1-i,i));distance(0,1+i)","distance2,distanceat,distanceatraw"},
{"distance2","Calculates the square of the distance between 2 points or a point and a curve.","","distance2(point(0),point(1+i));distance2(1+i,segment(1-i,i));distance2(0,1+i)","distance"},
{"distanceat","distanceat(A,B,z0) displays at point(z0), with a legend, the distance between 2 geometrical objects",""," A:=point(0);B:=point(1+i);distanceat(A,B,(1+i)/2); A:=point(0);s:=segment(1-i,i);distanceat(A,s,1)","distance,distanceatraw"},
{"distanceatraw","distanceatraw(A,B,z0) displays at the point(z0), the distance between 2 geometrical objects.",""," A:=point(0);B:=point(1+i);distanceatraw(A,B,(1+i)/2); A:=point(0);s:=segment(1-i,i);distanceatraw(A,s,1)","distance,distanceat"},
{"div","Euclidean quotient of 2 integers (infixed operator).",""," 125 div 15; 125 div 41; -7 div 3; (25+12*i) div (5+7*i)","iquo,mod"},
{"divergence","divergence([A,B,C],[x,y,z])=dA/dx+dB/dy+dC/dz.","","divergence([x^2+y,x+z+y,z^3+x^2],[x,y,z])","derive,curl"},
{"divide","Euclidean quotient and remainder of 2 polynomials.","(Vect or Poly),(Vect or Poly),[Var]","quorem([1,2,3,4],[-1,2]);quorem(x^3+2x^2+3x+4,-x+2);quorem(t^3+2t^2+3t+4,-t+2,t);quorem(t^4-1,(t+1)^2,t)","rem,quo,iquorem"},
{"divis","Returns the list of divisors of a polynomial.","","divis(x^2-1);divis(x^4-1);divis(t^4-1);divis([x^4-1,x^2-1]);divis([x^4-1,t^2-1]);divis(poly2symb([1,0,0,0,-1],x))","idivis,factors,poly2symb"},
{"division_point","Returns the point M such that (z-a)=k*(z-b) and z=affix of M (MA=k*MB).","","division_point(i,2+i,3+i);division_point(i,2+i,3)","harmonic_conjugate,is_conjugate"},
{"divisors","Returns the list of divisors of an integer.","Intg(a) or LstIntg","idivis(36);idivis([36,49])","divis,ifactors"},
{"divmod","Euclidean quotient and remainder of 2 integers.","Intg(a),Intg(b)","iquorem(125,15);iquorem(125,41);iquorem(25+12*i,5+7*i)","irem,iquo,quorem"},
{"divpc","n-degree Taylor-poly for the quotient of 2 polynomials.","","divpc(x^4+x+2,x^2+1,5)","series,quorem"},
{"dnewton_solver","Argument for fsolve giving the method for solving a system of numerical equations.",""," fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],dnewton_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrid_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrids_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridsj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],newtonj_solver)","fsolve"},
{"do","Key word used in a loop.",""," faire ffaire; n:=1;do n:=n+1; if (n>15) break; n:=2*n;od;; n:=1;tantque n<5 faire triangle_plein(10*n);saute(10*n);n:=n+1;ftantque; pour n de 1 jusque 4 faire triangle_plein(10*n);saute(10*n);fpour","tantque,pour,repeat"},
{"dodecahedron","Draws a dodecahedron with center A, vertex B and such that the plane ABC contains a symmetry axis of the dodecahedron.","","dodecahedron([0,0,0],[0,2,sqrt(5)/2+3/2],[0,0,1]);dodecahedron(evalf([0,0,0],[3,2,4],[1,1,0]))","icosahedron,octahedron,cube,tetrahedron"},
{"domain","Returns the definition domain of an expression.","Expr","domain(log(x+1));domain(log(x)+asin(x))",""},
{"dot","Scalar product.","","dot([1,2],[3,4]);dot([3,2,4],[3,2,4]);dot([[1,2],[3,4]],[[3,2],[4,5]])","*,cross,.*,hadamard"},
{"dotP","Scalar product.","Vect(v1),Vect(v2)","dot([1,2],[3,4]);dot([3,2,4],[3,2,4]);dot([[1,2],[3,4]],[[3,2],[4,5]])","*,cross,.*,hadamard"},
{"dot_paper","Draws in the rectangle [xmin..xmax]*[ymin..ymax], the apex of the network built with the lines y=n*uy and in the axes OxY of angle t!=0 with the lines x=n*ux.","","dot_paper(1,pi/3,sqrt(3)/2);dot_paper(1,pi/3,sqrt(3)/2,x=-1..4,y=-2..2);dot_paper(0.5,3*pi/4,0.5)",""},
{"dotprod","Scalar product.","Vect(v1),Vect(v2)","dot([1,2],[3,4]);dot([3,2,4],[3,2,4]);dot([[1,2],[3,4]],[[3,2],[4,5]])","*,cross,.*,hadamard"},
{"double","DOM_FLOAT or float is an integer representing the type of a floating point variable, returned by the type command. It is also an option of the assume command.","Opt"," type(2.3); DOM_FLOAT+0; assume(a,DOM_FLOAT); assume(a,real); type(1.2)","type,assume,DOM_INT,DOM_SYMBOLIC"},
{"draw_arc","Pixelised ellipsis arc","Intg(x),Intg(y),Intg(rx),Intg(ry),Real(theta1),Real(theta2),Intg(col)"," clear(); draw_arc(100,80,40,20,0,pi,blue); show_pixels();","draw_pixel,draw_circle"},
{"draw_circle","Pixelised circle, add filled to the color to fill the circle","Intg(x),Intg(y),Intg(r),Intg(col)","draw_circle(100,60,20,blue);; clear(); draw_circle(100,60,20,blue+filled); show_pixels();","draw_pixel,draw_arc"},
{"draw_graph","Returns the graphic representation of G obtained by using various algorithms (which can optionally be fine tuned by appending a sequence of options after the first argument).","Graph(G),[opts]","draw_graph(graph(\"petersen\"));draw_graph(graph(\"petersen\"),spring);draw_graph(random_tree(30));draw_graph(sierpinski_graph(5,3,at_triangle));draw_graph(graph(\"soccerball\"))","highlight_edges,highlight_subgraph,highlight_trail,highlight_vertex,set_vertex_positions,get_vertex_positions"},
{"draw_line","Pixelised segment","Intg(x1),Intg(y1),Intg(x2),Intg(y2),Intg(col)","draw_line(10,10,60,60,blue);","draw_pixel,draw_rectangle,draw_polygon"},
{"draw_pixel","Pixel on and adds to the list of pixel. Run show_pixels() to display","Intg(x),Intg(y),Intg(col)"," clear(); draw_pixel(1,2,red); show_pixels();","clear,show_pixels,draw_line,draw_rectangle,draw_polygon"},
{"draw_polygon","Pixelised polygon, add filled to the color to fill the rectangle","Lst(l),Intg(col)","draw_polygon([[50,30],[100,10],[20,70]],red); show_pixels();; clear(); draw_polygon([[50,30],[100,10],[20,70]],red+filled); show_pixels();","draw_pixel,draw_line,draw_rectangle"},
{"draw_rectangle","Pixelised rectangle, add filled to the color to fill the rectangle","Intg(x),Intg(y),Intg(w),Intg(h),Intg(col)","draw_rectangle(10,20,30,40,red);; clear(); draw_rectangle(10,20,30,40,red+filled); show_pixels();","draw_pixel,draw_line,draw_polygon"},
{"draw_string","Write a string at a given position (in pixels)","Str","draw_string(20,20,\"abcd\")","clear"},
{"droit","Returns the right part of an equality, of an interval, of a list or of a string.","Equal(a=b) or Interval(a..b) or Str,Intg","right(a=b);right(x^2+1=5);right(1..5);right(\"abcdefg\",3)","left,mid,tail,head"},
{"droite_tangente","Draws the tangent to y=f(x) at x=a.","","droite_tangente(sin(x),pi/4);droite_tangente(sin(t),t=pi/4);droite_tangente(sin(t),t,pi/4);droite_tangente(x^2-x,1)","tangent,LineTan"},
{"dsolve","Solves a differential equation or a differential linear system with constant coefficients.","Eq,[TimeVar],FncVar","desolve(y'+x*y=0);desolve(y'+x*y=0,y);desolve(y'+x*y=0,[0,1]);desolve([y'+x*y=0,y(0)=1],y);desolve([y'=[[1,2],[2,1]]*y+[x,x+1],y(0)=[1,2]]) ;desolve(y''+y=0,y);desolve([y''+y=sin(x),y(0)=1,y'(0)=2],y);desolve([y''+y=sin(x),y(0)=1,y'(0)=2],x,y);desolve([y''+y=sin(x),y(0)=1,y'(0)=2],[x,y]);desolve(diff(y(t),t)+t*y(t)=0,t,y);desolve(diff(y(t),t)+t*y(t)=0,[t,y]);desolve((y''+y=sin(x)) and (y(0)=1) and (y'(0)=2),y);desolve([z''+2*z'+z,z(0)=1,z'(0)=0],u,z);desolve([z''+2*z'+z,z(0)=1,z'(0)=0],z(u));desolve([z'=[[1,2],[2,1]]*z+[t,t+1],z(0)=[1,2]],t,z);desolve([z'=[[1,2],[2,1]]*z+[t,t+1],z(0)=[1,2]],z(t))","integrate,diff,odesolve,plotode,plotfiefd"},
{"duration","Returns the duration of an audio clip, in seconds.","Lst(clip)","duration(readwav(\"/some/file\"))","bit_depth,channels,channel_data,samplerate"},
{"e","exp(1)",""," evalf(e)","i,pi"},
{"e2r","Returns the coefficients of a polynomial with respect to the 2nd argument or if the second argument is a list the internal format of the polynomial.","Expr, LstVar or [Var]","symb2poly(x*3+2.1);symb2poly(3*x*y+2*y+1,y);symb2poly(3*x*y+2*y+1,x,y);symb2poly(3*x*y+2*y+1,[x,y]);symb2poly(-x^4+x*3*y+2+y^2*z,[x,y,z]);symb2poly(-x^4+x*3*y+2+y^2*z,[x,y,z])","poly2symb,r2e"},
{"ecart_type","Returns the standard deviation of the elements of its argument with an optional second argument as pound or the list of standard deviation of the columns of a matrix.","Lst||Mtrx,[Lst]","stddev([1,2,3]);stddev([1,2,3],[1,2,1]);stddev([[1,2,3],[5,6,7]])","mean,variance,stddevp"},
{"ecart_type_population","Returns an unbiaised estimate of the population standard deviation of the sample (first argument) with an optional list of pounds as second argument.","Lst||Mtrx,[Lst]","stddevp([1,2,3]);stddevp([1,2,3],[1,2,1]);stddevp([[1,2,3],[5,6,7]])","mean,stddev"},
{"ecm_factor","Factorization of integer n by the Elliptic Curve Method algorithm, B1 smoothness optional parameter","Intg(a),[Intg(B1)]","ecm_factor(1000000000000000003000000000000000000000000000000000031000000000000000093)",""},
{"ecris","Write the string s with the fount n (by default n=14) at the point [x,y] (by default at the point where the turtle is).","","ecris(\"bonjour\");ecris(\"bonjour\",20);ecris(\"bonjour\",20,30,10);ecris(bonjour,20,30,10)","signe"},
{"edge_connectivity","Returns the largest integer k for which G is k-edge connected, meaning that G remains connected after fewer than k edges are removed.","graph(G)","edge_connectivity(graph(\"petersen\"));edge_connectivity(graph(\"clebsch\"));edge_connectivity(complete_graph(5))","is_two_edge_connected,is_edge_cut,vertex_connectivity"},
{"edges","Return the list of edges in G [including weights].","Graph(G),[weights]","edges(complete_graph(4))","add_edge,incident_edges,set_edge_weight,get_edge_weight"},
{"efface","Erases the turtle screen or the turtle takes n steps back and erases.","","efface()","initialise"},
{"egcd","Extended greatest common divisor of 2 polynomials.","","egcd((x-1)^2,x^3-1);egcd((X-1)^2,X^3-1,X);egcd([1,-2,1],[1,0,0,-1]);egcd([1,-2,1],[1,-1,2])","gcd,iegcd"},
{"egv","Computes the eigenvectors of a diagonalizable matrix.","","egv([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);egv([[1,1,3],[1,3,1],[3,1,1]])","egvl,jordan"},
{"egvl","Returns the Jordan matrix associated to A when the eigenvalues are calculable.","","egvl([[4,1],[-4,0]]);egvl([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);egvl([[1,1,3],[1,3,1],[3,1,1]])","egv,jordan"},
{"eig","Returns the list made by the matrix of column-eigenvectors and of the eigenvalues of a matrix.","","a=array([[0,2],[1,0]]) ; p,d=eig(a)","egv,egvl,rat_jordan"},
{"eigVc","Computes the eigenvectors of a diagonalizable matrix.","Mtrx","egv([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);egv([[1,1,3],[1,3,1],[3,1,1]])","egvl,jordan"},
{"eigVl","Returns the Jordan matrix associated to A when the eigenvalues are calculable.","Mtrx(A)","egvl([[4,1],[-4,0]]);egvl([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);egvl([[1,1,3],[1,3,1],[3,1,1]])","egv,jordan"},
{"eigenvals","Returns the sequence of the (calculable) eigenvalues of a matrix.","","eigenvals([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);eigenvals([[1,1,3],[1,3,1],[3,1,1]]);eigenvals([[4,1],[-4,0]])","egv,jordan"},
{"eigenvalues","Returns the sequence of the (calculable) eigenvalues of a matrix.","Mtrx","eigenvals([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);eigenvals([[1,1,3],[1,3,1],[3,1,1]]);eigenvals([[4,1],[-4,0]])","egv,jordan"},
{"eigenvectors","Computes the eigenvectors of a diagonalizable matrix.","Mtrx","egv([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);egv([[1,1,3],[1,3,1],[3,1,1]])","egvl,jordan"},
{"eigenvects","Computes the eigenvectors of a diagonalizable matrix.","Mtrx","egv([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);egv([[1,1,3],[1,3,1],[3,1,1]])","egvl,jordan"},
{"element","Shows a point chosen on a curve or a real chosen in an interval",""," t:=element(0..1); t:=element(0..1,0.3); t:=element(0..1,0.3,0.02); P:=element(circle(i,1),t); M:=element(circle(i,1)); N:=element(circle(i,1),pi/2)","is_element"},
{"elif","Uses elif when you execute a series of tests (elif=else if). if condition1 then instruction1; elif condition2 then instruction2;...[else instruction;] end",""," if a>4 then [4,inf]; elif a>2 then [2,4]; elif a>0 then [0,2]; else [-inf,0];end;","if,else"},
{"eliminate","Eliminates the variables vars in a list of algebraic equations","","eliminate([x=v0*t,y=y0-g*t^2],t);eliminate([x+y+z+t-2,x*y*t=1,x^2+t^2=z^2],[x,z])",""},
{"ellipse","ellipse(F1,F2,M)=ellipse focus F1,F2 through M or such as MF1+MF2=2*a (geo2d) and ellipse(p(x,y)) draws the conic if deg(p)=2.","","ellipse(-1,1,point(1+i));ellipse(-1,1,1+sqrt(5));ellipse(2x^2+3y^2-x*y-10);ellipse(point(-1,0,0),point(1,0,0),point(1,1,1));ellipse(x^2+2y^2-y-2)","hyperbola,parabola"},
{"else","Starts false clause of an \"if\" statement: if (condition){instruction1;} else {instruction2;}",""," if (a>b) {a;} else {b;}","if"},
{"end","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"end_for","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"end_if","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"end_while","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"entry","Returns the n+1-th question of the command history if n>=0 or, the (-n)th previous question if n<0 (by defaults n=-1 for the previous question).","Intg(n)","quest();quest(2);quest(-2)","ans"},
{"envelope","Returns the envelope of the curves with equation Xpr=0, when t move.","","envelope(y+x*tan(t)-2*sin(t),t);envelope(v+u*tan(t)-3*sin(t),[u,v,t])","tangent,locus"},
{"epaisseur","Option (Maple compatibility) of a graphic command to define the thickness of lines.","Opt"," segment(0,point(1,1),thickness=5); segment(0,point(1,1),epaisseur=5)","line_width"},
{"epaisseur_ligne_1","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"epaisseur_ligne_2","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"epaisseur_ligne_3","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"epaisseur_ligne_4","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"epaisseur_ligne_5","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"epaisseur_ligne_6","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"epaisseur_ligne_7","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"epaisseur_point_1","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"epaisseur_point_2","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"epaisseur_point_3","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"epaisseur_point_4","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"epaisseur_point_5","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"epaisseur_point_6","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"epaisseur_point_7","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"epsilon","Returns the value of epsilon of the CAS configuration.","","epsilon()"," epsilon2zero"},
{"epsilon2zero","Values < epsilon are replaced by zero","","epsilon2zero(1e-13+x+5)","evalf"},
{"equal","Prefixed version of =",""," 2*x=4;equal(2*x,4);equal(x^2-3x+2,0)","=,equal2diff,equal2list,left,right"},
{"equal2diff","A=B or equal(A,B) is converted into the difference A-B","","equal2diff(x=2);equal2diff(equal(x,2))","left,right,equal2list,equal,="},
{"equal2list","A=B or equal(A,B)is converted into the list [A,B]","","equal2list(x=2);equal2list(equal(x,2))","left,right,equal2diff,equal,="},
{"equation","equation returns the cartesian equation of a curve","","equation(line(1-i,i),[x,y])","parameq"},
{"equilateral_triangle","equilateral_triangle(A,B) (resp equilateral_triangle(A,B,P)) draws the direct equilateral triangle ABC of side AB (resp in the half-plane ABP).","","equilateral_triangle(point(1+i),0);equilateral_triangle(0,1+i,C);equilateral_triangle(point(0,0,0),point(3,3,3),point(0,0,3));equilateral_triangle(point(0,0,0),point(3,3,3),point(0,0,3),C)","triangle"},
{"erase","Erase the graphic screen","","erase()","ClrGraph,erase3d"},
{"erase3d","Erase the graphic screen 3d","","erase3d()","ClrGraph,erase"},
{"erf","Returns the approximate value of 2/sqrt(pi)*int(exp(-t^2),t,0,x0).","","erf(1);erf(1/(sqrt(2)))*1/2","erfc"},
{"erfc","Returns the approximate value of 2/sqrt(pi)*int(exp(-t^2),t,x0,+infinity).","","erfc(1);erfc(1/(sqrt(2)))*1/2","erf"},
{"error","Generates the display of an error in a program","","error(\"Argument should be integer\");error(\"je provoque une erreur\")","try,catch"},
{"est_permu","Returns 1 if the argument is a permutation and 0 otherwise","Lst","is_permu([4,2,3,1]);is_permu([4,2,3,1,0])","is_cycle,permu2cycles"},
{"et","infixed boolean operator (and).","Expr, Expr"," 1==2 and 2>1; 1!=2 and 2>0","or,not,xor"},
{"euler","Euler's function (euler(n)=card({p<n,gcd(n,p)=1})).","","euler(11);euler(6)","gcd"},
{"euler_gamma","Euler's constant=euler_gamma=limit(sum(1/k,k,1,n)-ln(n),n,+infinity).",""," evalf(euler_gamma)",""},
{"euler_lagrange","Returns the (system of) Euler-Lagrange equation(s) for the functional F=int(f,x=a..b).","Expr(f),[(Var(x),[Var||Lst(y)]) || y(x) || Lst(y(x))]","euler_lagrange(x^2*y'^2+y^2);euler_lagrange(sqrt(x'^2+y'^2),[x(t),y(t)]); assume(y>=0):; euler_lagrange(sqrt((1+y'^2)/y),t,y)","dsolve,bvpsolve,convex"},
{"eval","Evaluates its argument.","","eval(2*sin(pi))","evalf"},
{"eval_level","Evaluation level in interactive mode","","eval_level();eval_level(1); purge(a,b,c);eval_level(1);a:=b+1; b:=c+1;c:=3;; purge(a,b,c);eval_level(2);a:=b+1; b:=c+1;c:=3;; purge(a,b,c);eval_level(3);a:=b+1; b:=c+1;c:=3;",""},
{"evala","Simplify the expression.","Expr","normal(2*x+y=1);normal(2*x*2);normal((2*x+1)^2)","simplify"},
{"evalb","Boolean evaluation of the argument","","evalb(a==2);evalb(sqrt(2)+pi>a)","evalf,eval"},
{"evalc","Returns an complex expression simplified with the format real+i*imag.","","evalc(-3+4*i+exp(i));evalc(1/(x+y*i))","normal"},
{"evalf","Numerical evaluation of the first argument (we can give the number of digits as second argument)","","evalf(2/3);evalf(2/3,2);evalf(2*sin(1));evalf(2*sin(1),40);evalf(sqrt(2)+pi);evalf(sqrt(2)+pi,30)","evalb,eval"},
{"evalm","Evaluates its argument.","Expr","eval(2*sin(pi))","evalf"},
{"even","Returns 1 if the integer is even, else returns 0.","","even(6);even(1251)","odd"},
{"evolute","Evolute of a curve C.","","evolute(plot(x^2));evolute([t,t^2],t);evolute([3*exp(t/2)*cos(t),3*exp(t/2)*sin(t)],t)","curvature,osculating_circle"},
{"exact","Converts the expression to a rational or real expression.","Expr","-2;float2rational(1.5);float2rational(1.4141);float2rational(0.156381102937)",""},
{"exbisector","Draws the exterior bisector of the angle (AB,AC) given by 3 points A,B,C.","","exbisector(0,1,i)","angle,bisector"},
{"excircle","excircle(A,B,C) draws the A-excircle of the ABC triangle.","","excircle(0,1,1+i)","incircle,circumcircle"},
{"execute","Instruction transforming a string into a command or into a number.","Str","expr(\"ifactor(54)\");expr(\"123\");expr(\"0123\");expr(sin,x)","string"},
{"exp","Exponential or Option of the convert or convertir command (id trig2exp).","","exp(0); convert(cos(x),exp)","ln,convert,trig2exp"},
{"exp2list","Returns the list made with the right member of (var=expr0 or var=expr1), to be used after solve in TI mode.","","exp2list((x=2) or (x=0));exp2list((x=3 and y=9) or (x=-1 and y=1) )","list2exp"},
{"exp2pow","Transforms exp(n*ln(x)) in x^n.","","exp2pow(exp(3*ln(x)));exp2pow(exp(x*ln(x)))","pow2exp"},
{"exp2trig","Transforms the complex exponential into sine and cosine.","","exp2trig(exp(i*x));exp2trig(exp(-i*x))","trig2exp,atrig2ln"},
{"expand","Full distribution of * and / over + and -","","expand((x+y)*(z+1));expand((a+b+c)/d);expand((y+x)*(z+y)*(x+z));expand((x+3)^4);expand((2*x-2*1)*(x^2-3*x+2)+(x^2-2*x+3)*(2*x-3*1))","texpand,normal,simplify,ratnormal"},
{"expexpand","Expands exponentials.","","expexpand(exp(3*x))","texpand,lnexpand,trigexpand"},
{"expln","Option of the convert or convertir command (id trig2exp).",""," convert(cos(x),expln)","exp,ln,convert,trig2exp"},
{"exponential","Returns the density of probability at x of the exponential law of parameter lambda.","","exponential(2.1,3.5);exponential(2.1,0.5); randvector(3,exponential,1.2); ranm(4,3,exponential,1.2)","exponential_cdf,exponential_icdf,randvector,ranm"},
{"exponential_cdf","Returns the probability that a exponential random variable of parameter lambda is lower than x0 (or between x0 and y0).","","exponential_cdf(4.2,2.1);exponential_cdf(4.2,2.1,3.2)","exponentiald,exponential_icdf"},
{"exponential_icdf","Returns h such that the probability that a exponential random variable of parameter lambda is lower than h is p (0<=p<=1).","","exponential_icdf(4.2,0.95);exponential_icdf(4.2,0.6)","exponential_cdf,exponentiald"},
{"exponential_regression","Returns the coefficients (a,b) of y=b*a^x : it is the best exponential which approx the points where the coordinates are the rows of A (or the 2 lists).","","exponential_regression([[1.0,2.0],[0.0,1.0],[4.0,7.0]]);exponential_regression([1.0,0.0,4.0],[2.0,1.0,7.0])","logarithmic_regression"},
{"exponential_regression_plot","Returns the plot of y=b*a^x : it is the best exponential which approx the points where the coordinates are the rows of A (or the 2 lists).","","exponential_regression_plot([[1.0,2.0],[0.0,1.0],[4.0,7.0]]);exponential_regression_plot([1.0,0.0,4.0],[2.0,1.0,7.0])","logarithmic_regression_plot"},
{"exponentiald","Returns the density of probability at x of the exponential law of parameter lambda.","Real(lambda),Real(x)","exponential(2.1,3.5);exponential(2.1,0.5); randvector(3,exponential,1.2); ranm(4,3,exponential,1.2)","exponential_cdf,exponential_icdf,randvector,ranm"},
{"exponentiald_cdf","Returns the probability that a exponential random variable of parameter lambda is lower than x0 (or between x0 and y0).","Real(lambda),Real(x0),[Real(y0)]","exponential_cdf(4.2,2.1);exponential_cdf(4.2,2.1,3.2)","exponentiald,exponential_icdf"},
{"exponentiald_icdf","Returns h such that the probability that a exponential random variable of parameter lambda is lower than h is p (0<=p<=1).","Real(lambda),Real(x0),Real(p)","exponential_icdf(4.2,0.95);exponential_icdf(4.2,0.6)","exponential_cdf,exponentiald"},
{"export_graph","Writes G to the file 'graphname.dot' in directory 'path/to' in dot format, returns 1 on success and 0 on failure.","Graph(G),Str(\"path/to/graphname\")","export_graph(complete_graph(5),\"K5\")","import_graph"},
{"expovariate","Returns a random real according to the exponential distribution of parameter a>0.","Real(a)","randexp(1);randexp(2)","rand,randpoly,randnorm,randvector"},
{"expr","Instruction transforming a string into a command or into a number.","","expr(\"ifactor(54)\");expr(\"123\");expr(\"0123\");expr(sin,x)","string"},
{"expression","DOM_SYMBOLIC or symbol is the type of a symbolic variable, as returned by the type command. It is also an option of the assume command.","Opt"," assume(a,symbol); assume(a,DOM_SYMBOLIC); a:=sqrt(2);type(a); type(2x+1)","type,assume,DOM_INT,DOM_FLOAT"},
{"extend","Concatenates two lists or two strings or two sequences or 2 matrix; L:=concat(L,L1) or L.concat(L1).","Lst,Lst||Seq,Seq||Str,Str||Mtrx,Mtrx","concat([1,2],[3,4,5]);concat(\"bon\",\"jour\");concat([[1,2],[3,4]],[[4,5,6],[6,7,8]]); L:=[1,2];L.concat([3,4,5]); S:=\"abcd\";S.concat(\"efghi\")","append,cat,semi_augment,border,+"},
{"extract_measure","extract_measure gives as answer the value calculated by the argument.","","extract_measure(distanceatraw(0,1+i,(1+i)/2));extract_measure(angleatraw(0,1,1+i,1)); A:=point(0);B:=point(1+i);a:=distanceatraw(A,B,(1+i)/2);extract_measure(a)","angleatraw,distanceatraw,angleat,distanceat,slopeatraw,areaatraw,perimeteratraw,slopeat,areaat,perimeterat"},
{"extrema","Search extrema of an expression","Expr,Var,a,b","extrema(-2*cos(x)-cos(x)^2,x);extrema((x^3-1)^4/(2x^3+1)^4,x=0..inf);extrema(x/2-2*sin(x/2),x=-12..12);extrema(x-ln(abs(x)),x); assume(a>=0):;extrema(x^2+a*x,x);extrema(x^7+3x^6+3x^5+x^4+2x^2-x,x);extrema((x^2+x+1)/(x^4+1),x);extrema(x^2+exp(-x),x);extrema(exp(-x)*ln(x),x);extrema(tan(x)*(x^3-5x^2+1),x=-0.5);extrema(tan(x)*(x^3-5x^2+1),x=0.5);extrema(exp(x^2-2x)*ln(x)*ln(1-x),x=0.5);extrema(ln(2+x-sin(x)^2),x=0..2*pi);extrema(x^3-2x*y+3y^4,[x,y]);extrema((2x^2-y)*(y-x^2),[x,y])  //Peano surface;extrema(5x^2+3y^2+x*z^2-z*y^2,[x,y,z]);extrema(3*atan(x)-2*ln(x^2+y^2+1),[x,y]);extrema(x*y,x+y=1,[x,y]);extrema(sqrt(x*y),x+y=2,[x,y]);extrema(x*y,x^3+y^3=16,[x,y]);extrema(x^2+y^2,x*y=1,[x=0..inf,y=0..inf]);extrema(ln(x*y^2),2x^2+3y^2=8,[x,y]);extrema(y^2+4y+2x-x^2,x+2y=2,[x,y]); assume(a>0):;extrema(x/a^2+a*y^2,x+y=a,[x,y]);extrema(6x+3y+2z,4x^2+2y^2+z^2=70,[x,y,z]);extrema(x*y*z,x+y+z=1,[x,y,z]);extrema(x*y^2*z^2,x+y+z=5,[x,y,z]);extrema(4y-2z,[2x-y-z=2,x^2+y^2=1],[x,y,z]);extrema((x-3)^2+(y-1)^2+(z-1)^2,x^2+y^2+z^2=4,[x,y,z]);extrema(x+3y-z,2x^2+y^2=z,[x,y,z]);extrema(2x*y+2y*z+x*z,x*y*z=4,[x,y,z]);extrema(x+y+z,[x^2+y^2=1,2x+z=1],[x,y,z]); assume(a>0):;extrema(x+y+z,[y^2-x^2=a,x+2z=1],[x,y,z]);extrema((x-u)^2+(y-v)^2,[x^2/4+y^2/9=1,(u-3)^2+(v+5)^2=1],[u,v,x,y]);extrema(x2^6+x1^3+4x1+4x2,x1^5+x2^4+x1+x2=0,[x1,x2]);extrema(x*y,-2x^3+15x^2*y+11y^3-24y=0,[x,y]);extrema(x2^4-x1^4-x2^8+x1^10,[x1,x2],order_size=1);extrema(x2^4-x1^4-x2^8+x1^10,[x1,x2]);extrema(x2^6+x1^3+4x1+4x2,x1^5+x2^4+x1+x2=0,[x1,x2]);extrema(x2^6+x1^3+2x1^2-x2^2+4x1+4x2,x1^5+x2^4+x1+x2=0,[x1,x2]);extrema(3x^2-2x*y+y^2-8y,[x,y]);extrema(x^3+3x*y^2-15x-12y,[x,y]);extrema(4x*y-x^4-y^4,[x,y]);extrema(x*sin(y),[x,y]);extrema(x^4+y^4,[x,y]);extrema(x^3*y-x*y^3,[x,y])  ;extrema(x^2+y^2+z^2,x^4+y^4+z^4=1,[x,y,z]);extrema(3x+3y+8z,[x^2+z^2=1,y^2+z^2=1],[x,y,z]);extrema(2x^2+y^2,x^4-x^2+y^2=5,[x,y]);extrema((3x^4-4x^3-12x^2+18)/(12*(1+4y^2)),[x,y]);extrema(x-y+z,[x^2+y^2+z^2=1,x+y+2z=1],[x,y,z]);extrema(ln(x)+2*ln(y)+3*ln(z)+4*ln(u)+5*ln(v),x+y+z+u+v=1,[x,y,z,u,v]);extrema(x*y*z,-2x^3+15x^2*y+11y^3-24y=0,[x,y,z]);extrema(x+y-exp(x)-exp(y)-exp(x+y),[x,y]);extrema(x^2*sin(y)-4*x,[x,y])    ;extrema((1+y*sinh(x))/(1+y^2+tanh(x)^2),[x,y]);extrema((1+y*sinh(x))/(1+y^2+tanh(x)^2),y=x^2,[x,y])",""},
{"ezgcd","GCD of 2 polynomials with at least 2 variables, with the ezgcd algorithm.","","ezgcd(x^2-2*xy+y^2-1,x-y);ezgcd((x+1)^4-y^4,(x+1-y)^2);ezgcd((x+y-1)*(x+y+1),(x+y+1)^2)","gcd,modgcd,heugcd,psrgcd"},
{"f2nd","Returns the list built with the numerator and the denominator of the simplified fraction .","","f2nd(42/12);f2nd((x^2+2*x+1)/(x^2-1))","simp2,numer,denom,getNum,getDenom"},
{"fMax","Returns the abscissa of the maximum of the expression.","","fMax(-x^2+2*x+1,x);fMax(-x^2+2*x+1,x=1..2)","fMin"},
{"fMin","Returns the abscissa of the minimum of the expression.","","fMin(x^2-2*x+1,x);fMin(x^2-2*x+1,x=1..2);fMin((x-3)^2+(y-5)^2+1,[],[x,y],[1,1]);fMin((x-3)^2+(y-5)^2+1,[x+y^2=1],[x,y],[1,1])","fMax"},
{"fPart","Returns the fractional part (if x<0 then frac(x)+floor(x)+1=x else frac(x)+floor(x)=x).","","fPart(1/2);fPart(-1/2);fPart(1.2);fPart(-1.2);fPart([3.4,sqrt(2)])","floor,iPart,trunc"},
{"faces","Returns the list of the faces (1 face=matrix(n,3) where the n rows are the n vertices of the face) of the polyhedron P.","","faces(polyhedron([0,0,0],[0,5,0],[0,0,5],[1,2,6]));faces(polyhedron([0,0,0],[0,5,0],[0,0,5],[1,2,6]))[2]","polyhedron"},
{"facteurs_premiers","Returns the list of prime factors of an integer (each factor is followed by its multiplicity).","Intg(a) or LstIntg","ifactors(36);ifactors([36,52])","ifactor,factors"},
{"factor","Factorizes a polynomial.","","factor(x^4-1);factor(x^4-4,sqrt(2));factor(x^4+12*x^3+54*x^2+108*x+81)","ifactor,partfrac,normal"},
{"factor_xn","Factorizes x^n in P (n=degree of polynomial P).","","factor_xn(x^4-1);factor_xn(x^4+12*x^3+54*x^2+108*x+81)","ifactor,partfrac,normal"},
{"factorial","factorial(n)=n!. For non-integers,factorial(a)=a! = G(a + 1). This calculates the Gamma function.","","factorial(4);factorial(1.2)","comb,perm"},
{"factoriser","Factorizes a polynomial.","Expr","factor(x^4-1);factor(x^4-4,sqrt(2));factor(x^4+12*x^3+54*x^2+108*x+81)","ifactor,partfrac,normal"},
{"factoriser_entier","Factorization of an integer into prime factors.","Intg(a)","ifactor(50);ifactor(123456789)","factor,ecm_factor"},
{"factoriser_sur_C","Factorization of the expression in ℂ (on the Gauss integers if there are more than 2 variables).","Expr","cFactor(x^2*y+y);cFactor(x^2*y^2+y^2+4*x^2+4);cFactor(x^2*y^2+y^2+2*x^2+2)","factor"},
{"factors","Returns the list of prime factors of a polynomial (each factor is followed by its multiplicity).","","factors(x^4-1);factors([x^2,x^2-1])","factor,ifactors"},
{"fadeev","Option of the pcar or charpoly command to specify the algorithm.",""," pcar([[4,1,-2],[1,2,-1],[2,1,0]],fadeev)","pcar"},
{"faire","Key word used in a loop.",""," faire ffaire; n:=1;do n:=n+1; if (n>15) break; n:=2*n;od;; n:=1;tantque n<5 faire triangle_plein(10*n);saute(10*n);n:=n+1;ftantque; pour n de 1 jusque 4 faire triangle_plein(10*n);saute(10*n);fpour","tantque,pour,repeat"},
{"false","boolean equal to false or 0.",""," a:=false","true"},
{"falsepos_solver","Argument for fsolve giving the method for solving an numerical equation.","Opt"," fsolve(cos(x)=x,x,0..1,bisection_solver); fsolve(cos(x)=x,x,0..1,brent_solver); fsolve(cos(x)=x,x,0..1,falsepos_solver); fsolve(cos(x)=x,x,0,newton_solver); fsolve(cos(x)=x,x,0,secant_solver); fsolve(cos(x)=x,x,0,steffenson_solver)","fsolve"},
{"fclose","Closes the file f.","","fclose(f)","fprint,fopen"},
{"fcoeff","Returns the polynomial describe by the list (root or pole, order).","","fcoeff([1,2,0,1,3,-1])","pcoeff,froot,proot"},
{"fdistrib","Full distribution of * and / over + and -","Expr","expand((x+y)*(z+1));expand((a+b+c)/d);expand((y+x)*(z+y)*(x+z));expand((x+3)^4);expand((2*x-2*1)*(x^2-3*x+2)+(x^2-2*x+3)*(2*x-3*1))","texpand,normal,simplify,ratnormal"},
{"feuille","Returns the arguments of an operator as a sequence.","","feuille(quote(gcd(45,126)));feuille('gcd(45,126)');feuille('1+2')[1];feuille([1,2,3]);feuille(set[1,2,3])","sommet,quote,makesuite"},
{"ffaire","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"ffonction","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"fft","Fast Fourier Transform in ℝ or in the field ℤ/pℤ, with a as primitive n-th root of 1 (n=size(L)).","","fft([1,2,3,4,0,0,0,0]);fft(ranm(128),22798,35969)","ifft"},
{"ffunction","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"fi","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"fieldplot","fieldplot(f(t,y),[t,y]) draws the plotfield of the diff equation y'=f(t,y).","","fieldplot(sin(t*y),[t=-5..5,y=-3..3],xstep=0.5,ystep=0.5);fieldplot(-t*y,[t,y]);fieldplot(-t*y,[t,y],normalize);fieldplot(-t*y,[t,y],normalize,xstep=0.5,ystep=0.5);fieldplot(-t*y,[t=-6.868..6.868,y=-6.868..6.868],normalize)","interactive_plotode,odeplot,odesolve,desolve"},
{"filled","Option of the display command to fill figures.",""," F:=display(square(0,2+i),filled); C:=display(square(2,2+i),red+filled)","display"},
{"fin_enregistrement","Marks the end of the recording of the commands and save these commands in the file whose name is the argument.","","fin_enregistrement(\"maison.tor\");fin_enregistrement(\"arbre.tor\")","debut_enregistrement"},
{"find","List of positions of an object in a list, a string or a set.","Expr,Vect","find(1,[3,x,1,2,1,3]);find(2,[0,1,3,2,4,2,5])[0];find(\"a\",\"abracadabrant\");find(\"ab\",\"abracadabrant\");find(1,%{4,3,1,2%})","index,member"},
{"find_cycles","Returns the list of elementary cycles of the digraph G. If option \"length\" is specified, only cycles of length k resp. of length between l and u are returned.","Graph(G,[length=k||l..u])","find_cycles(digraph(%{[1,2],[1,3],[3,1],[1,4],[2,3],[4,3],[4,5],[5,3],[5,6],[7,6],[8,6],[8,7]%}));find_cycles(digraph(%{[1,2],[1,3],[3,1],[1,4],[2,3],[4,3],[4,5],[5,3],[5,6],[7,6],[8,6],[8,7]%}),length=3);find_cycles(digraph(%{[1,2],[1,3],[3,1],[1,4],[2,3],[4,3],[4,5],[5,3],[5,6],[7,6],[8,6],[8,7]%}),length=3..4)","is_acyclic"},
{"findhelp","Returns the help about the command (if ? is infixed see when) .","","findhelp(ifactor)","ifte,when"},
{"fisher","Returns the density of probability of the Fisher-Snedecor law (n and m are the numbers of degrees of freedom).","","fisher(4,10,2.1);fisher(4,4,2.1); randvector(5,fisher,4,6); ranm(2,3,fisher,4,6)","fisher_cdf,fisher_icdf,randvector,ranm"},
{"fisher_cdf","Returns the probability that a Fisher-Snedecor random variable is lower than x0 (n and m are the numbers of degrees of freedom).","","fisher_cdf(4,4,2.1);fisher_cdf(4,10,3.5)","UTPF,fisher_icdf,fisherd"},
{"fisher_icdf","Returns h such as the probability that a Fisher-Snedecor random variable is lower than h is p (n and m are the numbers of degrees of freedom and 0<=p<=1).","","fisher_icdf(4,10,0.95);fisher_icdf(4,10,0.05)","fisher_cdf,fisherd"},
{"fisherd","Returns the density of probability of the Fisher-Snedecor law (n and m are the numbers of degrees of freedom).","Intg(n),Intg(m),Real(x0)","fisher(4,10,2.1);fisher(4,4,2.1); randvector(5,fisher,4,6); ranm(2,3,fisher,4,6)","fisher_cdf,fisher_icdf,randvector,ranm"},
{"fisherd_cdf","Returns the probability that a Fisher-Snedecor random variable is lower than x0 (n and m are the numbers of degrees of freedom).","Intg(n),Intg(m),Real(x0)","fisher_cdf(4,4,2.1);fisher_cdf(4,10,3.5)","UTPF,fisher_icdf,fisherd"},
{"fisherd_icdf","Returns h such as the probability that a Fisher-Snedecor random variable is lower than h is p (n and m are the numbers of degrees of freedom and 0<=p<=1).","Intg(n),Intg(m),Real(p)","fisher_icdf(4,10,0.95);fisher_icdf(4,10,0.05)","fisher_cdf,fisherd"},
{"fitdistr","Returns the distribution of type D which fits most closely to the i.i.d. samples in the list L.","Lst(L),Fnc(D)","fitdistr(randvector(1000,weibulld,1/2,1),weibull); X:=randvar(normal,stddev=9.5):;Y:=randvar(normal,stddev=1.5):;S:=sample(eval(X/Y,0),1000):;Z:=fitdistr(S,cauchy); X:=randvar(normal,mean=5,variance=2):;S:=sample(exp(X),1000):;fitdistr(log(S),normal)","normald,poisson,exponentiald,geometric,gammad,betad,cauchyd,weibulld,sample,randvector,randvar"},
{"flatten","Recursively flatten a list containing lists.","","flatten([[1,[2,3],4],[5,6]])","mat2list"},
{"float","DOM_FLOAT or float is an integer representing the type of a floating point variable, returned by the type command. It is also an option of the assume command.","Opt"," type(2.3); DOM_FLOAT+0; assume(a,DOM_FLOAT); assume(a,real); type(1.2)","type,assume,DOM_INT,DOM_SYMBOLIC"},
{"float2rational","Converts the expression to a rational or real expression.","","-2;float2rational(1.5);float2rational(1.4141);float2rational(0.156381102937)",""},
{"floor","Returns the greatest integer <= to the argument","","floor(-2.5);floor(2.5-4.2*i)","round,ceil,iPart,trunc"},
{"flow_polynomial","Returns the flow polynomial [or its value at point x] of undirected unweighted graph G.","Graph(G),[Var(x)]","flow_polynomial(graph(\"tetrahedron\"));flow_polynomial(graph(\"tetrahedron\"),5)","chromatic_polynomial,reliability_polynomial,tutte_polynomial"},
{"fmod","","Real(a),Real(b)","fmod(10.0,pi)",""},
{"foldl","Returns the composition of the binary operator or function op, with an identity or initial value id onto its arguments r1, r2, ..., associating from the left.","op,id,Seq(r1,r2,...)","foldl(F,init,a,b,c)","apply,foldr,map"},
{"foldr","Returns the composition of the binary operator or function op, with an identity or initial value id onto its arguments r1, r2, ..., associating from the right.","op,id,Seq(r1,r2,...)","foldr(F,init,a,b,c)","apply,foldl,map"},
{"fonction	","Instruction which define an user function.","Fnc(f)","fonction f(a,b) local c;c=a+b;c+gcd(a,b);ffonction;; f:=function(a,b) local c;c=a+b;c+gcd(a,b);end;; f:=fonction(a,b) local c;c=a+b;c+gcd(a,b);ffonction;","->,:=,end,ffonction"},
{"fonction_derivee","Returns the derivative function of the function f.","Fnc(f)","function_diff(sin+id);function_diff(sq@sin+id);function_diff(ln)(x,y);function_diff(ln)([x,y]); (function_diff @@3)(ln)('x') ","diff,',@"},
{"fopen","Opens a file named s, returns a variable of type file.",""," f:=fopen(\"glouglou\")","fprint,fclose,readrgb,readwav,csv2gen"},
{"for","Loop: for (init;do_if_true;increment) {action;}","","  fact10():={local j,n:=1; for(j:=0;j<=10;j++) n:=n*j;};  g():={local j,s:=0; for(j:=1;j<=10;j:=j+2) s:=s*j;};  s:=0;for j from 1 to 10 by 2 do s:=s+j end_for;","from,to,pour,by,{}"},
{"format","Transforms the real into a string with the indicated format (f=float,s=scientific,e=engineering).","","format(9.3456,\"f3\");format(9.3456,\"s3\");format(9.3456,\"e3\")","string"},
{"forward","The turtle takes n steps forward (by default n=10).","NULL or Real(n)"," avance 30;avance(30)","recule,saute"},
{"fourier_an","Returns the n-th Fourier coefficient an=2/T*integrate(f(x)*cos(2*pi*n*x/T),a,a+T).","","fourier_an(x^2,n);fourier_an(x^2,x,2*pi,n,-pi)","fourier_cn,fourier_bn,assume"},
{"fourier_bn","Returns the n-th Fourier coefficient bn=2/T*integrate(f(x)*sin(2*pi*n*x/T),a,a+T).","","fourier_bn(x^2,n);fourier_bn(x^2,x,2*pi,n,-pi)","fourier_cn,fourier_an,assume"},
{"fourier_cn","Returns the n-th Fourier coefficient cn=1/T*integrate(f(x)*exp(-2*i*pi*n*x/T),a,a+T).","","fourier_cn(x^2,n);fourier_cn(x^2,x,2*pi,n,-pi)","fourier_an,fourier_bn,assume"},
{"fpour","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"fprint","Writes in the file f some data.","","fprint(f,x+1,\"2\");fprint(f,\"blabla\");fprint(f,Unquoted,\"blabla\")","fopen,fclose"},
{"frac","Returns the fractional part (if x<0 then frac(x)+floor(x)+1=x else frac(x)+floor(x)=x).","Real||LstReal","fPart(1/2);fPart(-1/2);fPart(1.2);fPart(-1.2);fPart([3.4,sqrt(2)])","floor,iPart,trunc"},
{"fracmod","Returns the fraction a/b such as b*Xpr=a mod n, -sqrt(n)/2<a<=sqrt(n)/2 and 0<=b<sqrt(n)/2.","","fracmod(41,121)","mod,smod"},
{"frame_2d","frame_2d() draws the axes of the graphic-screen 2-d.","","frame_2d()","frame_3d,Ox_2d_unit_vector,Oy_2d_unit_vector"},
{"frame_3d","frame_3d() draws the axes of the graphic-screen 3-d.","","frame_3d()","frame_2d,Ox_3d_unit_vector,Oy_3d_unit_vector,Oz_3d_unit_vector"},
{"frames","Option of animate and animate3d commands to give the number of pictures.",""," animate(sin(x*t),x=-pi..pi,t=-3..3,frames=30); animate3d(x^2+t*y^2,[x=-2..2,y=-2..2],t=-3..3,frames=10)","animate,animate3d"},
{"frequencies","Returns the frequencies of a list values.","","frequencies([1,2,1,1,2,1,2,4,3,3]);frequencies([(rand(6)+1)$(k=1..100)])","histogram,cumulated_frequencies,bar_plot,classes"},
{"frobenius_norm","Frobenius norm of a matrix A (=sqrt(sum |aij|^2)).","","frobenius_norm([[1,2,3],[3,-9,6],[4,5,6]])","l1norm,l2 norm,linfnorm,matrix_norm"},
{"from","Used in a loop for (for...from ...to... [step...] do...od;).",""," pour de jusque [pas] faire fpour;; S:=0;pour n de 1jusque 4 faire S:=S+n;fpour;; S:=0;for n from 1 to 4 do S:=S+n;end;; S:=0;pour n de 4 jusque 1 pas -1 faire S:=S+n;fpour ;","for,pour,jusque,to"},
{"froot","Returns the list of roots and poles of F with their multiplicity.","","froot((x^5-2*x^4+x^3)/(x-3));froot((x^5-2*x^4+x^3)/(x-1))","proot,fcoeff,pcoeff,realroot,complexroot,rationalroot,crationalroot"},
{"fsi","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"fsi","Conditional instruction : (si...alors...sinon...fsi).",""," si alors sinon fsi; n:=1; si n>0 alors triangle_plein(20*n); sinon disque(20*n);fsi;; n:=-1; si n>0 alors triangle_plein(20*n); sinon disque(20*n);fsi;; si x>0 alors x:=x+1; print(\"x est strictement plus grand que 1\");fsi;; si x>0 alors x:=x+1; print(\"x est strictement plus grand que 1\"); sinon x:=x-1;print(\"x est plus petit ou égal à -1\");fsi;","if"},
{"fsolve","Numerical solution of an equation or a system of equation.","","fsolve(cos(x)=x,x,-1..1,bisection_solver);fsolve(cos(x)=x,x,0,newton_solver);fsolve([x^2+y-2,x+y^2-2],[x,y],[0,0],newtonj_solver);fsolve([x^2+y-2,x+y^2-2],[x,y])","cfsolve,nSolve,solve,csolve,lpsolve,nlpsolve"},
{"ftantque","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"fullparfrac","Option of the convert or convertir command (id at the option partfrac).","Opt"," convert(1/(x^2-1),parfrac); convert(1/(x^2-1),fullparfrac)","convert"},
{"func","DOM_FUNC or func is the type of a function, as returned by the type command. It is also an option of the assume command.","Opt"," assume(a,DOM_FUNC); a(x):=1+x;type(a); type(sin); type(factor)","type,assume,DOM_INT,DOM_FLOAT"},
{"funcplot","Plot a 1 variable or 2 variables expression with superposition.","Expr,[Var(x) or VectVar] ,[Intg(color)]","plotfunc(-2*x+1,x=1..2,color=red);plotfunc([-2*x+1,x^2-2],x=-2..2,color=[red,yellow],xstep=0.2);plotfunc(x^2-y^2,[x,y],xstep=0.5,ystep=0.3);plotfunc(x^2+y^2,[x=-1..1,y=-2..2],nstep=900);plotfunc((x+i*y)^2,[x=-1..1,y=-2..2],nstep=900,affichage=rempli)","plot,plot3d,plotparam,animate,animate3d,plotdensity"},
{"function","Instruction which define an user function.","","fonction f(a,b) local c;c=a+b;c+gcd(a,b);ffonction;; f:=function(a,b) local c;c=a+b;c+gcd(a,b);end;; f:=fonction(a,b) local c;c=a+b;c+gcd(a,b);ffonction;","->,:=,end,ffonction"},
{"function_diff","Returns the derivative function of the function f.","","function_diff(sin+id);function_diff(sq@sin+id);function_diff(ln)(x,y);function_diff(ln)([x,y]); (function_diff @@3)(ln)('x') ","diff,',@"},
{"fxnd","Returns the list built with the numerator and the denominator of the simplified fraction .","Frac or RatFrac","f2nd(42/12);f2nd((x^2+2*x+1)/(x^2-1))","simp2,numer,denom,getNum,getDenom"},
{"gammad","Returns the density of probability of the Gamma law (=x^(a-1)*exp(-b*x)*b^a/Gamma(a)).","","gammad(2.2,1.5,0.8)","gammad_cdf;,gammad_icdf"},
{"gammad_cdf","Returns the probability that a Gamma random variable (with a and b as parameters) is lower than x0 or between x0 and y0.","","gammad_cdf(2,1,2.96);gammad_cdf(2,1,1.4,2.96)","gammad,gammad_icdf"},
{"gammad_icdf","Returns h such that the probability that a Gamma random variable is lower than h is p (0<=p<=1).","","gammad_icdf(2,1,0.95);gammad_icdf(2,1,0.5)","gammad_cdf,gammad"},
{"gammavariate","Returns a random real according to the Gamma distribution of parameter a>0 and b>0","Real(a),Real(b)","randgammad(1,2);randgammad(1.5,4)","rand,randpoly,randnorm,randvector"},
{"gauche","Returns the left part of an equality, of an interval, of a list or of a string.","Equal(a=b) or Interval(a..b) or Str,Intg","left(a=b);left(x^2+1=5);left(1..5);left(\"abcdefg\",3)","right,mid,tail,head"},
{"gauss","Split a quadratic form as a sum/difference of square","","gauss(x^2+2*a*x*y,[x,y])","cholesky"},
{"gauss15","Option of the area command","Opt"," area(x^2,x=0..1,5,simpson); area(x^2,x=0..1,5,rombergt); area(x^2,x=0..1,5,rombergm);area(x^2,x=0..1,5,gauss15)","area"},
{"gauss_seidel_linsolve","Resolution of a linear system A*X=b  by the iterative Gauss-Seidel method (by default omega=1) or by relaxation method, with eps as error margin and a number of iterations inferior to maxiter.",""," a:=[[100,2],[2,100]];gauss_seidel_linsolve(a,[0,1],1e-12);; a:=[[100,2],[2,100]];gauss_seidel_linsolve(table(a),[0,1],1e-12); ; a:=[[100,2],[2,100]];gauss_seidel_linsolve(1.5,a,[0,1],1e-12);; a:=[[100,2],[2,100]];gauss_seidel_linsolve(1.5,table(a),[0,1],1e-12); ","jacobi_linsolve,linsolve"},
{"gaussian_window","Applies the Gaussian windowing function with parameter 0<a<=0.5 (by default a=0.1) to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Real(a)],[Interval(n1..n2)]"," scatterplot(gaussian_window(randvector(1000,0..1),0.4))","blackman_harris_window,blackman_window,bohman_window,cosine_window,bartlett_hann_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"gaussjord","Row reduction to echelon form of AX=b (M=A|(-b)) [Reduction on columns 0..k-1]","Mtrx(M),[Intg(k)]||Opt","rref([[3,1,-2],[3,2,2]]);rref([[2,1,1,-1],[1,1,2,-1],[1,2,1,-4]]);rref([[2,1,1,-1],[1,1,2,-1],[1,2,1,-4]],2);rref([[1,1,0,0,-a1],[0,1,1,0,-a2],[0,0,1,1,-a3],[1,0,0,1,-a4]],keep_pivot)","ker,image,det,Rref,pivot,ref,keep_pivot"},
{"gaussquad","Returns the approximate value of integrate(f(x),x,a,b) by adaptive Gaussian quadratures with 15 points.","","gaussquad(exp(x^2),x,0,1);gaussquad(x^2,x,0,1);gaussquad(exp(-x^2),x,-1,1)","integrate,romberg"},
{"gbasis","Groebner basis of the ideal spanned by the list of polynomials.","","gbasis([x^2-y^3,x+y^2],[x,y]);gbasis([x1+x2+x3,x1*x2+x1*x3+x2*x3,x1*x2*x3-1],[x1,x2,x3]);gbasis([x1+x2+x3,x1*x2+x1*x3+x2*x3,x1*x2*x3-1],[x1,x2,x3],tdeg);gbasis([x1+x2+x3,x1*x2+x1*x3+x2*x3,x1*x2*x3-1],[x1,x2,x3],plex);gbasis([x1+x2+x3,x1*x2+x1*x3+x2*x3,x1*x2*x3-1] mod 29,[x1,x2,x3])","greduce,gbasis_max_pairs,gbasis_simult_primes"},
{"gbasis_max_pairs","Gbasis fine-tuning: maximal number of S-pairs to be reduced simultaneously inside F4 algorithm (default 32768, 0 means no limit). Set it to a smaller value if short in memory.","Intg","gbasis_max_pairs(4096);gbasis_max_pairs(0)","gbasis,gbasis_simult_primes,gbasis_reinject"},
{"gbasis_reinject","Gbasis fine-tuning: in the modular algorithm of a gbasis over Q, adds a partial reconstruction of the basis if the ratio of new elements is greater than a and the speed ratio of the 2nd run/1st run is >= b (default a=0.2 and b=1/6.)","Real(a),[Real(b)]","gbasis_reinject(0.1);gbasis_reinject(0.1,0.05)","gbasis,gbasis_max_pairs,gbasis_reinject "},
{"gbasis_simult_primes","Gbasis fine-tuning: maximal number of Groebner basis modulo a prime that are computed simultaneously to rebuild a Groebner basis over Q (default 16). Set it to a smaller value if short in memory.","Intg","gbasis_simult_primes(3)","gbasis,gbasis_max_pairs,gbasis_reinject "},
{"gcd","Returns the greatest common divisor of 2 polynomials of several variables or of 2 integers or of 2 rationals.","","gcd(45,75);gcd(15/7,50/9);gcd(x^2-2*x+1,x^3-1);gcd(t^2-2*t+1,t^2+t-2);gcd((x^2-1)*(y^2-1)*z^2,x^3*y^3*z+(-(y^3))*z+x^3*z-z)","lcm,euler,modgcd,ezgcd,psrgcd,heugcd,Gcd"},
{"gcdex","Extended greatest common divisor of 2 polynomials.","(Poly or Lst),(Poly or Lst),[Var]","egcd((x-1)^2,x^3-1);egcd((X-1)^2,X^3-1,X);egcd([1,-2,1],[1,0,0,-1]);egcd([1,-2,1],[1,-1,2])","gcd,iegcd"},
{"genpoly","Returns the reconstruction of a n-variables polynomial Q(-b/2<=coef<=b/2) from a (n-1)-variable polynomial P and a base b (subst(Q,var=b)=P).","","genpoly(15,4,x);genpoly(7*y+5,6,x);genpoly(7*y-5*z,10,x)",""},
{"geometric","Returns the value at k of the geometric law of parameter p (0<p<1).","","geometric(0.3,4);geometric(0.5,5); randvector(3,geometric,0.3); ranm(4,3,geometric,0.3)","geometric_cdf,geometric_icdf,randvector,ranm"},
{"geometric_cdf","Returns the probability that a geometric random variable of parameter p (0<p<1) is lower than k (or between k and m).","","geometric_cdf(0.3,4);geometric_cdf(0.3,4,5)","geometric,geometric_icdf"},
{"geometric_icdf","Returns h such that the probability that a geometric random variable of parameter p (0<p<1) is lower than h is x (0<=x<=1).","","geometric_icdf(0.3,0.95)","geometric_cdf,geometric"},
{"getDenom","Returns the denominator of the unsimplified expression (except for rational number).","","getDenom(25/15);getDenom((x^3-1)/(x^2-1));getDenom(1+(x^3-1)/x^2)","denom,getNum,numer,f2nd"},
{"getKey","Instruction in a program, returns 0 if no key is pressed and else returns the ascii code of the pressed key.","","getKey()","getType"},
{"getNum","Returns the numerator of the unsimplified expression (except for rational number).","","getNum(25/15);getNum((x^3-1)/(x^2-1));getNum(1+(x^3-1)/x^2)","numer,denom,getDenom,f2nd"},
{"getType","Returns the type of the argument (STR,EXPR,FUNC,NUM,LIST,MAT,VAR,NONE,PIC...).","","getType(\"aze\");getType(2+i);getType(x->cos(2*x));getType(1.414)","getKey"},
{"get_edge_attribute","Return the attributes tag1, tag2, ... assigned to edge e in G as a sequence of the corresponding values.","Graph(G),Edge(e),Seq(tag1=value1,tag2=value2,..)","get_edge_attribute(cycle_graph(3),[1,2],\"cost\")","discard_edge_attribute,set_edge_attribute,list_edge_attributes"},
{"get_edge_weight","Returns the weight of the edge e in the weighted graph G.","Graph(G),Edge(e)","get_edge_weight(graph(%{[[1,2],5],[[2,3],6]%}),[1,2])","is_weighted,make_weighted,set_edge_weight,weight_matrix"},
{"get_graph_attribute","Return the graph attributes tag1, tag2, ..., as a sequence of the corresponding values.","Graph(G),Seq(tag1=value1,tag2=value2,..)","get_graph_attribute(cycle_graph(3),\"name\")","discard_graph_attribute,set_graph_attribute,list_graph_attributes"},
{"get_vertex_attribute","Return the attributes tag1, tag2, ... assigned to vertex v in G as a sequence of the corresponding values.","Graph(G),Vrtx(v),Seq(tag1=value1,tag2=value2,..)","get_vertex_attribute(cycle_graph(3),1,\"supply\")","discard_vertex_attribute,set_vertex_attribute,list_vertex_attributes"},
{"girth","Returns the length of the shortest cycle in the undirected unweighted graph G.","Graph(G)","girth(graph(\"petersen\"));girth(hypercube_graph(3))","odd_girth"},
{"gl_ortho","Global option that sets a orthonormal graphic configuration.",""," gl_ortho=1; cercle(i,1+i)",""},
{"gl_quaternion","Option that defines the quaternion for the visualization in 3-d scenes (do not use for interactive scenes).",""," gl_quaternion=[-0.35752,-0.50198,-0.64393,0.45338]",""},
{"gl_rotation","Global option that defines the rotation axis for the animation rotation of 3-d scene.",""," gl_rotation=[1,1,1];cube([0,0,0],[3,0,0],[0,0,1])",""},
{"gl_showaxes","Option that shows or hides axes.","Opt=Boolean"," gl_showaxes=true;plot(sin(x)); gl_showaxes=false;plot(sin(x)) ","switch_axes,axes"},
{"gl_shownames","Option that shows or hides objects names.",""," gl_shownames=true;K:=carre(i,1+i); gl_shownames=false;K:=carre(i,1+i)",""},
{"gl_texture","Option that puts a picture in a rectangle of sides parallel to the axis (2-d) or on a 3-d surface or to fill the background (2-d).",""," carre(i,1+i,gl_texture=\"image.jpg\"); gl_texture=\"image.jpg\"; carre(i,1+i)",""},
{"gl_x","Global option that sets the graphic configuration.",""," gl_x=0..2; carre(i,1+i)",""},
{"gl_x_axis_color","Global option that is an individual definition of the colors of the x, (or y or z) axis.",""," gl_x_axis_color=123;; gl_y_axis_color=216;; gl_z_axis_color=3;",""},
{"gl_x_axis_name","Global option that is an individual definition of the names of the x (or y or z) axis.",""," gl_x_axis_name=\"s\";; gl_y_axis_name=\"m/s\";",""},
{"gl_x_axis_unit","Global option that is an individual definition of the units of the x, (or y or z) axis.",""," gl_x_axis_unit=\"s\";; gl_y_axis_unit=\"m/s\";",""},
{"gl_xtick","Global option that defines the interval between tick marks on the x (resp. y, z) axis.",""," gl_xtick=0.5; gl_ytick=1",""},
{"gl_y","Global option that sets the graphic configuration.","Opt=Interval"," gl_x=0..2; carre(i,1+i)",""},
{"gl_y_axis_color","Global option that is an individual definition of the colors of the x, (or y or z) axis.","Opt=Intg"," gl_x_axis_color=123;; gl_y_axis_color=216;; gl_z_axis_color=3;",""},
{"gl_y_axis_name","Global option that is an individual definition of the names of the x (or y or z) axis.","Opt=Str"," gl_x_axis_name=\"s\";; gl_y_axis_name=\"m/s\";",""},
{"gl_y_axis_unit","Global option that is an individual definition of the units of the x, (or y or z) axis.","Opt=Str"," gl_x_axis_unit=\"s\";; gl_y_axis_unit=\"m/s\";",""},
{"gl_ytick","Global option that defines the interval between tick marks on the x (resp. y, z) axis.","Opt=Real"," gl_xtick=0.5; gl_ytick=1",""},
{"gl_z","Global option that sets the graphic configuration.","Opt=Interval"," gl_x=0..2; carre(i,1+i)",""},
{"gl_z_axis_color","Global option that is an individual definition of the colors of the x, (or y or z) axis.","Opt=Intg"," gl_x_axis_color=123;; gl_y_axis_color=216;; gl_z_axis_color=3;",""},
{"gl_z_axis_name","Global option that is an individual definition of the names of the x (or y or z) axis.","Opt=Str"," gl_x_axis_name=\"s\";; gl_y_axis_name=\"m/s\";",""},
{"gl_z_axis_unit","Global option that is an individual definition of the units of the x, (or y or z) axis.","Opt=Str"," gl_x_axis_unit=\"s\";; gl_y_axis_unit=\"m/s\";",""},
{"gl_ztick","Global option that defines the interval between tick marks on the x (resp. y, z) axis.","Opt=Real"," gl_xtick=0.5; gl_ytick=1",""},
{"gnuplot","Run a gnuplot command (in the 3-d screen).","","gnuplot(\"splot u,v,u+v\")",""},
{"goto","In a program, is used to jump to an instruction with the label nom.",""," essai(a):={label truc;a:=a+2;if (a<10) goto truc;print(a);}","label"},
{"grad","Returns the gradient of the expression Xpr","","grad(2*x^2*y-x*z^3,[x,y,z])","hessian"},
{"gramschmidt","Returns an orthonormal base of E of base B for the scalar product Sp","","-2;gramschmidt([1,1+x],(p,q)->integrate(p*q,x,-1,1))",""},
{"graph","Create an (un)directed (un)weighted graph from vertices V, edges E, and/or adjacency or weight matrix A. All parameters are optional.","[Lst(V)],[Set(E)],[Mtrx(A)],[options]","graph(5);graph([a,b,c]);graph([1,2,3],%{[1,2],[2,3],[3,1]%});graph(trail(1,2,3,4,1),directed=true);graph([a,b,c],[[0,2,0],[2,0,3],[0,3,0]]);graph(\"petersen\");graph([[0,1,1,0],[1,0,0,1],[1,0,0,0],[0,1,0,0]])","digraph,trail"},
{"graph2tex","Converts the graph screen to a LaTeX file","","graph2tex(\"graph.tex\");graph2tex()","graph3d2tex"},
{"graph3d2tex","Converts the 3d graph screen to a LaTeX file","","graph3d2tex(\"graph.tex\");graph3d2tex()","graph2tex"},
{"graph_automorphisms","Returns the sequence of generators of Aut(G), the automorphism group of G. Each element is a permutation in form of list of disjoint cycles.","Graph(G)","graph_automorphisms(graph(\"petersen\"))","cycles2permu,isomorphic_copy,permute_vertices"},
{"graph_charpoly","Returns the value p(x) of the characteristic polynomial p of G. If x is omitted, a list of coefficients of p is returned.","Graph(G),[Var(x)]","graph_charpoly(graph(%{[1,2],[2,3]%}));graph_charpoly(graph(\"shrikhande\"))","graph_spectrum,charpoly"},
{"graph_complement","Return the graph with the same vertex set as G, but whose edge (arc) set consists of the edges (arcs) not present in G.","Graph(G)","graph_complement(cycle_graph(5))","edges"},
{"graph_diameter","Returns the maximum distance between a pair of vertices in G or +infinity if G is disconnected.","Graph(G)","graph_diameter(graph(\"petersen\"))","allpairs_distance,dijkstra,shortest_path,vertex_distance"},
{"graph_equal","Returns true iff the input graphs G1 and G2 are equal, that is when the sets of vertices and edges of G1 and G2, as well as the orderings of vertices in both graphs, mutually coincide. If the graphs are weighted (they must both be (un)weighted and (un)directed), weights given to the same edge in two graphs must be equal.","Graph(G1),Graph(G2)","graph_equal(graph([1,2,3],%{[1,2],[2,3],[3,1]%}),graph(trail(1,2,3,1)))","edges,graph_vertices"},
{"graph_join","Returns the graph obtained by connecting every vertex from G with every vertex from H. The vertex labels in the resulting graph are strings of form \"1:u\" and \"2:v\" where u and v are vertices from G and H, respectively.","Graph(G),Graph(H)","edges(graph_join(cycle_graph(3),graph(2)))","disjoint_union,graph_union"},
{"graph_power","Returns the k-th power of G, where two vertices are connected iff there exists a path of length at most k in the original graph.","Graph(G),Intg(k)","edges(graph_power(path_graph(5),3))","adjacency matrix,graph_diameter,shortest_path"},
{"graph_rank","Returns the graph rank of G. If optional set E of edges is given, rank of the spanning subgraph of G with edge set E is returned.","Graph(G),[Lst(E)]","graph_rank(graph(%{[1,2],[3,4],[4,5]%}));graph_rank(graph(%{[1,2],[3,4],[4,5]%}),[[1,2],[3,4])","connected_components,number_of_vertices"},
{"graph_spectrum","Returns the graph spectrum of G as a list of lists with two elements, each containing an eigenvalue and its multiplicity.","Graph(G)","graph_spectrum(cycle_graph(5))","graph_charpoly,seidel_spectrum,is_integer_graph"},
{"graph_union","Returns the union of the graphs G1, G2, ... The set of vertices of the resulting graph is the union of the sets of vertices of the input graphs and the set of edges of the resulting graph is the union of sets of edges of the input graphs. If the input graphs are weighted, the weight of any common edge is the sum of the weights of that edge in G1, G2, ...","Seq(G1,G2,...)","edges(graph_union(cycle_graph(4),path_graph(5)))","disjoint_union,graph_join"},
{"graph_vertices","Return the list of vertices in G.","Graph(G)","graph_vertices(graph(%{[a,c],[b,c],[a,b]%}))","add_vertex,graph,neighbors,permute_vertices,relabel_vertices"},
{"graphe","Plot a one-variable expression (or list of expressions).","(Expr or LstExpr),Var[=VarMin..VarMax],[color=LstColor]","plot(x-1/6*x^3,x);plot([2*x-1,sin(x)],x=1..2);plot(sin(x),x=-2..2,color=green,xstep=0.1);plot([2*x-2,2*sin(x)],x=1..2,color=[green,red],legende=[\"2x-2\",\"sin\"]);plot(exponentiald(2));plot(normald);plot(normald(-1,2))","plotfunc,plotparam,animate,animate3d,plotarea"},
{"graphe3d","Erase and plot a 2 variable expression or of a surface defined with a list of the 3 functions or of 3 expression of 2 variables.","Expr||Lst(3*Expr),Var,Var","plot3d(x^2+y^2+1,x,y);plot3d(x^2+y^2,x=-1..1,y=-2..2);plot3d([u+1,2*v,u^2+v^2],u=-1..1,v=-2..2);plot3d(f,-1..1,-2..2);plot3d([f,g,h],-1..1,-2..2)","plotfunc,animate3d"},
{"graphe_suite","For seeing the pth terms of the sequence u(0)=a,u(n)=f(u(n-1)).","Expr(f(Var)),Var=[a,xm,xM],Intg(p)","plotseq(sqrt(2+x),6,5);plotseq(sqrt(2+t),t=6,5);plotseq(sqrt(2+x),x=[6,1,7],5,affichage=epaisseur_ligne_2)","seqsolve,rsolve"},
{"greduce","Returns the remainder of the division of a polynomial by a Groebner basis.","","greduce(x*y-1,[x^2-y^2,2*x*y-y^2,y^3],[x,y]);greduce(x1^2*x3^2,[x3^3-1,-x2^2-x2*x3-x3^2,x1+x2+x3],[x1,x2,x3],tdeg);greduce(x1^2*x3^2-x2,[x3^3-1,-x2^2-x2*x3-x3^2,x1+x2+x3],[x1,x2,x3])","gbasis"},
{"greedy_color","Returns the list of vertex colors (positive integers) obtained by coloring vertices one at a time [in the order given by permutation p], assigning to it the smallest available color.","Graph(G),[Permu(p)]","greedy_color(graph(\"petersen\"))","is_vertex_colorable,chromatic_number"},
{"green","Option of the display command to display with color.","Opt"," F:=display(point(2+1.5*i),red); F:=display(point(2+1.5*i),point_point+green)","display"},
{"grid_graph","Returns a [triangular] grid graph on m*n vertices, where m,n>=2.","Intg(m),Intg(n),[triangle]","grid_graph(5,8)","torus_grid_graph"},
{"grid_paper","Draws in the rectangle [xmin..xmax]*[ymin..ymax], the lines of the network built with the lines y=n*uy and in the axes OxY of angle t!=0 with the lines x=n*ux.","","grid_paper(1,pi/3,sqrt(3)/2);grid_paper(1,pi/3,sqrt(3)/2,x=-1..4,y=-2..2);grid_paper(0.5,3*pi/4,0.5)",""},
{"groupermu","Returns the group of permutations generated by a and b.","","groupermu([1,2,0],[3,1,2,0])",""},
{"hadamard","Hadamard bound of a matrix or element by element multiplication of 2 matrix","","hadamard([[1,2],[3,4]]);hadamard([[1,2],[3,4]],[[3,4],[5,6]])",".*,*"},
{"half_cone","Draws an half-cone with vertex A, direction v and with half_angle=t [and with altitude h].","","half_cone([0,0,0],[0,0,1],pi/6);half_cone([0,0,0],[0,1,1],pi/6,-4)","cone,cylinder"},
{"half_line","half_line(A,B) draws the half-line AB with A as origin.","","half_line(i,1+i);half_line(point(i),point(1+i))","line"},
{"halftan","Transforms sin(x),cos(x) and tan(x) as function of tan(x/2).","","halftan(sin(x));halftan(cos(x));halftan(tan(x))",""},
{"halftan_hyp2exp","Transforms the trigonometric functions in tan(x/2) and hyperbolic functions in exp","","halftan_hyp2exp(sin(x)+sinh(x))","hyp2exp,halftan"},
{"halt","Put a program in step-by-step debug mode","","halt()",""},
{"hamdist","Bit Hamming distance.","","hamdist(0x12,0x38)",""},
{"hamming_window","Applies the Hamming windowing function to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Interval(n1..n2)]"," scatterplot(hamming_window(randvector(1000,0..1)))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,bartlett_hann_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"hann_poisson_window","Applies the Hann-Poisson windowing function with parameter a (by default a=1) to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Interval(n1..n2)]"," scatterplot(hann_poisson_window(randvector(1000,0..1),2))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,bartlett_hann_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"hann_window","Applies the Hann windowing function to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Interval(n1..n2)]"," scatterplot(hann_window(randvector(1000,0..1)))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,bartlett_hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"harmonic_conjugate","Returns the harmonic conjugate C  toward A and B of 3 points or of 3 parallel or concurrent lines or the line of conjugates of a point in respect to 2 lines.","","harmonic_conjugate(0,2,3/2);harmonic_conjugate(0,1+i,2+2*i);harmonic_conjugate(line(0,1+i),line(0,3+i),line(0,i));harmonic_conjugate(line(0,1+i),line(0,3+i),point(3/2+i))","is_harmonic,harmonic_division"},
{"harmonic_division","Returns the 4 points (resp lines) and affects the last argument, such as the 4 points (resp lines) are in a harmonic division.","","harmonic_division(0,2,3/2,D);harmonic_division(0,1+i,2+2*i,D);harmonic_division(line(i,0),line(i,1+i),line(i,3+2*i),D);harmonic_division(line(0,1+i),line(0,3+i),line(0,i),D)","harmonic_conjugate,is_harmonic"},
{"has","Checks if a variable is in an expression","","has(x+y,x);has(x+y,n)","lname,lvar"},
{"has_arc","Returns true iff the arc e=[i,j] is contained in digraph G or, if e={i,j} is a set, iff G has both edges [i,j] and [j,i].","Graph(G),Edge(e)","has_arc(digraph(trail(1,2,3,4,1)),[4,2]);has_arc(digraph(trail(1,2,3,4,1)),%{4,2%})","edges,has_edge"},
{"has_edge","Returns true iff the edge e=[i,j] is contained in undirected graph G.","Graph(G),Edge(e)","has_edge(graph(trail(1,2,3,4,1)),[2,4])","edges,has_arc"},
{"hasard","(hasard n)=a random integer (resp (hasard p,n)=a real or hasard(p..n)=a real function) with uniform distribution in 0..n-1 (resp in [p;n])(hasard= (hasard 0,1)=a random real in [0,1[) or hasard(n,b1,b2)=n integers between b1 and b2 or hasard(n,L)=n elements of L. If hasard has only one argument, () are not necessary (compatibility with turtle language).",""," hasard 4; hasard(4);hasard(0,2); hasard 0..2; f:=hasard 0..2;hasard(3,1,10);hasard(3,[\"r\",\"r\",\"r\",\"b\",\"n\"])","rand,randpoly,ranm,randvector,srand"},
{"head","Shows the first element of a vector or a sequence or a string.","","head(1,2,3);head([1,2,3]);head(\"bonjour\")","back,tail,mid,left,right"},
{"heading","Returns the turtle cap in degrees or turns the turtle with the cap given by the argument.","NULL or Real"," cap;cap();cap 90","position,initialise"},
{"heapify","Partial ordering of a list as a heap","List","","heappush,heappop"},
{"heappop","Removes and returns the root node of a heap","List","","heapify,heappush"},
{"heappush","Adds an object in a heap","List,Object","","heapify,heappop"},
{"hermite","Returns the Hermite polynomial of degree n or the Hermite normal form for a polynomial coefficients matrix (I,U such that I*A=U)","","hermite(3); n:=5; a:=ranm(n,n) % 17; l,u:=hermite(x-a);normal(l*(x-a)-u);","legendre,laguerre,smith,ihermite,ismith"},
{"hessenberg","Matrix reduction to Hessenberg form. Returns [P,B] such that B=inv(P)*A*P, by default n=0 the result is exact else the result is numeric. For n=-1 B is triangular, n=-2 P is orthogonal and if n is prime the result is mod n.","","hessenberg([[1,2,3],[4,5,6],[7,8,1]]);hessenberg([[1,2,3,4],[4,5,6,7],[7,8,9,0],[0,1,2,3]]);hessenberg([[1,2,3],[4,5,6],[7,8,1]],-1);hessenberg([[1,2,3],[4,5,6],[7,8,1]],-2);hessenberg([[1,2,3],[4,5,6],[7,8,1]],3)","SCHUR"},
{"hessian","Returns the hessian of the expression Xpr","","hessian(2*x^2*y-x*z,[x,y,z])","grad"},
{"heugcd","GCD of 2 polynomials, with the algorithm called heuristic pgcd.","","heugcd(x^4-1,(x-1)^2)","gcd,modgcd,ezgcd,psrgcd"},
{"hexagon","Returns and draws the hexagon of side AB (ABCDEF is direct) (in the plane ABP.","","hexagon(i,1+i);hexagon(i,1+i,C,D,E,F);hexagon(point(0,0,0),point(3,3,3),point(0,0,3));hexagon(point(0,0,0),point(3,3,3),point(0,0,3),C,D,E,F)","isopolygon,polygon"},
{"hidden_name","Option of the display command to hide the name.",""," F:=display(point(2+1.5*i),hidden_name); F:=display(point(2+1.5*i),point_point+hidden_name)","display"},
{"highlight_edges","Change color of edge e resp. colors of edges in E of the input graph V to c resp C (by default red) and return the modified copy of G.","Graph(G),Edge(e)||Lst(E),[Color(c)||Lst(C)]"," draw_graph(highlight_edges(cycle_graph(3),[1,2]))","highlight_vertex,highlight_subgraph,highlight_trail"},
{"highlight_subgraph","Change colors of edges and vertices from the sugbraph S or list of subgraphs S1, S2, ... of G to c1 and c2, respectively (red and green by default), and return the modified copy of G.","Graph(G),Graph(S)||Lst(S1,S2,..),Seq(c1,c2)"," draw_graph(highlight_subgraph(cycle_graph(5),path_graph(3)))","highlight_edges,highlight_vertex,highlight_trail"},
{"highlight_trail","Change colors of edges in G which lie along the trail t resp. trails in T to c resp. C (by default red) and return the modified copy of G.","Graph(G),Trail(t)||Lst(T),[Color(c)||Lst(C)]"," draw_graph(highlight_trail(cycle_graph(5),trail(1,2,3),green)","highlight_edges,highlight_subgraph,highlight_vertex"},
{"highlight_vertex","Change the color of vertex v resp. colors of vertices from V in G to c resp. C (green by default) and return the modified copy of G.","Graph(G),Vrtx(v)||Lst(V),[Color(c)||Lst(C)]"," draw_graph(highlight_vertex(cycle_graph(3),1))","highlight_edges,highlight_subgraph,highlight_trail"},
{"highpass","Returns the result of applying a simple first-order highpass RC filter with cutoff frequency c (the default samplerate is 44100) to the given signal s.","Lst(s),Real(c),[Intg(samplerate)]"," f:=unapply(periodic(sign(x),x,-1/880,1/880),x):;s:=createwav(apply(f,soundsec(1))):;playsnd(highpass(s,5000))","lowpass,moving_average"},
{"hilbert","Returns the order n Hilbert matrix : Hjk=1/(j+k+1) j,k=1..n","","hilbert(4)",""},
{"histogram","Draws the histogram of data, optional arguments are eff (number of data for each data element) or nc the number of classes or the classes minimum and size","","histogram([1,2,1,1,2,1,2,4,3,3]);histogram([1,2,1,1,2,1,2,4,3,3],0.5,1);histogram(seq(rand(1000),k,0,100),0,100);histogram(binomial,10,.5);histogram([[0,1],[1,4],[2,3],[3,2],[4,1]]);histogram([[1.5..1.65,50],[1.65..1.7,20],[1.7..1.8,30]]);histogram(seq(rand(1000),k,0,100),0,100);histogram(seq(rand(1000),k,0,100),10)","cumulated_frequencies,classes,bar_plot,frequencies"},
{"hold","Returns its argument unevaluated (and also a:=quote(a) that purge a).","Expr","quote(1+2);quote(1/x+1/(x-1));quote((x+1)*(x-1))",""},
{"homothety","homothety(C,k,A)=point A1 such as vect(C,A1)=k*vect(C,A) i.e in 2d it is the similarity center C, coeff abs(k) and angle arg(k).","","homothety(1+i,1/3,i);homothety(point(1,1,1),1/3,point(0,1,0)); h:=homothety(1+i,1/3);h(i); h:=homothety(point(1,1,1),1/3);h(point(0,1,0))","similarity,inversion"},
{"horner","Returns the value of P(a) calculated with Horner's method. With horner(liste_alpha_i,liste_x_i,x), evals an interpolation polynomial from the divided differences at x.","","horner(x^2+1,2);horner([1,0,1],2);horner(x^2+y*x+y^3-1,2,y); X:=[0.0,1.0,2.0]; A:=lagrange(X,exp,lagrange); horner(A,X,1.5);","convert,base,revlist"},
{"hybrid_solver","Argument for fsolve giving the method for solving a system of numerical equations.","Opt"," fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],dnewton_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrid_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrids_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridsj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],newtonj_solver)","fsolve"},
{"hybridj_solver","Argument for fsolve giving the method for solving a system of numerical equations.","Opt"," fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],dnewton_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrid_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrids_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridsj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],newtonj_solver)","fsolve"},
{"hybrids_solver","Argument for fsolve giving the method for solving a system of numerical equations.","Opt"," fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],dnewton_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrid_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrids_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridsj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],newtonj_solver)","fsolve"},
{"hybridsj_solver","Argument for fsolve giving the method for solving a system of numerical equations.","Opt"," fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],dnewton_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrid_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrids_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridsj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],newtonj_solver)","fsolve"},
{"hyp2exp","Transforms the hyperbolic functions with the exponential function","","hyp2exp(cosh(x))","halftan_hyp2exp"},
{"hyperbola","hyperbola(F1,F2,M)=hyperbole focus F1,F2 through M or (|MF1-MF2|=2*a geo2d) and hyperbola(p(x,y)) draws the conic if deg(p)=2.","","hyperbola(-1,1,point(1+i));hyperbola(-1,1,sqrt(5)-1);hyperbola(point(-1,0,0),point(1,0,0),point(1,1,1));hyperbola(x^2-y^2+y+2)","ellipse,parabola"},
{"hypercube_graph","Constructs and returns the hypercube graph in dimension n (with 2^n vertices).","Intg(n)","hypercube_graph(3)","graph"},
{"i","Square root of -1",""," i*i","pi,e"},
{"iPart","Returns the argument without its fractional part (type=DOM_FLOAT).","","iPart(4.3);iPart(sqrt(2));iPart(4.3,sqrt(2))","fPart,floor,trunc"},
{"i[]","i[] is used to define a real interval(i[a,b]=[a..b]).","","i[1,3]; i[1,3]+i[2,4]*i","op"},
{"iabcuv","Returns [u,v] such as au+bv=c for 3 integers a,b,c.","","iabcuv(21,28,7);iabcuv(21,28,14);iabcuv(21,28,1)","iegcd,abcuv"},
{"ibasis","Basis of the intersection of two vector spaces","","ibasis([[1,0,0],[0,1,0]],[[1,1,1],[0,0,1]])","basis"},
{"ibpdv","Integration by parts of f(x)=u(x)*v'(x) with f(x) as 1st argument and v(x) (or 0) as 2nd argument. You can specify a variable of integration and also the calculus of the integrate (bounds a and b).","","ibpdv(ln(x),x);ibpdv(ln(x),x,x,1,3);ibpdv(x*ln(x),x^2/2);ibpdv([x*ln(x),-1],0);ibpdv(ibpdv(ln(x),x,x,2,3),0,x,2,3)","ibpu,int"},
{"ibpu","Integration by parts of f(x)=u(x)*v'(x) with f(x) as 1st argument and u(x) (or 0) as 2nd argument. You can specify a variable of integration and also the calculus of the integrate (bounds a and b).","","ibpu(ln(x),ln(x));ibpu(ln(x),ln(x),x,1,3);ibpu(x*ln(x),ln(x));ibpu([x*ln(x),-1],0);ibpu(ibpu(ln(x),ln(x),x,2,3),0,x,2,3)","ibpdv,int"},
{"icdf","Inverse cumulated distribution function.","","icdf(binomial,10,0.5,0.6);icdf(normald,0.0,1.0,0.975)","cdf,binomial_icdf,normald_icdf"},
{"ichinrem","Chinese remainders for integers.","","ichinrem([2,7],[3,5]);ichinrem([2%7,3%5]);ichinrem([2%7,3%5,1%9]);ichinrem([(x+1)%2,(x+2)%3,(3*x-1)%5])","gcd,fracmod,chinrem,chrem"},
{"ichrem","Chinese remainders for integers.","LstIntg(a,p),LstIntg(b,q)","ichinrem([2,7],[3,5]);ichinrem([2%7,3%5]);ichinrem([2%7,3%5,1%9]);ichinrem([(x+1)%2,(x+2)%3,(3*x-1)%5])","gcd,fracmod,chinrem,chrem"},
{"icomp","Returns the list of compositions of n into k parts.","Intg(n),Intg(k),[zeros=true||false]","icomp(4,2);icomp(6,3,zeros=false)","sum"},
{"icontent","GCD of the integer coefficients of a polynomial.","","icontent(24x^3+6x^2-12x+18);icontent(24t^3+6t^2-12t+18,t)",""},
{"icosahedron","Draws an icosahedron with center A, vertex B and such that the plane ABC contains one vertex among the 5 nearest vertices from B.","","icosahedron([0,0,0],[sqrt(5),0,0],[1,2,0]);icosahedron(evalf([0,0,0],[3,2,4],[1,1,0]))","octahedron,dodecahedron,cube,tetrahedron"},
{"id","Is the name of the identity function (ℝ^n -> ℝ^n).","","id(1,2,3)","sq,sqrt"},
{"identifier","DOM_IDENT or identifier is the type of an identifier, as returned by the type command. It is also an option of the assume command.","Opt"," purge(a);type(a)","type,assume,DOM_INT,DOM_FLOAT"},
{"identity","Returns the identity matrix of specified dimension n.","","identity(3);identity(5)","ranm"},
{"idivis","Returns the list of divisors of an integer.","","idivis(36);idivis([36,49])","divis,ifactors"},
{"idn","Returns the identity matrix of specified dimension n.","Intg(n)","identity(3);identity(5)","ranm"},
{"iegcd","Extended greatest common divisor of 2 integers.","","iegcd(45,75);iegcd(21,28);iegcd(30,49)","gcd,iabcuv,egcd"},
{"if","Test: if (condition){ true_action; } else { false_action; }",""," if (x<0) print(\"x negatif\");; x:=1;if (x>0) {x:=x+1; print(\"x est strictement plus grand que 1\");x}; if x<0 then print(\"x negatif\"); end_if;; x:=1;if x<0 then print(\"x negatif\"); else print(\"x positif\"); end_if;; if (j<0) cos(j); else cosh(j);; x:=0.1;if (x>0) {x:=x+1; print(\"x est strictement plus grand que 1\");} else {x:=x-1;print(\"x est plus petit ou égal à -1\");};x","switch,for,local,si,{},->"},
{"ifactor","Factorization of an integer into prime factors.","","ifactor(50);ifactor(123456789)","factor,ecm_factor"},
{"ifactors","Returns the list of prime factors of an integer (each factor is followed by its multiplicity).","","ifactors(36);ifactors([36,52])","ifactor,factors"},
{"ifft","Inverse Fast Fourier Transform.","","ifft([100.0,-52.2842712475+6*i,-8.0*i,4.28427124746-6*i,4.0,4.28427124746+6*i,8*i,-52.2842712475-6*i])","fft"},
{"ifte","If condition returns Expr1 else returns Expr2.",""," x:=3;ifte(x>0,x+1,x-1); a:=2;ifte(a>1,a+1,0)","if,then,else,when"},
{"igamma","Calculus of gamma at a point (a,x). If a and x>0, igamma(a,x)=int(e^{-t}*t^{a-1},t=0..x), (igamma(a,x,1)=igamma(a,x)/Gamma(a)).","","igamma(5.0,2.0);igamma(-5.1,2.1);igamma(5.0,2.0,1)","Psi,Beta,Gamma,ugamma"},
{"igcd","Returns the greatest common divisor of 2 polynomials of several variables or of 2 integers or of 2 rationals.","(Intg(a) or Poly),(Intg(b) or Poly)","gcd(45,75);gcd(15/7,50/9);gcd(x^2-2*x+1,x^3-1);gcd(t^2-2*t+1,t^2+t-2);gcd((x^2-1)*(y^2-1)*z^2,x^3*y^3*z+(-(y^3))*z+x^3*z-z)","lcm,euler,modgcd,ezgcd,psrgcd,heugcd,Gcd"},
{"igcdex","Extended greatest common divisor of 2 integers.","Intg,Intg","iegcd(45,75);iegcd(21,28);iegcd(30,49)","gcd,iabcuv,egcd"},
{"ihermite","Hermite normal form of a matrix with coefficients in ℤ : returns L,U such that L is invertible in ℤ, U upper triangular and U=L*A.","","ihermite([[9,-36,30], [-36,192,-180], [30,-180,180]]);ihermite([[1,2,3],[4,5,6],[7,8,9]])","ismith"},
{"ilaplace","Inverse Laplace transform of a rational fraction","","ilaplace(1/(x^2+1)^2);ilaplace(s/(s^4-1),s,x);ilaplace(exp(-s)/s,s,x)","laplace,ztrans,invztrans,Heaviside"},
{"im","Returns the imaginary part of a complex number","","im(1+2*i);im((1+2*i)^2);im([1+2*i,(1+2*i)^2])","re,conj"},
{"imag","Returns the imaginary part of a complex number","Cplx","im(1+2*i);im((1+2*i)^2);im([1+2*i,(1+2*i)^2])","re,conj"},
{"image","Image of a linear application of matrix M","","image([[1,2],[3,6]]);image([[1,2,3],[1,3,6],[2,5,9]])","ker,rref"},
{"implicitdiff","Implicit differentiation","constr,[depvars],y,diffvars","implicitdiff(x^2*y+y^2=1,y,x);implicitdiff(R=P*V/T,P,T);implicitdiff([x^2+y=z,x+y*z=1],[y(x),z(x)],y,x);implicitdiff([x^2+y=z,x+y*z=1],[y(x),z(x)],[y,z],x);implicitdiff(y=x^2/z,y,x);implicitdiff(y=x^2/z,y,z);implicitdiff(y^3+x^2=1,y,x);implicitdiff(y^3+x^2=1,y,x,x);implicitdiff(a*x^3*y-2y/z=z^2,y(x,z),x);implicitdiff(a*x^3*y-2y/z=z^2,y(x,z),x,z);implicitdiff([-2x*z+y^2=1,x^2-exp(x*z)=y],[y(x),z(x)],y,x);implicitdiff([-2x*z+y^2=1,x^2-exp(x*z)=y],[y(x),z(x)],[y,z],x);implicitdiff([a*sin(u*v)+b*cos(w*x)=c,u+v+w+x=z,u*v+w*x=z],[u(x,z),v(x,z),w(x,z)],u,z);implicitdiff(x*y,-2x^3+15x^2*y+11y^3-24y=0,y(x),x$2);implicitdiff((x-u)^2+(y-v)^2,[x^2/4+y^2/9=1,(u-3)^2+(v+5)^2=1],[v(u,x),y(u,x)],u,x);implicitdiff(x*y*z,-2x^3+15x^2*y+11y^3-24y=0,[x,z,y],order_size=1);implicitdiff(x*y*z,-2x^3+15x^2*y+11y^3-24y=0,[x,z,y],order_size=2,[1,-1,0]); pd:=implicitdiff(x*y*z,-2x^3+15x^2*y+11y^3-24y=0,[x,z,y],order_size=4,[0,z,0]);pd[4,0,0]","diff"},
{"implicitplot","plotimplicit(f(x,y),x,y) or plotimplicit(f(x,y),[x,y]) graph of f(x,y)=0.","Expr,Var1,Var2","plotimplicit(x^2+y^2-1,x,y);plotimplicit(x^4+y^4=x^2-y^2);plotimplicit(x^2+y^2-1,x,y,unfactored);plotimplicit(x^2+4*y^3-1);plotimplicit(x^2+4*y^3-k)$(k=-5..5);plotimplicit(y^3=x^3-x^2,x,y,xstep=0.1,ystep=0.1);plotimplicit(y^3=x^3-x^2,[x,y],xstep=0.1,ystep=0.1);plotimplicit((x+5)^2+(y+4)^2-1,x=-6..-4,y=-5..-3);plotimplicit((x+5)^2+(y+4)^2-1,[x=-6..-4,y=-5..-3])","plotcontour,unfactored,plotinequation"},
{"import_graph","Returns the graph constructed from instructions in the file 'path/to/graphname.dot' (in dot format), or \"undef\" on failure.","Str(\"path/to/graphname[.dot]\")","import_graph(\"K5.dot\")",""},
{"in","Iteration for ...end_for in a set or a list",""," s:=0;for k in 1..5 do s:=s+k; end_for;; s:=0;for k in %{ 1,5,7 %} do s:=s+k; end_for;; for k in %{2,1,3%} do print(k); end_for;; pour k in  %{2,1,3%} faire print(k);fpour;; P:=[1,3,7];L:=NULL;for k in P do L:=L,k^2 end_for; ; P:=[1,3,7];L:=NULL;pour k in P faire L:=L,k^2; fpour;","for,set[]"},
{"inString","Tests if e is in the string l (returns -1 or k if l[k]=e).","","inString(\"abcd\",\"b\");inString(\"abcd\",\"e\")","contains"},
{"in_ideal","Checks whether a polynomial or list of polynomials belongs to an ideal given by a Grobner basis (2nd argument) with respect to a variable list.","","in_ideal((x+y)^2,[y^2,x^2+2*x*y],[x,y]);in_ideal(x+y,[y^2,x^2+2*x*y],[x,y])","gbasis,greduce"},
{"incidence_matrix","Returns the incidence matrix of G whose rows are indexed by the vertices and columns by the edges (in order defined by the command 'edges').","Graph(G)","incidence_matrix(graph(\"tetrahedron\"))","incident_edges"},
{"incident_edges","Returns the list of all edges incident to the vertex v of G (or to the vertices in the list v).","Graph(G),Vrtx(v)","incident_edges(cycle_graph(8),[1,5,7])","adjacency_matrix,vertex_degree,incidence_matrix,neighbors"},
{"incircle","incircle(A,B,C) draws the incircle of the ABC triangle.","","incircle(0,1,1+i)","excircle,circumcircle"},
{"increasing_power","Pseudo-variable to control display of polynomial",":=Intg(0 or 1)"," increasing_power:=1; increasing_power:=0","cas_setup"},
{"independence_number","Returns the independence number of G.","Graph(G)","independence_number(complete_graph(3,4))","clique_number,graph_complement,maximum_clique,maximum_independent_set"},
{"indets","List of variables in the expression.","Expr","lname(exp(x)*2*sin(y))","has,lvar"},
{"index","Index of the first position of an object in a list, a string or a set or return an error message.","Vect,Expr","index([3,x,1,2,1,3],1);index([0,1,3,2,4,2,5],2);index(%{4,3,1,2%},1);index(\"abracadabrant\",\"c\")","find,member"},
{"induced_subgraph","Returns the subgraph of G induced by the vertices in list V.","Graph(G),Lst(V)","induced_subgraph(cycle_graph(6),[1,2,6])","subgraph"},
{"inequationplot","Shows the graph of the solution of inequations with 2 variables.","Expr,[x=xrange,y=yrange],[xstep],[ystep]","plotinequation(x^2-y^2<3);plotinequation(x^2-y^2<3,[x=-2..2,y=-2..2],xstep=0.1,ystep=0.1);plotinequation(3-(x^2-y^2),[x=-2..2,y=-2..2],xstep=0.1,ystep=0.1);plotinequation([x+y>3,x^2<y],[x,y],xstep=0.2,ystep=0.2)","plotfunc,plotcontour,plotdensity,plotimplicit"},
{"inf","Plus infinity","","","infinity,-infinity"},
{"infinity","Unsigned infinity","","","+infinity,-infinity"},
{"infnorm","","","",""},
{"input","Instruction in a program to input an expression or a string in Python","","input(\"age\",a)","InputStr,output"},
{"inputform","In a program, is used to do inputs.","","inputform(\"a=?\",a,\"b=?\",b);inputform(a,b)",""},
{"insert","Returns l where the element b is of index n.","","insert([0,1,2,3],2,5);insert(\"0123\",2,\"5\")","tail,mid,remove,suppress"},
{"insmod","Installs a dynamic module creates the commands that are, for example, in the file libprogfr.so putting the pwd of this file.","","insmod(\"/home/parisse/giac/src/libprogfr.so\")","rmmod,lsmod"},
{"int","Indefinite integral, you can specify a variable of integration or the calculus of the integrate (bounds a and b).","","int(1/x);int(1/(4+t^2),t);int(1/(1-x^4),x,2,3)","Int,diff,plotarea,romberg,gaussquad"},
{"intDiv","Euclidean quotient of 2 integers.","Intg(a),Intg(b)","iquo(125,15);iquo(125,41);iquo(-7,3);iquo(25+12*i,5+7*i)","irem,smod,quo"},
{"integer","DOM_INT or integer or DOM_int is an integer which is the type of an integer variable, it is the value of the type command. DOM_INT is used for integers < 2^31. It is also an option of the assume command.","Opt"," type(2^31); DOM_INT+0; assume(a,DOM_INT); assume(a,integer); a:=2;type(a)","type,assume,DOM_FLOAT,DOM_SYMBOLIC"},
{"integrate","Indefinite integral, you can specify a variable of integration or the calculus of the integrate (bounds a and b).","Expr,[Var(x)],[Real(a)],[Real(b)]","integrate(1/x);integrate(1/(4+t^2),t);int(1/(1-x^4),x,2,3)","Int,diff,plotarea,romberg,gaussquad"},
{"integrer","Indefinite integral, you can specify a variable of integration or the calculus of the integrate (bounds a and b).","Expr,[Var(x)],[Real(a)],[Real(b)]","int(1/x);int(1/(4+t^2),t);int(1/(1-x^4),x,2,3)","Int,diff,plotarea,romberg,gaussquad"},
{"inter","With 2 arguments (resp 3 arguments) gives the intersection of 2 curves or surfaces as a vector (resp a point close to the point given as third argument).","","inter(line(i,1-i),circle(0,1));inter(line(i,1-i),circle(0,1),point(-i));inter(plane(x=y+3),cone([0,0,0],[0,0,1],pi/6));inter(plane(x=y+3),cone([0,0,0],[0,0,1],pi/6));inter(line(i,1-i),circle(0,1))[0]","intersect,head"},
{"interactive_odeplot","Draws (in DispG) a solution for each point t0+i*y0 clicked with the mouse (Esc=halt).","Expr,VectVar","interactive_plotode(sin(t*y),[t,y]);interactive_plotode(-t*y,[t,y])","odeplot,plotfield,odesolve,desolve"},
{"interactive_plotode","Draws (in DispG) a solution for each point t0+i*y0 clicked with the mouse (Esc=halt).","","interactive_plotode(sin(t*y),[t,y]);interactive_plotode(-t*y,[t,y])","odeplot,plotfield,odesolve,desolve"},
{"interp","Returns the polynomial of degree n-1 such that P(xk)=yk=f(x_k) k=0..n-1 or the list of divided differences if the last argument is lagrange","(Lst_xk,Lst_yk)||Mtrx_2*n||(Lst_xk,Fnc(f)),[Var||[]||lagrange]","lagrange([1,3,4],[0,1,2]);lagrange([1,3,4],[0,1,2],t); f(x):=exp(-x); lagrange([1,3,4],f);lagrange([[1,3,4],[0,1,2]]);lagrange([1,3,4],[0,1,2],[]); X:=[1,3,4]; divdiff:=lagrange(X,[0,1,2],lagrange); horner(divdiff,X,5);;lagrange([[1,3,4],[0,1,2]],y);lagrange([-1,0,1],[1/e-1,0,e-1]); f(x):=exp(x)-1;lagrange([-1,0,1],f);lagrange([0,1,2],[1,exp(1),exp(2)],lagrange);lagrange([0,1,2],exp,lagrange)","spline"},
{"intersect","intersect is a infixed operator to get the intersection of 2 sets.",""," [1,2,3] intersect [2,5,6]; %{1,2,3%} intersect %{2,5,6%};[1..3] intersect [2..4]","union,minus"},
{"interval","Option of the convert or convertir command.",""," convert(sqrt(2),interval); convert(sqrt(2),interval,20); convert(sqrt(2)*sin(2)+sqrt(2)*cos(2),interval,20)","interval"},
{"interval2center","Returns the center of the interval or the object.","","interval2center(2..5);interval2center(3)","center2interval"},
{"interval_graph","Returns the interval graph with respect to intervals a..b, c..d, ... on the real line. It has one vertex per interval and two vertices are connected iff the corresponding intervals intersect.","Seq||Lst(a..b,c..d,...)","interval_graph([0..8,1..pi,exp(1)..20,7..18,11..14,17..24,23..25])","graph,kneser_graph"},
{"inv","Returns the inverse of an expression or matrix.","","inv(9/5);inv([[1,2],[3,4]])","Inv"},
{"inverse","Returns the inverse of an expression or matrix.","Expr||Mtrx","inv(9/5);inv([[1,2],[3,4]])","Inv"},
{"inversion","inversion(C,k,A)=point A1 such as A1 on line(C,A) and mes_alg(CA1*CA)=k","","inversion(i,1/2,1+i);inversion([1,1,1],-1/2,point(-1,-1,-1)); inver:=inversion(i,1/2);inver(i); inver:=inversion([1,1,1],-1/2);inver(point(-1,-1,-1))","homothety"},
{"invisible_point","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"invlaplace","Inverse Laplace transform of a rational fraction","Expr,[Var],[IlapVar]","ilaplace(1/(x^2+1)^2);ilaplace(s/(s^4-1),s,x);ilaplace(exp(-s)/s,s,x)","laplace,ztrans,invztrans,Heaviside"},
{"invztrans","Inverse z transform of a rational fraction","","invztrans(1/(x^2+1)^2);invztrans(z/(z^4-1),z,n)","ztrans,laplace,invlaplace"},
{"iquo","Euclidean quotient of 2 integers.","","iquo(125,15);iquo(125,41);iquo(-7,3);iquo(25+12*i,5+7*i)","irem,smod,quo"},
{"iquorem","Euclidean quotient and remainder of 2 integers.","","iquorem(125,15);iquorem(125,41);iquorem(25+12*i,5+7*i)","irem,iquo,quorem"},
{"iratrecon","Returns the fraction a/b such as b*Xpr=a mod n, -sqrt(n)/2<a<=sqrt(n)/2 and 0<=b<sqrt(n)/2.","Expr(Xpr),Intg(n)","fracmod(41,121)","mod,smod"},
{"irem","Euclidean remainder of 2 integers.","","irem(125,15);irem(125,41);irem(-7,3);irem(25+12*i,5+7*i)","iquo,smod,rem,mod"},
{"isPrime","Primality testing (=true or false).","Intg(a)","isprime(1999);isprime(9856989898997);isprime(9856989898997789789)","prevprime,nextprime,is_prime,is_pseudoprime"},
{"is_acyclic","Returns true iff digraph G has no topological ordering.","Graph(G)","is_acyclic(digraph(%{[c,a],[c,b],[c,d],[a,d],[b,d],[a,b]%}))","topologic_sort,topological_sort"},
{"is_arborescence","Returns true iff the directed and unweighted graph G is an arborescence.","Graph(G)","is_arborescence(digraph(%{[1,2],[1,3]%}));is_arborescence(digraph(%{[1,2],[2,3],[3,1]%}))","is_acyclic,is_forest,is_tree"},
{"is_biconnected","Returns true iff G is biconnected.","Graph(G)","is_biconnected(path_graph(5));is_biconnected(cycle_graph(5));is_biconnected(graph(\"petersen\"))","biconnected_components,is_connected,is_triconnected"},
{"is_bipartite","Returns true iff G is bipartite graph [and assign to P the list of partitions represented as lists of vertices].","Graph(G),[Var(P)]","is_bipartite(graph(\"desargues\"))","random_bipartite_graph,draw_graph"},
{"is_clique","Returns true iff undirected graph G is a clique (a complete graph).","Graph(G)","is_clique(complete_graph(3))","clique_number,induced_subgraph,maximum_clique"},
{"is_collinear","Returns 1 if the points are aligned,2 if the points are the same and 0 otherwise.","","is_collinear(0,i,1+i,2*i);is_collinear(point(0),point(1+i),point(2,2),point(-1-i));is_collinear(point(0,0,0),point(1,1,0),point(2,2,0),point(-1,-1,1))","is_concyclic"},
{"is_concyclic","Returns 1 if the points are on a circle and 0 otherwise.","","is_concyclic(0,i,1+i,1,1/2+i*(1/2+sqrt(2)/2));is_concyclic(1,-1,i,-i,1+i,-1-i)","is_collinear"},
{"is_conjugate","Returns 1 if the 3 (resp 4) arguments are conjugated toward a circle (resp 2 lines) and 0 otherwise.","","is_conjugate(circle(0,1+i),point(1-i),point(3+i));is_conjugate(circle(0,1),point((1+i)/2),line(1+i,2));is_conjugate(circle(0,1),line(1+i,2),point((1+i)/2));is_conjugate(circle(0,1),line(1+i,2),line((1+i)/2,0));is_conjugate(point(1+i),point(3+i),point(i),point(3/2+i));is_conjugate(line(0,1+i),line(2,3+i),line(3,4+i),line(3/2,5/2+i));is_conjugate(line(0,1+i),line(0,3+i),line(0,i),line(0,3/2+i));is_conjugate(line(0,1+i),line(0,3+i),line(0,i),point(3/2+i));is_conjugate(line(0,1+i),line(0,3+i),point(3/2+i),line(0,i));is_conjugate(line(0,1+i),line(0,3+i),point(i),point(3/2+i))","harmonic_conjugate,pole,polar"},
{"is_connected","Returns true iff G is connected.","Graph(G)","is_connected(path_graph(5));is_connected(cycle_graph(5));is_connected(graph_complement(complete_graph(3,4)))","connected_components,is_biconnected,is_triconnected"},
{"is_coplanar","Test if 4 points are in the same plan.","","is_coplanar([0,0,0],[1,2,-3],[1,1,-2],[2,1,-3])",""},
{"is_cospheric","","","",""},
{"is_cospherical","Test if 5 points are on the same sphere.","Pnt,Pnt,Pnt,Pnt","is_cospherical([-1,0,0],[1,0,0],[0,1,0],[0,-1,0],[0,0,1])",""},
{"is_cut_set","Returns true if removing edges in the list E from G increases the number of connected components of G, else returns false.","Graph(G),Lst(E)","is_cut_set(graph(trail(1,2,3,4,5,6,4,1,3)),[[1,4],[3,4]])","connected_components,delete_edge"},
{"is_cycle","Returns 1 if the argument is a cycle and 0 otherwise.","","is_cycle([1,0,5]);is_cycle([1,0,5,1])","is_permu,cycle2perm,cycles2permu"},
{"is_directed","Returns true iff G is directed.","Graph(G)","is_directed(digraph(3))","is_weighted,digraph,make_directed"},
{"is_element","Returns 1 if the point is on the geometric object and 0 otherwise.","","is_element(point(i),square(0,1));is_element(point(i),circle(point(0),point(2)))","element,member,contains"},
{"is_equilateral","Returns 1 if the 3 points (or the object) built an equilateral triangle and 0 otherwise.","","is_equilateral(0,2,1+i*sqrt(3));is_equilateral(point(0),point(1+i),point(2,2));is_equilateral(triangle(0,2,1+i*sqrt(3)))","is_isosceles,is_rectangle"},
{"is_eulerian","Return true iff G is eulerian [and write the corresponding eulerian trail to T].","Graph(G),[Var(T)]","is_eulerian(complete_graph(4));is_eulerian(complete_graph(5));is_eulerian(graph(trail(1,2,3,1,4,3,5,4)),T);is_eulerian(digraph(%{[1,4],[1,3],[2,1],[3,2],[4,5],[5,1]%}))","path_graph,trail"},
{"is_forest","Returns true iff G is a forest (disjoint union of trees).","Graph(G)","is_forest(graph(trail(1,2,3,4),trail(5,2,6,7),trail(8,9,10)))","is_tree"},
{"is_graphic_sequence","Returns true iff there exists a graph with degree sequence equal to the list L.","Lst(L)","is_graphic_sequence([3,2,4,2,3,4,5,7])","degree_sequence,sequence_graph"},
{"is_hamiltonian","Returns true if G is a Hamiltonian graph (and stores the Hamiltonian circuit in hc if unassigned identifier is given), else returns false.","Graph(G),[Var(hc)]","is_hamiltonian(graph(\"petersen\"));is_hamiltonian(hypercube_graph(5),C);is_hamiltonian(digraph(%{[1,2],[1,3],[2,3],[2,4],[3,2],[3,4],[4,1]%}))","traveling_salesman"},
{"is_harmonic","Returns 1 if the 4 points are in a harmonic division and 0 otherwise.","","is_harmonic(0,2,3/2,3);is_harmonic(0,1+i,1,i)","is_conjugate"},
{"is_harmonic_circle_bundle","Returns 1 if the circles built a beam, 2 if they have the same center, 3 if they are the same and 0 otherwise.","","is_harmonic_circle_bundle([circle(0,i),circle(4,i),circle(0,point(1/2))]);is_harmonic_circle_bundle([circle(0,1+i),circle(2,1+i),circle(1+i,point(1-i))])","is_harmonic_line_bundle"},
{"is_harmonic_line_bundle","Returns 1 if the lines have a common point, 2 if they are parallels, 3 if they are the same and 0 otherwise.","","is_harmonic_line_bundle([line(0,1+i),line(0,2+i),line(0,1),line(0,3+i)]);is_harmonic_line_bundle([line(0,1+i),line(2,3+i),line(3,4+i),line(-1,i)])","is_harmonic_circle_bundle"},
{"is_included","Test if a set or a list is included in another set or list.","","is_included([1,2,-3],[-1,-2,2,1,-3]);is_included(%{1,2,-3%},%{-1,3,-2,2,1,-3%})",""},
{"is_inside","Checks whether a point is inside a polygon or a circle.","","is_inside(point(0),circle(-1,1));is_inside(point(1-i),triangle([1,2-i,3+i]))","is_element"},
{"is_integer_graph","Returns true iff the spectrum of G consists only of integers.","Graph(G)","is_integer_graph(graph(\"levi\"))","graph_spectrum"},
{"is_isomorphic","Returns true if the input graphs G1 and G2 are isomorphic, else returns false. If an unassigned identifier 'I' is given, the isomorphism is stored to it in form of a list.","Graph(G1),Graph(G2),[Var(I)]"," G1:=graph(\"petersen\"); G2:=kneser_graph(5,2); is_isomorphic(G1,G2,I)","isomorphic_copy,permute_vertices"},
{"is_isosceles","Returns 1, 2 or 3 if the 3 points (or the object) built an isosceles triangle with vertices 1, 2, or 3, returns 4 if the 3 points (or the object) built an equilateral triangle and 0 otherwise.","","is_isosceles(0,i,1+i);is_isosceles(point(0),point(1+i),point(2,2));is_isosceles(triangle(0,i,1+i))","is_equilateral,is_right_triangle"},
{"is_network","Returns true if G is a network with the source s and sink t, else returns false. If s,t are not given, the output is a sequence of two sets of vertices: sources and sinks.","Graph(G),[Vrtx(s),Vrtx(t)]","is_network(digraph(trail(1,2,3,4,5,6,4,7)));is_network(digraph(trail(1,2,3,4,5,6,4,7)),1,7);is_network(digraph(trail(1,2,3,4,5,6,4,1)))","random_network,maxflow"},
{"is_orthogonal","Returns 1 if the 2 circles are orthogonal (orthogonal tangents at a point of intersection) or if the 2 lines are orthogonal and 0 otherwise.","","is_orthogonal(line(0,1+i),line(1,i));is_orthogonal(circle(0,1+i),circle(2,1+i));is_orthogonal(line([2,3,-2],[-1,-1,-1]),line([1,0,0],[1,2,8]))","is_parallel,is_perpendicular"},
{"is_parallel","Returns 1 if 2 lines are parallel and 0 otherwise.","","is_parallel(line(0,i),line(1,1+i));is_parallel(line([2,3,-2],[-1,-1,-1]),plane([-1,-1,-1],[1,2,-3],[0,0,0]));is_parallel(line([0,0,0],[-1,-1,-1]),line([2,3,-2],[-1,-1,-1]))","is_perpendicular"},
{"is_parallelogram","Returns 1,2,3 or 4 if the 4 points (or the object) built a parallelogram, (2 for a rhombus, 3 for a rectangle, 4 for a square) and 0 otherwise.","","is_parallelogram(0,i,1+i,1);is_parallelogram(1,-1,i,-i);is_parallelogram(sommets(parallelogram(1,-1,-i,C)))","est_rectangle,is_square,is_rhombus"},
{"is_permu","Returns 1 if the argument is a permutation and 0 otherwise","","is_permu([4,2,3,1]);is_permu([4,2,3,1,0])","is_cycle,permu2cycles"},
{"is_perpendicular","Returns 1 if 2 lines are perpendicular","","is_perpendicular(line(0,i),line(1,1+i));is_perpendicular(line([2,3,-2],[-1,-1,-1]),line([1,0,0],[1,2,8]));is_perpendicular(plane([0,0,0],[1,2,-3],[1,1,-2]),plane([-1,-1,-1],[1,2,-3],[0,0,0]));is_perpendicular(line([2,3,-2],[-1,-1,-1]),plane([0,0,0],[1,2,-3],[1,1,-2]))","is_parallel,is_orthogonal"},
{"is_planar","Returns true iff G is planar.","Graph(G)","is_planar(complete_graph(4));is_planar(complete_graph(5))","draw_graph,random_planar"},
{"is_prime","Mixed or \"p-1\" Pocklington [1] or APRCL test [2] (returns the coefficients for a proof of primality, 1 or 0)","","is_prime(1999);is_prime(9856989898997);is_prime(9856989898997789789);is_prime(9856989898997789789,1)","prevprime,nextprime,is_pseudoprime,isprime"},
{"is_pseudoprime","Pseudo-prime test (0 not prime, 1 probably prime, 2 prime)","","is_pseudoprime(1999);is_pseudoprime(9856989898997);is_pseudoprime(9856989898997789789)","prevprime,nextprime,is_prime"},
{"is_rectangle","Returns 1, 2 or 3 if the 3 points (or the object) built an rectangular triangle with vertex 1, 2 or 3 and 0 otherwise [or 1 if the 4 points (or the object) built a rectangle, 2 if the 4 points (or the object) built a square and 0 otherwise].","","is_rectangle(0,i,1+i);is_rectangle(point(0),point(1+i),point(2,2));is_rectangle(triangle(0,i,1+i));is_rectangle(point(0),point(2,2),point(1,3),point(-1,1));is_rectangle(rectangle(point(0),point(2,2),1/2));is_rectangle(sommets(rectangle(point(0),point(2,2),1/2)))","is_equilateral,is_isosceles,is_parallelogram,is_rhombus,is_square"},
{"is_regular","Returns true iff max and min degrees of G are equal (if G is directed then out- and in-degrees must be equal for each vertex of G).","Graph(G)","is_regular(complete_graph(5))","degree_sequence,maximum_degree,minimum_degree,random_regular_graph,vertex_degree"},
{"is_rhombus","Returns 1 or 2 if the 4 points (or the object) built a rhombus (2 for a square) and 0 otherwise.","","is_rhombus(0,i,1+i,1);is_rhombus(1,-1,i,-i);is_rhombus(sommets(rhombus(1,-1,pi/4,C,D)))","est_rectangle,is_parallelogram,is_square"},
{"is_square","Returns 1 if the 4 points built a square and 0 otherwise.","","is_square(0,i,1+i,1);is_square(1,-1,i,-i);is_square(sommets(square(0,i,C,D)))","est_rectangle,is_parallelogram,is_rhombus"},
{"is_strongly_connected","Returns true iff digraph G is strongly connected.","Graph(G)","is_strongly_connected(digraph([1,2,3],%{[1,2],[1,3],[2,3],[3,2]%}))","connected_components,is_connected,strongly_connected_components"},
{"is_strongly_regular","Returns true iff G is strongly regular and optionally outputs srg=[k,l,m] where k is the vertex degree and l resp. m is the number of common neighbors for adjacent resp. non-adjacent vertices.","Graph(G),[Var(srg)]","is_strongly_regular(graph(\"clebsch\"));is_strongly_regular(graph(\"shrikhande\"),s); s","is_regular,adjacency_matrix,seidel_spectrum"},
{"is_tournament","Returns true iff G is a tournament.","Graph(G)","is_tournament(digraph(%{[1,2],[2,3],[3,1]%}))","has_edge,random_tournament"},
{"is_tree","Returns true iff G is a tree.","Graph(G)","is_tree(random_tree(15));is_tree(path_graph(4));is_tree(cycle_graph(5))","is_forest,random_tree,tree_height"},
{"is_triconnected","Returns true iff G is triconnected.","Graph(G)","is_triconnected(graph(\"soccerball\"));is_triconnected(graph(\"petersen\"));is_triconnected(cycle_graph(5))","is_connected,is_biconnected"},
{"is_two_edge_connected","Returns true iff undirected graph G is two-edge-connected (has no bridges).","Graph(G)","is_two_edge_connected(cycle_graph(4));is_two_edge_connected(path_graph(4))","two_edge_connected_components,edge_connectivity"},
{"is_vertex_colorable","Returns true iff the vertices of G can be colored by using at most k colors. If true is returned and an identifier col is given, the colors of the vertices are stored in it.","Graph(G),Intg(k),[Var(col)]","is_vertex_colorable(graph(\"petersen\"),2);is_vertex_colorable(graph(\"petersen\"),3,cols)","greedy_color,chromatic_number"},
{"is_weighted","Returns true iff G is weighted.","Graph(G)","is_weighted(graph(%{[a,b],[b,c]%});is_weighted(graph(%{[[a,b],2],[[b,c],3]%})","get_edge_weight,make_weighted,set_edge_weight,weight_matrix"},
{"ismith","Smith normal form of a matrix with coefficients in ℤ : returns U,B,V such that U and V invertible in ℤ, B diagonal, B[j,j] divide B[j+1,j+1] and B=U*A*V.","","ismith([[9,-36,30],[-36,192,-180],[30,-180,180]]);ismith([[1,2,3],[4,5,6],[7,8,9]])","ihermite,smith"},
{"isobarycenter","isobarycenter(A,B,C,...) draws the isobarycenter of the n points A,B,C,...","","isobarycenter(-1,1-i,i)","barycenter,midpoint"},
{"isom","Find elements of a 2-d or 3-d isometry","","isom([[0,1],[1,0]])","mkisom"},
{"isomorphic_copy","Returns a copy of G with neighbors structure reordered according to sigma.","Graph(G),Permu(sigma)","isomorphic_copy(cycle_graph(5),randperm(5))","graph_vertices,permute_vertices,relabel_vertices"},
{"isopolygon","Draws a regular polygon having abs(n) vertices, given if n>0 by 2 vertices (or 2 vertices and 1 point of the plane) and  if n<0 by its center and 1 vertex (or its center, 1 vertex and 1 point of the plane).","","isopolygon(0,1,5);isopolygon(0,1,-5);isopolygon(point(0,0,0),point(3,3,3),point(0,0,3),5);isopolygon(point(0,0,0),point(3,3,3),point(0,0,3),-5)","polygon,hexagon"},
{"isosceles_triangle","Draws the isosceles triangle ABC AB=AC et angle(AB,AC)=t (or in the plane ABP angle(AB,AC)=angle(AB,AP) or angle(AB,AC)=t).","","isosceles_triangle(i,1,pi/4);isosceles_triangle(1,i,pi/4,C);isosceles_triangle(point(0,0,0),point(3,3,3),point(0,0,3));isosceles_triangle(point(0,0,0),point(3,3,3),[point(0,0,3),pi/4],C)","triangle"},
{"isprime","Primality testing (=true or false).","","isprime(1999);isprime(9856989898997);isprime(9856989898997789789)","prevprime,nextprime,is_prime,is_pseudoprime"},
{"ithprime","Returns the n-th prime number less than 2.10^8.","","ithprime(1229);ithprime(1000)","nextprime,prevprime"},
{"jacobi_equation","Returns the Jacobi equation for stationary function y0(x) in a problem of minimizing the functional int(f(x,y,y'),x=a..b).","Expr(f),Var(x),Var(y),Expr(y0),Var(h),Real(a)","jacobi_equation(-1/2*y'(t)^2+y(t)^2/2,t,y,sin(t),h,0)","conjugate_equation,euler_lagrange"},
{"jacobi_linsolve","Resolution of a linear system  A*X=b  by the iterative Jacobi method with eps as error margin  and a number of iterations inferior to maxiter.",""," a:=[[100,2],[2,100]];jacobi_linsolve(a,[0,1],1e-12);; a:=[[100,2],[2,100]];jacobi_linsolve(table(a),[0,1],1e-12); ","gauss_seidel_linsolve,linsolve"},
{"jacobi_symbol","Jacobi symbol","","jacobi_symbol(132,5);jacobi_symbol(132,25)","legendre_symbol"},
{"jordan","Returns the list made by the matrix of passage and the Jordan form of a matrix.","","jordan([[0,2],[1,0]]);jordan([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);jordan([[1,1,-1,2,-1],[2,0,1,-4,-1],[0,1,1,1,1],[0,1,2,0,1],[0,0,-3,3,-1]])","egv,egvl,rat_jordan"},
{"jusqu_a","Loop repeat (repeat the instructions until cond==true): repeat i1;i2; until cond; or repeter i1;i2;jusqua cond;",""," x:=32;repeat x:=x-5 until x<5;; x:=32;repeter x:=x-5; jusqua x<5;;  quoreste(a,b):={local q:=0;repeat a:=a-b;q:=q+1 until a<0;return q-1,a+b;};;  quoreste(a,b):={local q:=0;repeter a:=a-b;q:=q+1; jusqua a<0;return q-1,a+b;};; n:=1;repeter triangle_plein(10*n);saute(10*n);n:=n+1; jusqua n==5;; n:=4;repeter triangle_plein(10*n);saute(10*n);n:=n-1; jusqua n==0;","for,tantque"},
{"jusqua","Loop repeat (repeat the instructions until cond==true): repeat i1;i2; until cond; or repeter i1;i2;jusqua cond;",""," x:=32;repeat x:=x-5 until x<5;; x:=32;repeter x:=x-5; jusqua x<5;;  quoreste(a,b):={local q:=0;repeat a:=a-b;q:=q+1 until a<0;return q-1,a+b;};;  quoreste(a,b):={local q:=0;repeter a:=a-b;q:=q+1; jusqua a<0;return q-1,a+b;};; n:=1;repeter triangle_plein(10*n);saute(10*n);n:=n+1; jusqua n==5;; n:=4;repeter triangle_plein(10*n);saute(10*n);n:=n-1; jusqua n==0;","for,tantque"},
{"jusque","Used in a loop for (for...from ...to... [step...] do...od;).",""," pour de jusque [pas] faire fpour;; S:=0;pour n de 1 jusque 4 faire S:=S+n;fpour;; S:=0;for n from 1 to 4 do S:=S+n;end;; S:=0;pour n de 4 jusque 1 pas -1 faire S:=S+n;fpour;","for,pour,de,from"},
{"kde","Estimates the probability density function from which the (presumably independent) samples in list L are drawn.","Lst(L),[options]","kernel_density([1,2,3,2],bandwidth=1/4,exact); X:=randvar(gammad,mean=5,stddev=2):;kernel_density(sample(X,500),bins=50); Y:=randvar(normal,mean=5,stddev=1.5):;plot(kernel_density(sample(Y,1000),bins=50,piecewise),x=0..10)","random_variable,sample"},
{"keep_algext","Pseudo-variable to keep algebraic extensions (keep_algext:=1) or try to rewrite them (keep_algext:=0).",""," keep_algext:=1",""},
{"keep_pivot","Option of the rref command.",""," rref([[1,1,0,0,-a1],[0,1,1,0,-a2],[0,0,1,1,-a3],[1,0,0,1,-a4]],keep_pivot)","rref"},
{"ker","Kernel of a linear application of matrix M","","ker([[1,2],[3,6]]);ker([[1,2,3],[1,3,6],[2,5,9]])","image,rref,Nullspace"},
{"kernel","Kernel of a linear application of matrix M","Mtrx","ker([[1,2],[3,6]]);ker([[1,2,3],[1,3,6],[2,5,9]])","image,rref,Nullspace"},
{"kernel_density","Estimates the probability density function from which the (presumably independent) samples in list L are drawn.","Lst(L),[options]","kernel_density([1,2,3,2],bandwidth=1/4,exact); X:=randvar(gammad,mean=5,stddev=2):;kernel_density(sample(X,500),bins=50); Y:=randvar(normal,mean=5,stddev=1.5):;plot(kernel_density(sample(Y,1000),bins=50,piecewise),x=0..10)","random_variable,sample"},
{"kill","Stop step-by-step execution of a program (with debug)","","kill()",""},
{"kneser_graph","Returns the Kneser graph K(n,k) with comb(n,k) vertices (n<=20).","Intg(n),Intg(k)","kneser_graph(5,2)","odd_graph"},
{"kolmogorovd","Kolmogorov-Smirnov distribution, 1-2*sum((-1)^(k-1)*exp(-k^2*x^2),k,1,inf)","","kolmogorovd(1.36)",""},
{"kolmogorovt","Kolmogorov-Smirnov adequation test to a continuous distribution law, between 2 samples l1 l2 (unknown law) or between a sample l1 and a distribution law s.","","kolmogorovt(randvector(100,normald,0,1),randvector(100,normald,0,1));kolmogorovt(randvector(100,normald,0,1),randvector(100,normald,3,1));kolmogorovt(randvector(100,normald,0,1),normald(0,1));kolmogorovt(randvector(100,normald,0,1),student(2))","chisquaret,normalt,studentt"},
{"kovacicsols","Solves a linear homogeneous second-order ODE eq for y(x) with rational coefficients in variable x.","Expr||Lst(eq),[Var(x),[Var(y)]]","kovacicsols(y''=y*(1/x-3/16/x^2));kovacicsols(y''-y*27/(36*(x-1)^2),x,y);kovacicsols(x''+3*(t^2-t+1)/(16*(t-1)^2*t^2)*x,t,x);kovacicsols(y''+y'=6y/x^2);kovacicsols(y''+(19-x^2)*y=0,x,y);kovacicsols((1+x^2)^2*y''+3y=0,x,y);kovacicsols([48t*(t+1)*(5t-4),8*(25t+16)*(t-2),-(5t+68)],t)","desolve"},
{"kspaths","Returns a list of k shortest paths from s to t in the (weighted) (di)graph G.","Graph(G),Vrtx(s),Vrtx(t),Intg(k)","kspaths(digraph(%{[[\"C\",\"D\"],3],[[\"C\",\"E\"],2],[[\"D\",\"F\"],4],[[\"E\",\"D\"],1],[[\"E\",\"F\"],2],[[\"E\",\"G\"],3],[[\"F\",\"G\"],2],[[\"F\",\"H\"],1],[[\"G\",\"H\"],2]%}),\"C\",\"H\",5);kspaths(graph(\"soccerball\"),3,33,4)","dijkstra,shortest_path"},
{"l1norm","Returns the l1 norm of the vector=sum of the absolute values of its coordinates or matrix norm according to l1.","","ou triple norme d'une matrice selon l1.;l1norm([3,-4,2]);l1norm([[1,2,3],[3,-9,6],[4,5,6]])","l2norm,maxnorm,matrix_norm"},
{"l2norm","Returns the l2 norm of a vector = sqrt(x1^2+x2^2+...xn^2) or matrix norm induced by l2 norm.","Vect or Mtrx","norm([1,2]);norm([1,2,3,-4]);norm([[1,2],[3,-4]]);norm([[1,2,3],[3,-9,6],[4,5,6]])","maxnorm,l1norm"},
{"label","In a program, is used to mark an instruction with the label nom.",""," essai(a):={label truc;a:=a+2;if (a<10) goto truc;print(a);}","goto"},
{"labels","labels=[\"u\",\"v\"] renames the axis with \"u\" and \"v\".","","legend(1+i,\"Hello\");legend([30,20],\"bonjour\"); legende=[\"m\",\"s\"];point(1,1);; display(legend(1+i,\"A\"),red)","legend,angle"},
{"lagrange","Returns the polynomial of degree n-1 such that P(xk)=yk=f(x_k) k=0..n-1 or the list of divided differences if the last argument is lagrange","","lagrange([1,3,4],[0,1,2]);lagrange([1,3,4],[0,1,2],t); f(x):=exp(-x); lagrange([1,3,4],f);lagrange([[1,3,4],[0,1,2]]);lagrange([1,3,4],[0,1,2],[]); X:=[1,3,4]; divdiff:=lagrange(X,[0,1,2],lagrange); horner(divdiff,X,5);;lagrange([[1,3,4],[0,1,2]],y);lagrange([-1,0,1],[1/e-1,0,e-1]); f(x):=exp(x)-1;lagrange([-1,0,1],f);lagrange([0,1,2],[1,exp(1),exp(2)],lagrange);lagrange([0,1,2],exp,lagrange)","spline"},
{"laguerre","Returns the n-th Laguerre polynomial","","laguerre(4)","legendre,hermite"},
{"laplace","Laplace transform","","laplace(exp(x)*sin(x));laplace(sin(x)^2,x,s);laplace(Heaviside(x-1),x,s)","invlaplace,ztrans,invztrans,Heaviside"},
{"laplacian","Returns the Laplacian of the expression Xpr with respect to the list of variables and laplacian(n) for n  integer or float integer returns the matrix of size n of the discret laplacian en dimension 1.","","-2;laplacian(exp(z)*cos(x*y),[x,y,z]);laplacian(3);laplacian(3.0)",""},
{"laplacian_matrix","Returns the Laplacian matrix L=D-A of undirected graph G where D resp. A is the degree matrix resp. the adjacency matrix of G.","Graph(G),[normal]","laplacian_matrix(graph(trail(1,2,3,4,5,2)));laplacian_matrix(graph(trail(1,2,3,4,5,2)),normal)","adjacency_matrix,degree_sequence,number_of_spanning_trees"},
{"latex","Returns the evaluated expression written in latex.","","latex(1/2);latex((x^4-1)/(x^2+3))","mathml"},
{"lcf_graph","Returns the graph constructed from LCF notation J[^k] given the list of integers J [and a positive integer k, by default 1].","Lst(J),[Intg(k)]","lcf_graph([-3,3],4)","graph"},
{"lcm","Returns the lowest common multiple of 2 polynomials of several variables or of 2 integers or of 2 rationals.","","lcm(6,4);lcm(1251,123);lcm(5/7,50/9);lcm(x^2-2*x+1,x^3-1);lcm(t^2-2*t+1,t^2+t-2);lcm((x^2-1)*(y^2-1)*z^2,x^3*y^3*z+(-(y^3))*z+x^3*z-z)","gcd"},
{"lcoeff","Returns the coefficient of the term of highest degree of a polynomial (l=leading).","","lcoeff(-2*x^3+x^2+7*x);lcoeff([-2,1,7,0])","tcoeff"},
{"ldegree","Returns the valuation (degree of the term of lowest degree) of the polynomial P.","Poly(P)","valuation(x^4+x^3);valuation([1,1,0,0,0]);valuation(x^5+3*x^2);valuation([5,0,0,3,0,0])","degree,tcoeff"},
{"left","Returns the left part of an equality, of an interval, of a list or of a string.","","left(a=b);left(x^2+1=5);left(1..5);left(\"abcdefg\",3)","right,mid,tail,head"},
{"left_rectangle","Option of the plotarea command and of the area command.","Opt"," plotarea(x^2,x=0..1,5,trapezoid); plotarea(x^2,x=0..1,5,middle_point); plotarea(x^2,x=0..1,5,right_rectangle); plotarea(x^2,x=0..1,5,left_rectangle); area(x^2,x=0..1,5,middle_point); area(x^2,x=0..1,5,trapezoid)","plotarea,area"},
{"legend","legend(za,\"here\") (or legend([20,60],\"here\")) \"here\" is written at the point of affix za (or at the pixel position [20,60]) and legend=[\"m\",\"s\"] write \"m\",\"s\" as units on the axis.","","legend(1+i,\"Hello\");legend(point([0,2,3],\"Hello\");legend(point(0,1),\"Hello\",vert);legend(point(0,1,0),\"Hello\",vert);legend(1+i,\"Hello\",quadrant4,red);legend([30,20],\"bonjour\"); r:=evalf(sqrt(2));legend([30,20],string(r)); r:=evalf(sqrt(2));legend([30,20],r); legende=[\"m\",\"s\"];point(1,1);; display(legend(1+i,\"A\"),red); point(2+i,legend=\"2+i\",display=quadrant2+red); point([2,2*i],legend=\"1+i\",display=quadrant2+red); polygon(2,1,i,2*i,legend=\"1+i\",display=quadrant2+red)","labels,angle"},
{"legendre","Returns the n-th Legendre polynomial","","legendre(4)",""},
{"legendre_symbol","Legendre symbol.","","legendre_symbol(132,5);legendre_symbol(132,25)","jacobi_symbol"},
{"len","Returns the size of a list, a string or a sequence.","Lst or Str or Seq","size([1,2,3]);size(\"bonjour\");size(1,2,3)","sizes,dim,degree"},
{"length","Returns the size of a list, a string or a sequence.","Lst or Str or Seq","size([1,2,3]);size(\"bonjour\");size(1,2,3)","sizes,dim,degree"},
{"leve_crayon","Puts the pencil up so that the turtle moves without traces.","","leve_crayon()","baisse_crayon,crayon"},
{"lgcd","Returns the greatest common divisor of a list of polynomials or of integers","","lgcd([45,75,20,15]);lgcd([x^2-2*x+1,x^3-1,x-1]);lgcd(x^2-2*x+1,x^3-1,x-1)","gcd,lcm,euler,content"},
{"lhs","Returns the left part of an equality, of an interval, of a list or of a string.","Equal(a=b) or Interval(a..b) or Str,Intg","left(a=b);left(x^2+1=5);left(1..5);left(\"abcdefg\",3)","right,mid,tail,head"},
{"ligne_chapeau_carre","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"ligne_chapeau_plat","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"ligne_chapeau_rond","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"ligne_polygonale","Draws the polygons joining for j fixed and for k=0..nrows, the points (xk,yk) where xk=element row k column 0 et yk=element row k column j ,when the xk are sorted (we obtain ncols-1 polygons).","Mtrx","polygonplot([[1,2,3],[2,0,1],[-1,2,3]])","scatterplot,listplot,polygonscatterplot"},
{"ligne_polygonale_pointee","Draws the points (xk,yk) and the polygons joining for j fixed and for k=0..nrows, the points (xk,yk) where xk=element row k column 0 et yk=element row k column j ,when the xk are sorted (we obtain ncols-1 polygons).","Mtrx","polygonscatterplot([[1,2,3],[2,0,1],[-1,2,3]])","scatterplot,polygonplot,listplot"},
{"ligne_tiret","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"ligne_tiret_point","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"ligne_tiret_pointpoint","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"ligne_trait_plein","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"limit","Limit of an expression at a limit point (a or +/-infinity)(d=-1 for limit inf and +1 for limit sup).","","limit((n*tan(x)-tan(n*x))/(sin(n*x)-n*sin(x)),x,0);limit(sin(x)/(x^2-3*x),x,0);limit((2*x-1)/exp(1/(x-1)),x,+infinity);limit(exp(1/x),x,0,1);limit(exp(1/x),x,0,-1);limit(taux_accroissement(x^n,1,1+h),h,0)","series,taylor,taux_accroissement"},
{"limite","Limit of an expression at a limit point (a or +/-infinity)(d=-1 for limit inf and +1 for limit sup).","Expr,Var,Val,[Dir(d)]","limit((n*tan(x)-tan(n*x))/(sin(n*x)-n*sin(x)),x,0);limit(sin(x)/(x^2-3*x),x,0);limit((2*x-1)/exp(1/(x-1)),x,+infinity);limit(exp(1/x),x,0,1);limit(exp(1/x),x,0,-1);limit(taux_accroissement(x^n,1,1+h),h,0)","series,taylor,taux_accroissement"},
{"lin","Linearization of exponentials","","lin(exp(x)^n);lin((exp(x)^3+exp(x))^2)","tlin,texpand"},
{"line","line(A,B) (resp line(A,slope=m) or line(A,[1,m]) or line(a*x+b*y+c=0) or line(a*x+b*y+c*z+d=0,aa*x+bb*y+cc*z+dd=0) or line(A,u)) draws the line AB (resp the line going through A with slope m or with direction vector u or of equation the argument) in the plane or in the 3D space.","","line(i,1+i);line(point(-i),point(1+i));line(1+i,slope=2);line([0,0,0],[1,1,1]);line(x+y=1);line(x+y+z=0,x+y=0);line([1+t,-1+t],t);line([1+t,2-t,-1+3*t],t);line(1-i,slope=slope(line(1,2i)))","point,plane,slope"},
{"line_graph","Returns the line graph of undirected graph G.","Graph(G)","line_graph(hypercube_graph(3))","plane_dual"},
{"line_inter","Gives one of the intersections of 2 curves or surfaces (or the intersection near A or not in L).","Curve,Curve,[Pnt(A)||LstPnt(L)]","single_inter(line(i,1-i),line(0,1));single_inter(line(i,1-i),circle(0,1));single_inter(line(i,1+2*i),circle(0,1),[point(i)]);single_inter(line(-1-i,1+2*i),circle(0,1),point(-1));single_inter(circle(1,sqrt(2)),circle(0,1));single_inter(plane(x=y),plane(y=z));single_inter(line(x=y+1,y=2*z),plane(y=z))","intersect,head"},
{"line_paper","Draws in the rectangle [xmin..xmax]*[ymin..ymax], the lines x=n*ux in the axes OxY of angle t!=0.","","line_paper(0.4,pi/3);line_paper(0.4,pi/3,x=-1..4,y=-2..2);line_paper(0.5,3*pi/4)",""},
{"line_segments","Returns the list of the line_segments (1 line=segment) of the polyhedron P.","","line_segments(polyhedron([0,0,0],[0,5,0],[0,0,5],[1,2,6]));line_segments(polyhedron([0,0,0],[0,5,0],[0,0,5],[1,2,6]))[2]","polyhedron"},
{"line_width_1","Option of the display command for a line.",""," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"line_width_2","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"line_width_3","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"line_width_4","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"line_width_5","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"line_width_6","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"line_width_7","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); display(segment(0,1+i),line_width_5); segment(1,i,affichage=epaisseur_ligne_4)","display,thickness"},
{"linear_interpolate","Make a regular sample from a polygonal line defined by a 2 rows matrix","","linear_interpolate([[1,2,6,9],[3,4,6,7]],1,9,1)","polygonplot"},
{"linear_regression","Returns the coefficients a and b of y=a*x+b ;it is the best line approx the points where the coordinates are the rows of A (or the 2 lists).","","linear_regression([[0.0,0.0],[1.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]]);linear_regression([0.0,1.0,2.0,3.0,4.0],[0.0,1.0,4.0,9.0,16.0])","polynomial_regression,power_regression,logistic_regression"},
{"linear_regression_plot","Returns the plot of y=a*x+b ;it is the best line approx the points where the coordinates are the rows of A (or the 2 lists).","","linear_regression_plot([[0.0,0.0],[1.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]]);linear_regression_plot([0.0,1.0,2.0,3.0,4.0],[0.0,1.0,4.0,9.0,16.0])","polynomial_regression_plot,power_regression_plot"},
{"lineariser","Linearization of exponentials","Expr","lin(exp(x)^n);lin((exp(x)^3+exp(x))^2)","tlin,texpand"},
{"lineariser_trigo","Trigonometric linearization","ExprTrig","tlin(sin(x)^3);tlin(cos(x)*cos(y))","texpand,lin"},
{"linfnorm","Matrix norm induced by linfinity norm.","Mtrx","linfnorm([[1,2,3],[3,-9,6],[4,5,6]])","l1norm,l2norm,matrix_norm,frobenius_norm"},
{"linsolve","Linear equations system solver.","","linsolve([x+y+z=1,x-y=2,2*x-z=3],[x,y,z]);linsolve([m*x+y=a,x+m*y=b],[x,y]);linsolve([x+y-z-1,x-y+1,x-y-z-1]%2,[x,y,z]);linsolve([[3,4],[1,2]],[0,1]); p,l,u:=lu([[3,4],[1,2]]); linsolve(p,l,u,[0,1]) ;linsolve([2*x+y+z=1,x+y+2*z=1,x+2*y+z=4],[x,y,z]);linsolve([[2,1,1],[1,1,2],[1,2,1]],[1,1,4]); p,l,u:=lu([[2,1,1],[1,1,2],[1,2,1]]);linsolve(p,l,u,[1,1,4]); a:=[[100,2],[2,100]];linsolve(evalf(a),[0,1]);","solve,proot,simult,gaussjord,pivot,ref,conjugate_gradient"},
{"linspace","linspace(a,b,n) creates a list of n elements at regular intervals between a and b, by default n=100 (compatibility with scilab).","","linspace(0,1,11)",""},
{"lis","Instruction in a program so that you can input an expression and store it in var.","[Str],Var(Var)","input(\"age\",a)","InputStr,output"},
{"lis_phrase","Instruction in a program so that you can input a string and store it in var.","[Str],Var(Var)","InputStr(\"nom?\",N)","input"},
{"list","Convert to a list","","list((1,2))","symb2poly,convert"},
{"list2exp","Invert exp2list","","list2exp([[3,9],[- 1,1]],[x, y]);list2exp(solve(x^2-1=0),x)","exp2list"},
{"list2mat","Returns the matrix with n columns and where terms are the list l completed eventually by 0.","","list2mat([1,8,4,9],1);list2mat([1,8,4,9],2)","mat2list"},
{"list_edge_attributes","Returns the list of attributes assigned to edge e of G in form tag=value.","Graph(G),Edge(e)","","set_edge_attribute,get_edge_attribute,discard_edge_attribute"},
{"list_graph_attributes","Returns the list of graph attributes of G in form tag=value.","Graph(G)","","set_graph_attribute,get_graph_attribute,discard_graph_attribute"},
{"list_vertex_attributes","Returns the list of attributes assigned to vertex v of G in form tag=value.","Graph(G),Vrtx(v)","","set_vertex_attribute,get_vertex_attribute,discard_vertex_attribute"},
{"listplot","Draws the polygonal line through the points of abscissa 0,...,n and ordinate l=[y0,...,yn] or the line through the points of abscissa the first M column and ordinate the second column.","","listplot([13,10,15,16]);listplot([1,13],[2,10],[3,15],[4,16]);listplot([[0,13],[2,10],[4,15]])","polygonplot,scatterplot,polygonscatterplot"},
{"lll","(S,A,L,O):=lll(M), short basis of a lattice (L*O=A*M=S).","","lll([[1234,3452,4521],[3425,2241,1543],[5643,3425,8721]])",""},
{"ln","Natural logarithm or Option of the convert or convertir command (id trig2exp).","","ln(1);ln(e); convert(cos(x),ln)","exp,convert,trig2exp,log10"},
{"lname","List of variables in the expression.","","lname(exp(x)*2*sin(y))","has,lvar"},
{"lncollect","Collect logarithms. Applies ln(a)+n*ln(b)->ln(a*b^n) for integers n.","","lncollect(ln(x)+2*ln(y))","texpand"},
{"lnexpand","Expands logarithms.","","lnexpand(ln(3*x))","texpand,expexpand,trigexpand"},
{"local","Local variables definition: f(x):={local (var1:=x),var2; instruction;};",""," f2(x):={local (a:=2),b; b:=a*x; return b;}; f2(x):={var (a:=2),b; b:=a*x; return b;}","for,if,->,{}"},
{"locus","locus(M,A) draws the locus of M (or locus(d,A) draws the envelope of d) when A:=element(C) (C is a curve). The example instructions below, must be written in a geometric level on different lines.",""," A:=element(circle(i,1+i));M:=homothety(0,2,A);locus(M,A); A:=element(line(x=0));d:=perpen_bisector(1,A);locus(d,A)","envelope,trace"},
{"log","Natural logarithm or Option of the convert or convertir command (id trig2exp).","Expr or Opt","ln(1);ln(e); convert(cos(x),ln)","exp,convert,trig2exp,log10"},
{"log10","Common logarithm (base 10).","","log10(10)","alog10,ln"},
{"logarithmic_regression","Returns the coefficients a and b of y=a*ln(x)+b : it is the best logarithm which approx the points where the coordinates are the rows of A (or the 2 lists).","","logarithmic_regression([[1.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]]);logarithmic_regression([1.0,2.0,3.0,4.0],[1.0,4.0,9.0,16.0])","exponential_regression"},
{"logarithmic_regression_plot","Returns the plot of y=a*ln(x)+b : it is the best logarithm which approx the points where the coordinates are the rows of A (or the 2 lists).","","logarithmic_regression_plot([[1.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]]);logarithmic_regression_plot([1.0,2.0,3.0,4.0],[1.0,4.0,9.0,16.0])","exponential_regression_plot"},
{"logb","Logarithm of base b.","","logb(5,2);logb(7,10)","log,log10"},
{"logistic_regression","Returns y,y',C,y'max,xmax,R : y is a logistic function (sol of y'/y=a*y+b), such that y(x0)=y0 and where [y'(x0),y'(x0+1)...] is the best approximation of L.","","logistic_regression(evalf([1,2,4,6,8,7,5]),1,2);logistic_regression([0.0,1.0,2.0,3.0,4.0],0.0,1.0)","polynomial_regression,power_regression,linear_regression"},
{"logistic_regression_plot","Returns the plot of a logistic function y such that y(x0)=y0 and where [y'(x0),y'(x0+1)...] is the best approximation of L.","","logistic_regression_plot(evalf([1,2,4,6,8,7,5]),1,2);logistic_regression_plot([0.0,1.0,2.0,3.0,4.0],0.0,1.0)","polynomial_regression_plot,power_regression_plot,linear_regression_plot"},
{"lower","Returns the lower matrix (under the diagonal, included) or write lowercase","Mtrx||Strng","lower([[1,2,3],[4,5,6],[7,8,9]]);lower(\"HELLO\")","diag,upper"},
{"lowest_common_ancestor","Returns the lowest common ancestor of nodes u and v in the tree graph T with root r, or the list of lowest common ancestors of all pairs [uk,vk].","Graph(T),Vrtx(r),Seq(u,v)||Lst([u1,v1],[u2,v2],...)"," T:=random_tree(30); lowest_common_ancestor(T,15,10,20); T:=random_tree(30); lowest_common_ancestor(T,15,[[10,20],[11,19]])","is_tree,tree_height"},
{"lowpass","Returns the result of applying a simple first-order lowpass RC filter with cutoff frequency c (the default samplerate is 44100) to the given signal s.","Lst(s),Real(c),[Intg(samplerate)]"," f:=unapply(periodic(sign(x),x,-1/880,1/880),x):;s:=createwav(apply(f,soundsec(1))):;playsnd(lowpass(s,1000))","highpass,moving_average"},
{"lp_assume","Options for lpsolve command","Opt","","lpsolve"},
{"lp_bestprojection","Options for lpsolve command","Opt","","lpsolve"},
{"lp_binary","Options for lpsolve command","Opt","","lpsolve"},
{"lp_binaryvariables","Options for lpsolve command","Opt","","lpsolve"},
{"lp_breadthfirst","Options for lpsolve command","Opt","","lpsolve"},
{"lp_depthfirst","Options for lpsolve command","Opt","","lpsolve"},
{"lp_depthlimit","Options for lpsolve command","Opt","","lpsolve"},
{"lp_firstfractional","Options for lpsolve command","Opt","","lpsolve"},
{"lp_gaptolerance","Options for lpsolve command","Opt","","lpsolve"},
{"lp_hybrid","Options for lpsolve command","Opt","","lpsolve"},
{"lp_initialpoint","Options for lpsolve command","Opt","","lpsolve"},
{"lp_integer","Options for lpsolve command","Opt","","lpsolve"},
{"lp_integertolerance","Options for lpsolve command","Opt","","lpsolve"},
{"lp_integervariables","Options for lpsolve command","Opt","","lpsolve"},
{"lp_interiorpoint","Options for lpsolve command","Opt","","lpsolve"},
{"lp_iterationlimit","Options for lpsolve command","Opt","","lpsolve"},
{"lp_lastfractional","Options for lpsolve command","Opt","","lpsolve"},
{"lp_maxcuts","Options for lpsolve command","Opt","","lpsolve"},
{"lp_maximize","Options for lpsolve command","Opt","","lpsolve"},
{"lp_method","Options for lpsolve command","Opt","","lpsolve"},
{"lp_mostfractional","Options for lpsolve command","Opt","","lpsolve"},
{"lp_nodelimit","Options for lpsolve command","Opt","","lpsolve"},
{"lp_nodeselect","Options for lpsolve command","Opt","","lpsolve"},
{"lp_nonnegative","Options for lpsolve command","Opt","","lpsolve"},
{"lp_nonnegint","Options for lpsolve command","Opt","","lpsolve"},
{"lp_pseudocost","Options for lpsolve command","Opt","","lpsolve"},
{"lp_simplex","Options for lpsolve command","Opt","","lpsolve"},
{"lp_timelimit","Options for lpsolve command","Opt","","lpsolve"},
{"lp_variables","Options for lpsolve command","Opt","","lpsolve"},
{"lp_varselect","Options for lpsolve command","Opt","","lpsolve"},
{"lp_verbose","Options for lpsolve command","Opt","","lpsolve"},
{"lpsolve","solves a (mixed integer/binary) LP problem in general form","Expr(o),[List(c)],[bounds],[options]","lpsolve(2x+y-z+4,[x<=1,y>=2,x+3y-z=2,2x-y+z<=8,-x+y<=5]);lpsolve(-4x-5y,[x+2y<=6,5x+4y<=20,0<=x,0<=y]);lpsolve(-7x+2y,[4x-12y<=20,-x+3y<=3],x=-5..5,y=0..inf,lp_maximize=true);lpsolve(x-y-2z+3,[-3x-y+z<=3,2x-3y>=4z,x-z=y,x>=0,y<=0],lp_maximize);lpsolve(-x-y,[y<=3x+1/2,y<=-5x+2],assume=lp_nonnegative);lpsolve(x+y,[x<=8,-x+y<=4,-x+2y>=6,2x+y<=25,3x+y>=18,-x+2y>=6],assume=lp_nonnegative);lpsolve(45.55x1+21.87x2,[1.64x1+2.67x2<=31.2,2.11x1+2.3x2>=13.9],assume=lp_nonnegative);lpsolve(3x+4y,[x<=4,x+3y<=15,-x+2y>=5,x-y>=9,x+y=6],assume=lp_nonnegative,lp_maximize=true);lpsolve(-6x+4y+z,[5x-10y<=20,2z-3y=6,-x+3y<=3],x=1..20,y=0..inf);lpsolve(-5x-7y,[7x+y<=35,-x+3y<=6],assume=integer);lpsolve(x+3y+3z,[x+3y+2z<=7,2x+2y+z<=11],assume=lp_nonnegative,lp_integervariables=[x,z],lp_maximize);lpsolve(2x+5y,[3x-y=1,x-y<=5],assume=nonnegint);lpsolve(x1+x2,[2x1+5x2<=16,6x1+5x2<=30],assume=nonnegint,lp_maximize);lpsolve(8x1+11x2+6x3+4x4,[5x1+7x2+4x3+3x4<=14],assume=lp_binary,lp_maximize);lpsolve(x1+x2,[1867x1+1913x2=3618894],assume=nonnegint,lp_verbose=true)","nlpsolve,fsolve"},
{"lsmod","Displays the installed dynamic libraries.","","lsmod()","insmod,rmmod"},
{"lsq","Returns the vector (resp matrix) X which is the minimum of the euclidean (resp Frobenius) norm of A*X-B corresponding to the linear system A*X=B when B is a vector (resp matrix).","Mtrx(A),(Mtrx || Vect)(B)","LSQ([[1,2],[3,4]],[5,11]);LSQ([[1,2],[3,4]],[[5,-1],[11,-1]])","lu,QR"},
{"lu","For a numerical matrix A, returns p permutation, L and U such that PA=LU (P=permu2mat(p)).","","lu([[1,2],[3,4]]);lu([[6,12,18],[5,14,31],[3,8,18]])","qr,cholesky,LU"},
{"lvar","List of variables of an object (with rational dependence).","","lvar(exp(x)*2*sin(y));lvar(exp(x)*2*sin(y)+ln(x))","lname,has"},
{"mRow","Multiplies the row n1 of the matrix A by Xpr.","","mRow(12,[[1,2],[3,4],[5,6]],0)","rowAdd,mRowAdd"},
{"mRowAdd","Multiplies the row n1 of the matrix A by Xpr, then adds it to the row n2.","","mRowAdd(12,[[1,2],[3,4],[5,6]],0,2)","rowAdd,mRow"},
{"magenta","Option of the display command to display with color.","Opt"," F:=display(point(2+1.5*i),red); F:=display(point(2+1.5*i),point_point+green)","display"},
{"make_directed","Returns the copy of undirected graph G in which every edge is converted to a pair of arcs [and with weights specified by matrix A].","Graph(G),[Mrtx(A)]","make_directed(cycle_graph(4),[[0,0,0,1],[2,0,1,3],[0,1,0,4],[5,0,4,0]])","is_directed,make_weighted,underlying_graph"},
{"make_weighted","Returns a copy of G with edge/arc weights set as specified by matrix M. If M is omitted, a suqare matrix of ones is used. If G is undirected, M is assumed to be symmetric.","Graph(G),[Mrtx(M)]","make_weighted(cycle_graph(3),[[0,2,3],[2,0,1],[3,1,0]])","get_edge_weight,is_weighted,make_directed,set_edge_weight,underlying_graph,weight_matrix"},
{"makelist","Returns a list made with a function or with a constant.","","makelist(x->x^2,1,10,2);makelist(4,1,10);makelist(4,5,10);makelist(x->ifte(x<5,\"A\",\"B\"),1,10)","seq,range,makemat,$"},
{"makemat","Create a matrix.","","makemat((j,k)->j+k,3,2);makemat((j,k)->1/(j+k+1),2,3);makemat(sqrt(2),2,3)","matrix"},
{"makesuite","Returns a sequence made with a vector.","","makesuite([1,2,3])","makevector,op"},
{"makevector","Returns a vector made with a sequence.","","makevector(1,2,3)","makesuite"},
{"map","Apply the function f at the elements of the list l or at a polynomial of internal format.","","list(map(lambda x:x*x,[1,23]));map([1,2,3],x->x^3);map([1,2,3],unapply(x^3,x));map(%%%{1,[2,0]%%%}+%%%{2,[1,1]%%%},(a,b,c)->a*(b+2*c))","apply,set,unapply"},
{"maple2mupad","maple2mupad(\"file1\",\"file2\") translate file1(Maple) to file2(MuPAD).","","","maple2xcas"},
{"maple2xcas","maple2xcas(\"file1\",\"file2\") translate file1(Maple) to file2(Xcas).","","","maple2mupad"},
{"maple_ifactors","Returns 1 or -1 for the sign and the prime factors with their multiplicity of n in a matrix such as ifactors in Maple.","","maple_ifactors(120)","ifactors"},
{"maple_mode","Switches to mode Xcas (0), Maple (1), Mupad (2), TI89 (3).","","xcas_mode(1);xcas_mode(0)","python_compat"},
{"markov","Computation of the proper elements of a Markov chain transition matrix M, returns the list of sequence of positive recurrent states, the list of corresponding invariant probabilities, the list of other strong connected components, the list of probability to end up in the sequence of recurrent states.","","markov([[0,0,1/2,0,1/2],[0,0,1,0,0],[1/4,1/4,0,1/4,1/4],[0,0,1/2,0,1/2],[0,0,0,0,1]])","randmarkov,plotproba"},
{"mat2list","Returns the list of the terms of the matrix.","","mat2list([[1,8],[4,9]])","list2mat,flatten"},
{"mathml","Converts the expression into a string so that we can display maths for the web.","","mathml(1/2)","latex"},
{"matpow","Calculates the n power of a matrix by jordanization","","matpow([[1,2],[3,4]],n)","&^,^"},
{"matrix","Make a matrix m(j,k) with p rows and q cols, m(j,k)=f(j,k) or m(j,k)=a : the index start at 0 or 1 according to the mode (Xcas or Maple) (or option of apply) or make a maytice with a table.","","matrix(2,3,lambda j,k:1/(j+k+1));matrix(3,2,(j,k)->j+k);matrix(2,3,4);  A[0..2,0..2]:=1;A[0..1,1..2]:=2;a:=matrix(A) ","makemat,makelist,apply"},
{"matrix_norm","Matrix norm   induced by l1norm or by l2norm or by linfinty norm.","","matrix_norm([[1,2,3],[3,-9,6],[4,5,6]]);matrix_norm([[1,2,3],[3,-9,6],[4,5,6]],1);matrix_norm([[1,2,3],[3,-9,6],[4,5,6]],2);matrix_norm([[1,2,3],[3,-9,6],[4,5,6]],inf)","l1norm,l2 norm,linfnorm,frobenius_norm"},
{"max","Maximum of elements of a sequence or a list of reals.","","max(25,35)","min"},
{"maxflow","Returns the optimal value for the max flow problem for network G with the source s and sink t along with an optimal flow (as a matrix).","Graph(G),Vrtx(s),Vrtx(t)","maxflow(digraph(%{[[1,2],2],[[2,3],4],[[3,4],3],[[1,5],3],[[5,2],1],[[5,4],2]%}),1,4)","minimum_cut"},
{"maximal_independent_set","Returns a maximal set of mutually independent (non-adjacent) vertices in G.","Graph(G)","maximal_independent_set(graph(\"petersen\"))","maximum_independent_set"},
{"maximize","Minimize a function","Expr,[Constr],Vars,[Options]","minimize(sin(x),[x=0..4]);minimize(x^4-x^2,x=-3..3,locus);minimize(piecewise(x<=-2,x+6,x<=1,x^2,3/2-x/2),x=-3..2);minimize(x^2-3x+y^2+3y+3,[x=2..4,y=-4..-2],point);minimize(2x^2-y^2+6y,x^2+y^2<=16,[x,y]);minimize(sqrt(x^2+y^2)-z,[x^2+y^2<=16,x+y+z=10],[x,y,z]);minimize((1+x^2+3y+5x-4*x*y)/(1+x^2+y^2),x^2/4+y^2/3=9,[x,y]);minimize(cos(x)^2+cos(y)^2,x+y=pi/4,[x,y],locus)",""},
{"maximum_clique","Returns maximum clique of undirected graph G as a list of vertices.","Graph(G)","maximum_clique(graph_complement(complete_graph(3,4)))","clique_number,is_clique,maximum_independent_set"},
{"maximum_degree","Returns the larges degree among the vertices of G.","Graph(G)","maximum_degree(digraph(trail(1,2,3,4,5,6,4,7,8,2)))","minimum_degree,vertex_degree"},
{"maximum_independent_set","Returns the maximum independent vertex set of G.","Graph(G)","maximum_independent_set(complete_graph(3,4))","clique_number,graph_complement,independence_number,maximum_clique"},
{"maximum_matching","Returns the list of edges representing maximum matching in G.","Graph(G)"," G:=graph(\"soccerball\"); draw_graph(highlight_edges(G,maximum_matching(G)))","maximum_independent_set"},
{"maxnorm","Norm with the max of a vector (or of a matrix): maxnorm([x1,x2,..,xn])=max(|x1|,..,|xn|).","","maxnorm([1,2]);maxnorm([1,2,3,-4]);maxnorm([[1,2],[3,-4]])","l2norm,l1norm"},
{"mean","Mean of a list with the second argument as pound or of the columns of a matrix.","","mean([1,2,3]);mean([1,2,3],[1,2,3]);mean([[1,2,3],[1,2,3]])","stddev"},
{"median","Returns the median of a list with the second argument as pound or of the columns of a matrix.","","median([1,2,3,5,10,4]);median([1,2,3,5,10,4],[1,2,3,1,2,3])","quartiles"},
{"median_line","median_line(A,B,C) draws the median-line through A of the triangle ABC","","median_line(-1,1-i,i)","midpoint,perpen_bisector"},
{"member","Tests if e is in the list or set l (=0 or k+1 with l[k]=e).","","member(1,[4,3,1,2]);member(1,%{4,3,1,2%})","contains,est_element,find,index"},
{"mgf","Returns the moment generating function of a probability distribution from normal, binomial, Poisson, beta, gamma distribution","","mgf(normald,1,0);mgf(poisson,5);mgf(binomial,n,p)",""},
{"mid","Returns the extracted list of l with n elements (by default n=size(l)-d) and beginning at index d.","","mid([0,1,2,3,4,5,6],2,3);mid([0,1,2,3,4,5,6],2);mid(\"azertyuiop\",2,4);mid(\"azertyuiop\",2);mid([[1,2],[3,4],[5,6]],1)","head,tail,left,right,subMat"},
{"middle_point","Option of the plotarea command and of the area command.","Opt"," plotarea(x^2,x=0..1,5,trapezoid); plotarea(x^2,x=0..1,5,middle_point); plotarea(x^2,x=0..1,5,right_rectangle); plotarea(x^2,x=0..1,5,left_rectangle); area(x^2,x=0..1,5,middle_point); area(x^2,x=0..1,5,trapezoid)","plotarea,area"},
{"midpoint","midpoint(A,B) draws the midpoint of the segment AB","","midpoint(-2,2i)","median_line,perpen_bisector"},
{"min","Minimum of elements of a sequence or a list of reals.","","min(25,35)","max"},
{"minimal_edge_coloring","Finds the minimal edge coloring of G and returns the sequence n,L where n is the class of G (1 for D colors and 2 for D+1 colors) and L is the list of colors of edges of G as returned by the edges command, or a copy of G with colored edges if the option 'sto' is specified.","Graph(G),[sto]","minimal_edge_coloring(graph(\"petersen\")); G:=minimal_edge_coloring(graph(\"dodecahedron\"),sto); draw_graph(G)","chromatic_index,minimal_vertex_coloring,edges"},
{"minimal_spanning_tree","Returns the minimal spanning tree of undirected graph G.","Graph(G)","minimal_spanning_tree(graph([[0,1,0,4,0,0],[1,0,1,0,4,0],[0,1,0,3,0,1],[4,0,3,0,1,0],[0,4,0,1,0,4],[0,0,1,0,4,0]]))","spanning_tree"},
{"minimal_vertex_coloring","Computes minimal vertex coloring for G and returns the colors in the order of vertices. If optional parameter \"sto\" is given, the colors are assigned to vertices and the modified copy of G is returned.","Graph(G),[sto]","minimal_vertex_coloring(graph(\"petersen\")); draw_graph(minimal_vertex_coloring(graph(\"petersen\"),sto))","chromatic_number,is_vertex_colorable"},
{"minimax","Implementation of Remez method for minimax polynomial approximation of degree n of a continuous bounded function on a..b.","Expr,Var=a..b,n,[Options]","minimax(x*exp(-x),x=0..10,12);minimax(x*sin(x),x=0..10,15);minimax(ln(2+x-sin(x)^2),x=0..2*pi,20);minimax(cos(x^2-x+1),x=-2..2,17);minimax(atan(x),x=-5..5,30);minimax(tanh(sin(9x)),x=-1/2..1/2,15);minimax(abs(x),x=-1..1,25);minimax(abs(x)*sqrt(abs(x)),x=-2..2,15);minimax(min(1/cosh(3*sin(x)),sin(9x/10)),x=-3..4,30);minimax(when(x==0,0,exp(-1/x^2)),x=-1..1,25)",""},
{"minimize","Minimize a function","Expr,[Constr],Vars,[Options]","minimize(sin(x),[x=0..4]);minimize(x^4-x^2,x=-3..3,locus);minimize(piecewise(x<=-2,x+6,x<=1,x^2,3/2-x/2),x=-3..2);minimize(x^2-3x+y^2+3y+3,[x=2..4,y=-4..-2],point);minimize(2x^2-y^2+6y,x^2+y^2<=16,[x,y]);minimize(sqrt(x^2+y^2)-z,[x^2+y^2<=16,x+y+z=10],[x,y,z]);minimize((1+x^2+3y+5x-4*x*y)/(1+x^2+y^2),x^2/4+y^2/3=9,[x,y]);minimize(cos(x)^2+cos(y)^2,x+y=pi/4,[x,y],locus)",""},
{"minimum_cut","Returns the list of edges forming a minimum cut in a directed graph G with the source s and sink t.","Graph(G),Vrtx(s),Vrtx(t)","minimum_cut(digraph(%{[[1,2],2],[[2,3],4],[[3,4],3],[[1,5],3],[[5,2],1],[[5,4],2]%}),1,4)","maxflow"},
{"minimum_degree","Returns the smallest degree among the vertices of G.","Graph(G)","minimum_degree(digraph(trail(1,2,3,4,5,6,4,7,8,2)))","maximum_degree,vertex_degree"},
{"minus","minus is a infixed operator to get the difference of 2 sets.",""," [1,2,3] minus [2,5,6]; %{1,2,3%} minus %{2,5,6%}","union,intersect"},
{"mkisom","Matrix of an isometry given by its proper elements.","","mkisom([1,2],1);mkisom([[1,0,0],pi/3],-1);mkisom(pi,1)","isom"},
{"mksa","Convert units in MKSA international unit system","","mksa(1_N)","convert,ufactor"},
{"mod","Infixed operator which returns n mod p a number of ℤ/pℤ.",""," 15 mod 6; (2 mod 10)^50; (72 mod 7) mod 0; (2%10)^50; (72%7)%0","smod,irem,fracmod"},
{"modgcd","GCD of 2 polynomials, with the modular algorithm.","","modgcd(x^4-1,(x-1)^2)","gcd,heugcd,ezgcd,psrgcd"},
{"mods","Returns the Euclidean symmetric remainder of two integers.","Intg,Intg","smod(8,3);smod(10,4);smod(11,7)","irem,iquo,mod,fracmod"},
{"monotonic","Returns a real that increases as time passes","","monotonic()",""},
{"montre_tortue","Shows the turtle.","","montre_tortue()","cache_tortue"},
{"moustache","Box and Whisker plot for a statistical series.","Lst,[Lst],[x=a..b||y=a..b]","boxwhisker([-1,1,2,2.2,3,4,-2,5]);boxwhisker([1,2,3,5,10,4],x=1..2);boxwhisker([1,2,3,5,10,4],[1,2,3,1,2,3]);boxwhisker([[6,0,1,3,4,2,5],[0,1,3,4,2,5,6],[1,3,4,2,5,6,0],[3,4,2,5,6,0,1],[4,2,5,6,0,1,3],[2,5,6,0,1,3,4]])","quartiles"},
{"moving_average","Applies a moving average filter of length n to a signal sample A, and returns its result as an array of length nops(A)-n+1.","Lst(A),Intg(n)"," snd:=soundsec(2):;data:=0.5*threshold(3*sin(2*pi*220*snd),[-1.0,1.0])+randvector(length(snd),normald,0,0.05):;moving_average(data,25)","lowpass"},
{"moyal","Moyal product of 2 symbols.","","moyal(x^2+y^4,x^4-y^2,[x,y],5)",""},
{"moyenne","Mean of a list with the second argument as pound or of the columns of a matrix.","Lst||Mtrx,[Lst]","mean([1,2,3]);mean([1,2,3],[1,2,3]);mean([[1,2,3],[1,2,3]])","stddev"},
{"mul","Multiplicates the values of the expression when the variable go from a to b with a step p (product(expression,var,begin,end,step) by default p=1) or product of the elements of a list or product element by element of 2 lists or matrix. In Python (linalg) product of 2 matrices.","Expr||Lst,[Var||Lst],[Intg(a)],[Intg(b)],[Intg(p)]","mul([[1,2],[3,4]],[[2,3],[5,6]]);product([1,2,3,4])","sum"},
{"mult_c_conjugate","Returns the expression after multiplication by the complex conjugated quantity of the denominator (or of the numerator if no denominator).","","mult_c_conjugate(1/(3+i*2));mult_c_conjugate(3+i*2)","mult_conjugate"},
{"mult_conjugate","Returns the expression after multiplication by the conjugated quantity of the denominator (or of the numerator if no denominator).","","mult_conjugate(sqrt(3)-sqrt(2));mult_conjugate(1/(sqrt(3)-sqrt(2)))","mult_c_conjugate"},
{"multinomial","Returns n!/(k0!*k1!*..;kj!)*(p0^k0*p1^k1..*pj^kj) (sum(p)=1 et sum(k)=n).","","multinomial(10,[0.5,0.5],[3,7]);multinomial(10,[0.2,0.3,0.5],[1,3,6]); randvector(3,multinomial,[1/2,1/3,1/6]); ranm(4,3,multinomial,[1/2,1/3,1/6])","binomial,randvector,ranm"},
{"multiplier_conjugue","Returns the expression after multiplication by the conjugated quantity of the denominator (or of the numerator if no denominator).","Expr","mult_conjugate(sqrt(3)-sqrt(2));mult_conjugate(1/(sqrt(3)-sqrt(2)))","mult_c_conjugate"},
{"multiplier_conjugue_complexe","Returns the expression after multiplication by the complex conjugated quantity of the denominator (or of the numerator if no denominator).","Expr","mult_c_conjugate(1/(3+i*2));mult_c_conjugate(3+i*2)","mult_conjugate"},
{"multiply","Returns the product of the 2 arguments.","","multiply(41,-4);multiply([4,1],[-4,2]);multiply([[4,1],[-4,1]],[[4,1],[-4,1]])","*"},
{"mupad2maple","mupad2maple(\"file1\",\"file2\") translate file1(MuPAD) to file2(Maple).","","","mupad2xcas"},
{"mupad2xcas","mupad2xcas(\"file1\",\"file2\") translate file1(MuPAD) to file2(Xcas).","","","mupad2maple"},
{"mycielski","Returns the Mycielskian of undirected graph G.","Graph(G)","mycielski(graph(\"petersen\")); is_isomorphic(mycielski(mycielski(path_graph(2))),graph(\"grotzsch\"))","chromatic_number,number_of_triangles"},
{"nCr","comb(n,r)=number of combinations of r objects taken among n : n!/(r!(n-r)!) (If n<0 comb(n,r)=n(n-1)..(n-r+1)/r!).","Intg(n),Intg(r)","comb(4,2)","factorial,perm"},
{"nDeriv","Returns an approximation of the derivative number at a point: (Xpr(var+h)-Xpr(var-h))/(2*h) (by default h=0.001).","","nDeriv(f(x),x,h);nDeriv(x^2,x,0.1);nDeriv(x^2,x)","avgRC"},
{"nInt","Returns the approximate value of integrate(f(x),x,a,b) by Romberg's method.","Expr(f(x)),Var(x),Real(a),Real(b)","romberg(exp(x^2),x,0,1);romberg(x^2,x,0,1);romberg(exp(-x^2),x,-1,1)","integrate,gaussquad"},
{"nPr","perm(n,p)=number of arrangements of p objects taken among n : n!/(n-p)!","Intg(n),Intg(p)","perm(4,2)","comb,factorial"},
{"nSolve","Numerical solution of an equation or a system of equation","","nSolve(cos(x)=x,x);nSolve(cos(x)=x,x=1.3)","solve,fsolve,csolve"},
{"ncols","Number of columns of a matrix.","Mtrx","coldim([[1,2,3],[4,5,6]]);coldim([[1,2],[3,4],[5,6]])","rowdim"},
{"negbinomial","Returns comb(n+k-1,k)*p^k*(1-p)^n.","","negbinomial(4,0,0.5);negbinomial(4,2,0.6);negbinomial(4,6,0.3)","negbinomial_cdf,negbinomial_icdf,binomial"},
{"negbinomial_cdf","Returns Proba(X<=x) or Proba(x<=X<=y) when X follows the negbinomial(n,p) law.","Intg(n),Real(p),Real(x),[Real(y)]","negbinomial_cdf(4,0.5,2);negbinomial_cdf(4,0.1,2);negbinomial_cdf(4,0.5,2,3)","negbinomial,negbinomial_icdf"},
{"negbinomial_icdf","Returns h such as Proba(X<=h)=t when X follows the negbinomial(n,p) law.","","negbinomial_icdf(4,0.5,0.68);negbinomial_icdf(4,0.1,0.95)","negbinomial,negbinomial_cdf"},
{"neighbors","Returns the list of vertices adjacent to vertex v of G. If v is omitted, a list of adjacency lists of all vertices in G is returned.","Graph(G),[Vrtx(v)]","neighbors(digraph(trail(1,2,3,4,5,6,4,7,8,2)),4)","adjacency_matrix,vertex_degree,in_degree,out_degree"},
{"network_transitivity","Returns the transitivity (also called triangle density or global clustering coefficient) of G.","Graph(G)","network_transitivity(graph(%{[1,2],[2,3],[2,4],[3,4],[4,1]%}))","clustering_coefficient,number_of_triangles"},
{"newList","Returns the list made with n zeros.","","newList(4)","newMat,makelist"},
{"newMat","Returns the list with n rows and p columns, made with zeros.","","newMat(2,3)","newList,makemat"},
{"newton","newton(f(x),x,a,p)=one root of f(x) by Newton method beginning with a and p iterations (by default p=20).","","newton(x^2-2,x);newton(x^2-2,x,2);newton(x^2-2,x,-2);newton(x^2-2,x,2,5,1e-7)","rootof"},
{"newton_solver","Argument for fsolve giving the method for solving an numerical equation.","Opt"," fsolve(cos(x)=x,x,0..1,bisection_solver); fsolve(cos(x)=x,x,0..1,brent_solver); fsolve(cos(x)=x,x,0..1,falsepos_solver); fsolve(cos(x)=x,x,0,newton_solver); fsolve(cos(x)=x,x,0,secant_solver); fsolve(cos(x)=x,x,0,steffenson_solver)","fsolve"},
{"newtonj_solver","Argument for fsolve giving the method for solving a system of numerical equations.","Opt"," fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],dnewton_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrid_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybrids_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],hybridsj_solver); fsolve([x^2+y-2,x+y^2-2],[x,y],[2,2],newtonj_solver)","fsolve"},
{"nextperm","Returns the next permutation with the lexicographic order.","","nextperm([0,2,1,3]);nextperm([0,3,2,1])","prevperm,is_permu"},
{"nextprime","Next prime or pseudo-prime after a given integer.","","nextprime(9856989898990);nextprime(97160249868928888261606009)","prevprime,is_prime,ithprime"},
{"nlpsolve","Solves a nonlinear programming problem of optimizing the objective obj under constraints constr (list of equations and/or inequations) and within bounds bd (sequence of x=a..b) with optional options (for example setting an initial point).","objective, [constr], [bd], [opts]","nlpsolve((x1-10)^3+(x2-20)^3,[(x1-5)^2+(x2-5)^2>=100,(x2-5)^2+(x1-6)^2<=82.81],nlp_initialpoint=[x1=20.1,x2=5.84]);nlpsolve(sin(x1+x2)+(x1-x2)^2-1.5x1+2.5x2+1,x1=-1.5..4,x2=-3..3);nlpsolve(ln(1+x1^2)-x2,[(1+x1^2)^2+x2^2=4]);nlpsolve(x1,[x2>=exp(x1),x3>=exp(x2)],maximize=true,x1=0..100,x2=0..100,x3=0..10,nlp_initialpoint=[x1=1,x2=1.05,x3=2.9]);nlpsolve(-x1*x2*x3,[72-x1-2x2-2x3>=0],x1=0..20,x2=0..11,x3=0..42);nlpsolve(2-1/120*x1*x2*x3*x4*x5,[x1<=1,x2<=2,x3<=3,x4<=4,x5<=5],assume=nlp_nonnegative);nlpsolve(sin(x)/x,x=1..30);nlpsolve(x^3+2x*y-2y^2,x=-10..10,y=-10..10,nlp_initialpoint=[x=3,y=4],maximize) ;nlpsolve(w^3*(v-w)^2+(w-x-1)^2+(x-y-2)^2+(y-z-3)^2,[w+x+y+z<=5,3z+2v=3],assume=nlp_nonnegative);nlpsolve(sin(x)*Psi(x),x=1..20,nlp_initialpoint=[x=16])","lpsolve,fsolve,fMin,fMax"},
{"nodisp","To display Done in place of a value.","","nodisp(A:=ranm(50,50))",""},
{"nom_cache","Option of the display command to hide the name.","Opt"," F:=display(point(2+1.5*i),hidden_name); F:=display(point(2+1.5*i),point_point+hidden_name)","display"},
{"non","Returns the logical inverse of the argument.","Boolean","not(b==0);not(b>0)","or,and,xor"},
{"non_recursive_normal","Simplifies the expressions, but without simplification into no-rational expressions.","","non_recursive_normal(sin(x+x)+sin(2*x)+x+x);non_recursive_normal(sin(2*x)+sin(2*x)+x+x)","normal"},
{"nop","No OPeration instruction.","","nop()",""},
{"nops","Returns the size of a list, a string or a sequence.","Lst or Str or Seq","size([1,2,3]);size(\"bonjour\");size(1,2,3)","sizes,dim,degree"},
{"norm","Returns the l2 norm of a vector = sqrt(x1^2+x2^2+...xn^2) or matrix norm induced by l2 norm.","","norm([1,2]);norm([1,2,3,-4]);norm([[1,2],[3,-4]]);norm([[1,2,3],[3,-9,6],[4,5,6]])","maxnorm,l1norm"},
{"normal","Simplify the expression.","","normal(2*x+y=1);normal(2*x*2);normal((2*x+1)^2)","simplify"},
{"normal_cdf","Returns the probability that a Normal random variable is lower than x0 or between x0 and y0 (mu is the mean and sigma the standard deviation).","","normal_cdf(1.96);normal_cdf(1,2,2.96*sqrt(2));normal_cdf(1,2,1.4*sqrt(2),2.96*sqrt(2))","UTPN,normal_icdf,normald"},
{"normal_icdf","Returns h such as the probability that a Normal random variable is lower than h is p (mu is the mean and sigma the standard deviation and 0<=p<=1).","","normal_icdf(0.95);normal_icdf(1,2,0.95)","normal_cdf,normald"},
{"normald","Returns the density of probability of the Normal law (mu is the mean and sigma the standard deviation).","","normald(1);normald(1,2,3.5); randvector(3,normald,1,0.5); ranm(4,3,normald,1,0.5)","normal_cdf,normal_icdf,randvector,ranm"},
{"normald_cdf","Returns the probability that a Normal random variable is lower than x0 or between x0 and y0 (mu is the mean and sigma the standard deviation).","Real(mu),Real(sigma),Real(x0),[Real(y0)]","normal_cdf(1.96);normal_cdf(1,2,2.96*sqrt(2));normal_cdf(1,2,1.4*sqrt(2),2.96*sqrt(2))","UTPN,normal_icdf,normald"},
{"normald_icdf","Returns h such as the probability that a Normal random variable is lower than h is p (mu is the mean and sigma the standard deviation and 0<=p<=1).","Real(mu),Real(sigma),Real(p)","normal_icdf(0.95);normal_icdf(1,2,0.95)","normal_cdf,normald"},
{"normalize","Returns the vector divided by its l2norm. It is also an option for plotfiefd.","","normalize(3+4*i);normalize([3,4]); fieldplot(-t*y,[t,y],normalize); fieldplot(-t*y,[t,y],normalize,xstep=0.5,ystep=0.5)","l2norm"},
{"normalt","Z-Test/normal law: arg1=[success,trial] or [mean,sample size] or data, arg2=proportion or data, arg3 optional if data=sigma, arg4 alternative '!=' or '>' or '<', arg5 optional alpha confidence level.","","normalt([10,30],.5,.02,'!=',0.1);normalt([0.48,50],0.5,0.1,'<')","studentt,chisquaret,kolmogorovt"},
{"normalvariate","Returns a random real with normal distribution N(mu,sigma).","Real(mu),Real(sigma)","randnorm(0,1);randnorm(2,1)","rand,randpoly,ranm,randvector,randexp,randbinomial,randpoisson,randgeometric,randmultinomial"},
{"not","Returns the logical inverse of the argument.","","not(b==0);not(b>0)","or,and,xor"},
{"nprimes","Count the number of primes less than n.","","nprimes(20)","ithprime,prevprime,nextprime,isprime"},
{"nrows","Number of rows of a matrix.","Mtrx","rowdim([[1,2,3],[4,5,6]]);rowdim([[1,2],[3,4],[5,6]])","ncols"},
{"nuage_points","Draws for k=0..nrows, the points (xk,yk) where xk=element row k column 0 and yk=element row k column j (j=1..ncols).","Mtrx","scatterplot([[1,2,3],[2,0,1],[-1,2,3]])","polygonplot,polygonscatterplot,listplot"},
{"nullspace","Kernel of a linear application of matrix M","Mtrx","ker([[1,2],[3,6]]);ker([[1,2,3],[1,3,6],[2,5,9]])","image,rref,Nullspace"},
{"number_of_edges","Returns the number of edges/arcs of G.","Graph(G)","number_of_edges(complete_graph(5))","edges,number_of_vertices"},
{"number_of_spanning_trees","Returns the number of spanning trees in undirected graph G.","Graph(G)","number_of_spanning_trees(complete_graph(4));number_of_spanning_trees(graph(trail(1,2,3,4,1,3)))","spanning_tree"},
{"number_of_triangles","Returns the number of 3-cliques if G is undirected resp. the number of directed cycles on 3 vertices if G is directed.","Graph(G)","number_of_triangles(graph(\"tetrahedron\"))","is_clique,maximal_clique"},
{"number_of_vertices","Returns the number of vertices of G.","Graph(G)","number_of_vertices(graph(\"petersen\"))","graph_vertices,number_of_edges"},
{"numer","Returns the numerator of the simplified fraction.","","numer(25/15);numer((x^3-1)/(x^2-1));numer(1+(x^3-1)/x^2)","getNum,getDenom,denom,f2nd"},
{"octahedron","Draws an octahedron with center A, vertex B and such that the plane ABC contains 4 vertices.","","octahedron([0,0,0],[0,0,5],[0,5,0]);octahedron(evalf([0,0,0],[3,2,4],[1,1,0]))","icosahedron,dodecahedron,cube,tetrahedron"},
{"od","Bloc end.",""," if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);end;; if (2>1) begin print(\"ifactor(154)=\",ifactor(154));ifactor(154);fi;; f:=function(a,b) local c;c:=a+b;c+gcd(a,b);end;f(28,21);; f:=fonction(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;; fonction f(a,b) local c;c:=a+b;c+gcd(a,b);ffonction;","begin,bloc,{}"},
{"odd","Returns 1 if the integer is odd, else returns 0.","","odd(6);odd(1251)","even"},
{"odd_girth","Returns the length of the shortest odd cycle in the undirected unweighted graph G.","Graph(G)","odd_girth(graph(\"petersen\"));odd_girth(hypercube_graph(3))","girth"},
{"odd_graph","Returns the odd graph of order n as Kneser graph K(2n-1,n-1), where n<=8.","Intg(n)","odd_graph(3)","kneser_graph"},
{"odeplot","odeplot(f(t,y),[t,y],[t0,y0]) draws the solution of y'=f(t,y) and y(t0)=y0 or of the system [x'=g(t,x,y),y'=h(t,x,y)] with x(t0)=x0 and y(t0)=y0.","","odeplot(sin(t*y),[t,y],[0,1]);odeplot(sin(t*y),[t=-10..10,y],[0,1]);odeplot(sin(t*y),[t=-3..3,y],[0,1],tstep=0.1,color=vert);odeplot([x-0.3*x*y, 0.3*x*y-y], [t,x,y],[0,0.3,0.7]);odeplot([x-0.3*x*y, 0.3*x*y-y], [t,x,y],[0,0.3,0.7],plan);odeplot([-y+b,-1+(x-a)^2+(y-b)^2],[t=-3..3,x,y],[0,a+1,b+0.5],plan);odeplot(5*[-y,x],[t=0..1,x,y],[0,0.3,0.7],tstep=0.05,plan)","interactive_plotode,fieldplot,odesolve,desolve"},
{"odesolve","odesolve(f(t,y),[t,y],[t0,y0],t1)=odesolve(t0..t1,f,y0)=y(t1) for y approx sol of y'=f(t,y) and y(t0)=y0 with y=vector for systems.","","odesolve(sin(t*y),[t,y],[0,1],2);odesolve(0..2,(t,y)->sin(t*y),1);odesolve(0..pi,(t,v)->{[-v[1],v[0]]},[0,1]);odesolve(sin(t*y),t=0..2,y,1,tstep=0.5);odesolve(sin(t*y),t=0..2,y,1,tstep=0.5,curve)","plotode,plotfield,interactive_plotode,desolve"},
{"of","Returns the value : f(a).","","of(x->x^2,4)","at"},
{"op","Returns the arguments of an operator as a sequence.","Op or Fnc","feuille(quote(gcd(45,126)));feuille('gcd(45,126)');feuille('1+2')[1];feuille([1,2,3]);feuille(set[1,2,3])","sommet,quote,makesuite"},
{"open","Opens a file named s, returns the file handle.",""," f:=open(\"filename\")","fopen,close,readrgb,readwav,csv2gen"},
{"open_polygon","Returns and draws the polygonal line where its vertices are the element of l.","","open_polygon(i,1+i,2-i,-1,-1+i/2);open_polygon(point(0,0,0),point(3,3,3),point(0,0,3),point(3,0,0))","isopolygon,quadrilateral"},
{"option","Reserved word for compatibility.","","",""},
{"or","infixed boolean operator (or).",""," (1==2) or (2>1)","and,not,xor"},
{"ord","Returns the ASCII code of a character or of the first character of a string.","","ord(\"A\");ord(\"ABC\");ord([\"a\",\"b\",\"c\"])","asc,char"},
{"order","Returns element order of g in (Z/nZ)^* or in a finite field","g","order(3 % 7); GF(3,5,g); order(g^2+g+1);",""},
{"order_size","Remainder (O term) of a series expansion: limit(x^a*order_size(x),x=0)=0 if a>0.","","order_size(x); limit(sqrt(x)*order_size(x),x=0)","series"},
{"ordinate","Returns the ordinate of a point or a vector.","","ordinate(point(1+2*i));ordinate(point(i)-point(1+2*i));ordinate(-1-i);ordinate(point(1,2,3))","abscissa,affix,cote,coordinates"},
{"orthocenter","Shows the orthocenter of a triangle or of the triangle made with 3 points.","","orthocenter(1+i,2,i);orthocenter(point(1+i),point(2),point(i));orthocenter(triangle(0,1,1+i))","altitude,triangle"},
{"orthogonal","orthogonal(A,line(B,C)) draws the orthogonal plane of line BC through A and orthogonal(A,plane(B,C,D)) draws the orthogonal line of plan(B,C,D) through A.","","orthogonal(point(0,0,0),line(point(1,0,0),point(0,1,0)));orthogonal(point(0,0,0),plane(point(1,0,0),point(0,1,0),point(0,0,1)))","altitude,perpendicular"},
{"osculating_circle","Osculating circle at point M to the curve C.","","osculating_circle(plot(x^2),point(1,1));osculating_circle([5*cos(t),5*sin(t)],t,0);osculating_circle([t,t^2],t);osculating_circle([t,t^2],t,1);osculating_circle([3*exp(t/2)*cos(t),3*exp(t/2)*sin(t)],t);osculating_circle([3*exp(t/2)*cos(t),3*exp(t/2)*sin(t)],t,7)","curvature,evolute"},
{"otherwise","Default case in a switch instruction.",""," default: print(\"Default case!\"); a:=1;switch(a){case 0:{b:=1;break;} case 1:{b:=3;break;} default:{b:=0;}};","switch,case,if"},
{"ou","infixed boolean operator (or).","Expr, Expr"," (1==2) or (2>1)","and,not,xor"},
{"output","Instruction in a program so that you can output an expression stored in var.","","output(\"age\",a)","input"},
{"p1oc2","Returns the permutation product of p1 and c2.","","p1oc2([0,2,1],[2,1,3])","c1op2,p1op2"},
{"p1op2","Returns the permutation product of p1 and p2.","","p1op2([0,2,1],[1,0,3,2])","c1op2,p1oc2"},
{"pa2b2","Returns [a,b] such as a^2+b^2=n (for n prime and n=1 (mod 4)).","","pa2b2(17);pa2b2(209);pa2b2(229)",""},
{"pade","Pade approximation P/Q=Xpr mod x^(n+1) or mod N with degree(P)<p.","","pade(exp(x),x,10,6)","taylor,series"},
{"parabola","parabola(F,A)=focus F, top A (in the plane ABP) or (parabola(A,c) of equa. y=yA+c*(x-xA)^2 c=1/(2*p) and FA=p/2 geo2d) and parabola(P(x,y)) draws the conic if deg(P)=2.","","parabola(point(0),point(2));parabola(0,2);parabola(point(0,0,0),point(1,0,0),point(1,1,1));parabola(x-y^2+y-2)","ellipse,hyperbola"},
{"parallel","parallel(A,D) (resp parallel(A,P) or parallel(A,D,DD)) draws the line (resp plane) through A parallel to the line D (resp parallel to the plane P or to the lines D,DD) and, parallel(d,D) draws the plane through d parallel to the line D.","","parallel(1+i,line(1-i,i));parallel(1+i,segment(1-i,i));parallel(point([1,1,1]),line(x=0,y=0));parallel([1,1,1],line(x=0,y=0));parallel([1,1,1],plane(x=0));parallel([1,0,0],line(x=0,y=0),line(x=y,y=z));parallel(line(x=y,y=z),line(x=0,y=0))",""},
{"parallelepiped","Draws a parallelepiped with sides AB,AC,AD (the faces are parallelograms).","","parallelepiped([0,0,0],[2,0,0],[0,1,0],[0,0,3]); p:=parallelepiped([0,0,0],[5,0,0],[0,3,0],[0,0,2]);c1,c2,c3,c4,c5,c6,c7,c8:=sommets(p);","cube,polyhedron"},
{"parallelogram","Returns and draws the parallelogram ABCD such as vector(AB)+vector(AD)=vector(AC).","","parallelogram(0,1,2+i);parallelogram(1,0,2+i,D);parallelogram(point(0,0,0),point(3,3,3),point(0,0,3));parallelogram(point(0,0,0),point(3,3,3),point(0,0,3),D)","quadrilateral,rhombus"},
{"parameq","parameq(C) returns the complex number=parametric equation of the curve C.","","parameq(circle(0,1));parameq(line(i,1-i))","equation"},
{"parameter","Reserved word.","","",""},
{"paramplot","plotparam(a(x)+i*b(x),x=x0..x1) draws the curve X=a(x),Y=b(x) x=x0..x1 or plotparam([a(u,v),b(u,v),c(u,v)],[u=u0..u1,v=v0..v1]) draws the surface X=a(u,v),Y=b(u,v),Z=c(u,v) u=u0..u1 and v=v0..v1.","Cplx||Lst,Var||Lst(Var)","plotparam(sin(t)+i*cos(t),t);plotparam(exp(i*t),t=0..pi/2,affichage=1);plotparam(exp(i*t),t=0..pi/2,affichage=1+rempli);plotparam([sin(x),cos(x)],x=0..1);plotparam([sin(x),cos(x)],x=0..1,affichage=rouge);plotparam(sin(x)+i*cos(x),x=0..1,tstep=0.01);plotparam([v*cos(u),v*sin(u),v],[u,v]);plotparam([v*cos(u),v*sin(u),v],[u=0..pi,v=0..3],ustep=0.1,vstep=0.2)","plotfunc,plotpolar,arc"},
{"parfrac","Option of the convert or convertir command (id at the option partfrac).",""," convert(1/(x^2-1),parfrac); convert(1/(x^2-1),fullparfrac)","convert"},
{"pari","Execute a PARI/GP command or exports all PARI/GP commands.","","pari();pari(\"gcd\",15,50);pari(\"gcd\",5/7,50/9);pari(\"gcd\", 3,[25,15,50,75]);pari(\"gcd\", [2,3],[25,15,50,75]);pari(\"content\",[25,15,50,75]);pari(\"isprime\",9856989898997789789,1);pari(\"isprime\",9856989898997789789,2)","gcd,lgcd,is_prime"},
{"part","Returns the n-th subexpression of the expression.","","part(sin(x)+cos(x),1);part(sin(x)+cos(x),2);part(exp(x)*sin(x),1);part(part(exp(x)*sin(x)+cos(x),1),1)",""},
{"partfrac","Performs partial fraction decomposition on a fraction or Option of the convert or convertir command (id at the option parfrac).","","partfrac(x/(4-x^2));partfrac((x^2-2*x+3)/(x^2-3*x+2));partfrac(a/(z*(z-b)),z); convert(x/(4-x^2),partfrac)","factor,normal,convert,propfrac"},
{"parzen_window","Applies the Parzen windowing function to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Interval(n1..n2)]"," scatterplot(parzen_window(randvector(1000,0..1)))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,bartlett_hann_window,poisson_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"pas","Step in an iteration (step size of incrementation).",""," s:=0;for j from 1 to 10 step 2 do s:=s+j end_for; s:=0;for j from 1 step 2 to 10 do s:=s+j end_for; s:=0;for j from 1 to 10 by 2 do s:=s+j end_for; s:=0;for j from 1 by 2 to 10 do s:=s+j end_for; s:=0;pour j de 1 jusque 10 pas 2 do s:=s+j fpour; s:=0;pour j de 1 pas 2 jusque 10 do s:=s+j fpour","for,pour"},
{"pas_de_cote","The turtle does n side-steps on the left (-n steps on the right if n negative) without trace (by default n=10).",""," pas_de_cote 30;pas_de_cote(30)","saute,tourne_droite,tourne_gauche"},
{"path_graph","Returns a path graph on n vertices [with labels from V].","Intg(n)||Lst(V)","path_graph(5)","cycle_graph,graph,trail"},
{"pcar","List of the coefficients of the characteristic polynomial of a matrix or characteristic polynomial of a matrix with the second argument as variable.","","pcar([[1,2],[3,4]]);pcar([[1,2],[3,4]],x);pcar([[1,2,3],[1,3,6],[2,5,7]]);pcar([[1,2,3],[1,3,6],[2,5,7]],z)","jordan,egv,egvl,companion,rat_jordan,pmin,adjoint_matrix "},
{"pcar_hessenberg","Characteristic polynomial of a matrix by the Hessenberg method (if the coefficients are in a finite field).","","pcar_hessenberg([[1,2],[3,4]]);pcar_hessenberg([[1,2],[3,4]],x);pcar_hessenberg([[1,2,3],[1,3,6],[2,5,7]])","jordan,pcar,egvl"},
{"pcoef","Returns the polynomial coefficients having the roots specified as argument.","Vect","pcoeff([1,0,0,0,1]);pcoeff([1,0,-2])","proot,peval"},
{"pcoeff","Returns the polynomial coefficients having the roots specified as argument.","","pcoeff([1,0,0,0,1]);pcoeff([1,0,-2])","proot,peval"},
{"pencolor","Changes the color of the pencil (without parameter,returns the current color).","Color","pencolor(red);crayon(5);crayon(gomme)","leve_crayon,baisse_crayon"},
{"pendown","Puts the pencil down so that the turtle move with traces.","NULL","pendown();baisse_crayon()","leve_crayon,crayon"},
{"penup","Puts the pencil up so that the turtle moves without traces.","NULL","penup();leve_crayon()","baisse_crayon,crayon"},
{"perimeter","Perimeter of a polygon (e.g. triangle, square, ...)","","perimeter(triangle(0,1,i));perimeter(square(0,2));perimeter(circle(0,2));perimeter(0,1,i)","polygon,area,perimeteratraw,perimeterat"},
{"perimeterat","Displays at point(z0), with a legend, the perimeter of a circle or of a polygon (e.g. triangle, square, ...)",""," t:=triangle(0,1,i);perimeterat(t,1+i); c:=square(0,2);perimeterat(c,1+i); c2:=circle(0,2);perimeterat(c2,1+i); p:=polygon(0,1,i);perimeterat(p,1+i); A:=point(0);B:=point(1+i);c:=carre(A,B);perimeterat(c,i)","perimeter,perimeteratraw,polygon,areaatraw"},
{"perimeteratraw","Displays at point(z0), the perimeter of a circle or of a polygon (e.g. triangle, square, ...)","","perimeteratraw(triangle(0,1,i),1+i);perimeteratraw(square(0,2),1+i);perimeteratraw(circle(0,2),1+i);perimeteratraw(polygon(0,1,i),1+i); A:=point(0);B:=point(1+i);c:=carre(A,B);perimeteratraw(c,i)","perimeter,perimeterat,polygon,areaatraw"},
{"periodic","Make a periodic expression equal to Expr on a..b, period b-a","Expr,Var,a,b","periodic(x^2,x,-1,1)",""},
{"perm","perm(n,p)=number of arrangements of p objects taken among n : n!/(n-p)!","","perm(4,2)","comb,factorial"},
{"perminv","Returns the inverse permutation of the permutation a.","","perminv([1,3,2,4,0])","cycleinv"},
{"permu2cycles","Converts a permutation to a product of disjoined cycles.","","permu2cycles([0,2,1,3,5,4]);permu2cycles([0,2,1,4,3,5])"," cycles2permu,cycle2perm"},
{"permu2mat","Returns the matrix where the lines of the identity matrix are permuted with the permutation p.","","permu2mat([1,3,2,4,0])",""},
{"permuorder","Returns the order of the permutation a.","","permuorder([1,3,2,4,0])","cycles2permu"},
{"permute_vertices","Returns a copy of G with vertices reordered according to the order in the list V.","Graph(G),Lst(V)","permute_vertices(graph([a,b,c]),[a,c,b])","graph_vertices,isomorphic_copy,relabel_vertices"},
{"perpen_bisector","perpen_bisector(A,B) draws the bisection (line or plane) of the segment AB.","","perpen_bisector(1-i,i);perpen_bisector([0,0,0],[5,5,0])","midpoint,median_line"},
{"perpendicular","perpendicular(A,line(B,C)) or perpendicular(A,B,C) draws the orthogonal line of line BC through A and perpendicular(d,plane(B,C,D)) draws the orthogonal plane of plane(B,C,D) through the line d.","","perpendicular(1,line(1,i));perpendicular(1,0,1+i);perpendicular([0,0,0],line(x=y,y=z));perpendicular(line([0,0,0],[1,1,0]),plane(x+y+z=1))","altitude,orthogonal"},
{"petersen_graph","Returns the generalized Petersen graph G(n,k), where n and k are positive integers (k defaults to 2).","Intg(n),[Intg(k)]","petersen_graph(5,2);petersen_graph(6,3);petersen_graph(10,2)","graph"},
{"peval","Evaluates at a point x0, a polynomial given by its coefficients.","","peval([1,0,-2],1);peval([1,2,-25,-26,120],8)","proot,pcoeff"},
{"phase","Returns the argument of a complex number (Python).","","arg(1+i);arg(1+2*i);arg((1+2*i)^2)","abs"},
{"pi","pi",""," pi/4; Pi/4; evalf(pi); evalf(Pi)","e,i"},
{"piecewise","If condition1 returns expr1 else...if condition2p returns expr2p else returns expr2p+1.","","piecewise(x<=-pi,x+2*pi,x<=pi,x,x+2*pi);piecewise(x<-2,-2,x<-1,3x+4,x<0,1,x+1)","if,then,else,ifte,switch"},
{"pivot","Returns the matrix get from A creating zeros in the column nc, by the method of Gauss-Jordan with the element A[nl,nc] as pivot.","","pivot([[1,2],[3,4],[5,6]],0,1);pivot([[1,2],[3,4],[5,6]],1,1)","gaussjord,linsolve"},
{"pixoff","Pixel off.","","pixoff(1,2)","set_pixel,pixon"},
{"pixon","Pixel on","","pixon(1,2)","set_pixel,pixoff"},
{"planar","Option for the draw_graph command.","Opt","","spring,tree,draw_graph"},
{"plane","plane(A,B,C) or plane(A,line(B,C)) (resp plane(a*x+b*y+c*z+d=0)) draws the plane ABC (resp of equation a*x+b*y+c*z+d=0) in the 3D space.","","plane([0,0,0],[1,1,1],[1,0,0]);plane([0,0,0],line([1,0,0],[1,1,1]));plane(x+y+z=0);plane(2*x+y-2*z-1)","line"},
{"plane_dual","Returns the plane dual of the biconnected planar graph G or constructed from the list of faces F.","Graph(G)||Lst(F)","plane_dual(hypercube_graph(3))","is_planar"},
{"playsnd","Plays a sound data.","","playsnd(2^14*(sin(2*pi*440*soundsec(1)))","readwav,writewav,soundsec"},
{"plex","Option of the gbasis or greduce command to specify an order for monomials (=default order=pure lexicographic).","","","gbasis,greduce"},
{"plot","Plot a polygonal line given by the list of abscissas and ordinates. In Xcas, plot a one-variable expression (or list of expressions).","","plot([1,2,3],[4,5,7]);plot(x-1/6*x^3,x);plot([2*x-1,sin(x)],x=1..2);plot(sin(x),x=-2..2,color=green,xstep=0.1);plot([2*x-2,2*sin(x)],x=1..2,color=[green,red],legende=[\"2x-2\",\"sin\"]);plot(exponentiald(2));plot(normald);plot(normald(-1,2))","plotfunc,plotparam,animate,animate3d,plotarea"},
{"plot3d","Erase and plot a 2 variable expression or of a surface defined with a list of the 3 functions or of 3 expression of 2 variables.","","plot3d(x^2+y^2+1,x,y);plot3d(x^2+y^2,x=-1..1,y=-2..2);plot3d([u+1,2*v,u^2+v^2],u=-1..1,v=-2..2);plot3d(f,-1..1,-2..2);plot3d([f,g,h],-1..1,-2..2)","plotfunc,animate3d"},
{"plotarea","Displays the area below a curve, optionally with a quadrature method (trapezoid,left_rectangle,right_rectangle,middle_point).","","plotarea(sin(x),x=0..pi);plotarea(x^2,x=0..1,5,trapezoid);plotarea(x^2,x=0..1,5,middle_point)","integrate,plot,area,areaat,areaatraw"},
{"plotcdf","Graphic representation of a cumulated distribution function.","","plotcdf(binomial,10,0.5);plotcdf(normald,0.0,1.0);plotcdf([1,3,4,3,5,6])","icdf,binomial_cdf,normald_cdf,cdf"},
{"plotcontour","Draws whether 11 equirepartited contour-lines z=z_min,,...z=z_max of the surface z=Xpr, whether the contour-lines defined by the 3-rd argument.","","plotcontour(x^2+y^2);plotcontour(x^2+y^2,[x,y]);plotcontour(x^2+2*y^2-2,[x,y],[1.0,2.0,3.0]);plotcontour(x^2-y^2,[x=-4..4,y=-4..4],seq(k,k,-11,11,3),xstep=0.1,ystep=0.1)","plotdensity,plotimplicit"},
{"plotdensity","Shows in the plan with colors the graph of a expression of 2 variables.","","plotdensity(x^2-y^2,[x=-2..2,y=-2..2],xstep=0.1,ystep=0.1);plotdensity(x^2-y^2,[x=-2..2,y=-2..2],z=-2..2,xstep=0.1,ystep=0.1)","plotfunc,plotcontour"},
{"plotfield","plotfield(f(t,y),[t,y]) draws the plotfield of the diff equation y'=f(t,y).","Expr,VectVar,[Opt]","plotfield(sin(t*y),[t=-5..5,y=-3..3],xstep=0.5,ystep=0.5);plotfield(-t*y,[t,y]);plotfield(-t*y,[t,y],normalize);plotfield(-t*y,[t,y],normalize,xstep=0.5,ystep=0.5);plotfield(-t*y,[t=-6.868..6.868,y=-6.868..6.868],normalize)","interactive_plotode,odeplot,odesolve,desolve"},
{"plotfunc","Plot a 1 variable or 2 variables expression with superposition.","","plotfunc(-2*x+1,x=1..2,color=red);plotfunc([-2*x+1,x^2-2],x=-2..2,color=[red,yellow],xstep=0.2);plotfunc(x^2-y^2,[x,y],xstep=0.5,ystep=0.3);plotfunc(x^2+y^2,[x=-1..1,y=-2..2],nstep=900);plotfunc((x+i*y)^2,[x=-1..1,y=-2..2],nstep=900,affichage=rempli)","plot,plot3d,plotparam,animate,animate3d,plotdensity"},
{"plotimplicit","plotimplicit(f(x,y),x,y) or plotimplicit(f(x,y),[x,y]) graph of f(x,y)=0.","","plotimplicit(x^2+y^2-1,x,y);plotimplicit(x^4+y^4=x^2-y^2);plotimplicit(x^2+y^2-1,x,y,unfactored);plotimplicit(x^2+4*y^3-1);plotimplicit(x^2+4*y^3-k)$(k=-5..5);plotimplicit(y^3=x^3-x^2,x,y,xstep=0.1,ystep=0.1);plotimplicit(y^3=x^3-x^2,[x,y],xstep=0.1,ystep=0.1);plotimplicit((x+5)^2+(y+4)^2-1,x=-6..-4,y=-5..-3);plotimplicit((x+5)^2+(y+4)^2-1,[x=-6..-4,y=-5..-3])","plotcontour,unfactored,plotinequation"},
{"plotinequation","Shows the graph of the solution of inequations with 2 variables.","","plotinequation(x^2-y^2<3);plotinequation(x^2-y^2<3,[x=-2..2,y=-2..2],xstep=0.1,ystep=0.1);plotinequation(3-(x^2-y^2),[x=-2..2,y=-2..2],xstep=0.1,ystep=0.1);plotinequation([x+y>3,x^2<y],[x,y],xstep=0.2,ystep=0.2)","plotfunc,plotcontour,plotdensity,plotimplicit"},
{"plotlist","Draws the polygonal line through the points of abscissa 0,...,n and ordinate l=[y0,...,yn] or the line through the points of abscissa the first M column and ordinate the second column.","Lst(l)||Mtrx(M)","listplot([13,10,15,16]);listplot([1,13],[2,10],[3,15],[4,16]);listplot([[0,13],[2,10],[4,15]])","polygonplot,scatterplot,polygonscatterplot"},
{"plotode","plotode(f(t,y),[t,y],[t0,y0]) draws the solution of y'=f(t,y) and y(t0)=y0 or of the system [x'=g(t,x,y),y'=h(t,x,y)] with x(t0)=x0 and y(t0)=y0.","Expr,VectVar,VectInitCond","plotode(sin(t*y),[t,y],[0,1]);plotode(sin(t*y),[t=-10..10,y],[0,1]);plotode(sin(t*y),[t=-3..3,y],[0,1],tstep=0.1,color=vert);plotode([x-0.3*x*y, 0.3*x*y-y], [t,x,y],[0,0.3,0.7]);plotode([x-0.3*x*y, 0.3*x*y-y], [t,x,y],[0,0.3,0.7],plan);plotode([-y+b,-1+(x-a)^2+(y-b)^2],[t=-3..3,x,y],[0,a+1,b+0.5],plan);plotode(5*[-y,x],[t=0..1,x,y],[0,0.3,0.7],tstep=0.05,plan)","interactive_plotode,fieldplot,odesolve,desolve"},
{"plotparam","plotparam(a(x)+i*b(x),x=x0..x1) draws the curve X=a(x),Y=b(x) x=x0..x1 or plotparam([a(u,v),b(u,v),c(u,v)],[u=u0..u1,v=v0..v1]) draws the surface X=a(u,v),Y=b(u,v),Z=c(u,v) u=u0..u1 and v=v0..v1.","","plotparam(sin(t)+i*cos(t),t);plotparam(exp(i*t),t=0..pi/2,affichage=1);plotparam(exp(i*t),t=0..pi/2,affichage=1+rempli);plotparam([sin(x),cos(x)],x=0..1);plotparam([sin(x),cos(x)],x=0..1,affichage=rouge);plotparam(sin(x)+i*cos(x),x=0..1,tstep=0.01);plotparam([v*cos(u),v*sin(u),v],[u,v]);plotparam([v*cos(u),v*sin(u),v],[u=0..pi,v=0..3],ustep=0.1,vstep=0.2)","plotfunc,plotpolar,arc"},
{"plotpolar","plotpolar(f(x),x,a,b) draws the polar curve r=fx) for x in [a,b].","","plotpolar(sin(2*x),x,0,pi);plotpolar(sin(2*x),x,0,pi,tstep=0.1)","plotparam,plotfunc,plotpolar"},
{"plotproba","Graph of a transition matrix with at most 7x7 entries (optionally with list of vertex positions)","","plotproba([[1/2,1/3,1/12,1/12],[1/3,1/2,1/6,0],[0,0,1/2,1/2],[1/4,1/4,1/4,1/4],[\"xy\",b,\"state\",d]]);plotproba([[1/2,1/3,1/12,1/12],[1/3,1/2,1/6,0],[0,0,1/2,1/2],[1/4,1/4,1/4,1/4]],[0,1,i,1/3+2/3*i]); L:=point(1):;C:=point(0.5+0.3*i):;G:=point(0.5+0.8*i):;plotproba([[1/2,1/3,1/12],[1/3,1/2,1/6],[0,0,1/2]],[L,C,G])","markov,randmarkov"},
{"plotseq","For seeing the pth terms of the sequence u(0)=a,u(n)=f(u(n-1)).","","plotseq(sqrt(2+x),6,5);plotseq(sqrt(2+t),t=6,5);plotseq(sqrt(2+x),x=[6,1,7],5,affichage=epaisseur_ligne_2)","seqsolve,rsolve"},
{"plotspectrum","Plots the power spectrum of an audio clip (on the specified frequency range).","Lst(clip),[range=a..b]","plotspectrum(readwav(\"/some/file\"));plotspectrum(readwav(\"/some/file\"),range=100..1000)","plotwav"},
{"plotwav","Plots the waveform of an audio clip (optionally at the specified range).","Lst(clip),[range=a..b]","plotwav(readwav(\"/some/file\"));plotwav(readwav(\"/some/file\"),range=1.0..2.5) // range in seconds;plotwav(readwav(\"/some/file\"),range=[10000,22000]) // range in samples","plotspectrum"},
{"plus_point","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"pmin","Returns the minimal polynomial of the matrix A or the minimal polynomial of the algebraic number a.","","(αλγεβρική αριθμού).;pmin([[1,0],[0,1]]);pmin([[1,0],[0,1]],x);pmin(sqrt(2)+sqrt(3));pmin(sqrt(2)+sqrt(3),x)","pcar,jordan"},
{"point","A:=point(za) or A:=point(a,b) (resp A:=point([a,b,c])) draws a point of affix za=a+ib (resp of coordinates (a,b,c)) with the legend A.","","point(1+2i);point(1,2);point(1,2,3);point([1,2,3]); B:=point(1-i); B:=point(1,-1); B:=point(1,0,0); B:=point([1,0,0])","pixon,line,point2d,point3d,polar_point"},
{"point2d","Defines at random, the coordinates (between -5 and +5) of the 2d points given as argument.","","point2d(A,B,C,D)","point3d,point"},
{"point3d","Defines at random, the coordinates (between -5 and +5) of the 3d points given as argument.","","point3d(A,B,C,D)","point2d,point"},
{"point_carre","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"point_croix","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"point_etoile","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"point_invisible","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"point_losange","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"point_milieu","Option of the plotarea command and of the area command.","Opt"," plotarea(x^2,x=0..1,5,trapezoid); plotarea(x^2,x=0..1,5,middle_point); plotarea(x^2,x=0..1,5,right_rectangle); plotarea(x^2,x=0..1,5,left_rectangle); area(x^2,x=0..1,5,middle_point); area(x^2,x=0..1,5,trapezoid)","plotarea,area"},
{"point_plus","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"point_point","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"point_triangle","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"point_width_1","Option of the display command for a point.",""," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"point_width_2","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"point_width_3","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"point_width_4","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"point_width_5","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"point_width_6","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"point_width_7","Option of the display command for a point.","Opt"," display(point(1+i),green+point_triangle+point_width_2); display(milieu(segment(0,1+i)),point_width_5); point(i,affichage=epaisseur_point_3)","display,thickness"},
{"poisson","Returns exp(-mu)*mu^k/k!","","poisson(0.5,2);poisson(4.0,2); randvector(3,poisson,0.5); ranm(4,3,poisson,0.5)","poisson_cdf,poisson_icdf,randvector,ranm"},
{"poisson_cdf","Returns Proba(X<=x) when X follows the Poisson law with mu as mean.","","poisson_cdf(4.0,7);poisson_cpdf(2.5,4)","poisson,poisson_icdf"},
{"poisson_icdf","Returns h such as Proba(X<=h)=p when X follows the Poisson law with mu as parameter.","","poisson_icdf(4.0,0.95);poisson_icdf(2.5,0.9)","poisson,poisson_cdf"},
{"poisson_window","Applies the Poisson windowing function with parameter a>0 (by default a=1) to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Real(a)],[Interval(n1..n2)]"," scatterplot(poisson_window(randvector(1000,0..1),0.5))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,bartlett_hann_window,riemann_window,triangle_window,tukey_window,welch_window"},
{"polar","Returns the line of the conjugated points of A with respect to the circle.","","polar(circle(0,1),point(1+i)/2);polar(circle(0,1),point(1+i))","pole,is_conjugate"},
{"polar_coordinates","Returns the list of the norm and of the argument of the affix of a point (for 2D) or of a complex number or of the the list of rectangular coordinates.","","polar_coordinates(point(1+2*i));polar_coordinates(-1-i);polar_coordinates([-1,2]);polar_coordinates(point(1+2*i)-point(-1+i))","abscissapoint,ordinate,rectangular_coordinates,polar_point"},
{"polar_point","Returns the point (for 2D) with the arguments r and t as polar coordinates (i.e. with  r*exp(i*t) as affix).","","polar_point(1,pi/4);polar_point(2,-pi/3)","abscissa,ordinate,polar_coordinates,rectangular_coordinates,point"},
{"polarplot","plotpolar(f(x),x,a,b) draws the polar curve r=fx) for x in [a,b].","Expr,Var,VarMin,VarMax","plotpolar(sin(2*x),x,0,pi);plotpolar(sin(2*x),x,0,pi,tstep=0.1)","plotparam,plotfunc,plotpolar"},
{"pole","Returns the point having the line as polar with respect to the circle .","","pole(circle(0,1),line(i,1));pole(circle(0,1),line((1+i),2))","polar,is_conjugate"},
{"poly2symb","Gives the polynomial (or its value) : the first argument is the vector of coefficients and the second argument is the variable (by default x).","","poly2symb([1,2,3]);poly2symb([1,2,3],x);poly2symb([1,2,3],-1);poly2symb([1,2,-1],y)","e2r,symb2poly"},
{"polyEval","Evaluates at a point x0, a polynomial given by its coefficients.","Vect,Real(x0)","peval([1,0,-2],1);peval([1,2,-25,-26,120],8)","proot,pcoeff"},
{"polygon","Returns and draws the polygon where its vertices are the element of l.","","polygon(i,1+i,2-i,-1,-1+i/2);polygon(point(0,0,0),point(3,3,3),point(0,0,3),point(3,0,0))","isopolygon,quadrilateral,convexhull,hexagon"},
{"polygone_rempli","The argument is an integer <-1 which gives the number of previous turtle position drawing a polygon and created this full polygon.",""," repete(4,avance 40,tourne_droite);polygone_rempli -8; repete(3,avance 40,tourne_droite 120);polygone_rempli -6; repete(3,avance 40,avance 40,tourne_droite 120);polygone_rempli -9",""},
{"polygonplot","Draws the polygons joining for j fixed and for k=0..nrows, the points (xk,yk) where xk=element row k column 0 et yk=element row k column j ,when the xk are sorted (we obtain ncols-1 polygons).","","polygonplot([[1,2,3],[2,0,1],[-1,2,3]])","scatterplot,listplot,polygonscatterplot"},
{"polygonscatterplot","Draws the points (xk,yk) and the polygons joining for j fixed and for k=0..nrows, the points (xk,yk) where xk=element row k column 0 et yk=element row k column j ,when the xk are sorted (we obtain ncols-1 polygons).","","polygonscatterplot([[1,2,3],[2,0,1],[-1,2,3]])","scatterplot,polygonplot,listplot"},
{"polyhedron","Draws a convex polyhedron with vertices among the arguments.","","polyhedron([0,0,0],[0,5,0],[0,0,5],[1,2,6])","cube,parallelepiped"},
{"polynom","Option of the convert or convertir command and of the taylor and series commands (list=>n-poly ou series=>poly).",""," convert([[10,[3,1]],[12,[2,2]]],polynom); convert(taylor(sin(x)),polynom); convert(series(sin(x),x=0,6),polynom); taylor(sin(x),x=0,5,polynom); series(sin(x),x=0,6,,polynom)","poly2symb,taylor,series,convert"},
{"polynomial_regression","Returns the coefficients (an,...a1,a0) of y=an*x^n+..a1x+a0) : it is the best polynomial which approx the points where the coordinates are the rows of A (or the 2 lists) (n is the 2nd argument).","","polynomial_regression([[1.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]],3);polynomial_regression([[0.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]],3);polynomial_regression([0.0,2.0,3.0,4.0],[1.0,4.0,9.0,16.0],3)","linear_regression,power_regression"},
{"polynomial_regression_plot","Returns the plot of y=an*x^n+..a1x+a0) : it is the best polynomial which approx the points where the coordinates are the rows of A (or the 2 lists) (n is the 2nd argument).","","polynomial_regression_plot([[1.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]],3);polynomial_regression_plot([[0.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]],3);polynomial_regression_plot([0.0,2.0,3.0,4.0],[1.0,4.0,9.0,16.0],3)","linear_regression_plot,power_regression_plot"},
{"position","Returns the turtle position in pixels or puts the turtle at the position given by the argument with the same cap.","","position();position(50,70);position([50,70])","cap,initialise"},
{"poslbdLMQ","Returns a lower bound on the values of the positive roots of P. Akritas-Strzebonski-Vigklas' Local Max Quadratic (LMQ) method is used.","","poslbdLMQ(x^3-7*x+7)","posubLMQ,VAS_positive,realroot"},
{"posubLMQ","Returns an upper bound on the values of the positive roots of P. Akritas-Strzebonski-Vigklas' Local Max Quadratic (LMQ) method is used.","","posubLMQ(x^3-7*x+7)","poslbdLMQ,VAS_positive,realroot"},
{"potential","Returns U such as derive(U,Vector_of_variable)=V.","","potential([2*x*y+3,x^2-4*z,-4*y],[x,y,z])","derive,vpotential"},
{"pour","Loop pour (pour...de ...jusque... [pas...] faire...fpour;).",""," pour de jusque faire fpour;; S:=0;pour n de 1 jusque 4 faire S:=S+n;fpour;; S:=0;for n from 1 to 4 do S:=S+n;end;; pour n de 1 jusque 4 faire disque(10*n);saute(10*n);fpour;; pour n de 4 jusque 1 pas -1 faire disque(10*n);saute(10*n);fpour;; S:=0;pour n de 4 jusque 1 pas -1 faire S:=S+n;fpour;","for,de,jusque,pas"},
{"pow","Computes a^n or a^n mod m (fast algorithm).","","pow(17,452,19);pow(x+1,452)","^,powmod"},
{"pow2exp","Converts powers to exponentials.","","pow2exp(a^b)","exp2pow"},
{"power_regression","Returns the coefficients (m,b) of y=b*x^m : it is the best monomial which approx the points where the coordinates are the rows of A (or the 2 lists).","","power_regression([[1.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]]);power_regression([[1.0,2.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]]);power_regression([1.0,2.0,3.0,4.0],[2.0,4.0,9.0,16.0])","polynomial_regression,linear_regressiont"},
{"power_regression_plot","Returns the plot of y=b*x^m : it is the best monomial which approx the points where the coordinates are the rows of A (or the 2 lists).","","power_regression_plot([[1.0,1.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]]);power_regression_plot([[1.0,2.0],[2.0,4.0],[3.0,9.0],[4.0,16.0]]);power_regression_plot([1.0,2.0,3.0,4.0],[2.0,4.0,9.0,16.0])","polynomial_regression_plot,linear_regression_plot"},
{"powermod","Computes a^n modulo p or modulo p,P(x) (fast algorithm).","Intg(a),Intg(n),Intg(p),[Expr(P(x))],[Var]","powmod(17,452,19);powmod(x+1,452,19,x^4+x+1,x)","pow,^"},
{"powerpc","Returns the real number d^2-R^2 (d=distance between point and center, R=radius) .","","powerpc(circle(0,1+i),3+i);powerpc(circle(0,point(1+i)),3+i)","radical_axis"},
{"powexpand","Expands the expression in function of the exponent.","","powexpand(2^(x+y));powexpand(3^(2*x))",""},
{"powmod","Computes a^n modulo p or modulo p,P(x) (fast algorithm).","","powmod(17,452,19);powmod(x+1,452,19,x^4+x+1,x)","pow,^"},
{"prepend","Puts an element to a set or at the beginning of a list or of a string (L:=prepend(L,a) or L.prepend(a)).","","prepend([1,2],3);prepend(set[1,2],3); L:=[1,2];L:=prepend(L,3); L:=[1,2];L.prepend(L,3) ; S:=set[1,2];S:=prepend(L,3); S:=set[1,2];S.prepend(L,3)","append,concat"},
{"preval","Returns F(b)-F(a).","","preval(x^2-2,2,3);preval(y^2-2,2,3,y);preval(int(x),0,1);preval(int(y,y),0,1,y)","subst,int"},
{"prevperm","Returns the previous permutation with the lexicographic order.","","prevperm([0,1,3,2]);prevperm([0,1,2,3])","nextperm,is_permu"},
{"prevprime","Previous prime or pseudo-prime before a given integer a.","","prevprime(9856989898999);prevprime(97160249868928888261606009)","nextprime,is_prime,ithprime"},
{"primpart","Returns the polynomial P divided by the gcd of its coefficients.","","primpart(2x^2+10x+6);primpart(2t^2+10t+6,t)","content"},
{"print","Prints its argument.","","print(\"salut\");print(a)","printf"},
{"printf","2d printing","Expr","printf(sqrt(2));printf(\"%gen+%gen=%gen\",a,b,a+b)","print"},
{"prism","Draws a prism with plane base ABCD...and with edges parallel to AA1 (the faces are parallelograms).","","prism([[0,0,0],[5,0,0],[0,5,0],[-5,5,0]],[0,0,5])","cube,polyhedron"},
{"prism_graph","Returns the generalized Petersen graph GP(n,1).","Intg(n)","prism_graph(5)","antiprism_graph,web_graph"},
{"proc","Begin a procedure (like with MuPAD).",""," proc ... begin ... end_proc;",""},
{"product","Multiplicates the values of the expression when the variable go from a to b with a step p (product(expression,var,begin,end,step) by default p=1) or product of the elements of a list or product element by element of 2 lists or matrix.","","product(n,n,1,10,2);product(1/n,n,1,10);product(1/n,n,11,1);product(1/n,n,10,1,1);product([2,3,4,5]);product([2,3,4],[5,6,7]);product([[2,3,4],[5,6,7]],[[2,3,4],[5,6,7]])","sum"},
{"program","Reserved word.","","",""},
{"projection","projection(C,A) is the orthogonal projection of A on the curve C.",""," H:=projection(line(i,1-i),1+i); K:=projection(circle(0,1),1+i); J:=projection(circle(0,1),point(1+2*i))","perpendicular"},
{"proot","Returns all computed roots of a polynomial given by its coefficients (may not work if roots are not simple).","","proot([1,0,-2]);proot(x^2-2);proot([1,2,-25,-26,120]);proot(x^4+5x-3,30)","pcoeff,peval,realroot,complexroot,rationalroot,crationalroot"},
{"propFrac","Simplifies and writes the fraction (or rational fraction) A/B as Q+R/B with R<B (or deg(R)<deg(B)).","Frac or RatFrac","propfrac(28/12);propfrac((x^2+2*x-1)/(x+1))","partfrac"},
{"propfrac","Simplifies and writes the fraction (or rational fraction) A/B as Q+R/B with R<B (or deg(R)<deg(B)).","","propfrac(28/12);propfrac((x^2+2*x-1)/(x+1))","partfrac"},
{"psrgcd","GCD of 2 polynomials, with the sub resultant algorithm.","","psrgcd(x^4-1,(x-1)^2)","gcd,modgcd,ezgcd,heugcd"},
{"ptayl","Returns the Taylor polynomial of the expression at the given point and order or a polynomial Q such that P(x)=Q(x-a).","","ptayl(sin(x),x=0,5);ptayl(x^2+2*x+1,1);ptayl(x^2+2*x+1,-1);ptayl(y^2+2*y+1,1.1,y);ptayl(y^3+y^2+2*y+1,2,y); subst(ptayl(y^3+y^2+2*y+1,2,y),y,y-2)","series,taylor"},
{"purge","purge(varname) unassign the variable varname.","","purge(t);purge(C)","sto,restart,assume,about"},
{"pwd","Current working directory.","","pwd()","cd"},
{"pyramid","Draws the regular direct pyramid ABCD with vertices A,B and a face in the plan (A,B,C) when there is 3 arguments et the pyramid ABCD when there is 4 arguments.","","pyramid([0,0,0],[3,0,0],[0,1,0]);pyramid([0,0,0],[3,0,0],[0,3,0],[0,0,4])","cube,cylinder,icosahedron,dodecahedron,octahedron"},
{"python","Set MicroPython interpreter or translate from Xcas to Python","","python;python(f)","xcas"},
{"python_compat","Set Python-syntax compatibility (1) or not (0)","Intg(0) or 1","python_compat();python_compat(1)","xcas_mode"},
{"q2a","q2a(q(x,y),[x,y])=the symmetric matrix associated to the quadratic form q.","","q2a(x^2+2*x*y+2*y^2,[x,y])","a2q"},
{"qr","For a numerical matrix A, returns R (right) such that A=QR and Q orthogonal.","","qr([[1,2],[3,4]])","lu"},
{"quadrant1","Option of the display command to write a legend.",""," display(legende(1+i,\"abc\"),4+quadrant2)","display"},
{"quadrant2","Option of the display command to write a legend.","Opt"," display(legende(1+i,\"abc\"),4+quadrant2)","display"},
{"quadrant3","Option of the display command to write a legend.","Opt"," display(legende(1+i,\"abc\"),4+quadrant2)","display"},
{"quadrant4","Option of the display command to write a legend.","Opt"," display(legende(1+i,\"abc\"),4+quadrant2)","display"},
{"quadric","Defines a quadric by its cartesian equation with x,y,z as default variables and draws it.","","quadric(4*x^2+y^2+z^2-4*x*y+4*x*z-2*y*z+8*x-4*y+4*z+2);quadric(x^2+3*y^2-3*z^2-8*y*z+2*z*x-4*x*y-1,x,y,z,affichage=vert+rempli);quadric((u+v)*(v-w)+3*u-5*v,[u,v,w],affichage=cyan);quadric(7*x^2+4*y^2+4*z^2+4*x*y-4*x*z-2*y*z-4*x+5*y+4*z-18,[x,y,z])","reduced_quadric"},
{"quadrilateral","Returns and draws the quadrilateral ABCD.","","quadrilateral(i,1+i,2-i,-1);quadrilateral(point(0,0,0),point(3,3,3),point(0,0,3),point(3,0,0))","polygon,square"},
{"quantile","Returns the quantile of the elements of l corresponding to p (0<p<1).","","quantile([0,1,3,4,2,5,6],0.25);quantile([0,1,3,4,2,5,6],0.75)","quartile1,median,quartile3"},
{"quartile1","Returns the 1st quartile of the elements (or of the columns) of its argument.","","quartile1([1,2,3,5,10,4]);quartile1([1,2,3,5,10,4],[1,2,3,1,2,3]);quartile1([[1,2],[5,4],[3,6],[7,8]])","quantile,quartiles"},
{"quartile3","Returns the 3rd quartile of the elements (or of the columns) of its argument.","","quartile3([1,2,3,5,10,4]);quartile3([[1,2,3,5,10,4],[2,3,4,4,5,6],[7,6,5,8,9,1]]);quartile3([[1,2],[5,4],[3,6],[7,8]])","quartiles,quantile"},
{"quartiles","Min,1st quartile,the median,3rd quartile, max of the elements (or of the columns) of its argument.","","quartiles([1,2,3,5,10,4]);quartiles([1,2,3,5,10,4],[1,2,3,5,10,4]);quartiles([[1,2],[5,4],[3,6],[7,8]])","boxwhisker,quantile,mean"},
{"quest","Returns the n+1-th question of the command history if n>=0 or, the (-n)th previous question if n<0 (by defaults n=-1 for the previous question).","","quest();quest(2);quest(-2)","ans"},
{"quo","Euclidean quotient of 2 polynomials.","","quo([1,2,3,4],[-1,2]);quo(x^3+2x^2+3x+4,-x+2);quo(t^3+2t^2+3t+4,-t+2,t)","rem,quorem,Quo,iquo"},
{"quorem","Euclidean quotient and remainder of 2 polynomials.","","quorem([1,2,3,4],[-1,2]);quorem(x^3+2x^2+3x+4,-x+2);quorem(t^3+2t^2+3t+4,-t+2,t);quorem(t^4-1,(t+1)^2,t)","rem,quo,iquorem"},
{"quote","Returns its argument unevaluated (and also a:=quote(a) that purge a).","","quote(1+2);quote(1/x+1/(x-1));quote((x+1)*(x-1))",""},
{"r2e","Gives the polynomial (or its value) : the first argument is the vector of coefficients and the second argument is the variable (by default x).","Lst,Var","poly2symb([1,2,3]);poly2symb([1,2,3],x);poly2symb([1,2,3],-1);poly2symb([1,2,-1],y)","e2r,symb2poly"},
{"radical_axis","Returns the line of points with same powerpc with respect to the 2 circles.","","radical_axis(circle(0,1+i),circle(1,1+i));radical_axis(circle(0,point(1+i)),circle(1,point(1+i)))","powerpc"},
{"radius","radius(C) gives the radius of the circle C.","","radius(incircle(-1,1-i,i))","center,circle"},
{"ramene","To read in the file fich_name the variables and their values.","Str(fich_name)","read(\"toto\")","write,readrgb,readwav,csv2gen"},
{"rand","rand(n)=a random integer (resp rand(p,n)=a real or rand(p..n)=a real function) with uniform distribution in 0..n-1 (resp in [p;n])(rand()=rand(0,1)=a real in [0,1[) or rand(n,b1,b2)=n integers between b1 and b2 or rand(n,L)=list of n elements of L.","","rand(4);rand();rand(0,2);rand(0..2)(); f:=rand(0..2);rand(3,1,10);rand(3,[\"r\",\"r\",\"r\",\"b\",\"n\"]); L:=[\"r\",\"r\",\"r\",\"b\",\"n\"];L3:=rand(L,3); L:=[\"r\",\"r\",\"r\",\"b\",\"n\"];L3:=L.rand(3); L:=[\"r\",\"r\",\"r\",\"b\",\"n\"];a:=rand(L); L:=[\"r\",\"r\",\"r\",\"b\",\"n\"];a:=L.rand()","srand,randpoly,ranm,randvector,hasard"},
{"randMat","Returns a list of size n or a n*m matrix that contains random integers in the range -99 through 99 with uniform distribution or contains random numbers according to the law put between quote.","Intg(n), [Intg(m)],[Interval or quote(DistribLaw)]","ranm(3);ranm(3,2);ranm(3,2,6);ranm(3,2,binomial,10,0.3);ranm(3,2,multinomial,[1/2,1/3,1/6]);ranm(3,2,poisson,5.2);ranm(3,2,normald,0,1);ranm(3,2,exp,7/2);ranm(3,2,poisson,1.2);ranm(3,2,'rand(3)');ranm(3,2,1..2);ranm(3,5,multinomial,[1/2,1/3,1/6],[\"R\",\"V\",\"B\"]); GF(2,8,g);ranm(3,3,g)","idn,randPoly,rand,randvector"},
{"randNorm","Returns a random real with normal distribution N(mu,sigma).","Real(mu),Real(sigma)","randnorm(0,1);randnorm(2,1)","rand,randpoly,ranm,randvector,randexp,randbinomial,randpoisson,randgeometric,randmultinomial"},
{"randPoly","Returns a polynomial of variable var (or x), of degree n and where the coefficients are random integers in the range -99 through 99 with uniform distribution or according to a law.","[Var(Var)],Intg(n),[law]","randpoly(5);randpoly(t,8);randpoly(t,8,-1..1);randpoly([x,y],[10,3]);randpoly([x,y],[10,3],1 mod 7); GF(2,8,g);randpoly(t,8,g);randpoly([x,y],[2,3],g)","ranm,randvector"},
{"randbetad","Returns a random real according to the Beta distribution of parameter a>0 and b>0","Real(a),Real(b)","randbetad(1,2);randbetad(1.5,4)","rand,randpoly,randnorm,randvector"},
{"randbinomial","Returns a random integer with binomial distribution B(n,p) i.e. the number of success for n independent tests where for each test, the success probability is p.","","randbinomial(10,0.4);randbinomial(100,0.8)","rand,randpoly,ranm,randvector,randexp,randnorm,randpoisson,randgeometric,randmultinomial"},
{"randchisquare","Returns a random integer with chi^2 distribution, χ^2(n).","","randchisquare(5);randchisquare(2)","rand,randpoly,ranm,randvector,randexp,randbinomial,randnorm,randgeometric,randmultinomial"},
{"randexp","Returns a random real according to the exponential distribution of parameter a>0.","","randexp(1);randexp(2)","rand,randpoly,randnorm,randvector"},
{"randfisher","Returns a random integer with Fisher-Snedecor distribution F(n,m).","","randfisher(5,2);randfisher(2,4)","rand,randpoly,ranm,randvector,randexp,randbinomial,randnorm,randgeometric,randmultinomial"},
{"randgammad","Returns a random real according to the Gamma distribution of parameter a>0 and b>0","Real(a),Real(b)","randgammad(1,2);randgammad(1.5,4)","rand,randpoly,randnorm,randvector"},
{"randgeometric","Returns a random integer following geometric distribution of parameter p.","","randgeometric(0.4)","rand,randpoly,ranm,randvector,randexp,randnorm,randpoisson,randbinomial,randmultinomial"},
{"randint","randint(n1,n2)=an integer in [n1, n2] or [n2,n1].","Intg(n1),Intg(n2)","randint(1,10);randint(-1,-10)","rand "},
{"randmarkov","Returns a random sequence of n states (Markov chain) starting from i0, with probability transition matrix M, or returns a stochastic matrix with p recurrent loops v=[n1,..,np] and i0 transient states.","","randmarkov([[0,0,1/2,0,1/2],[0,0,1,0,0],[1/4,1/4,0,1/4,1/4],[0,0,1/2,0,1/2],[0,0,0,0,1]],2,20);randmarkov([1,2,1,3],4)","markov,plotproba"},
{"randmatrix","Returns a list of size n or a n*m matrix that contains random integers in the range -99 through 99 with uniform distribution or contains random numbers according to the law put between quote.","Intg(n), [Intg(m)],[Interval or quote(DistribLaw)]","ranm(3);ranm(3,2);ranm(3,2,6);ranm(3,2,binomial,10,0.3);ranm(3,2,multinomial,[1/2,1/3,1/6]);ranm(3,2,poisson,5.2);ranm(3,2,normald,0,1);ranm(3,2,exp,7/2);ranm(3,2,poisson,1.2);ranm(3,2,'rand(3)');ranm(3,2,1..2);ranm(3,5,multinomial,[1/2,1/3,1/6],[\"R\",\"V\",\"B\"]); GF(2,8,g);ranm(3,3,g)","idn,randPoly,rand,randvector"},
{"randmultinomial","Returns a random index or list element according to a multinomial distribution probability list P.","","randmultinomial([1/2,1/3,1/6]);randmultinomial([1/2,1/3,1/6],[\"R\",\"V\",\"B\"])","rand,randpoly,ranm,randvector,randexp,randnorm,randpoisson,randgeometric,randbinomial"},
{"randnorm","Returns a random real with normal distribution N(mu,sigma).","","randnorm(0,1);randnorm(2,1)","rand,randpoly,ranm,randvector,randexp,randbinomial,randpoisson,randgeometric,randmultinomial"},
{"random","rand(n)=a random integer (resp rand(p,n)=a real or rand(p..n)=a real function) with uniform distribution in 0..n-1 (resp in [p;n])(rand()=rand(0,1)=a real in [0,1[) or rand(n,b1,b2)=n integers between b1 and b2 or rand(n,L)=list of n elements of L.","Intg(n) or Interval(p..n) or NULL,[Intg(b1) or Lst(L)],[Intg(b2)]","rand(4);rand();rand(0,2);rand(0..2)(); f:=rand(0..2);rand(3,1,10);rand(3,[\"r\",\"r\",\"r\",\"b\",\"n\"]); L:=[\"r\",\"r\",\"r\",\"b\",\"n\"];L3:=rand(L,3); L:=[\"r\",\"r\",\"r\",\"b\",\"n\"];L3:=L.rand(3); L:=[\"r\",\"r\",\"r\",\"b\",\"n\"];a:=rand(L); L:=[\"r\",\"r\",\"r\",\"b\",\"n\"];a:=L.rand()","srand,randpoly,ranm,randvector,hasard"},
{"random_bipartite_graph","Returns a random undirected unweighted bipartite graph with n vertices where each possible edge is present with probability p or where m edges are created at random. When the first argument is list [a,b] of integers, two groups of vertices with sizes a and b are created.","Intg(n)||Lst(a,b),Real(p)||Intg(m)","random_bipartite_graph(10,0.5);random_bipartite_graph([2,3],1.0)","random_digraph,random_graph,random_planar_graph,random_regular_graph,random_sequence_graph,random_tournament,random_tree"},
{"random_digraph","Returns a random directed unweighted graph with n vertices (list V of labels may me specified) where two vertices are connected with probability p or where m edges are created at random.","Intg(n)||Lst(V),Real(p)||Intg(m)","random_digraph(8,0.5);random_digraph(8,10)","random_bipartite_graph,random_graph,random_planar_graph,random_regular_graph,random_sequence_graph,random_tournament,random_tree"},
{"random_graph","Returns a random undirected unweighted graph with n vertices (list V of labels may me specified) where two vertices are connected with probability p or where m edges are created at random.","Intg(n)||Lst(V),Real(p)||Intg(m)","random_graph(8,0.5);random_graph(8,10)","random_bipartite_graph,random_digraph,random_planar_graph,random_regular_graph,random_sequence_graph,random_tournament,random_tree"},
{"random_network","Returns a random network with b grid frames of size a*a in which every edge appears with the probability p (by default 0.5).","Intg(a),Intg(b),[Real(p)],[opts]","random_network(3,3);random_network(3,3,acyclic);random_network(3,4,0.75)","is_network,maxflow"},
{"random_planar_graph","Return random planar graph with n vertices, which can also be specified as a list V of their labels, obtained by trying to remove each edge of a random triangulated graph with probability 0<=p<1 [c is connectivity level : 0 - any, 1 - connected, 2 - biconnected, 3 - triconnected (by default, c=1)].","Intg(n)||Lst(V),Real(p),[Intg(c)]","","random_bipartite_graph,random_digraph,random_graph,random_regular_graph,random_sequence_graph,random_tournament,random_tree"},
{"random_regular_graph","Returns a random d-regular graph with n vertices, which may be specified as list V of their labels.","Intg(n)||Lst(V),Intg(d),[connected]","random_regular_graph(100,80,connected)","random_bipartite_graph,random_digraph,random_graph,random_planar_graph,random_sequence_graph,random_tournament,random_tree"},
{"random_sequence_graph","Returns a random undirected graph with degree sequence L.","Lst(L)","random_sequence_graph([1,3,3,2,1,2,2,2,3,3])","random_bipartite_graph,random_digraph,random_graph,random_planar_graph,random_sequence_graph,random_tournament,random_tree"},
{"random_tournament","Returns a random tournament graph with n vertices, which may be specified as list V of their labels.","Intg(n)||Lst(V)","random_tournament(5)","random_bipartite_graph,random_digraph,random_graph,random_planar_graph,random_regular_graph,random_sequence_graph,random_tree"},
{"random_tree","Returns a random tree graph with n vertices, which may be specified as list V of their labels [with the upper bound d (positive integer) for the degree of graph or 'root' for rooted trees].","Intg(n)||Lst(V),[Intg(d)||root[=Vrtx(v)]]","","random_bipartite_graph,random_digraph,random_graph,random_planar_graph,random_regular_graph,random_sequence_graph,random_tournament"},
{"random_variable","Returns a random variable from a probability density function f or from list of weights (discrete variable).","Lst(W)||Mtrx(M)||Fnc(f),[params]","randvar(fisher,2,3);randvar([[\"apple\",1/3],[\"orange\",1/4],[\"pear\",1/5],[\"plum\",13/60]]);randvar(k->1-(k/10)^2,range=-10..10);randvar([3,1,2,5],[alpha,beta,gamma,delta]);randvar(gammad,mean=12,variance=4);randvar(binomial,mean=18,stddev=4);randvar(multinomial,[1/2,1/3,1/6],[a,b,c]);randvar(weibull,mean=12.5,variance=1);randvar(uniform,mean=10,stddev=2);randvar(uniform,e..pi)","randvector,randmatrix,rand"},
{"randperm","Returns a random permutation of [0,1,2,..,n-1] or of the list L.","","randperm(4);randperm(7);randperm([1,3,5,7,9]); L:=[1,3,5,7,9];L:=randperm(L); L:=[1,3,5,7,9];L.randperm()","permu2cycles,is_permu,permu2mat"},
{"randpoisson","Returns a random integer with poisson distribution P(λ).","","randpoisson(5.4);randpoisson(2.8)","rand,randpoly,ranm,randvector,randexp,randbinomial,randnorm,randgeometric,randmultinomial"},
{"randpoly","Returns a polynomial of variable var (or x), of degree n and where the coefficients are random integers in the range -99 through 99 with uniform distribution or according to a law.","","randpoly(5);randpoly(t,8);randpoly(t,8,-1..1);randpoly([x,y],[10,3]);randpoly([x,y],[10,3],1 mod 7); GF(2,8,g);randpoly(t,8,g);randpoly([x,y],[2,3],g)","ranm,randvector"},
{"randseed","srand returns an integer and initialize the sequence of random numbers.","","srand(12); srand","RandSeed"},
{"randstudent","Returns a random integer with Student distribution S(n).","","randstudent(5);randstudent(2)","rand,randpoly,ranm,randvector,randexp,randbinomial,randnorm,randgeometric,randmultinomial"},
{"randvar","Returns a random variable from a probability density function f or from list of weights (discrete variable).","Lst(W)||Mtrx(M)||Fnc(f),[params]","randvar(fisher,2,3);randvar([[\"apple\",1/3],[\"orange\",1/4],[\"pear\",1/5],[\"plum\",13/60]]);randvar(k->1-(k/10)^2,range=-10..10);randvar([3,1,2,5],[alpha,beta,gamma,delta]);randvar(gammad,mean=12,variance=4);randvar(binomial,mean=18,stddev=4);randvar(multinomial,[1/2,1/3,1/6],[a,b,c]);randvar(weibull,mean=12.5,variance=1);randvar(uniform,mean=10,stddev=2);randvar(uniform,e..pi)","randvector,randmatrix,rand"},
{"randvector","Returns a list of size n that contains random integers in the range -99 through 99 (or in 0..m-1) with uniform distribution or contains random numbers according to the law put between quote.","","randvector(3);randvector(3,6);randvector(3,normald,0,1);randvector(3,poisson,1.2);randvector(3,exponentiald,1.2);randvector(3,multinomial,[1/2,1/3,1/6]);randvector(3,multinomial,[1/2,1/3,1/6],[a,b,c]);randvector(3,'rand(3)');randvector(3,1..2); GF(2,8,g);randvector(3,g)","idn,randPoly,rand,ranm"},
{"randweibulld","Returns a random real according to the Weibull distribution of parameter a>0 and b>0","Real(a),Real(b)","randweibulld(1,2);randweibulld(1.5,4)","rand,randpoly,randnorm,randvector"},
{"range","Returns the list [0,1..n-1] or the list [a,a+1..b[ or the list [a,a+p,a+2p..b[","Intg(n)||Intg(a),Intg(b),[Intg(p)]","range(10);range(1,11);range(1,11,2);range(1,11,3);range(11,1,-1); L:=[j^2 for j in range(20) if isprime(j)]","$,makelist,seq"},
{"rank","Returns the rank of the matrix.","","rank([[1,1,2],[2,1,3],[3,1,4]]);rank([[1,1,2],[2,1,3],[3,1,5]])","det,image"},
{"ranm","Returns a n*m matrix that contains random integers in the range -99 through 99 with uniform distribution (Xcas) or random reals (Python) or contains random numbers according to the law put between quote (Xcas).","","ranm(3,2);ranm(3,2,6);ranm(3,2,binomial,10,0.3);ranm(3,2,multinomial,[1/2,1/3,1/6]);ranm(3,2,poisson,5.2);ranm(3,2,normald,0,1);ranm(3,2,exp,7/2);ranm(3,2,poisson,1.2);ranm(3,2,'rand(3)');ranm(3,2,1..2);ranm(3,5,multinomial,[1/2,1/3,1/6],[\"R\",\"V\",\"B\"]); GF(2,8,g);ranm(3,3,g)","idn,randPoly,rand,randvector"},
{"ranv","Returns a list of size n that contains random integers in the range -99 through 99 (Xcas) or random reals in 0..1 (Python) with uniform distribution or contains random numbers according to the law put between quote (Xcas).","Intg(n), [Intg(m)],[Interval or quote(DistribLaw)]","ranv(3);randvector(3,6);randvector(3,normald,0,1);randvector(3,poisson,1.2);randvector(3,exponentiald,1.2);randvector(3,multinomial,[1/2,1/3,1/6]);randvector(3,multinomial,[1/2,1/3,1/6],[a,b,c]);randvector(3,'rand(3)');randvector(3,1..2); GF(2,8,g);randvector(3,g)","idn,randPoly,rand,ranm"},
{"rassembler_trigo","Collect trigonometric expressions.","Expr","tcollect(sin(x)+cos(x))","texpand,tlin"},
{"rat_jordan","Returns the list made by the matrix of passage and the rational Jordan form of a matrix.","","rat_jordan([[0,2],[1,0]]);rat_jordan([[-2,-2,1],[-2,1,-2],[1,-2,-2]]);rat_jordan([[1,1,-1,2,-1],[2,0,1,-4,-1],[0,1,1,1,1],[0,1,2,0,1],[0,0,-3,3,-1]])","egv,egvl,jordan,companion"},
{"rational","DOM_RAT or rational is the type of a rational, as returned by the type command. It is also an option of the assume command.","Opt"," assume(a,rational); assume(a,DOM_RAT); a:=1/2;type(a)","type,assume,DOM_INT,DOM_FLOAT"},
{"rationalroot","Returns the list of rational roots of P without indicating the multiplicity.","","rationalroot(2*x^3-9*x^2+13*x-6)","proot,froot,complexroot,realroot,crationalroot"},
{"ratnormal","Rewrite as an irreducible rational fraction.","","ratnormal((x^2-1)/(x^3-1));ratnormal(c/d+b/d+a/d);ratnormal((x^2-1)/(x^3-1)+(x-1)/(x^3-1)+1)","normal,simplify,factor,expand"},
{"rcl","Recalls an identifier content, does not evaluate it.","","rcl(a)",""},
{"rdiv","Division of a by b (prefixed version of /).","","rdiv(3,5);rdiv(3.2,5.4)","/"},
{"re","Returns the real part of a complex number.","","re(1+2*i);re((1+2*i)^2);real([1+2*i,(1+2*i)^2])","im,conj"},
{"read","To read in the file fich_name the variables and their values.","","read(\"toto\")","write,readrgb,readwav,csv2gen"},
{"readrgb","Reads a picture file, using it's natural dimensions, or using specified dimensions.","","readrgb(\"image.png\");readrgb(\"image.png\",50,50)","writergb,readwav"},
{"readwav","Reads a WAV sound file.","","readwav(\"pop.wav\")","writewav,readrgb"},
{"real","Returns the real part of a complex number.","Cplx or LstCplx","re(1+2*i);re((1+2*i)^2);real([1+2*i,(1+2*i)^2])","im,conj"},
{"realroot","Returns the list of intervals of length <=l containing the real roots of P inside a..b with their multiplicity. By default the Vincent-Akritas-Strzebonski (VAS) method is used. realroot(sturm,P) uses Sturm's method.","","realroot(x^3+7,0.1);realroot(x^3-7*x+7);realroot(sturm,x^3-7*x+7);realroot(x^5-2*x^4+x^3+1);realroot(x^5-2*x^4+x^3+1,0.1);realroot(x^3+x+8,1e-5,-4,4)","proot,froot,complexroot,rationalroot,crationalroot,sturmab,VAS"},
{"reciprocation","Returns the list where a point (resp a line) are replaced with its polar (resp pole), with respect to the circle C.","","reciprocation(circle(0,1),[point((1+i)/2), line(1,-1+i)]);reciprocation(circle(0,1),[line(1+i,2),point(1+i*2)])","pole,polar"},
{"rectangle","Returns and draws the rectangle ABCD, AD=k*AB if k>0 ABCD is direct else indirect (in the plane ABP AD=AP or AD=k*AB).","","rectangle(-i,1,2);rectangle(-i,1,-2,D,C);rectangle(point(0,0,0),point(3,3,3),point(0,0,3),D,C);rectangle(point(0,0,0),point(3,3,3),2,D,C)","quadrilateral,square"},
{"rectangle_droit","Option of the plotarea command and of the area command.","Opt"," plotarea(x^2,x=0..1,5,trapezoid); plotarea(x^2,x=0..1,5,middle_point); plotarea(x^2,x=0..1,5,right_rectangle); plotarea(x^2,x=0..1,5,left_rectangle); area(x^2,x=0..1,5,middle_point); area(x^2,x=0..1,5,trapezoid)","plotarea,area"},
{"rectangle_gauche","Option of the plotarea command and of the area command.","Opt"," plotarea(x^2,x=0..1,5,trapezoid); plotarea(x^2,x=0..1,5,middle_point); plotarea(x^2,x=0..1,5,right_rectangle); plotarea(x^2,x=0..1,5,left_rectangle); area(x^2,x=0..1,5,middle_point); area(x^2,x=0..1,5,trapezoid)","plotarea,area"},
{"rectangle_plein","Draws a full direct rectangle (resp square) with sides a,b (resp a) from the turtle position and on the left (by default b=a).",""," rectangle_plein 20;rectangle_plein(20);rectangle_plein(20,40)","triangle_plein"},
{"rectangular_coordinates","Returns the list of the abscissa and of the ordinate of a point given by the list of its polar coordinates.","","rectangular_coordinates([1,pi/4]);rectangular_coordinates(polar_point(1,pi/4))","abscissa,ordinate,rectangular_coordinates,polar_point"},
{"recule","The turtle takes n steps back (by default n=10).",""," recule 30;recule(30)","avance,saute"},
{"red","Option of the display command to display with color.","Opt"," F:=display(point(2+1.5*i),red); F:=display(point(2+1.5*i),point_point+green)","display"},
{"redim","Shrink or enlarge with 0 a matrix (or vector) according to the new n1 and n2 dimensions.","Mtrx||Vect,Intg(n1),Intg(n2)","redim([[1,2,3],[3,-9,6],[4,5,6]],1,2);redim([[1,2,3],[3,-9,6],[4,5,6]],4,4)","replace"},
{"reduced_conic","Returns the origin and the matrix of a base in which the conic given by its equation, is reduced, 0 or 1 (0 if the conic is degenerated) and the equation of the conic in this base and also its parametric equation.","","reduced_conic(x^2+2*x-2*y+1);reduced_conic(a*x^2-2*x*y+a*y^2-2*x+2*y+3,[x,y]);reduced_conic(2*u^2+2*u*v+2*v^2+5*u+3,[u,v]);reduced_conic((x+y)^2-2*x+1,x,y)","gauss,conic"},
{"reduced_quadric","Returns the origin and the matrix of a basis in which the quadric (given by its equation) is reduced, the list of its eigenvalues, the equation of the quadric in this basis and its parametric equation.","","reduced_quadric(4*x^2+y^2+z^2-4*x*y+4*x*z-2*y*z+8*x-4*y+4*z+2);reduced_quadric(x^2+3*y^2-3*z^2-8*y*z+2*z*x-4*x*y-1,x,y,z);reduced_quadric((u+v)*(v-w)+3*u-5*v,[u,v,w]);reduced_quadric(7*x^2+4*y^2+4*z^2+4*x*y-4*x*z-2*y*z-4*x+5*y+4*z-18,[x,y,z])","gauss,quadric"},
{"ref","Reduction of Gauss of AX=b (M=A|(-b)).","","ref([[3,1,-2],[3,2,2]]);ref([[2,1,1,-1],[1,1,2,-1],[1,2,1,-4]])","rref,det"},
{"reflection","reflection(D,C) (or reflection(A,C))=symmetrical of C in the symmetry-line D (or sym-point A).","","reflection(line(0,1+i),A);reflection(B,A);reflection(line(0,1+i),circle(i,1+i))","rotation,translation"},
{"regroup","Collect terms in an expression.","","regroup(x+3*x+5*4/x)","simplify,normal"},
{"relabel_vertices","Returns a copy of G with vertex labels changed to those in the list L.","Graph(G),Lst(L)","relabel_vertices(graph([a,b,c]),[\"first\",\"second\",\"third\"])","graph_vertices,isomorphic_copy,permute_vertices"},
{"reliability_polynomial","Returns the reliability polynomial [or its value at point p] of undirected graph G. If G is weighted, all weights must be positive integers and are interpreted as edge multiplicities.","Graph(G),[Var(p)]","reliability_polynomial(graph(\"petersen\"));reliability_polynomial(graph(\"petersen\"),0.5)","chromatic_polynomial,flow_polynomial,tutte_polynomial"},
{"rem","Euclidean remainder of 2 polynomials.","","rem([1,2,3,4],[-1,2]);rem(x^3+2x^2+3x+4,-x+2);rem(t^3+2t^2+3t+4,-t+2,t)","quo,quorem,Rem,irem"},
{"remain","Euclidean remainder of 2 integers.","Intg(a),Intg(b)","irem(125,15);irem(125,41);irem(-7,3);irem(25+12*i,5+7*i)","iquo,smod,rem,mod"},
{"remove","Remove the occurrences a of l or the elements a such that f(a)=true.","","remove(x->x>=5,[1,2,6,7]);remove(5,[1,2,5,6,7,5])","select,suppress"},
{"reorder","Reorders the variables in E according to the order of the 2nd argument.","","-2;reorder(x^2+2*x+y^2,[y,x])",""},
{"repeat","Loop repeat (repeat the instructions until cond==true): repeat i1;i2; until cond; or repeter i1;i2;jusqua cond;",""," x:=32;repeat x:=x-5 until x<5;; x:=32;repeter x:=x-5; jusqua x<5;;  quoreste(a,b):={local q:=0;repeat a:=a-b;q:=q+1 until a<0;return q-1,a+b;};;  quoreste(a,b):={local q:=0;repeter a:=a-b;q:=q+1; jusqua a<0;return q-1,a+b;};; n:=1;repeter triangle_plein(10*n);saute(10*n);n:=n+1; jusqua n==5;; n:=4;repeter triangle_plein(10*n);saute(10*n);n:=n-1; jusqua n==0;","for,tantque"},
{"repete","Instruction doing k times the same commands.",""," repete 3,avance 40,tourne_droite 120; repete 3,avance(30),tourne_droite(120); repete 4,rectangle_plein(20,40),tourne_droite;repete(3,avance 20,tourne_droite 120);repete(4,rectangle_plein(20,40),tourne_droite)","polygone_rempli"},
{"repeter","Loop repeat (repeat the instructions until cond==true): repeat i1;i2; until cond; or repeter i1;i2;jusqua cond;",""," x:=32;repeat x:=x-5 until x<5;; x:=32;repeter x:=x-5; jusqua x<5;;  quoreste(a,b):={local q:=0;repeat a:=a-b;q:=q+1 until a<0;return q-1,a+b;};;  quoreste(a,b):={local q:=0;repeter a:=a-b;q:=q+1; jusqua a<0;return q-1,a+b;};; n:=1;repeter triangle_plein(10*n);saute(10*n);n:=n+1; jusqua n==5;; n:=4;repeter triangle_plein(10*n);saute(10*n);n:=n-1; jusqua n==0;","for,tantque"},
{"replace","Replace part of matrix A from indices n1,n2 with the values of matrix B.","Mtrx(A),Lst(n1,n2),Mtrx(B)","replace([[1,2,3],[3,-9,6],[4,5,6]],[1,0],[[7,8],[9,0]])","redim"},
{"resample","Returns a copy of the input audio clip resampled to the rate s (by default 44100), optionally with quality level q (from 0 to 4, by default 2).","Lst(clip),[Intg(s),[Intg(q)]]","resample(readwav(\"/some/file\"),48000);resample(readwav(\"/some/file\"),48000,3)","samplerate,playsnd,readwav,writewav"},
{"reset","Reset the turtle","NULL","reset()","baisse_crayon,crayon"},
{"reshape","Python (numpy) Shrink or enlarge with 0 a matrix (or vector) according to the new n1 and n2 dimensions.","Mtrx||Vect,Intg(n1),Intg(n2)","a=array([1,2,3,4,5]) ; reshape(a,(2,3))","replace"},
{"residue","Returns the residue in a of the expression with v as variable.","","residue(1/z,z,0);residue(5/z,z=0);residue(cos(z)/(z*(z-b)),z,0);residue(c/(z*(z-b)),z=b)","series"},
{"resoudre","Solves a (or a set of) polynomial equation.","Expr,[Var]","solve(x^2-3=1);solve(x^3-3*y,y);solve([y-z=0,z-x=0,x-y=0,x-1+y+z=0],[x,y,z]);solve([x^2-y^2=0,x^2-z^2=0],[x,y,z])","linsolve,proot,fsolve,csolve,nSolve"},
{"resoudre_dans_C","Returns the list of complex solutions of an equation or a matrix where the rows are ℂ-solutions of a system of polynomial equations.","LstEq,LstVar","csolve(x^4-1,x);csolve(x^4-y^4 and x+y=2,[x,y]);csolve(x^4-y^4 and x+y=0 and x^2=2*x,[x,y]);csolve(u*v-u=v and v^2=u,[u,v])","cZeros,solve,fslove"},
{"resoudre_systeme_lineaire","Linear equations system solver.","LstLinEq,LstVar","linsolve([x+y+z=1,x-y=2,2*x-z=3],[x,y,z]);linsolve([m*x+y=a,x+m*y=b],[x,y]);linsolve([x+y-z-1,x-y+1,x-y-z-1]%2,[x,y,z]);linsolve([[3,4],[1,2]],[0,1]); p,l,u:=lu([[3,4],[1,2]]); linsolve(p,l,u,[0,1]) ;linsolve([2*x+y+z=1,x+y+2*z=1,x+2*y+z=4],[x,y,z]);linsolve([[2,1,1],[1,1,2],[1,2,1]],[1,1,4]); p,l,u:=lu([[2,1,1],[1,1,2],[1,2,1]]);linsolve(p,l,u,[1,1,4]); a:=[[100,2],[2,100]];linsolve(evalf(a),[0,1]);","solve,proot,simult,gaussjord,pivot,ref,conjugate_gradient"},
{"restart","Purges all the variables.","","restart","purge"},
{"resultant","Resultant of two polynomials.","","resultant(x^2-1,x^3-1,x);resultant(x^3-p*x+q,3*x^2-p,x)","sylvester,gcd"},
{"return","Instruction that interrupts a function and returns its value.",""," zeroinl(l):={local k; for (k:=0;k<size(l);k++){if (l[k]==0) return(1);} return(0);}; zerodansl(l):={local k; pour k de 0 jusque size(l)-1 faire si l[k]==0 alors return(1);fsi; fpour; return(0);}","break"},
{"reverse","Returns the list L in reverse order; L:=revlist(L) or L.revlist().","Lst(L)","revlist([1,2,3,4]); L:=[1,2,3,4];L:=revlist(L); L:=[1,2,3,4];L.revlist(); L:=[1,2,3,4];L.reverse()",""},
{"reversed","Python: returns the list L in reverse order.","Lst(L)","list(reversed([1,2,3,4]))",""},
{"reverse_graph","Returns the copy of G with the directions of all edges reversed.","Graph(G)","reverse_graph(digraph(%{[1,2],[1,3],[2,3]%}))","digraph"},
{"reverse_rsolve","If v=[v_0 ... v_(2n-1)], return [b_n,...,b_0] such that b_n*v_{n+k}+...+b_0*v_k=0 for k=0..n-1.","","reverse_rsolve([1,-1,3,3])","rsolve"},
{"revert","Returns the revert expansion of a series expansion at 0.","","revert(x+x^2+x^4)","series"},
{"revlex","Option of the gbasis or greduce command to specify an order for monomials (complete degree then inverse lexicographic order).","","","gbasis,greduce"},
{"revlist","Returns the list L in reverse order; L:=revlist(L) or L.revlist().","","revlist([1,2,3,4]); L:=[1,2,3,4];L:=revlist(L); L:=[1,2,3,4];L.revlist(); L:=[1,2,3,4];L.reverse()",""},
{"rgb","Option of the display (or affichage) command to defined colors RGB.","Opt"," redcolor:=rgb(0.99,0,0);display(square(0,2+i),filled+redcolor); greencolor:=rgb(0,0.99,0);display(square(0,2+i),filled+greencolor); bluecolor:=rgb(0,0,0.99);display(square(0,2+i),filled+bluecolor); greycolor:=rgb(0.5,0.5,0.5);display(square(0,2+i),filled+greycolor); F:=display(square(0,2+i),filled+rgb(rand(),rand(),rand())); L:=rand(),rand(),rand();affichage(square(0,2+i),rgb(L)+rempli);legend(0.2,[L])","display,filled"},
{"rhombus","Returns and draws the rhombus ABCD such as the angle (AB,AD)=a (or in the plane ABP angle(AB,AD)=angle(AB,AP) or such that angle(AB,AD)=a).","","rhombus(i,1+i,pi/4);rhombus(i,1+i,pi/4,C,D);rhombus(point(0,0,0),point(3,3,3),[point(0,0,3),pi/4]);rhombus(point(0,0,0),point(3,3,3),point(0,0,3),C,D);rhombus(point(0,0,0),point(3,3,3),[point(0,0,3),pi/4],C,D)","square,quadrilateral"},
{"rhombus_point","Option of the display command for a point.",""," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"rhs","Returns the right part of an equality, of an interval, of a list or of a string.","Equal(a=b) or Interval(a..b) or Str,Intg","right(a=b);right(x^2+1=5);right(1..5);right(\"abcdefg\",3)","left,mid,tail,head"},
{"riemann_window","Applies the Riemann windowing function to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Interval(n1..n2)]"," scatterplot(riemann_window(randvector(1000,0..1)))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,bartlett_hann_window,triangle_window,tukey_window,welch_window"},
{"right","Returns the right part of an equality, of an interval, of a list or of a string.","","right(a=b);right(x^2+1=5);right(1..5);right(\"abcdefg\",3)","left,mid,tail,head"},
{"right_rectangle","Option of the plotarea command and of the area command.","Opt"," plotarea(x^2,x=0..1,5,trapezoid); plotarea(x^2,x=0..1,5,middle_point); plotarea(x^2,x=0..1,5,right_rectangle); plotarea(x^2,x=0..1,5,left_rectangle); area(x^2,x=0..1,5,middle_point); area(x^2,x=0..1,5,trapezoid)","plotarea,area"},
{"right_triangle","Draws the A_rectangular triangle ABC with AC=k*AB (or in the plane ABP AC=AP or AC=k*AB).","","right_triangle(1,i,tan(pi/3));right_triangle(1,i,1/2,C);right_triangle(point(0,0,0),point(3,3,3),point(0,0,3));right_triangle(point(0,0,0),point(3,3,3),[point(0,0,3),1/2],C);right_triangle(point(0,0,0),point(3,3,3),[point(0,0,3),1/2],C)","triangle"},
{"risch","Returns a primitive of the expression calculated with the Risch algorithm.","","risch(ln(x),x);risch(ln(x));risch(exp(x^2),x)","int"},
{"rm_a_z","Erase all the variable name with only one minuscule a..z character.","","rm_a_z()","rm_all_vars"},
{"rm_all_vars","Erase all the variable name.","","rm_all_vars()","rm_a_z"},
{"rmbreakpoint","Removes a breakpoint.","","rmbreakpoint(1)","breakpoint"},
{"rmmod","Removes the installed dynamic libraries.","","rmmod(\"/home/parisse/giac/src/libprogfr.so\")","lsmod,insmod"},
{"rmwatch","Clears a variables from the table of displayed variables in step/step.","","rmwatch(a)","watch"},
{"romberg","Returns the approximate value of integrate(f(x),x,a,b) by Romberg's method.","","romberg(exp(x^2),x,0,1);romberg(x^2,x,0,1);romberg(exp(-x^2),x,-1,1)","integrate,gaussquad"},
{"rombergm","Option of the area command","Opt"," area(x^2,x=0..1,5,simpson); area(x^2,x=0..1,5,rombergt); area(x^2,x=0..1,5,rombergm);area(x^2,x=0..1,5,gauss15)","area"},
{"rombergt","Option of the area command","Opt"," area(x^2,x=0..1,5,simpson); area(x^2,x=0..1,5,rombergt); area(x^2,x=0..1,5,rombergm);area(x^2,x=0..1,5,gauss15)","area"},
{"rond","Draws a circle (resp a arc) with radius r (resp and of angle (0,a) or (a,b)), tangent at the turtle position.",""," rond 30;rond(40);rond(40,90);rond(40,10,100)","disque"},
{"root","Returns b^(1/a) (root(2,3)=sqrt(3)).","","root(3,2);root(1/3,2);root(3,1.2);root(3.2,1.2)",""},
{"rootof","Polynomial in terms of a root of an irreducible polynomial on Q. Returns P(a) with a the greatest root of Q.",""," normal(1/rootof([1,0],[1,0,10,0,1])); normal(1/rootof([1,0,0],[1,1,0,-1])); rootof(x^4+x+1):='j'; normal(j^5); ",""},
{"roots","Returns a matrix having 2 columns and where the rows are the roots of the polynomial with their multiplicity (for 1 variable).","","roots(t^3-1,t);roots(x^5-2*x^4+x^3)","proot,cZeros"},
{"rotate","Returns the list where the last element [or the tail beginning with the n-th element] is the first element (by default n=-1);L:=rotate(L,n) or L.rotate(n).","","rotate([0,1,2,3],2);rotate([[1,2,3],[4,5,6],[7,8,9]]);rotate([0,1,2,3,4]);rotate([0,1,2,3,4],-1); L:=[0,1,2,3,4];L:=rotate([0,1,2,3,4]); L:=[0,1,2,3,4];L.rotate(); L:=[0,1,2,3];L:=rotate([0,1,2,3],2); L:=[0,1,2,3];L.rotate(2)","tail,mid,shift"},
{"rotation","rotation(B,a1,A)(resp rotation(d,a1,A)) is the transformed of A by rotation of center B (resp of axis d) and of angle a1.","","rotation(point(1+i),pi/2,point(i));rotation(1+i,pi/3,line(i,1));rotation(line(x=y,y=z),pi/2,point(1,-1,2)); r:=rotation(1+i,pi/2);r(i); r:=rotation(line(x=y,y=z),pi/2);r(point(1,-1,2))","translation,reflection"},
{"round","Rounds the real or complex as the nearest integer (resp the nearest decimal number) or as nearest element of ℤ[i], (resp with n decimals).","","round(2.5);round(-2.4);round(-2.5+i*2.4);round(1.237,2);round(sqrt(2)+i*sqrt(5),4)","floor,ceil"},
{"row","Returns the row n or the sequence of the rows n1..n2 of the matrix A, or optional argument of count,count_eq,count_inf,count_sup.","","row([[1,2,3],[4,5,6],[7,8,9]],1);row([[1,2,3],[4,5,6],[7,8,9]],0..1); count_eq(3,[[1,2,3],[4,3,2],[3,2,1]],row)","col,count,count_eq,count_inf,count_sup"},
{"rowAdd","Returns the matrix get from A by replacing the n2-th row by the sum of the n1-th and n2-th rows.","","rowAdd([[1,2],[3,4],[5,6]],1,2)","rowSwap"},
{"rowDim","Number of rows of a matrix.","Mtrx","rowdim([[1,2,3],[4,5,6]]);rowdim([[1,2],[3,4],[5,6]])","ncols"},
{"rowNorm","Returns the max of the l1_norm of the rows of a matrix: rowNorm(a_{j,k})=max_j(sum_k(|a_{j,k}|)).","","rowNorm([[1,2],[3,-4]]);rowNorm([[1,2,3,-4],[-5,3,2,1]])","norm"},
{"rowSwap","Returns the matrix get from A by swapping the n1-th row and the n2-th row.","","rowSwap([[1,2],[3,4],[5,6]],1,2)","rowAdd,colSwap"},
{"rowdim","Number of rows of a matrix.","","rowdim([[1,2,3],[4,5,6]]);rowdim([[1,2],[3,4],[5,6]])","ncols"},
{"rownorm","Returns the max of the l1_norm of the rows of a matrix: rowNorm(a_{j,k})=max_j(sum_k(|a_{j,k}|)).","Vect or Mtrx","rowNorm([[1,2],[3,-4]]);rowNorm([[1,2,3,-4],[-5,3,2,1]])","norm"},
{"rowspace","Returns a matrix where the rows are a basis of the vector space generated with the rows of the matrix A [d is the dimension of this space].","","rowspace([[1,2,3],[1,2,3],[1,2,4],[1,2,5]]);rowspace([[1,2,3],[1,3,6],[2,5,9]],d)","colspace"},
{"rowswap","Returns the matrix get from A by swapping the n1-th row and the n2-th row.","Mtrx(A),Intg(n1),Intg(n2)","rowSwap([[1,2],[3,4],[5,6]],1,2)","rowAdd,colSwap"},
{"rref","Row reduction to echelon form of AX=b (M=A|(-b)) [Reduction on columns 0..k-1]","","rref([[3,1,-2],[3,2,2]]);rref([[2,1,1,-1],[1,1,2,-1],[1,2,1,-4]]);rref([[2,1,1,-1],[1,1,2,-1],[1,2,1,-4]],2);rref([[1,1,0,0,-a1],[0,1,1,0,-a2],[0,0,1,1,-a3],[1,0,0,1,-a4]],keep_pivot)","ker,image,det,Rref,pivot,ref,keep_pivot"},
{"rsolve","Gives the value of a recurrent sequence or of a system of recurrent sequences.","","rsolve(u(n+1)=2*u(n)+n,u(n),u(0)=1);rsolve(u(n+1)=2*u(n)+n,u(n),u(1)^2=1);rsolve(u(n+1)=(u(n)-1)/(u(n)-2),u(n),u(0)=4);rsolve(u(n+2)=u(n)+2*u(n+1)+n+1,u(n),[u(0)=0,u(1)=1]);rsolve([u(n+1)=3*v(n)+u(n),v(n+1)=v(n)+u(n)],[u(n),v(n)],[u(0)=1,v(0)=2])","seqsolve,plotseq,tableseq,reverse_rsolve"},
{"same","Equality test.","","same(a,b);same((2-1)^2,2^2-2*2+1)",""},
{"sample","sample(L,n)= rand(n,L)=list of de n extracted elements of L without throw-in.","Lst(L),Intg(n)","sample([1,2,3,4,5,6],6);sample([1,2,3,4,5,6],3);sample([\"r\",\"r\",\"r\",\"b\",\"n\"],3); L:=[1,2,3,4,5,6];L:=sample(L,3); L:=[1,2,3,4,5,6];L.sample(3); ","rand "},
{"samplerate","Returns the sampling rate of an audio clip, in Hertz.","Lst(clip)","samplerate(readwav(\"/some/file\"))","bit_depth,channels,channel_data,duration"},
{"sans_factoriser","Option of the plotimplicit command.","Opt."," plotimplicit(x^2+y^2-1,x,y,unfactored); plotimplicit(x^2+y^2-1,[x,y],unfactored); plotimplicit(x^2+y^2+z^2-1,x,y,z,xstep=0.2,ystep=0.2,zstep=0.2,unfactored); plotimplicit(x^2+y^2+z^2-1,[x,y,z],xstep=0.2,ystep=0.2,zstep=0.2,unfactored); plotimplicit(x^2+y^2+z^2-1,x=0..1,y=0..1,z=0..1,xstep=0.2,ystep=0.2,zstep=0.2,unfactored)","plotimplicit"},
{"saute","The turtle takes n steps forward without traces (by default n=10).",""," saute 30;saute(30)","avance,recule"},
{"sauve","To write in the file fich_name the variables and their values.","Str(fich_name),SeqVar","write(\"toto\",a,b,c)","read"},
{"save_history","Save the historic in a file with name str.","","save_history(\"toto.cas\")",""},
{"scalarProduct","Scalar product.","Vect(v1),Vect(v2)","dot([1,2],[3,4]);dot([3,2,4],[3,2,4]);dot([[1,2],[3,4]],[[3,2],[4,5]])","*,cross,.*,hadamard"},
{"scalar_product","Scalar product.","Vect(v1),Vect(v2)","dot([1,2],[3,4]);dot([3,2,4],[3,2,4]);dot([[1,2],[3,4]],[[3,2],[4,5]])","*,cross,.*,hadamard"},
{"scale","Multiplies the row n1 of the matrix A by Xpr.","","scale([[1,2],[3,4],[5,6]],12,0)","rowAdd,scaleadd,mRowAdd"},
{"scaleadd","Multiplies the row n1 of the matrix A by Xpr, then adds it to the row n2.","","scaleadd([[1,2],[3,4],[5,6]],12,0,2)","rowAdd,scale,mRow"},
{"scatterplot","Draws for k=0..nrows, the points (xk,yk) where xk=element row k column 0 and yk=element row k column j (j=1..ncols).","","scatterplot([1,2,3,4,5],[2,0,1,3,5])","polygonplot,polygonscatterplot,listplot"},
{"schur","Matrix reduction to Hessenberg form. Returns [P,B] such that B=inv(P)*A*P:SCHUR(A)=hessenberg(A,-1).","Mtrx(A)","SCHUR([[1,2,3],[4,5,6],[7,8,1]]);SCHUR([[1,2,3,4],[4,5,6,7],[7,8,9,0],[0,1,2,3]])","hessenberg"},
{"sec","Secant: sec(x)=1/cos(x).","","sec(pi/3)","cos,asec"},
{"secant_solver","Argument for fsolve giving the method for solving an numerical equation.","Opt"," fsolve(cos(x)=x,x,0..1,bisection_solver); fsolve(cos(x)=x,x,0..1,brent_solver); fsolve(cos(x)=x,x,0..1,falsepos_solver); fsolve(cos(x)=x,x,0,newton_solver); fsolve(cos(x)=x,x,0,secant_solver); fsolve(cos(x)=x,x,0,steffenson_solver)","fsolve"},
{"segment","segment(A,B) draws the segment AB and segment([xM,yM],[xN,yN]) draws the vector as origin [xM,yM], of coordinates [xN,yN] (i.e draws segment(M,point(M+N)) or Option of the arc command.","","segment(i,1+i);segment(point(i),point(1+i));segment(point(i),point(1+i),A,B);segment([-1,0],[2,1]);segment([-1,0],point([-1,0]+[2,1])); arc(i,1,pi/4,segment); affichage( arc(i,1,pi/4,segment),1+rempli)","line,arc"},
{"seidel_spectrum","Returns the Seidel spectrum of G as a list of lists with two elements, each containing an eigenvalue and its multiplicity.","Graph(G)","seidel_spectrum(graph(\"clebsch\"))","graph_spectrum"},
{"seidel_switch","Returns a copy of G in which the edges between vertices in list V and vertices not in V are inverted (replaced with a set of edges from V to other vertices which is not present in G).","Graph(G),Lst(V)","seidel_switch(cycle_graph(5),[1,2])","neighbors,graph_complement"},
{"select","Selects the elements e of l such that f(e)=true.","","select(x->x>=5,[1,2,6,7]);select(x->isprime(x),range(20)).^2","remove,range"},
{"semi_augment","Returns a matrix made with A and B, with n1+n2 rows and p columns if dim(A)=[n1,p] and dim(B)=[n2,p].","","semi_augment([[68,-21],[56,59],[1,2]],[[68,-21],[56,59]])","augment"},
{"seq","Returns the sequence (2 or 3 arg) or the list (4 or 5 arg) obtained when var go from a to b (step p) in Xpr (or the Xpr is repeated n times or returns the sequence of reals from a to b (step p)).And also seq(expression,variable,liste) is equivanent to map(liste,unapply(expression,variable)) ","","seq(0.3,4);seq(t,4);seq(0,0);seq(2^k,k=0..8);seq(2^k,k=0..8,2);seq(0.3..2,0.2);seq(2^k,k,0,8);seq(2^k,k,0,8,2);seq(x^3,x,[1,2,3]); [seq(0.3..2,0.2)] ; a:=(1,2,3);eval(seq(a,4))","$,makelist,range,map,unapply"},
{"seqplot","For seeing the pth terms of the sequence u(0)=a,u(n)=f(u(n-1)).","Expr(f(Var)),Var=[a,xm,xM],Intg(p)","plotseq(sqrt(2+x),6,5);plotseq(sqrt(2+t),t=6,5);plotseq(sqrt(2+x),x=[6,1,7],5,affichage=epaisseur_ligne_2)","seqsolve,rsolve"},
{"seqsolve","Gives the value of a recurrent sequence (u_{n+1}=f(u_n) or u_{n+k}=f(u_n,u_{n+1}...u_{n+k-1})) or of a system of recurrent sequences.","","seqsolve(2x+n,[x,n],1);seqsolve(2x+n*3^n,[x,n],1);seqsolve(x+y,[x,y,n],[1,1]);seqsolve(x+2*y+n+1,[x,y,n],[0,1]);seqsolve([x+2*y,n+1+x],[x,y,n],[0,1]);seqsolve([x+2*y+n+1,x],[x,y,n],[0,1])","rsolve,plotseq,tableseq"},
{"sequence_graph","Returns an undirected graph with the degree sequence equal to the list L.","Lst(L)","degree_sequence(sequence_graph([3,2,4,2,3,4,5,7]))","degree_sequence,is_graphic_sequence"},
{"series","Series expansion at finite or infinite points.","","series(sin(x)/x,x=0);series(sin(x),x=0,6,polynom);series(ln(x+x^2)-ln(x),x=0,1);series((x^4+x+2)/(x^2+1),x=0,5); series(\"h\",8); ln(1+h);;series(1/(1+x+y),[x,y],[0,0],5) ;series(sin(x*y),[x,y],[1,pi/2],3);series(sin((1+h*t)*(pi/2+k*t)),t=0,3,polynom)(t=1);series(y^2/x^3,[x,y],[1,-1],3);series((-1+k*t)^2/(1+h*t)^3,t=0,3,polynom)(t=1);series(subst(sin(x+y)+cos(y*x),[x,y],h*[x,y]),h=0,6,polynom);series(subst(sin(x+y)+cos(y*x),[x,y],h*[x,y]),h=0,6,polynom)(h=1); truncate(series(sin(x),x=0,6),6)","limit,taylor,pad,polynom,truncate"},
{"set[]","set[] or %{%} is used to define a set.",""," set[1,2,3]; %{1,2,3%}; L:=[1,2,2,3];S:=set[op(L)]; set[1,2]*set[2,3]","in,op"},
{"set_edge_attribute","Stores the attributes to edge e and returns the modified copy of G.","Graph(G),Edge(e),Seq(tag1=value1,tag2=value2,..)","set_edge_attribute(cycle_graph(3),[1,2],\"cost\"=12.4)","discard_edge_attribute,get_edge_attribute,list_edge_attributes"},
{"set_edge_weight","Sets weight of the edge e in the weighted graph G to w and returns the modified copy of G.","Graph(G),Edge(e),Real(w)","set_edge_weight(graph(%{[1,2],[2,3]%}),[1,2],5)","is_weighted,get_edge_weight,make_weighted,weight_matrix"},
{"set_graph_attribute","Stores the attributes where each tag is string, and returns the modified copy of G.","Graph(G),Seq(tag1=value1,tag2=value2,..)","set_graph_attribute(cycle_graph(3),\"name\"=\"cycle graph\")","discard_graph_attribute,get_graph_attribute,list_graph_attributes"},
{"set_pixel","Pixel on and adds to the list of pixel. Run show_pixels() to display","Intg(x),Intg(y),Intg(col)","set_pixel(1,2,red); show_pixels();","clear,show_pixels,draw_line,draw_rectangle,draw_polygon"},
{"set_vertex_attribute","Stores the attributes to vertex v and returns the modified copy of G.","Graph(G),Vrtx(v),Seq(tag1=value1,tag2=value2,..)","set_vertex_attribute(cycle_graph(3),1,\"supply\"=27)","discard_vertex_attribute,get_vertex_attribute,list_vertex_attributes"},
{"set_vertex_positions","Sets the coordinates, given in the list vp, to the vertices of G and returns the modified copy of G.","Graph(G),Lst(vp)"," G:=graph([1,2,3,4,5,6],%{[1,2],[1,4],[4,5],[2,5],[2,3],[3,6],[5,6]%}); G:=set_vertex_positions(G,[[0,0],[0.5,0],[1,0],[0,0.5],[0.5,0.5],[1,0.5]])","draw_graph"},
{"shift","Returns the list where the last element [or the tail beginning with the n-th element] is the first element and then complete with 0 (by default n=-1);L:=shift(L,2) o L.shift(2).","","shift([0,1,2,3],2);shift([0,1,2,3]);shift([0,1,2,3,4]); L:=[0,1,2,3];L:=shift(L,2); L:=[0,1,2,3];L.shift(2)","rotate,tail"},
{"shift_phase","shift_phase returns the expressions where the phase of the evaluated trigonometric expressions is increased by pi/2.","","shift_phase(sin(x));shift_phase('sin(x+pi/2)');shift_phase(x+sin(x));shift_phase(x+sin(x));shift_phase(cos(t));shift_phase(tan(u))","series"},
{"shortest_path","Returns the shortest path from vertex s to vertex t in G. If such path does not exist, returns an empty list. If vector T of vertices from G is given, the list of shortest paths from s to each t int T is returned.","Graph(G),Vrtx(s),Vrtx(t)||Lst(T)","shortest_path(cycle_graph(6),1,5)","dijkstra,vertex_distance"},
{"show","Displays matplotl graph in Python","NULL","show()","clf"},
{"show_pixels","Displays the list of pixels","NULL","show_pixels()","set_pixel,clear"},
{"shuffle","Returns a random permutation of [0,1,2,..,n-1] or of the list L.","Intg(n)||Lst(L)","randperm(4);randperm(7);randperm([1,3,5,7,9]); L:=[1,3,5,7,9];L:=randperm(L); L:=[1,3,5,7,9];L.randperm()","permu2cycles,is_permu,permu2mat"},
{"si","Conditional instruction : (si...alors...sinon...fsi).",""," si alors sinon fsi; n:=1; si n>0 alors triangle_plein(20*n); sinon disque(20*n);fsi;; n:=-1; si n>0 alors triangle_plein(20*n); sinon disque(20*n);fsi;; si x>0 alors x:=x+1; print(\"x est strictement plus grand que 1\");fsi;; si x>0 alors x:=x+1; print(\"x est strictement plus grand que 1\"); sinon x:=x-1;print(\"x est plus petit ou égal à -1\");fsi;","if"},
{"sierpinski_graph","Returns Sierpiński (triangle) graph S(n,k) (resp. ST(n,k)).","Intg(n),Intg(k),[triangle]","sierpinski_graph(2,4);sierpinski_graph(4,3);sierpinski_graph(3,4);sierpinski_graph(3,2);sierpinski_graph(3,3,at_triangle)","graph"},
{"sign","Returns the sign (-1,0,+1) of its argument.","","sign(-4);sign(4-5)","abs"},
{"signature","Returns the signature of a permutation.","","signature([1,0,3,4,2])","permu2cycles,is_permu"},
{"signe","Write the string s with the fount 20 at the point [10,10].","","signe(\"Thomas\");signe(Thomas)","ecris"},
{"similarity","similarity(B,k,a1,A)=transformed of A in the similarity (center B or axis d, coeff k,angle a1) (or also homothety(B,k*exp(i*a1),A)).","","similarity(1+i,2,pi/3,i);similarity(line(x=y,y=z),2,pi/3,point(-1,2,1)); s:=similarity(1+i,2,pi/3);s(i); s:=similarity(line(x=y,y=z),2,pi/3),s(point(-1,2,1))","homothety"},
{"simp2","Returns the list [A/gcd(A,B),B/gcd(A,B)].","","simp2(12,18);simp2(x^3-1,x^2-1)","gcd"},
{"simplex_reduce","Reduction by simplex algorithm to find max(c.x) under A.x<=b and x>=0, b>=0. Returns the maximum, the augmented solution x and the reduced matrix. Accepts also [[A|I|b],[-c|*|0]] as argument.","","simplex_reduce([[3,2,2],[1,1,1]],[3,4],[1,2,3]);simplex_reduce([[3,2,2,1,0,3],[1,1,1,0,1,4],[-1,-2,-3,0,0,0]]);simplex_reduce([[-3,2],[1,1]],[3,4],[1,2]);simplex_reduce([[-3,2,1,0,3],[1,1,0,1,4],[-1,-2,0,0,0]]);simplex_reduce([[2,1,1,1,0,0,2],[1,2,3,0,1,0,5],[2,2,1,0,0,1,6],[-3,-1,-3,1,-1,2,0]])",""},
{"simplifier","Simplifies an expression.","Expr","simplify(4*atan(1/5)-atan(1/239));simplify(texpand((sin(3*x)+sin(7*x))/sin(5*x)));simplify(texpand((cos(3*x)+cos(7*x))/cos(5*x)))","normal"},
{"simplify","Simplifies an expression.","","simplify(4*atan(1/5)-atan(1/239));simplify(texpand((sin(3*x)+sin(7*x))/sin(5*x)));simplify(texpand((cos(3*x)+cos(7*x))/cos(5*x)))","normal"},
{"simpson","Option of the area command",""," area(x^2,x=0..1,5,simpson); area(x^2,x=0..1,5,rombergt); area(x^2,x=0..1,5,rombergm);area(x^2,x=0..1,5,gauss15)","area"},
{"simult","Returns the matrix where the column of index k is solution of A*X=column of index k of B (=B[0..nr-1,k..k] with nr=number of rows of B).","","simult([[3,1],[3,2]],[[-2],[2]]);simult([[3,1],[3,2]],[[-2,1],[2,-1]])","rref,linsolve"},
{"sin","Sine or Option of the convert or convertir command (id trigsin).","","sin(0); convert(cos(x)^4+sin(x)^2,sin)","asin,convert,trigsin"},
{"sin2costan","Replaces sin(x) by cos(x)*tan(x) in the argument.","","sin2costan(sin(x))","tan2sincos,cos2sintan,tan2sincos2,tan2cossin2"},
{"sincos","Transforms the complex exponential into sine and cosine (id exp2trig) or Option of the convert or convertir command (id sincos).","","sincos(exp(i*x));sincos(exp(-i*x)); convert(exp(i*x),sincos)","trig2trig,trig2exp,atrig2ln,convert"},
{"single_inter","Gives one of the intersections of 2 curves or surfaces (or the intersection near A or not in L).","","single_inter(line(i,1-i),line(0,1));single_inter(line(i,1-i),circle(0,1));single_inter(line(i,1+2*i),circle(0,1),[point(i)]);single_inter(line(-1-i,1+2*i),circle(0,1),point(-1));single_inter(circle(1,sqrt(2)),circle(0,1));single_inter(plane(x=y),plane(y=z));single_inter(line(x=y+1,y=2*z),plane(y=z))","intersect,head"},
{"sinh","Hyperbolic sine.","Expr","sinh(0)","asinh"},
{"sinon","Conditional instruction : (si...alors...sinon...fsi).",""," si alors sinon fsi; n:=1; si n>0 alors triangle_plein(20*n); sinon disque(20*n);fsi;; n:=-1; si n>0 alors triangle_plein(20*n); sinon disque(20*n);fsi;; si x>0 alors x:=x+1; print(\"x est strictement plus grand que 1\");fsi;; si x>0 alors x:=x+1; print(\"x est strictement plus grand que 1\"); sinon x:=x-1;print(\"x est plus petit ou égal à -1\");fsi;","if"},
{"size","Returns the size of a list, a string or a sequence.","","size([1,2,3]);size(\"bonjour\");size(1,2,3)","sizes,dim,degree"},
{"sizes","Returns the list of sizes of a list of lists.","","sizes([[1,2,3],[1,2],[1]])","size,dim"},
{"sleep","Pause; in a program stopping its execution (the execution goes on if you press ENTER) [Pause n; stopping its execution during n seconds].",""," Pause 3;;sleep(2)","WAIT"},
{"slope","Returns the slope of the line defined in the argument or is an attribute of line.","","slope(line(1,2i));slope(segment(1,2i));slope(1,2i);slope(line(y+2x=2));slope(point(1),point(2i));slope(tangent(plotfunc(sin(x)),pi/4));slope(LineTan(sin(x),pi/4)); line(point(1,2),slope=-1)","line,tangent,LinTan,slopeatraw,slopeat"},
{"slopeat","slopeat(d,z0) displays at the point(z0), with a legend, the value of the slope of the line or segment d.",""," A:=point(0);B:=point(1+i);slopeat(droite(A,B),(1+i)/2); s:=segment(1-i,i);slopeat(s,point(0.4)); t:=tangent(plotfunc(sin(x)),pi/4);slopeat(t,0)","slope,slopeatraw"},
{"slopeatraw","slopeatraw(d,z0) displays at point(z0), the value of the slope of the line or segment d.",""," A:=point(0);B:=point(1+i);slopeatraw(droite(A,B),(1+i)/2); s:=segment(1-i,i);slopeatraw(s,point(0.4));slopeatraw(tangent(plotfunc(sin(x)),pi/4),0);slopeatraw((LineTan sin(x),pi/4),i)","slope,slopeat"},
{"smith","Smith normal form of a matrix with  polynomial coefficients : returns U,D,V such that U and V invertible, D diagonal, and U*A*V=D.",""," n:=10; A:=ranm(n,n) % 17; U,D,V:=smith(x*idn(n)-A);normal(U*(x*idn(n)-A)*V-D); diag(D);; GF(3,5,g); n:=3; A:=ranm(n,n,g); U,D,V:=smith(x*idn(n)-A);normal(U*(x*idn(n)-A)*V-D); diag(D);","hermite,ismith,ihermite"},
{"smith","Returns the Smith normal form of a polynomial coefficients matrix (U,D,V tels que U*A*V=D)","Matr(A)"," n:=10; a:=ranm(n,n) % 17; u,b,v:=smith(x-a);normal(u*(x-a)*v-b); diag(b);; GF(3,5,g); n:=3; a:=ranm(n,n,g); u,b,v:=smith(x-a);normal(u*(x-a)*v-b); diag(b);","hermite,ismith,ihermite"},
{"smod","Returns the Euclidean symmetric remainder of two integers.","","smod(8,3);smod(10,4);smod(11,7)","irem,iquo,mod,fracmod"},
{"snedecor","Returns the density of probability of the Fisher-Snedecor law (n and m are the numbers of degrees of freedom).","Intg(n),Intg(m),Real(x0)","fisher(4,10,2.1);fisher(4,4,2.1); randvector(5,fisher,4,6); ranm(2,3,fisher,4,6)","fisher_cdf,fisher_icdf,randvector,ranm"},
{"snedecor_cdf","Returns the probability that a Fisher-Snedecor random variable is lower than x0 (n and m are the numbers of degrees of freedom).","Intg(n),Intg(m),Real(x0)","fisher_cdf(4,4,2.1);fisher_cdf(4,10,3.5)","UTPF,fisher_icdf,fisherd"},
{"snedecor_icdf","Returns h such as the probability that a Fisher-Snedecor random variable is lower than h is p (n and m are the numbers of degrees of freedom and 0<=p<=1).","Intg(n),Intg(m),Real(p)","fisher_icdf(4,10,0.95);fisher_icdf(4,10,0.05)","fisher_cdf,fisherd"},
{"snedecord","Returns the density of probability of the Fisher-Snedecor law (n and m are the numbers of degrees of freedom).","Intg(n),Intg(m),Real(x0)","fisher(4,10,2.1);fisher(4,4,2.1); randvector(5,fisher,4,6); ranm(2,3,fisher,4,6)","fisher_cdf,fisher_icdf,randvector,ranm"},
{"snedecord_cdf","Returns the probability that a Fisher-Snedecor random variable is lower than x0 (n and m are the numbers of degrees of freedom).","Intg(n),Intg(m),Real(x0)","fisher_cdf(4,4,2.1);fisher_cdf(4,10,3.5)","UTPF,fisher_icdf,fisherd"},
{"snedecord_icdf","Returns h such as the probability that a Fisher-Snedecor random variable is lower than h is p (n and m are the numbers of degrees of freedom and 0<=p<=1).","Intg(n),Intg(m),Real(p)","fisher_icdf(4,10,0.95);fisher_icdf(4,10,0.05)","fisher_cdf,fisherd"},
{"solid_line","Option of the display command for a line.","Opt"," display(line(y=x),green+dash_line+line_width_2); d:=display(line(2+i,1),cap_round_line)","display"},
{"solve","Solves a (or a set of) polynomial equation (Xcas) or a linear system (Python, numpy).","","solve([[1,2],[3,4]],[5,6]);solve(x^2-3=1,x);solve([y-z=0,z-x=0,x-y=0,x-1+y+z=0],[x,y,z]);solve([x^2-y^2=0,x^2-z^2=0],[x,y,z])","linsolve,proot,fsolve,csolve,nSolve"},
{"somme","Discrete sum (with 2 or 4 arguments return then sum from a to b if a<=b or of the opposite of the sum from b+1 to a-1 if a>b+1 or 0 if a=b+1) or the discrete primitive or sum of the elements of a list or a sequence.","Expr,Var,VarMin(a),VarMax(b),[VarStep(p)]","sum(1/n^2,n,1,17);sum(1/n^2,n=1..17);sum(1/n^2,n,17,1);sum(1/n^2,n=17..1);sum(1/n^2,n,17,1,1);sum(1/n^2,n,1,17,2);sum(1,2,3,4);sum([[1,2,3,4,5,6,7,8,9],[1,2,3,4,5,6,7,8,9]]);sum(1/(x*(x+1)),x);sum(cos(n*x),n)","+"},
{"sommet","Returns the sommet of an operator.","","sommet(quote(gcd(45,123)));sommet('gcd(45,123)')","feuille,quote"},
{"sort","Returns the sorted list (or sequence) with increasing order according with the second argument which defines an weak strict ordering or sort and collect equal terms in sums and products.","","sort([3,2,2,4,1,0]);sort(3,2.1,2,4,1,0);sort([3,4,2],(x,y)->x>y);sort([[1,2],[2,3],[4,3]],(x,y)->when(x[1]==y[1],x[0]>y[0],x[1]>y[1]));sort(y*x*2+x*y)","SortA,SortD"},
{"sorta","Sorts the lists with increasing order or the first matrix row with increasing order and with the same columns.","","sorta(3,4,2);sorta([3,4,2]);sorta([[3,4,2],[6,4,5]])","SortA,sortd,sort"},
{"sortd","Sorts the lists with decreasing order or the first matrix line with decreasing order and with the same columns.","","sortd(3,4,2);sortd([3,4,2]);sortd([[3,4,2],[6,4,5]])","SortD,sorta,sort"},
{"sorted","Returns the sorted list (or sequence) with increasing order","LstReal or Seq [Fnc]","sorted([3,2,2,4,1,0]);sorted([3,4,2],(x,y)->x>y);sort([[1,2],[2,3],[4,3]],(x,y)->when(x[1]==y[1],x[0]>y[0],x[1]>y[1]));sort(y*x*2+x*y)","SortA,SortD"},
{"soundsec","Generates a vector coding n seconds of time/N (default N=44100).","","soundsec(1);soundsec(1,22100)","readwav,writewav,playsnd"},
{"spanning_tree","Returns a spanning tree of undirected graph G [with the vertex r as the root node].","Graph(G),[Vrtx(r)]","spanning_tree(graph(\"petersen\"));spanning_tree(graph(\"petersen\"),5)","number_of_spanning_trees,minimal_spanning_tree"},
{"sphere","sphere(A,B) (resp sphere(A,r)) draws the sphere of diameter AB (resp center A and radius r) in the space 3D.","","sphere([0,0,0],[2,2,2]);sphere([1,1,1],1)","circle"},
{"spline","Natural spline through the points given by the lx and ly lists, variable x, degree d.","","spline([0,1,2],[1,3,0],x,3)","lagrange"},
{"split","Splits the two variables var1,var2 of the expression Xpr (without denominator) or returns [0].","","split(x^3*y^2-y^2+x^3-1,[x,y]);split(x^3*y^2-y^2+x^3+1,[x,y])","factor"},
{"spring","Option for the draw_graph command.","Opt","","planar,tree,draw_graph"},
{"sq","Is the name of the function (ℝ^n -> ℝ)=sum of the square of the arguments.","","sq(5);sq(1,2,3)","sqrt"},
{"sqrfree","Factorization of the its argument gathering the terms with the same exponent.","","sqrfree(x^4-2*x^2+1);sqrfree((x-2)^7*(x+2)^7*(x^4-2*x^2+1))","factor"},
{"sqrt","Square root.","","sqrt(50);sqrt(x^2)","surd,^"},
{"square","Returns and draws the square of side AB (ABCD is direct) (in the plane ABP.","","square(i,1+i);square(i,1+i,C,D);square(point(0,0,0),point(3,3,3),point(0,0,3));square(point(0,0,0),point(3,3,3),point(0,0,3),C,D)","rhombus,quadrilateral"},
{"square_point","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"srand","srand returns an integer and initialize the sequence of random numbers.","","srand(12); srand","RandSeed"},
{"sst","Step 1 instruction.","","sst()",""},
{"sst_in","Enter into a function in step-by-step mode.","","sst_in()",""},
{"st_ordering","Returns ST numbering for the biconnected graph G with source s and sink (target) t.","Graph(G),Vrtx(s),Vrtx(t)","st_ordering(graph(\"petersen\"),1,2)","is_biconnected"},
{"stack","Reserved word.","","",""},
{"star_graph","Returns the complete bipartite graph complete_graph(1,n).","Intg(n)","star_graph(5)","complete_graph,wheel_graph"},
{"star_point","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"start","RPN loop.","","",""},
{"stdDev","Returns an unbiaised estimate of the population standard deviation of the sample (first argument) with an optional list of pounds as second argument.","Lst||Mtrx,[Lst]","stddevp([1,2,3]);stddevp([1,2,3],[1,2,1]);stddevp([[1,2,3],[5,6,7]])","mean,stddev"},
{"stddev","Returns the standard deviation of the elements of its argument with an optional second argument as pound or the list of standard deviation of the columns of a matrix.","","stddev([1,2,3]);stddev([1,2,3],[1,2,1]);stddev([[1,2,3],[5,6,7]])","mean,variance,stddevp"},
{"stddevp","Returns an unbiaised estimate of the population standard deviation of the sample (first argument) with an optional list of pounds as second argument.","","stddevp([1,2,3]);stddevp([1,2,3],[1,2,1]);stddevp([[1,2,3],[5,6,7]])","mean,stddev"},
{"steffenson_solver","Argument for fsolve giving the method for solving an numerical equation.","Opt"," fsolve(cos(x)=x,x,0..1,bisection_solver); fsolve(cos(x)=x,x,0..1,brent_solver); fsolve(cos(x)=x,x,0..1,falsepos_solver); fsolve(cos(x)=x,x,0,newton_solver); fsolve(cos(x)=x,x,0,secant_solver); fsolve(cos(x)=x,x,0,steffenson_solver)","fsolve"},
{"step","Step in an iteration (step size of incrementation).",""," s:=0;for j from 1 to 10 step 2 do s:=s+j end_for; s:=0;for j from 1 step 2 to 10 do s:=s+j end_for; s:=0;for j from 1 to 10 by 2 do s:=s+j end_for; s:=0;for j from 1 by 2 to 10 do s:=s+j end_for; s:=0;pour j de 1 jusque 10 pas 2 do s:=s+j fpour; s:=0;pour j de 1 pas 2 jusque 10 do s:=s+j fpour","for,pour"},
{"stereo2mono","Returns an audio clip with all channels in the input clip downmixed to a single one.","Lst(clip)","stereo2mono(readwav(\"/some/file\"))","channel_data,mean,createwav"},
{"sto","Store the first argument in the variable given as second argument.","","sto(2,a);sto(\"salut\",b)",":=,=>"},
{"str","Returns the evaluated expression as a string or Option of the convert or convertir command (id string).","Expr or Opt","string(1.23);string(a:=12);string(quote(a:=12)); convert(quote(a:=12),string)","expr,format,convert"},
{"string","DOM_STRING or string is the type of a string, as returned by the type command. It is also an option of the assume command.",""," a:=\"123\";type(a); assume(a,DOM_STRING)","type,assume,DOM_INT,DOM_FLOAT"},
{"string","Returns the evaluated expression as a string or Option of the convert or convertir command (id string).","Expr or Opt","string(1.23);string(a:=12);string(quote(a:=12)); convert(quote(a:=12),string)","expr,format,convert"},
{"strongly_connected_components","Returns the list of strongly connected components in digraph G.","Graph(G)","strongly_connected_components(digraph([1,2,3],%{[1,2],[1,3],[2,3],[3,2]%}))","connected_components,is_connected,is_strongly_connected"},
{"student","Returns the density of probability of the Student law (n is the number of degrees of freedom).","","student(3,5.2);student(1,5.2)","student_cdf,student_icdf"},
{"student_cdf","Returns the probability that a Student random variable is lower than x0 (n is the number of degrees of freedom).","","student_cdf(3,2.35);student_cdf(3,-3.2)","UTPT,student_icdf,studentd"},
{"student_icdf","Returns h such as the probability that a Student random variable is lower than h is p (n is the number of degrees of freedom and 0<=p<=1).","","student_icdf(3,0.95);student_icdf(3,0.05)","student_cdf,studentd"},
{"studentd","Returns the density of probability of the Student law (n is the number of degrees of freedom).","Intg(n),Real(x0)","student(3,5.2);student(1,5.2)","student_cdf,student_icdf"},
{"studentt","T-Test/Student law: arg1=[success,trial] or [mean,sample size] or data, arg2=proportion or data, arg3 optional if data=sigma, arg4 alternative '!=' or '>' or '<', arg5 optional alpha confidence level.","","studentt([10,20],.5,.02,'!=',0.1);studentt([0.48,20],0.5,0.1,'<')","normalt,chisquaret,kolmogorovt"},
{"sturm","Sturm sequence corresponding to a polynomial or number of sign changes of this polynomial in ]a;b].","","sturm(x^3-1,x);sturm(x^5-x^3,x);sturm((x^5-x^3)/(x+2),x);sturm(x^5-x^3,x,-2,5);sturm(x^3-1,x,-2-i,5+3i)","sturmseq,sturmab"},
{"sturmab","Number of sign changes of a polynomial in ]a;b] or of complex roots in a..b if a or b is non-real.","","sturmab(x^3-1,x,-2,5);sturmab(x^3-1,x,-2-i,5+3i)","sturm,sturmseq,realroot"},
{"sturmseq","Sturm sequence corresponding to a polynomial or to a rational fraction.","","sturmseq(x^3-1,x);sturmseq(x^5-x^3,x);sturmseq((x^5-x^3)/(x+2),x)","sturm,sturmab"},
{"style","Local option (Maple compatibility) of a graphic command to plot a line with dots with style=point.",""," segment(0,point(1,1),style=point); line(y=x,style=point,display=green+line_width_2)","line_width"},
{"subMat","Extracts a sub matrix with first element=A[n1,n2] and last element=A[n3,n4].","","subMat([[1,2],[3,4],[5,6]],1,0,2,1)","mid"},
{"sub","subtract 2 matrices (Python, linalg)","A,B","sub([1,2],[3,4]);sub([[1,2],[3,4]],[[5,6],[7,8]])","+"},
{"subdivide_edges","Inserts r (by default 1) new vertices to each edge/arc in G contained in the list E (which may be a single edge/arc) and returns the modified copy of G. New vertices are labelled with smallest available integers.","Graph(G),Lst(E),[Intg(r)]","subdivide_edges(complete_graph(2,3),[[1,3],[1,4]],2)","edges"},
{"subgraph","Returns the subgraph of G defined by the edges in list E.","Graph(G),Lst(E)","subgraph(complete_graph(5),[[1,2],[2,3],[3,4],[4,1]])","induced_subgraph,highlight_subgraph"},
{"subs","Equivalent of subst except in maple_mode where the arguments are switched over, in maple_mode choose the second example.","","subs(1/(4+x^2),x=2);subs(x=2,1/(4+x^2)); f:=1/(4+x^2);f(x=2)","subst,maple_mode,algsubs,()"},
{"subsop","Replaces in the list (or the matrix) the element of index n with the expression (with Maple the arguments are switched over)(NULL remove this element).","","subsop([0,1,2,3,4],2=sqrt(2)+1);subsop([[1,2],[3,4]],[1,1]=5);subsop([[1,2],[3,4]],1=[10,8]);subsop([0,1,2,3],'1=NULL')",""},
{"subst","Substitutes a value for a variable in an expression.","","subst(1/(4+x^2),x=2);subst(1/(x^2+y^2),x=2,y=3);subst(1/(x^2+y^2+z^2),[x=2,y=3,z=1]);subst(x-2/(4+x^2),x=1);subst('integrate(sin(x^2)*x,x)',x=sqrt(t));subst('sum(x^(n+1)/((n+p+1)*(n+1)),n,0,inf)',n=k-1); f:=1/(x^2+y^2;f(x=2,y=3)","eval,algsubs,subs,()"},
{"substituer","Substitutes a value for a variable in an expression.","Expr,Var(v)=value(a)","subst(1/(4+x^2),x=2);subst(1/(x^2+y^2),x=2,y=3);subst(1/(x^2+y^2+z^2),[x=2,y=3,z=1]);subst(x-2/(4+x^2),x=1);subst('integrate(sin(x^2)*x,x)',x=sqrt(t));subst('sum(x^(n+1)/((n+p+1)*(n+1)),n,0,inf)',n=k-1); f:=1/(x^2+y^2;f(x=2,y=3)","eval,algsubs,subs,()"},
{"subtype","Returns 1 for a sequence,2 for a set, 10 for a polynomial and 0 otherwise.","","subtype(1,2,3);subtype(set[1,2,3]);subtype(poly1[1,2,3]);subtype([1,2,3])","DOM_LIST,type"},
{"sum","Discrete sum (with 2 or 4 arguments return then sum from a to b if a<=b or of the opposite of the sum from b+1 to a-1 if a>b+1 or 0 if a=b+1) or the discrete primitive or sum of the elements of a list or a sequence.","","sum(1/n^2,n,1,17);sum(1/n^2,n=1..17);sum(1/n^2,n,17,1);sum(1/n^2,n=17..1);sum(1/n^2,n,17,1,1);sum(1/n^2,n,1,17,2);sum(1,2,3,4);sum([[1,2,3,4,5,6,7,8,9],[1,2,3,4,5,6,7,8,9]]);sum(1/(x*(x+1)),x);sum(cos(n*x),n)","+"},
{"sum_riemann","Returns an equivalent when var1=+infinity of the sum of Xpr(var1,var2) for var2 from 1 to var1 when the sum is a sum of Riemann.","","sum_riemann(1/(n+k),[n,k]);sum_riemann(n/(n^2+k),[n,k]);sum_riemann(n/(n^2+k^2),[n,k])",""},
{"suppress","Returns L without the element of index n; L:=suppress(L,n) or L.suppress(n).","","suppress([0,1,2,3],2);suppress(\"0123\",2); L:=[0,1,2,3];L:=suppress(L,2); L:=[0,1,2,3];L.suppress(2)","tail,mid,remove,insert"},
{"surd","Power 1/n.","","surd(8,3);surd(-8,3)","sqrt,^"},
{"svd","For a square numerical real matrix A, returns U orthogonal, S vector of singular values, Q orthogonal such that A=U*diag(S)*tran(Q).","","svd([[1,2],[3,4]])",""},
{"swapcol","Returns the matrix get from A by swapping the n1-th column and the n2-th column.","Mtrx(A),Intg(n1),Intg(n2)","colSwap([[1,2],[3,4],[5,6]],0,1)","rowSwap"},
{"swaprow","Returns the matrix get from A by swapping the n1-th row and the n2-th row.","Mtrx(A),Intg(n1),Intg(n2)","rowSwap([[1,2],[3,4],[5,6]],1,2)","rowAdd,colSwap"},
{"switch","Test (multiple choice): switch(variable) {case 1: {bloc1;} default: {bloc2;}};",""," a:=1;switch(a){case 0:{b:=1;break;} case 1:{b:=3;break;}default:{b:=0;}};b;; f(x):={local y;switch (x){case 1:{return \"un\";} case 2:{y:=\"deux\";break;}default:{y:=\"default\";}};return(y);}","if,case,default"},
{"switch_axes","switch_axes() put or erase the axes of the graphic-screen.","","switch_axes();switch_axes(0);switch_axes(1)","gl_showaxes,axes"},
{"sylvester","Sylvester matrix of two polynomials.","","sylvester(x^2-1,x^3-1,x);sylvester(x^3-p*x+q,3*x^2-p,x)","resultant"},
{"symb2poly","Returns the coefficients of a polynomial with respect to the 2nd argument or if the second argument is a list the internal format of the polynomial.","","symb2poly(x*3+2.1);symb2poly(3*x*y+2*y+1,y);symb2poly(3*x*y+2*y+1,x,y);symb2poly(3*x*y+2*y+1,[x,y]);symb2poly(-x^4+x*3*y+2+y^2*z,[x,y,z]);symb2poly(-x^4+x*3*y+2+y^2*z,[x,y,z])","poly2symb,r2e"},
{"symbol","DOM_SYMBOLIC or symbol is the type of a symbolic variable, as returned by the type command. It is also an option of the assume command.","Opt"," assume(a,symbol); assume(a,DOM_SYMBOLIC); a:=sqrt(2);type(a); type(2x+1)","type,assume,DOM_INT,DOM_FLOAT"},
{"syst2mat","Returns the matrix M=A|(-b) associate to the system Y=AX+b.","","syst2mat([x-y=1,x+2*y],[x,y])","linsolve,rref"},
{"tCollect","Collect trigonometric expressions.","Expr","tcollect(sin(x)+cos(x))","texpand,tlin"},
{"tExpand","Expand transcendental expressions.","Expr","texpand(sin(2*x)+exp(x+y));texpand(cos(x+y));texpand(cos(3*x))","tcollect,tlin,lin,trigexpand"},
{"table","Defines an array where the index are strings or real numbers or defines a table with a matrix.","","table(3=-10,\"a\"=10,\"b\"=20,\"c\"=30,\"d\"=40); A:=[[0,1],[2,3]];table(A)  ; B:=table([1,2]=12,[2,5]=25);matrix(B)","matrix,convert,array"},
{"tablefunc","Table of value of a function : you must be in a spreadsheet.","","tablefunc(sin(x),x);tablefunc(x^2-x-2,x)","tabvar,tableseq"},
{"tableseq","Table of value of a sequence (in a spreadsheet.)","","tableseq(cos(x),x,0.0);tableseq(x+y,[x,y],[1,1])","tablefunc"},
{"tabvar","Table of variations of a function with its graph on DispG.","","tabvar(sin(x),x);tabvar(1/ln(x^2-1),x,diff=1);tabvar(x^2+x+1,x);tabvar(x^2,x,-3,5);tabvar([sin(2t),cos(3t)])","tablefunc"},
{"tail","Returns the list (or sequence or string) without its first element.","","tail([3,2,4,1,0]);tail(3,2,4,1,0);tail(\"bonjour\")","head,mid,left,right,back"},
{"tan","Tangent or Option of the convert or convertir command (id halftan)","","tan(0);tan(pi/4); convert(tan(x),tan)","atan or Opt,convert,halftan"},
{"tan2cossin2","Replaces tan(x) by (1-cos(2*x))/sin(2*x) in the argument.","","tan2cossin2(tan(x))","tan2sincos2,tan2sincos,sin2costan,cos2sintan"},
{"tan2sincos","Replaces tan(x) by sin(x)/cos(x) in the argument.","","tan2sincos(tan(x))","sin2costan,cos2sintan,tan2sincos2,tan2cossin2"},
{"tan2sincos2","Replaces tan(x) by sin(2*x)/(1+cos(2*x)) in the argument.","","tan2sincos2(tan(x))","tan2cossin2,tan2sincos,sin2costan,cos2sintan"},
{"tangent","tangent(C,A) draws the tangents (line or plane) to C through A.","","tangent(circle(i,1+i),A);tangent(plotfunc(sin(x)),3*pi/4);tangent(plotfunc(sin(x)),point(3*pi/4+i*sqrt(2)/2));tangent(plotfunc(x^2+y^2,[x,y]),[2,2]);tangent(plotfunc(x^2+y^2,[x,y]),point([2,2,8]));tangent(plotparam(3*exp(t/2)*exp(i*t),t),7);tangent(plotpolar(3*exp(t/2),t),7); equation(tangente([2*cos(t),2*sin(t),3*t],t))","LineTan,droite_tangente"},
{"tangente","tangent(C,A) draws the tangents (line or plane) to C through A.","Curve(C),Pnt(A)","tangent(circle(i,1+i),A);tangent(plotfunc(sin(x)),3*pi/4);tangent(plotfunc(sin(x)),point(3*pi/4+i*sqrt(2)/2));tangent(plotfunc(x^2+y^2,[x,y]),[2,2]);tangent(plotfunc(x^2+y^2,[x,y]),point([2,2,8]));tangent(plotparam(3*exp(t/2)*exp(i*t),t),7);tangent(plotpolar(3*exp(t/2),t),7); equation(tangente([2*cos(t),2*sin(t),3*t],t))","LineTan,droite_tangente"},
{"tanh","Hyperbolic tangent.","","tanh(0);hyp2exp(tanh(1))","atanh,hyp2exp"},
{"tantque","Loop tantque (tantque...faire...ftantque;).",""," tantque faire ftantque; n:=1;tantque n<5 faire triangle_plein(10*n);saute(10*n);n:=n+1;ftantque; n:=4;tantque n>0 faire triangle_plein(10*n);saute(10*n);n:=n-1;ftantque; pgcd(a,b):={local r;tantque (b!=0) faire r:=irem(a,b);a:=b;b:=r;ftantque;return a};; quoreste(a,b):={local q:=0;tantque (a>=b) faire a:=a-b;q:=q+1;ftantque; return q,a};","while,pour"},
{"taux_accroissement","Returns the rate of increment of an expression when the variable go from Val1 to Val2 (by default Var=x).","","taux_accroissement(x^2,1,1+h);taux_accroissement(x^2,1,2);taux_accroissement(a^2,a,1,1+h)","diff,limit"},
{"taylor","Series expansion at finite or infinite points (by default x=0, and relative order=5).","","taylor(sin(x)/x,x,0);taylor(sin(x),x=0,5,polynom);taylor(ln(y+y^2)-ln(y),y);taylor(ln(x+x^2)-ln(x),x,2);taylor(ln(x+x^2)-ln(x),x=0,2);taylor(ln(x+x^2)-ln(x),x=1,2);taylor((x^4+x+2)/(x^2+1),x,5);taylor(sin(t*x+t*y)+cos(t*x*t*y),t=0,6,polynom)(h=1) ;taylor(sin((1+h*t)*(pi/2+k*t)),t=0,3,polynom)(t=1);taylor((-1+k*t)^2/(1+h*t)^3,t=0,3,polynom)(t=1)","series,limit,pade,polynom"},
{"tchebyshev1","Returns the n-th Tchebyshev polynomial of first sort.","","tchebyshev1(3)","tchebyshev2,hermite"},
{"tchebyshev2","Returns the nt-h Tchebyshev polynomial of second sort.","","tchebyshev2(3)","tchebyshev1,hermite"},
{"tcoeff","Returns the coefficient of the term of lowest degree of a polynomial (t=trailing).","","tcoeff(-2*x^3+x^2+7*x);tcoeff([-2,1,7,0])","lcoeff"},
{"tcollect","Collect trigonometric expressions.","","tcollect(sin(x)+cos(x))","texpand,tlin"},
{"tdeg","Option of the gbasis or greduce command to specify an order for monomials (complete degree then lexicographic order).","","","gbasis,greduce"},
{"tensor_product","Returns the tensor product of the input graphs G1, G2, ... with vertices labelled as \"u:v:...\" where u, v, ... are vertices from G1, G2, ..., respectively.","Seq(G1,G2,..)","tensor_product(graph(trail(1,2,3,4,5,2)),star_graph(3))","cartesian_product"},
{"test","Test function for system developers.","","test(x)",""},
{"tetrahedron","Draws the regular direct pyramid ABCD with vertices A,B and a face in the plan (A,B,C) when there is 3 arguments et the pyramid ABCD when there is 4 arguments.","Pnt(A),Pnt(B),Pnt(C),[Pnt(D)]","pyramid([0,0,0],[3,0,0],[0,1,0]);pyramid([0,0,0],[3,0,0],[0,3,0],[0,0,4])","cube,cylinder,icosahedron,dodecahedron,octahedron"},
{"texpand","Expand transcendental expressions.","","texpand(sin(2*x)+exp(x+y));texpand(cos(x+y));texpand(cos(3*x))","tcollect,tlin,lin,trigexpand"},
{"text","Legend at x,y","","text(1,2,\"txt\")",""},
{"textinput","Instruction in a program so that you can input a string and store it in var.","[Str],Var(Var)","InputStr(\"nom?\",N)","input"},
{"then","Used in a test if: if (condition) then instruction; end_if;",""," if (a<0) then a:=-a; end_if;","if"},
{"thickness","Option (Maple compatibility) of a graphic command to define the thickness of lines.",""," segment(0,point(1,1),thickness=5); segment(0,point(1,1),epaisseur=5)","line_width"},
{"thiele","computes rational interpolation for the given list of points using Thiele's method with continued fractions","[Data || Data_x],[Data_y],v "," data_x:=[-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1,1.25,1.5,1.75,2]:;data_y:=[0.0,2.83341735599,2.88770329586,2.75030303645,2.71828182846,2.66568510781,2.24894558809,1.21863761951,0.0,-0.555711613283,-0.377871362418,-0.107135851128,-0.0136782294833]:;thiele(data_x,data_y,x)",""},
{"threshold","Performs thresholding operations on a list of real or complex numbers.","Lst,Real(bound)[=Expr(repl)] or Lst[Real(lower)[=Expr(rl)],Real(upper)[=Expr(ru)]],[Fnc(compare)],[abs[=true or false]]","threshold([1,3,2,4,5,4,3,2,3,1],3,'>=');threshold([-10,-5,0,5,10],7=a,abs=true)","max,min"},
{"throw","Generates the display of an error in a program","Str","error(\"Argument should be integer\");error(\"je provoque une erreur\")","try,catch"},
{"time","Returns the time to compute a command or from the beginning of the session.","","time(factor(x^10-1));time()",""},
{"title","Global option of a graphic command to put a title in a graphic.",""," title=\"segment\";segment(0,point(1,1),epaisseur=5); titre=\"segment\";segment(0,point(1,1),epaisseur=5)","line_width"},
{"titre","Global option of a graphic command to put a title in a graphic.","Opt"," title=\"segment\";segment(0,point(1,1),epaisseur=5); titre=\"segment\";segment(0,point(1,1),epaisseur=5)","line_width"},
{"tlin","Trigonometric linearization","","tlin(sin(x)^3);tlin(cos(x)*cos(y))","texpand,lin"},
{"to","Used in a loop for (for...from ...to... [step...] do...od;).",""," pour de jusque [pas] faire fpour;; S:=0;pour n de 1 jusque 4 faire S:=S+n;fpour;; S:=0;for n from 1 to 4 do S:=S+n;end;; S:=0;pour n de 4 jusque 1 pas -1 faire S:=S+n;fpour;","for,pour,de,from"},
{"tonnetz","Returns the graph corresponding to the [a,b,c] resp. [a,b,c,d] tone network (tonnetz) used in neo-Riemannian music theory.","Intg(a),Intg(b),Intg(c),[Intg(d)]","tonnetz(3,4,5);tonnetz(2,3,3,4)","is_regular,clique_stats"},
{"topologic_sort","Returns the list of vertices sorted according to the topological ordering in the directed acyclic graph G.","Graph(G)","topologic_sort(digraph(%{[c,a],[c,b],[c,d],[a,d],[b,d],[a,b]%}))","digraph,is_acyclic"},
{"topological_sort","Returns the list of vertices sorted according to the topological ordering in the directed acyclic graph G.","Graph(G)","topologic_sort(digraph(%{[c,a],[c,b],[c,d],[a,d],[b,d],[a,b]%}))","digraph,is_acyclic"},
{"torus_grid_graph","Returns a torus grid graph on m*n vertices, where m,n>=3.","Intg(m),Intg(n)","torus_grid_graph(6,12)","grid_graph"},
{"total_degree","Total degree of the polynomial P with respect to the second argument.","Poly(P),Lst(Vars)","total_degree(x^3*y+x*y,[x,y])","valuation,size,degree"},
{"tourne_droite","The turtle turns right of n degrees (by default n=90).","","turn_right(60);tourne_droite(60)","tourne_gauche,pas_de_cote"},
{"tourne_gauche","The turtle turns left of n degrees (by defaults n=90).",""," turn_left(60);tourne_gauche(60)","tourne_droite"},
{"tpsolve","solves a transportation problem using MODI method","supply,demand,cost_matrix","tpsolve([12,17,11],[10,10,10,10],[[500,750,300,450],[650,800,400,600],[400,700,500,550]]);tpsolve([7,10,8,8,9,6],[9,6,12,8,10],[[36,40,32,43,29],[28,27,29,40,38],[34,35,41,29,31],[41,42,35,27,36],[25,28,40,34,38],[31,30,43,38,40]]);tpsolve([95,70,165,165],[195,150,30,45,75],[[15,M,45,M,0],[12,40,M,M,0],[0,15,25,25,0],[M,0,M,12,0]]);tpsolve([1,1,1,1],[1,1,1,1],[[10,12,9,11],[5,10,7,8],[12,14,13,11],[8,15,11,9]])",""},
{"trace","Returns the trace of a square matrix or draws the trace of a geometric object when the parameter changes (see Trace in Menu button of a geometric level and write only one instruction on each line).","","trace([[1,2,3],[1,3,6],[2,5,7]]);trace([[1+i,2,3],[1,3,6],[2,5,9-i]]); assume(a=[0.7,-5,5,0.1]);trace(point(a-i*a)); assume(a=[0.7,-5,5,0.1]);trace(inter_unique(droite(y=a*x+a),droite(y=2*a*x+1)))","det,lieu"},
{"trail","Returns a trail of vertices from V (inert command).","Seq(V)","trail(1,2,3,4,1)","graph,digraph"},
{"trail2edges","Converts a trail T to the list of its edges.","Trail(T)","trail2edges(trail(1,2,3,4,1,3));trail2edges([1,2,3,4,1,3])","subgraph,trail"},
{"trames","Option of animate and animate3d commands to give the number of pictures.","Opt"," animate(sin(x*t),x=-pi..pi,t=-3..3,frames=30); animate3d(x^2+t*y^2,[x=-2..2,y=-2..2],t=-3..3,frames=10)","animate,animate3d"},
{"tran","Transposes a matrix (without conjugation).","","tran([[1,2,3],[1,3,6],[2,5,7]]);tran([[1+i,2,3],[1,3,6],[2,5,9-i]]);tran(conj([[1+i,2,3],[1,3,6],[2,5,9-i]]))","conj,trn"},
{"transitive_closure","Returns the [weighted, by default false] transitive closure of G.","Graph(G),[weighted[=true||false]]","transitive_closure(digraph([1,2,3,4,5,6],%{[1,2],[2,3],[2,4],[4,5],[3,5]%}),weighted)","allpairs_distance,is_connected,shortest_path,vertex_distance"},
{"translation","translation(B-A,C) (resp translation([a,b,c],C)) is the translated of C in the translation of vector AB (resp [a,b,c]).","","translation(1+i,i);translation([1,1,1],point([1,2,3])); t:=translation(1+i);t(i); t:=translation([1,1,1]);t(point([1,2,3]))","rotation,reflection"},
{"transpose","Transposes a matrix (without conjugation).","Mtrx","transpose([[1,2,3],[1,3,6],[2,5,7]]);transpose([[1+i,2,3],[1,3,6],[2,5,9-i]]);transpose(conj([[1+i,2,3],[1,3,6],[2,5,9-i]]))","conj,trn"},
{"trapeze","Option of the plotarea command and of the area command.","Opt"," plotarea(x^2,x=0..1,5,trapezoid); plotarea(x^2,x=0..1,5,middle_point); plotarea(x^2,x=0..1,5,right_rectangle); plotarea(x^2,x=0..1,5,left_rectangle); area(x^2,x=0..1,5,middle_point); area(x^2,x=0..1,5,trapezoid)","plotarea,area"},
{"trapezoid","Option of the plotarea command and of the area command.",""," plotarea(x^2,x=0..1,5,trapezoid); plotarea(x^2,x=0..1,5,middle_point); plotarea(x^2,x=0..1,5,right_rectangle); plotarea(x^2,x=0..1,5,left_rectangle); area(x^2,x=0..1,5,middle_point); area(x^2,x=0..1,5,trapezoid)","plotarea,area"},
{"traveling_salesman","Returns a Hamiltonian cycle in an unweighted graph G or solves traveling salesman problem if G is weighted (matrix M can be used for edge weights), returning a sequence containing the minimal cost and the corresponding Hamiltonian cycle.","Graph(G),[Mtrx(M)],[opts]","traveling_salesman(hypercube_graph(5));traveling_salesman(digraph(%{[[1,2],1],[[1,3],2],[[2,3],2],[[2,4],3],[[3,2],3],[[3,4],2],[[4,1],1]%})); M:=randmatrix(4,4,99); traveling_salesman(graph(\"tetrahedron\"),M); G:=set_vertex_positions(complete_graph(42),[randvector(2,1000)$(k=1..42)]); traveling_salesman(G,vertex_distance); G:=set_vertex_positions(complete_graph(120),[randvector(2,1000)$(k=1..120)]); c,T:=traveling_salesman(G,vertex_distance,approx)","is_hamiltonian"},
{"tree","Option for the draw_graph command.","Opt","","planar,spring,draw_graph"},
{"tree_height","Returns the height of the tree graph T with r as the root node.","Graph(T),Vrtx(r)","tree_height(graph(%{[1,2],[2,3],[2,4],[4,5]%}),1)","is_tree,random_tree"},
{"triangle","triangle(A,B,C) draws the triangle ABC","","triangle(point(1+i),1,0);triangle(0,1,1+i);triangle(point(0,0,0),point(3,3,3),point(0,3,3))","equilateral_triangle,isosceles_triangle,right_triangle"},
{"triangle_paper","Draws in the rectangle [xmin..xmax]*[ymin..ymax], the lines of the network built with the lines y=n*uy and in the axes OxY of angle t!=0 with the lines x=n*ux and ux*y+uy*x=n*ux*uy.","","triangle_paper(1,pi/3,sqrt(3)/2);triangle_paper(1,pi/3,sqrt(3)/2,x=-1..4,y=-2..2);papier_triangule(1,pi/3,sqrt(3)/2,x=-2..6,y=-4*sqrt(3)..4*sqrt(3));triangle_paper(0.5,3*pi/4,0.5)",""},
{"triangle_plein","Draws a full direct triangle with sides a,b and with angle t, from the turtle position (by default t=90 or (b=a and t=60)).",""," triangle_plein 30;triangle_plein(30);triangle_plein(30,40);triangle_plein(30,40,60)","rectangle_plein"},
{"triangle_point","Option of the display command for a point.","Opt"," F:=display(point(2+1.5*i),point_point); F:=display(point(2+1.5*i),rhombus_point)","display"},
{"triangle_window","Applies the triangular windowing function with parameter d in {-1,0,1} (by default L=0) to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Intg(d)],[Interval(n1..n2)]"," scatterplot(triangle_window(randvector(1000,0..1),1))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,bartlett_hann_window,tukey_window,welch_window"},
{"trig2exp","Replaces in the argument the trigonometric functions by complex exponentials without linearisation.","","trig2exp(sin(x))","exp2trig,atrig2ln"},
{"trigcos","Simplifies the argument with the formulas sin(x)^2+cos(x)^2=1 and tan(x)=sin(x)/cos(x) privileging cosine.","","trigcos(sin(x)^4+sin(x)^2)","trigsin,trigtan"},
{"trigexpand","Expands trigonometric functions.","","trigexpand(sin(3*x))","texpand,lnexpand,expexpand"},
{"triginterp","Returns a trigonometric polynomial interpolation (with respect to variable x) of the points with ordinate given in list y and the abscissa equally spaced between a and b.","List,Var=xmin..xmax","triginterp([11,10,17,24,32,26,23,19],x=0..21);triginterp([11,10,17,24,32,26,23,19],0,21,x)","lagrange,thiele"},
{"trigsimplify","Simplifies a trigonometric expression.","Expr","trigsimplify(3*sin(x)-4*sin(x)^3)","simplify"},
{"trigsin","Simplifies the argument with the formulas sin(x)^2+cos(x)^2=1 and tan(x)=sin(x)/cos(x) privileging sine.","","trigsin(cos(x)^4+sin(x)^2)","trigcos,trigtan"},
{"trigtan","Simplifies the argument with the formulas sin(x)^2+cos(x)^2=1 and tan(x)=sin(x)/cos(x) privileging tangent.","","trigtan(cos(x)^4+sin(x)^2)","trigsin,trigcos"},
{"trn","Returns the adjoint matrix of A =tran(conj(A)).","","trn([[1,2+i],[3,4]])","tran,conj"},
{"true","boolean equal to true or 1.",""," a:=true","false"},
{"trunc","Truncates value to n decimal places (by default n=0). Accepts complex numbers.(type=DOM_COMPLEX or DOM_FLOAT).","","trunc(4.3);trunc(sqrt(2),3);trunc([4.3333,sqrt(2)]);trunc([4.3333,sqrt(2)],2);trunc(sqrt(2)+i*sqrt(5),4)","fPart,floor,iPart"},
{"truncate","Truncates the polynomial P at order n.","","truncate((x^2+x)^2,3)","series"},
{"truncate_graph","Returns the graph obtained by truncating the biconnected planar graph G.","Graph(G)","truncate_graph(graph(\"tetrahedron\"))","is_biconnected,is_planar,plane_dual"},
{"try","Error protection: try {instructions;} catch(variable) {error_instructions;} (in a program).",""," essai(x):={local y,err;try {y:=[[1,2]]*x;}catch (err){y:=\"erreur fatale:\"+err;} return y;};essai([1,2,3])","throw,catch"},
{"tsimplify","Lower the number of non rational variables.","","tsimplify(exp(2*x)+exp(x))","simplify"},
{"tuer","Stop step-by-step execution of a program (with debug)","NULL","kill()",""},
{"tukey_window","Applies the Tukey windowing function with parameter a in [0,1] (by default a=0.5) to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Real(a)],[Interval(n1..n2)]"," scatterplot(tukey_window(randvector(1000,0..1),0.4))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,bartlett_hann_window,welch_window"},
{"tutte_polynomial","Returns the Tutte polynomial [or its value at point (x,y)] of undirected graph G. If G is weighted, all weights must be positive integers and are interpreted as edge multiplicities.","Graph(G),[Var(x),Var(y)]","tutte_polynomial(graph(\"tetrahedron\"));tutte_polynomial(graph(\"tetrahedron\"),1,1)","chromatic_polynomial,flow_polynomial,reliability_polynomial,delete_edge,contract_edge"},
{"two_edge_connected_components","Returns the list of two-edge-connected components of undirected graph G, each of them represented by the list of its vertices.","Graph(G)","two_edge_connected_components(graph(trail(1,2,3,4,5,3,1),trail(5,6,7,8,6)))","is_two_edge_connected,connected_components"},
{"type","Returns n in [1..12] that define the type of the argument.","","type(\"abc\");type([1,2,3])","DOM_FLOAT,DOM_INT,DOM_COMPLEX,DOM_IDENT,DOM_LIST,DOM_SYMBOLIC,DOM_RAT,DOM_STRING,DOM_FUNC,subtype"},
{"ufactor","Factors a unit in a unit object","","ufactor(100_C,1_A)","convert,mksa,usimplify"},
{"ugamma","Calculus of ugamma function at a point (a,x):if a and x>=0 ugamma(a,x)=int(e^{-t}*t^{a-1},t=x..inf),(ugamma(a,x)+igamma(a,x)=Gamma(a)).","","ugamma(5.0,2.0);ugamma(-5.1,2.1)","Psi,Beta,Gamma,igamma"},
{"unapply","Returns a function defined by an expression.","","unapply(2*x^2,x); f(x):=x*exp(x);g:=unapply(diff(f(x),x),x)","apply"},
{"unarchive","Reads the value of a variable or of a list of variables which are in the file given as argument (file created with archive).","","unarchive(\"toto\");unarchive(\"aa.txt\")","archive,Archive,Unarchiv"},
{"underlying_graph","Returns the graph obtained by stripping directions and weights from arcs (pairs of arcs connecting the same vertices are merged to a single edge).","Graph(G)","underlying_graph(digraph(trail(1,2,3,4,1)))","is_directed,is_weighted,make_directed,make_weighted"},
{"unfactored","Option of the plotimplicit command.",""," plotimplicit(x^2+y^2-1,x,y,unfactored); plotimplicit(x^2+y^2-1,[x,y],unfactored); plotimplicit(x^2+y^2+z^2-1,x,y,z,xstep=0.2,ystep=0.2,zstep=0.2,unfactored); plotimplicit(x^2+y^2+z^2-1,[x,y,z],xstep=0.2,ystep=0.2,zstep=0.2,unfactored); plotimplicit(x^2+y^2+z^2-1,x=0..1,y=0..1,z=0..1,xstep=0.2,ystep=0.2,zstep=0.2,unfactored)","plotimplicit"},
{"uniform","Returns the density of probability at x of the uniform law on [a,b].","","uniform(2,5,4);uniform(1.2,3.5,3); randvector(3,uniform,1.2,3.5); ranm(4,3,uniform,1.2,3.5)","uniform_cdf,uniform_icdf,randvector,ranm"},
{"uniform_cdf","Returns the probability that a uniform random variable on [a,b] is lower than x0 (or between x0 and y0).","","uniform_cdf(3.2,5.7,4.4);uniform_cdf(3.2,5.7,4.4,5.4)","uniformd,uniform_icdf"},
{"uniform_icdf","Returns h such that the probability that a uniform random variable on [a,b] is lower than h is p (0<=p<=1).","","uniform_icdf(4.2,10.3,0.95);uniform_icdf(3.2,5.7,0.48)","uniform_cdf,uniformd"},
{"uniformd","Returns the density of probability at x of the uniform law on [a,b].","Real(a),Real(b),Real(x)","uniform(2,5,4);uniform(1.2,3.5,3); randvector(3,uniform,1.2,3.5); ranm(4,3,uniform,1.2,3.5)","uniform_cdf,uniform_icdf,randvector,ranm"},
{"uniformd_cdf","Returns the probability that a uniform random variable on [a,b] is lower than x0 (or between x0 and y0).","Real(a),Real(b),Real(x0),[Real(y0)]","uniform_cdf(3.2,5.7,4.4);uniform_cdf(3.2,5.7,4.4,5.4)","uniformd,uniform_icdf"},
{"uniformd_icdf","Returns h such that the probability that a uniform random variable on [a,b] is lower than h is p (0<=p<=1).","Real(a),Real(b),Real(p)","uniform_icdf(4.2,10.3,0.95);uniform_icdf(3.2,5.7,0.48)","uniform_cdf,uniformd"},
{"union","union is an infixed operator to get the union of 2 sets.",""," [1,2,3] union [2,5,6]; %{1,2,3%} union %{2,5,6%}","minus,intersect"},
{"unitV","Returns the vector divided by its l2norm. It is also an option for plotfiefd.","Lst||Cplx","normalize(3+4*i);normalize([3,4]); fieldplot(-t*y,[t,y],normalize); fieldplot(-t*y,[t,y],normalize,xstep=0.5,ystep=0.5)","l2norm"},
{"unquote","Evaluates an quoted expression (for example purge(c);a:=c;unquote(a):=3; put 3 in the variables a and c).","","unquote(a)","quote"},
{"until","Loop repeat (repeat the instructions until cond==true): repeat i1;i2; until cond; or repeter i1;i2;jusqua cond;",""," x:=32;repeat x:=x-5 until x<5;; x:=32;repeter x:=x-5; jusqua x<5;;  quoreste(a,b):={local q:=0;repeat a:=a-b;q:=q+1 until a<0;return q-1,a+b;};;  quoreste(a,b):={local q:=0;repeter a:=a-b;q:=q+1; jusqua a<0;return q-1,a+b;};; n:=1;repeter triangle_plein(10*n);saute(10*n);n:=n+1; jusqua n==5;; n:=4;repeter triangle_plein(10*n);saute(10*n);n:=n-1; jusqua n==0;","for,tantque"},
{"upper","Returns the upper matrix (over the diagonal, included) or write uppercase","Mtrx||Strng","upper([[1,2,3],[4,5,6],[7,8,9]]);upper(\"hello\")","diag,lower"},
{"user_operator","Definition of an binary operator and returns 0 (failure) or 1(success).","","user_operator(\"R\",(x,y)->x*y+x+y,Binary);user_operator(\"R\",(x,y)->x*y+x+y,Delete)",""},
{"usimplify","Simplifies a unit in a unit object","","usimplify(100_(W*s))","convert,mksa,ufactor"},
{"valuation","Returns the valuation (degree of the term of lowest degree) of the polynomial P.","","valuation(x^4+x^3);valuation([1,1,0,0,0]);valuation(x^5+3*x^2);valuation([5,0,0,3,0,0])","degree,tcoeff"},
{"vandermonde","Returns the Vandermonde matrix=[V^0,V^1,..].","","vandermonde([1,2,a])","det"},
{"var","Local variables definition: f(x):={local (var1:=x),var2; instruction;};",""," f2(x):={local (a:=2),b; b:=a*x; return b;}; f2(x):={var (a:=2),b; b:=a*x; return b;}","for,if,->,{}"},
{"variables_are_files","Pseudo-variable to specify if you want to save the variables as file \"nameofthevariable.cas\".",""," variables_are_files:=1; variables_are_files:=0","cas_setup"},
{"variance","Returns the variance of a list with the second argument as pound or the list of variance of the columns of a matrix.","","variance([3,4,2]);variance([1,2,3],[1,2,1]);variance([[1,2,3],[5,6,7]])","stddev,mean"},
{"vector","DOM_LIST or vector is the type of a list or of a sequence, as returned by the type command. It is also an option of the assume command.","Opt"," assume(a,DOM_LIST); a:=[1,2,3];type(a); a:=1,2,3;type(a)","type,assume,DOM_INT,DOM_FLOAT"},
{"vers","Puts the turtle in the direction of the point given by the argument.","","vers(0,0);vers(150,200);vers([150,200])","position,initialise"},
{"version","Returns the number giac version, you are using : giac 0.4.0","","version()",""},
{"vertex_connectivity","Returns the largest integer k such that undirected connected graph G remains connected when fewer than k vertices are removed.","Graph(G)","vertex_connectivity(graph(\"petersen\"));vertex_connectivity(graph(\"clebsch\"));vertex_connectivity(complete_graph(5))","edge_connectivity,is_connected"},
{"vertex_degree","Returns the degree of the vertex v in G (i.e. the number of edges incident to v).","Graph(G),Vrtx(v)","vertex_degree(digraph(trail(1,2,3,4,2)),2)","degree_sequence,is_regular,maximum_degree,minimum_degree,vertex_in_degree,vertex_out_degree"},
{"vertex_distance","Returns the number of edges in the shortest path from vertex s to vertex t in G. If such path does not exist, returns +infinity. For vector T of vertices from G returns the list of distances from s to each vertex t in T.","Graph(G),Vrtx(s),Vrtx(t)||Lst(T)","vertex_distance(graph(\"petersen\"),1,4);vertex_distance(graph(\"petersen\"),1,[2,4])","allpairs_distance,graph_diameter,dijkstra,shortest_path"},
{"vertex_in_degree","Returns the number of arcs in G entering the vertex v.","Graph(G),Vrtx(v)","vertex_in_degree(digraph(trail(1,2,3,4,2)),2)","degree_sequence,is_regular,maximum_degree,minimum_degree,vertex_degree,vertex_out_degree"},
{"vertex_out_degree","Returns the number of arcs in G emanating from the vertex v.","Graph(G),Vrtx(v)","vertex_out_degree(digraph(trail(1,2,3,4,2)),2)","degree_sequence,is_regular,maximum_degree,minimum_degree,vertex_degree,vertex_in_degree"},
{"vertices","Returns the list of the vertices of the polygon or polyhedron P.","","vertices(isosceles_triangle(0,1,pi/4));vertices(polyhedron([0,0,0],[0,5,0],[0,0,5],[1,2,6]));vertices(isosceles_triangle(0,1,pi/4))[2]","isosceles_triangle,polyhedron"},
{"vertices_abc","Returns the list of the vertices of the polygon or polyhedron P.","Polygon or Polyedr(P)","vertices(isosceles_triangle(0,1,pi/4));vertices(polyhedron([0,0,0],[0,5,0],[0,0,5],[1,2,6]));vertices(isosceles_triangle(0,1,pi/4))[2]","isosceles_triangle,polyhedron"},
{"vertices_abca","Returns the closed list [A,B,...A] of the vertices of the polygon or polyhedron P.","","vertices_abca(isosceles_triangle(0,1,pi/4));vertices_abca(polyhedron([0,0,0],[0,5,0],[0,0,5],[1,2,6]));vertices_abca(isosceles_triangle(0,1,pi/4))[2]","isosceles_triangle,polyhedron"},
{"vpotential","Returns U such as curl(U)=V.","","vpotential([2*x*y+3,x^2-4*z,-2*y*z],[x,y,z])","curl,potential"},
{"watch","Adds a variable to the list of displayed variables in step by step.","","watch(a)","rmwatch"},
{"web_graph","Returns a web graph on a*b vertices, where a>=3 and b>=2.","Intg(a),Intg(b)","web_graph(5,3)","prism_graph,wheel_graph"},
{"weibull","Returns the density of probability at x of the Weibull law of parameters k, lambda, theta (by default theta=0).","","weibull(2.1,1.2,1.3);weibull(2.1,1.2,0.0,1.3);weibull(2.1,1.2,0.5,1.8)","weibull_cdf,weibull_icdf"},
{"weibull_cdf","Returns the probability that a Weibull random variable of parameters k, lambda, theta is lower than x0.","","weibull_cdf(2.1,1.2,1.9);weibull_cdf(2.1,1.2,0.0,1.9);weibull_cdf(2.2,1.5,0.4,1.9);weibull_cdf(2.2,1.5,0.4,1.2);weibull_cdf(2.2,1.5,0.4,1.2,1.9)","weibulld,weibull_icdf"},
{"weibull_icdf","Returns h such that the probability that a Weibull random variable of parameters k, lambda, theta is lower than h is p (0<=p<=1).","","weibull_icdf(4.2,1.3,0.0,0.95);weibull_icdf(2.2,1.5,0.4,0.632)","weibull_cdf,weibull"},
{"weibulld","Returns the density of probability at x of the Weibull law of parameters k, lambda, theta (by default theta=0).","Real(k),Real(lambda),Real(theta),Real(x)","weibull(2.1,1.2,1.3);weibull(2.1,1.2,0.0,1.3);weibull(2.1,1.2,0.5,1.8)","weibull_cdf,weibull_icdf"},
{"weibulld_cdf","Returns the probability that a Weibull random variable of parameters k, lambda, theta is lower than x0.","Real(k),Real(lambda),Real(theta),Real(x0)","weibull_cdf(2.1,1.2,1.9);weibull_cdf(2.1,1.2,0.0,1.9);weibull_cdf(2.2,1.5,0.4,1.9);weibull_cdf(2.2,1.5,0.4,1.2);weibull_cdf(2.2,1.5,0.4,1.2,1.9)","weibulld,weibull_icdf"},
{"weibulld_icdf","Returns h such that the probability that a Weibull random variable of parameters k, lambda, theta is lower than h is p (0<=p<=1).","Real(k),Real(lambda),Real(theta),Real(p)","weibull_icdf(4.2,1.3,0.0,0.95);weibull_icdf(2.2,1.5,0.4,0.632)","weibull_cdf,weibull"},
{"weibullvariate","Returns a random real according to the Weibull distribution of parameter a>0 and b>0","Real(a),Real(b)","randweibulld(1,2);randweibulld(1.5,4)","rand,randpoly,randnorm,randvector"},
{"weight_matrix","Returns the weight matrix of G.","Graph(G)","weight_matrix(graph(%{[[1,2],2],[[2,3],1]%})","set_edge_weight,get_edge_weights,is_weighted,make_weighted,assign_edge_weights"},
{"weighted","Option for graph and digraph commands.","Opt","","directed,graph,digraph"},
{"weights","Option for the edges command.","Opt","","edges"},
{"welch_window","Applies the Welch windowing function to the given signal u (or to the elements with indices between n1 and n2) and returns the result in a new list.","Lst,[Interval(n1..n2)]"," scatterplot(welch_window(randvector(1000,0..1)))","blackman_harris_window,blackman_window,bohman_window,cosine_window,gaussian_window,hamming_window,hann_poisson_window,hann_window,parzen_window,poisson_window,riemann_window,triangle_window,tukey_window,bartlett_hann_window"},
{"wheel_graph","Returns a wheel graph with n+1 vertices.","Intg(n)","wheel_graph(5)","star_graph,web_graph"},
{"when","If condition (even symbolic) returns Expr1 else returns Expr2 (? is the infixed version of when).","","when(x>0,x+1,x-1);when(n,1,0); (a>1)?a+1:0","?,if,then,else,ifte"},
{"while","Loop while (do the instructions while cond==true): while (cond) {i1;i2;};",""," pgcd(a,b):={local r;while (b!=0){r:=irem(a,b);a:=b;b:=r}return a;};; quoreste(a,b):={local q:=0;while (a>=b){a:=a-b;q:=q+1;} return q,a;};","for,tantque,repeat"},
{"white","Option of the display command to display with color.",""," F:=display(point(2+1.5*i),red); F:=display(point(2+1.5*i),point_point+green)","display"},
{"widget_size","Changes the characters size of the display on the xcas screen (size=n) and with more parameters define the general configuration.","","widget_size(20);widget_size(8);widget_size(20,58,49,697,563,1,1,0)","cas_setup"},
{"wilcoxonp","Distribution of the Wilcoxon or Mann-Whitney test for one or two samples","","wilcoxonp(4);wilcoxonp(7,5)","wilcoxont,wilcoxons"},
{"wilcoxons","Rank statistic of Wilcoxon or Mann-Whitney for 1 sample and one median or 2 samples","","wilcoxons([1, 3, 4, 5, 7, 8, 8, 12, 15, 17] , [2, 6, 10, 11, 13, 14, 15, 18, 19, 20]);wilcoxons([1, 3, 4, 5, 7, 8, 8, 12, 15, 17] , 10)","wilcoxont,wilcoxonp"},
{"wilcoxont","Wilcoxon or Mann-Whitney test for one sample and a median or 2 samples","","wilcoxont([1, 3, 4, 5, 7, 8, 8, 12, 15, 17] , [2, 6, 10, 11, 13, 14, 15, 18, 19, 20]);wilcoxont([1, 3, 4, 5, 7, 8, 8, 12, 15, 17] , [2, 6, 10, 11, 13, 14, 15, 18, 19, 20],0.01);wilcoxont([1, 3, 4, 5, 7, 8, 8, 12, 15, 17] , 10,'>');wilcoxont([1, 3, 4, 5, 7, 8, 8, 12, 15, 17] , 10,'>',0.05)","wilcoxonp,wilcoxons,studentt,normalt"},
{"with_sqrt","Pseudo-variable to force factorization of polynomial of degree 2 (with_sqrt:=1)",":=Intg(0 or 1)"," with_sqrt:=1; with_sqrt:=0","cas_setup"},
{"write","To write in the file fich_name the variables and their values.","","write(\"turtle\"); write(\"toto\",a,b,c)","read"},
{"writergb","Write a PNG picture file named s whether from a list [[number_channels,width,height],red,green,alpha,blue] where red,green,alpha,blue are matrices of pixels color or from a matrix of pixels grey or from 3 matrices of pixels color RGB.","","writergb(\"image.png\",[[255,0],[0,255]]);writergb(\"image.png\",[[255,0],[0,0]],[[0,255],[0,0]],[[0,0],[255,0]]); a:=readrgb(\"rgb_image.png\");writergb(\"brg_image.png\",[a[0],a[4],a[1],a[3],a[2]])","readrgb"},
{"writewav","Writes a WAV sound file.","","writewav(\"la.wav\",2^14*(sin(2*pi*440*soundsec(1))));writewav(\"beep.wav\",[[1,16,44100,80000],[65000$10000,0$10000,65000$10000,0$10000]])","readwav"},
{"wz_certificate","Wilf-Zeilberger certificate for an identity sum(U,k)=res","","wz_certificate((-1)^k*comb(n,k)*comb(2k,k)*4^(n-k),comb(2n,n),n,k);;wz_certificate((-1)^k*comb(n,k)/comb(k+a,k),a/(n+a),n,k);;wz_certificate((-1)^(n-k)*comb(2n,k)^2,comb(2n,n),n,k);;wz_certificate((a+k)!*(b+k)!*(c+n-k-a-b-1)!/(k+1)!/(n-k)!/(c+k)!,(a-1)!*(b-1)!*(c-a-b-1)!*(c+n-a)!*(c+n-b)!/(c-a-1)!/(c-b-1)!/(n+1)!/(c+n)!,n,k);","sum"},
{"xcas","Set Xcas interpreter or translate from Pythin to Xcas","","xcas;xcas(f)","python"},
{"xcas_mode","Switches to mode Xcas (0), Maple (1), Mupad (2), TI89 (3).","Intg(0) or 1 or 2 or 3","xcas_mode(1);xcas_mode(0)","python_compat"},
{"xor","Exclusive or (infix operator).",""," 1 xor 1; 0 xor 1; 0 xor 0","or,and,not"},
{"xyztrange","xyztrange put or erase the axes on the graphic-screen (cf button Cfg).","","xyztrange(-5.0,5.0,-5.0,2.0,-10.0,10.0,-1.0,6.0,-5.0,5.0,-1.2384,2.0,1,0.0,1.0)",""},
{"yellow","Option of the display command to display with color.","Opt"," F:=display(point(2+1.5*i),red); F:=display(point(2+1.5*i),point_point+green)","display"},
{"zeros","Returns the zeros (real or complex according to the mode) of the expression (or the matrix where the lines are the solutions of the system : expression1=0,expression2=0...).","","zeros(x^2+4);zeros(ln(x)^2-4);zeros(ln(y)^2-2,y);zeros([x^2-1,x^2-y^2],[x,y])",""},
{"zip","Returns a list whose j-th entry is f(l1[j],l2[j]): without default value its length is the minimum of the lengths of the two input lists and else the shorter list is padded with the default value.","","zip([a,b,c,d], [1,2,3,4]);zip('+',[a,b,c,d], [1,2,3,4]);zip('+',[a,b,c,d], [1,2,3]);zip('+',[a,b,c,d], [1,2,3],5);zip(sum,[a,b,c,d], [1,2,3,4])",""},
{"ztrans","z transform of a sequence","","ztrans(a^x);ztrans(a^n,n,z)","invztrans,laplace,invlaplace"},
{"{}","Instructions bloc.",""," k(x):={local (n:=x+1);return x+n;}","begin,end,bloc,local,return"},
{"|","Infixed operator. Substitutes a value for a variable in an expression.",""," 1/(4+x^2)|x=2; y/(4+x^2)|x=2,y=5","subst,eval"},
{"||","infixed boolean operator (or).","Expr, Expr"," (1==2) or (2>1)","and,not,xor"},
